/**
* TcHmiControl
* -------------------------------------------------------------------
* (c) 2016 BECKHOFF Automation GmbH & Co. KG http://www.beckhoff.com
* -------------------------------------------------------------------
* @ignore
*/
/**
*
*/
declare module TcHmi {
    /**
     *
     */
    module Controls {
        /**
         *
         */
        module System {
            /**
            *
            */
            class TcHmiControl extends TcHmi.Controls.System.baseTcHmiControl {
                /**
                 * Constructor of the control
                 * @constructor
                 * @param {JQuery} element Element from HTML (internal, do not use)
                 * @param {JQuery} pcElement precompiled Element (internal, do not use)
                 * @param {TcHmi.Controls.ControlAttributeList} attrs Attributes defined in HTML in a special format (internal, do not use)
                 * @returns {void}
                 * @preserve (Part of the public API)
                 */
                constructor(element: JQuery, pcElement: JQuery, attrs: TcHmi.Controls.ControlAttributeList);
                protected __resourcesDomEventRegWatchOnMouseRightClick: Dictionary<{
                    event: EventProvider.IEventEntry;
                    domEventListener: TcHmiControl.IDomEventObj;
                }>;
                protected __resourcesDomEventRegWatchOnMouseDoubleClick: Dictionary<{
                    event: EventProvider.IEventEntry;
                    domEventListener: TcHmiControl.IDomEventObj;
                }>;
                protected __resourcesDomEventRegWatchOnMouseEnter: Dictionary<{
                    event: EventProvider.IEventEntry;
                    domEventListener: TcHmiControl.IDomEventObj;
                }>;
                protected __resourcesDomEventRegWatchOnMouseMove: Dictionary<{
                    event: EventProvider.IEventEntry;
                    domEventListener: TcHmiControl.IDomEventObj;
                }>;
                protected __resourcesDomEventRegWatchOnMouseOut: Dictionary<{
                    event: EventProvider.IEventEntry;
                    domEventListener: TcHmiControl.IDomEventObj;
                }>;
                protected __resourcesDomEventRegWatchOnMouseLeave: Dictionary<{
                    event: EventProvider.IEventEntry;
                    domEventListener: TcHmiControl.IDomEventObj;
                }>;
                protected __resourcesDomEventRegWatchOnMouseDown: Dictionary<{
                    event: EventProvider.IEventEntry;
                    domEventListener: TcHmiControl.IDomEventObj;
                }>;
                protected __resourcesDomEventRegWatchOnMouseUp: Dictionary<{
                    event: EventProvider.IEventEntry;
                    domEventListener: TcHmiControl.IDomEventObj;
                }>;
                protected __resourcesDomEventRegWatchOnMouseOver: Dictionary<{
                    event: EventProvider.IEventEntry;
                    domEventListener: TcHmiControl.IDomEventObj;
                }>;
                protected __resourcesDomEventRegWatchOnMouseClick: Dictionary<{
                    event: EventProvider.IEventEntry;
                    domEventListener: TcHmiControl.IDomEventObj;
                }>;
                protected __resourcesDomEventRegWatchOnMouseWheel: Dictionary<{
                    event: EventProvider.IEventEntry;
                    domEventListener: TcHmiControl.IDomEventObj;
                }>;
                protected __resourcesDomEventRegWatchOnTouchStart: Dictionary<{
                    event: EventProvider.IEventEntry;
                    domEventListener: TcHmiControl.IDomEventObj;
                }>;
                protected __resourcesDomEventRegWatchOnTouchMove: Dictionary<{
                    event: EventProvider.IEventEntry;
                    domEventListener: TcHmiControl.IDomEventObj;
                }>;
                protected __resourcesDomEventRegWatchOnTouchEnd: Dictionary<{
                    event: EventProvider.IEventEntry;
                    domEventListener: TcHmiControl.IDomEventObj;
                }>;
                protected __resourcesDomEventRegWatchOnTouchCancel: Dictionary<{
                    event: EventProvider.IEventEntry;
                    domEventListener: TcHmiControl.IDomEventObj;
                }>;
                protected __resourcesEventRegWatchOnPressed: Dictionary<{
                    event: EventProvider.IEventEntry;
                    destroy: DestroyFunction;
                }>;
                protected __resourcesEventRegWatchOnMouseDownLeft: Dictionary<{
                    event: EventProvider.IEventEntry;
                    destroy: DestroyFunction;
                }>;
                protected __resourcesEventRegWatchOnMouseDownRight: Dictionary<{
                    event: EventProvider.IEventEntry;
                    destroy: DestroyFunction;
                }>;
                protected __resourcesEventRegWatchOnMouseUpLeft: Dictionary<{
                    event: EventProvider.IEventEntry;
                    destroy: DestroyFunction;
                }>;
                protected __resourcesEventRegWatchOnMouseUpRight: Dictionary<{
                    event: EventProvider.IEventEntry;
                    destroy: DestroyFunction;
                }>;
                protected __destroyDomEventRegWatchOnMouseRightClick: DestroyFunction | null;
                protected __destroyDomEventRegWatchOnMouseDoubleClick: DestroyFunction | null;
                protected __destroyDomEventRegWatchOnMouseEnter: DestroyFunction | null;
                protected __destroyDomEventRegWatchOnMouseMove: DestroyFunction | null;
                protected __destroyDomEventRegWatchOnMouseOut: DestroyFunction | null;
                protected __destroyDomEventRegWatchOnMouseLeave: DestroyFunction | null;
                protected __destroyDomEventRegWatchOnMouseDown: DestroyFunction | null;
                protected __destroyDomEventRegWatchOnMouseUp: DestroyFunction | null;
                protected __destroyDomEventRegWatchOnMouseOver: DestroyFunction | null;
                protected __destroyDomEventRegWatchOnMouseClick: DestroyFunction | null;
                protected __destroyDomEventRegWatchOnMouseWheel: DestroyFunction | null;
                protected __destroyDomEventRegWatchOnTouchStart: DestroyFunction | null;
                protected __destroyDomEventRegWatchOnTouchMove: DestroyFunction | null;
                protected __destroyDomEventRegWatchOnTouchEnd: DestroyFunction | null;
                protected __destroyDomEventRegWatchOnTouchCancel: DestroyFunction | null;
                protected __destroyEvenRegWatchOnPressed: DestroyFunction | null;
                protected __destroyEvenRegWatchOnMouseDownLeft: DestroyFunction | null;
                protected __destroyEvenRegWatchOnMouseDownRight: DestroyFunction | null;
                protected __destroyEvenRegWatchOnMouseUpLeft: DestroyFunction | null;
                protected __destroyEvenRegWatchOnMouseUpRight: DestroyFunction | null;
                version: Version;
                /**
                * main JQuery element defining this control
                @member */
                __element: JQuery;
                /**
                * @member
                */
                readonly __attrs: TcHmi.Controls.ControlAttributeList;
                /**
                * precompiled copy of main JQuery element defining this control
                @member */
                __pcElement: JQuery;
                /**
                * Id of the control
                * @type {string}
                */
                __id: string;
                /**
                * The type of the current control.
                * @type {string}
                */
                protected readonly __type: string;
                /** Row index of the Control inside a TcHmiGrid Container. */
                __gridRowIndex: number | undefined;
                /** Column index of the Control inside a TcHmiGrid Container. */
                __gridColumnIndex: number | undefined;
                /** Enable or disable this and its children controls */
                __isEnabled: boolean | undefined;
                /**
                * Is set to true if the control is attached to the dom
                * and to false if the control is not attached to the dom.
                */
                __isAttached: boolean;
                /** */
                __pendingTach: boolean;
                /** This control should never be destroyed. */
                __keepAlive: boolean;
                /**
                * Parent control or null if there is (till now?) no parent control
                */
                __parent: TcHmi.Controls.System.TcHmiControl | null;
                protected readonly __children: TcHmi.Controls.System.baseTcHmiControl[];
                /**
                * True for all ContainerControls
                */
                __isContainerControl: boolean;
                /**
                    A list of access rules which is defined in this control
                */
                __accessConfig: TcHmi.AccessControl[];
                __virtualControlRightMappings: TcHmi.VirtualControlRightMapping[];
                protected __classNames: string[] | undefined;
                /**
                * Is set if control was marked as destroyed.
                */
                protected __isDestroyed: boolean;
                /**
                * The elements z-index.
                */
                protected __zindex: number | null | undefined;
                protected __onMovedDestroyCallback: TcHmi.DestroyFunction | null;
                protected __onResizedDestroyCallback: TcHmi.DestroyFunction | null;
                /** state of the className checkable without DOM access */
                private __accessAndEnableState;
                /**
                 * The width of the control element.
                 * @type {number}
                 */
                protected __width: number | null | undefined;
                /**
                * The width unit of the control element.
                * @type {MeasurementUnit}
                */
                protected __widthUnit: DimensionUnit | undefined;
                /**
                 * In normal controls only 'Value' and 'Parent' must be used
                 * This base class must hold all possible values for technical reasons.
                 */
                protected __widthMode: SizeMode | SizeModeWithContent | undefined;
                /**
                * The height of the control element.
                * @type {number}
                */
                protected __height: number | null | undefined;
                /**
                * The height unit of the control element.
                * @type {MeasurementUnit}
                */
                protected __heightUnit: DimensionUnit | undefined;
                /**
                    Resolved (content?) height as string, will be set to control.__element on __processHeight
                */
                protected __intHeight: string | null;
                /**
                 * In normal controls only 'Value' and 'Parent' must be used
                 * This base class must hold all possible values for technical reasons.
                 */
                protected __heightMode: SizeMode | SizeModeWithContent | undefined;
                /**
                * The top coordinate of the element.
                * @type {number}
                */
                protected __top: number | null | undefined;
                /**
                * The top unit of the control element.
                * @type {MeasurementUnit}
                */
                protected __topUnit: DimensionUnit | undefined;
                /**
                * The left coordinate of the element.
                * @type {number}
                */
                protected __left: number | null | undefined;
                /**
                * The left unit of the control element.
                * @type {MeasurementUnit}
                */
                protected __leftUnit: DimensionUnit | undefined;
                /**
                * The bottom coordinate of the element.
                * @type {number}
                */
                protected __bottom: number | null | undefined;
                /**
                * The bottom unit of the control element.
                * @type {MeasurementUnit}
                */
                protected __bottomUnit: DimensionUnit | undefined;
                /**
                * The right coordinate of the element.
                * @type {number}
                */
                protected __right: number | null | undefined;
                /**
                * The right unit of the control element.
                * @type {MeasurementUnit}
                */
                protected __rightUnit: DimensionUnit | undefined;
                /**
                * The minimum width of the element.
                * @type {number}
                */
                protected __minWidth: number | null | undefined;
                /**
                * The minimum width unit of the control element.
                * @type {MeasurementUnit}
                */
                protected __minWidthUnit: DimensionUnit | undefined;
                /**
                * The maximum width of the element.
                * @type {number}
                */
                protected __maxWidth: number | null | undefined;
                /**
                * The maximum width unit of the control element.
                * @type {MeasurementUnit}
                */
                protected __maxWidthUnit: DimensionUnit | undefined;
                /**
                * The minimum height of the element.
                * @type {number}
                */
                protected __minHeight: number | null | undefined;
                /**
                * The minimum height unit of the control element.
                * @type {MeasurementUnit}
                */
                protected __minHeightUnit: DimensionUnit | undefined;
                /**
                * The maximum height of the element.
                * @type {number}
                */
                protected __maxHeight: number | null | undefined;
                /**
                * The maximum height unit of the control element.
                * @type {MeasurementUnit}
                */
                protected __maxHeightUnit: DimensionUnit | undefined;
                protected readonly __renderedSizeCache: {
                    left: number | null;
                    top: number | null;
                    right: number | null;
                    bottom: number | null;
                    width: number | null;
                    height: number | null;
                };
                /**
                * The elements opacity. The value has to be between 0 (0%) and 1 (100%).
                */
                protected __opacity: number | null | undefined;
                /**
                * The elements visibility.
                */
                protected __visibility: Visibility | undefined;
                /**
                * Transform
                */
                protected __transform: Transform[] | null | undefined;
                /**
                * Internal reference to the attribute "data-tchmi-border-color".
                */
                protected __borderColor: TcHmi.Color | null | undefined;
                /**
                * Internal reference to the attribute "data-tchmi-border-width".
                */
                protected __borderWidth: TcHmi.BorderWidth | null | undefined;
                /**
                * Internal reference to the attribute "data-tchmi-border-radius".
                */
                protected __borderRadius: TcHmi.BorderRadius | null | undefined;
                /**
                * Internal reference to the attribute "data-tchmi-border-style".
                */
                protected __borderStyle: TcHmi.BorderStyle | null | undefined;
                /**
                * Internal reference to the attribute "data-tchmi-box-shadow".
                */
                protected __boxShadow: TcHmi.BoxShadow[] | null | undefined;
                /** Trigger */
                protected __trigger: TcHmi.System.Trigger[] | null | undefined;
                /** Trigger which are active even when detached (only own onInitialized and onDestroyed) */
                protected __triggerNonAttachList: TcHmi.System.Trigger[];
                /** Trigger which are active only when attached */
                protected __triggerAttachList: TcHmi.System.Trigger[];
                /**
               * Internal reference to the attribute "data-tchmi-tooltip".
               */
                protected __tooltip: string | null | undefined;
                /**
                 * Internal onject to store the values of the various background attributes.
                 */
                protected __background: Partial<TcHmi.Background>;
                /**
                 * Is raised before control attribute setters are called to allow initialization based on current attribute values.
                 */
                __previnit(): void;
                /**
                * Is raised after control attribute setters have been called to allow initialization based on current attribute values.
                */
                __init(): void;
                /**
                * Is called by tachcontrol() after the control instance gets part of the current DOM.
                * Is only allowed to be called from the framework itself!
                * @function
                */
                __attach(): void;
                /**
                * Is called by tachcontrol() after the control instance is no longer part of the current DOM.
                * Is only allowed to be called from the framework itself!
                * @function
                */
                __detach(): void;
                /**
                 * Destroy the current control instance.
                 * Will be called automatically if system destroys control!
                 * @function
                 */
                destroy(): void;
                /**
                 * Adds a child to the __children Array and links the parent. No DOM insertion is done!
                 * @function
                 */
                __addChild(co: TcHmi.Controls.System.baseTcHmiControl, pos?: number | null): void;
                /**
                 * Remove a child control.
                 * @function
                 */
                __removeChild(co: TcHmi.Controls.System.baseTcHmiControl): void;
                /**
                 * Returns the configured defaultInternalValue of the control property
                 *
                 * @param propertyName
                 * @returns {any | null} returns the value or null
                 * @preserve (Part of the public API)
                 */
                protected getAttributeDefaultValueInternal<T>(propertyName: string): T | null;
                /**
                * Is raised if the mouseover event is raised from the ".tchmi-button-action-area" element.
                * @function
                * @callback
                */
                protected __onElementMouseOver(event: EventProvider.IEventEntry): (e: MouseEvent) => void;
                /**
                * Is raised if the mouseenter event is raised from the ".tchmi-button-action-area" element.
                * @function
                * @callback
                */
                protected __onElementMouseEnter(event: EventProvider.IEventEntry): (e: MouseEvent) => void;
                /**
                * Is raised if the mousedown event is raised from the ".tchmi-button-action-area" element.
                * @function
                * @callback
                */
                protected __onElementMouseDown(event: EventProvider.IEventEntry): (e: MouseEvent) => void;
                /**
                * Is raised if the MouseMove event is raised from the ".tchmi-button-action-area" element.
                * @function
                * @callback
                */
                protected __onElementMouseMove(event: EventProvider.IEventEntry): (e: MouseEvent) => void;
                /**
                * Is raised if the mouseup event is raised from the ".tchmi-button-action-area" element.
                * @function
                * @callback
                */
                protected __onElementMouseUp(event: EventProvider.IEventEntry): (e: MouseEvent) => void;
                /**
                * Is raised if the click event is raised from the ".tchmi-button-action-area" element.
                * @function
                * @callback
                */
                protected __onElementMouseClick(event: EventProvider.IEventEntry): (e: MouseEvent) => void;
                /**
                * Is raised if the rightclick event is raised from the ".tchmi-button-action-area" element.
                * @function
                * @callback
                */
                protected __onElementMouseRightClick(event: EventProvider.IEventEntry): (e: MouseEvent) => void;
                /**
                * Is raised if the doubleclick event is raised from the ".tchmi-button-action-area" element.
                * @function
                * @callback
                */
                protected __onElementMouseDoubleClick(event: EventProvider.IEventEntry): (e: MouseEvent) => void;
                /**
                * Is raised if the mouseout event is raised from the ".tchmi-button-action-area" element.
                * @function
                * @callback
                */
                protected __onElementMouseOut(event: EventProvider.IEventEntry): (e: MouseEvent) => void;
                /**
                * Is raised if the mouseleave event is raised from the ".tchmi-button-action-area" element.
                * @function
                * @callback
                */
                protected __onElementMouseLeave(event: EventProvider.IEventEntry): (e: MouseEvent) => void;
                /**
                * Is raised if the wheel event is raised from the ".tchmi-button-action-area" element.
                * @function
                * @callback
                */
                protected __onElementMouseWheel(event: EventProvider.IEventEntry): (e: MouseEvent) => void;
                /**
                * Is raised if the touchstart event is raised from  the ".tchmi-button-action-area" element.
                * @function
                * @callback
                */
                protected __onElementTouchStart(event: EventProvider.IEventEntry): (e: TouchEvent) => void;
                /**
                * Is raised if the touchmove event is raised from  the ".tchmi-button-action-area" element.
                * @function
                * @callback
                */
                protected __onElementTouchMove(event: EventProvider.IEventEntry): (e: TouchEvent) => void;
                /**
                * Is raised if the touchend event is raised from  the ".tchmi-button-action-area" element.
                * @function
                * @callback
                */
                protected __onElementTouchEnd(event: EventProvider.IEventEntry): (e: TouchEvent) => void;
                /**
                * Is raised if the touchcancel event is raised from  the ".tchmi-button-action-area" element.
                * @function
                * @callback
                */
                protected __onElementTouchCancel(event: EventProvider.IEventEntry): (e: TouchEvent) => void;
                /**
                 * Name of the Control
                 */
                getId(): string;
                /**
                 * Type of the Control
                 */
                getType(): string;
                /**
                 * Main HTML Element of the Control as jQuery object
                 */
                getElement(): JQuery<HTMLElement>;
                /**
                 * Is this control already destroyed?
                 */
                getIsDestroyed(): boolean;
                /**
                 * Defines the classes the control is part of.
                 */
                getClassNames(): string[] | undefined;
                /**
                 * Defines the classes the control is part of.
                 * @param valueNew
                 */
                setClassNames(valueNew: string[] | null): void;
                __processClassNames(): void;
                getAccessConfig(): AccessControl[];
                /**
                * Sets the new AccessConfig
                * @param valueNew
                * @function
                */
                setAccessConfig(valueNew: AccessControl[] | null): void;
                /**
                 * Shows/hides the control depending of the current 'observe' right and mark if operate is not allowed
                 * @function
                 */
                __processAccessConfig(): void;
                /**
                 * Returns the mapping of virtual rights to real rights
                 */
                getVirtualControlRightMappings(): VirtualControlRightMapping[];
                /**
                 * Sets the new VirtualControlRightMapping
                 * @param valueNew
                 * @function
                 */
                setVirtualControlRightMappings(valueNew: VirtualControlRightMapping[] | null): void;
                /**
                 * Reprocesses the access config
                 * @function
                 */
                protected __processVirtualControlRightMappings(): void;
                /**
                 * Returns the Row index of the Control inside a TcHmiGrid Container.
                 */
                getGridRowIndex(): number | undefined;
                /**
                 * Sets a new GridRow index
                 * @param valueNew
                 */
                setGridRowIndex(valueNew: number | null): void;
                /**
                 * Process GridRowIndex (no op in this base class)
                 */
                protected __processGridRowIndex(): void;
                /**
                 * Returns the Column index of the Control inside a TcHmiGrid Container.
                 */
                getGridColumnIndex(): number | undefined;
                /**
                 * Sets a new GridColumn index
                 * @param valueNew
                 */
                setGridColumnIndex(valueNew: number | null): void;
                /**
                 * Process GridColumnIndex (no op in this base class)
                 */
                protected __processGridColumnIndex(): void;
                /**
                * Returns true if the control is attached to the dom
                * and false if the control is not attached to the dom.
                * @function getIsAttached
                * @returns {boolean}
                */
                getIsAttached(): boolean;
                /**
                * Returns the current width of the Control.
                * @function
                * @returns   {number}    The current width value.
                */
                getWidth(): number | null | undefined;
                /**
                * Returns the current width unit of the Control.
                * @function
                * @returns   {MeasurementUnit}    The current width unit.
                */
                getWidthUnit(): "px" | "%" | undefined;
                /**
                * Returns the current width mode of the control.
                * @function
                * @returns   {string}    The current width mode value.
                */
                getWidthMode(): "Value" | "Parent" | "Content" | undefined;
                /**
                * Returns the current height of the Control.
                * @function
                * @returns   {number}    The current height value.
                */
                getHeight(): number | null | undefined;
                /**
                * Returns the current height mode of the control.
                * @function
                * @returns   {string}    The current height mode value.
                */
                getHeightMode(): "Value" | "Parent" | "Content" | undefined;
                /**
                * Returns the current height unit of the Control.
                * @function
                * @returns   {MeasurementUnit}    The current height unit.
                */
                getHeightUnit(): "px" | "%" | undefined;
                /**
                * Returns the current top coordinate of the Control.
                * @function
                * @returns   {number}    The current top value.
                */
                getTop(): number | null | undefined;
                /**
                * Returns the current top coordinate unit of the Control.
                * @function
                * @returns   {MeasurementUnit}    The current top unit.
                */
                getTopUnit(): "px" | "%" | undefined;
                /**
                * Returns the current left coordinate of the Control.
                * @function
                * @returns   {number}    The current left value.
                */
                getLeft(): number | null | undefined;
                /**
                * Returns the current left coordinate unit of the Control.
                * @function
                * @returns   {MeasurementUnit}    The current left unit.
                */
                getLeftUnit(): "px" | "%" | undefined;
                /**
                * Returns the current bottom coordinate of the Control.
                * @function
                * @returns   {number}    The current bottom value.
                */
                getBottom(): number | null | undefined;
                /**
                * Returns the current bottom coordinate unit of the Control.
                * @function
                * @returns   {MeasurementUnit}    The current bottom unit.
                */
                getBottomUnit(): "px" | "%" | undefined;
                /**
                * Returns the current right coordinate of the Control.
                * @function
                * @returns   {number}    The current right value.
                */
                getRight(): number | null | undefined;
                /**
                * Returns the current right coordinate unit of the Control.
                * @function
                * @returns   {MeasurementUnit}    The current right unit.
                */
                getRightUnit(): "px" | "%" | undefined;
                /**
                * Returns the current minwidth value.
                * @function
                * @returns   {number}    The current width value.
                */
                getMinWidth(): number | null | undefined;
                /**
                * Returns the current minwidth unit.
                * @function
                * @returns   {MeasurementUnit}    The current width unit.
                */
                getMinWidthUnit(): "px" | "%" | undefined;
                /**
                * Returns the current minheight value.
                * @function
                * @returns   {number}    The current height value.
                */
                getMinHeight(): number | null | undefined;
                /**
                * Returns the current minheight unit.
                * @function
                * @returns   {MeasurementUnit}    The current height unit.
                */
                getMinHeightUnit(): "px" | "%" | undefined;
                /**
                * Returns the current maxwidth value.
                * @function
                * @returns   {number}    The current width value.
                */
                getMaxWidth(): number | null | undefined;
                /**
                * Returns the current maxwidth unit.
                * @function
                * @returns   {MeasurementUnit}    The current width unit.
                */
                getMaxWidthUnit(): "px" | "%" | undefined;
                /**
                * Returns the current maxheight value.
                * @function
                * @returns   {number}    The current height value.
                */
                getMaxHeight(): number | null | undefined;
                /**
                * Returns the current maxheight unit.
                * @function
                * @returns   {MeasurementUnit}    The current height unit.
                */
                getMaxHeightUnit(): "px" | "%" | undefined;
                /**
                * Returns the current rendered left value in pixel.
                * @function
                * @returns   {number}    The current left pixel distance.
                */
                getRenderedLeft(): number | null;
                /**
                * Returns the current rendered top value in pixel.
                * @function
                * @returns   {number}    The current top pixel distance.
                */
                getRenderedTop(): number | null;
                /**
                * Returns the current rendered right value in pixel.
                * @function
                * @returns   {number}    The current right pixel distance.
                */
                getRenderedRight(): number | null;
                /**
                * Returns the current rendered bottom value in pixel.
                * @function
                * @returns   {number}    The current bottom pixel distance.
                */
                getRenderedBottom(): number | null;
                /**
                * Returns the current rendered width value in pixel.
                * @function
                * @returns   {number}    The current width pixel size.
                */
                getRenderedWidth(): number | null;
                /**
                * Returns the current rendered height value in pixel.
                * @function
                * @returns   {number}    The current height pixel size.
                */
                getRenderedHeight(): number | null;
                /**
                 * Checks computed style of the main element for some css attributes
                 * Updates the cache and returns an array of corresponding getters
                 * @param stylesToCheck
                 */
                private __findRenderChanges(stylesToCheck);
                /**
                * Is raised if the control was moved
                * @function
                * @callback
                */
                protected __onElementPrevMoved(): (evt: EventProvider.Event, ctrl: TcHmiControl) => void;
                /**
                * Is raised if the control was resized
                * @function
                * @callback
                */
                protected __onElementPrevResized(): (evt: EventProvider.Event, ctrl: TcHmiControl) => void;
                /**
                * Sets the value of the width attribute.
                * @function
                * @param    {number}    valueNew   -   The new width value..
                */
                setWidth(valueNew: number | null): void;
                /**
                * Processes the current width and width unit and trigger __processWidth in parent of this is Content sized.
                * @function
                */
                __processWidth(callerControl?: TcHmiControl): void;
                /**
                * Sets the unit of the width attribute.
                * @function
                * @param    {MeasurementUnit}    valueNew   -   The new width unit.
                */
                setWidthUnit(valueNew: DimensionUnit | null): void;
                /**
                * Processes the current width and width unit.
                * @function
                */
                protected __processWidthUnit(): void;
                /**
                * Sets the value of the width mode attribute.
                * @function
                * @param    {string}    valueNew   -   The new width mode value..
                */
                setWidthMode(valueNew: SizeMode | null): void;
                /**
                * Processes the current width and width unit.
                * @function
                */
                protected __processWidthMode(): void;
                /**
                * Sets the value of the height attribute.
                * @function
                * @param    {number}    valueNew   -   The new height value.
                */
                setHeight(valueNew: number | null): void;
                /**
                * Processes the current height and height unit and trigger __processHeight in parent of this is Content sized.
                * Adds fake height when minWidth without height and only top/bottom
                * @function
                */
                __processHeight(callerControl?: TcHmiControl): void;
                /**
                * Sets the value of the height mode attribute.
                * @function
                * @param    {string}    valueNew   -   The new height mode value..
                */
                setHeightMode(valueNew: SizeMode | null): void;
                /**
                * Processes the current height and height unit.
                * @function
                */
                protected __processHeightMode(): void;
                /**
                * Sets the unit of the height attribute.
                * @function
                * @param    {MeasurementUnit}    valueNew   -   The new height unit.
                */
                setHeightUnit(valueNew: DimensionUnit | null): void;
                /**
                * Processes the current height and height unit
                * @function
                */
                protected __processHeightUnit(): void;
                /**
                 * Returns the calculated width in pixel if self defined (not percent based).
                 * max-width overrides width, but min-width overrides max-width.
                 */
                __getContentWidth(): number | null;
                /**
                 * Returns the calculated height in pixel if self defined (not percent based).
                 * max-height overrides height, but min-height overrides max-height.
                 */
                __getContentHeight(): number | null;
                /**
                * Sets the value of the top attribute.
                * @function
                * @param    {number}    valueNew   -   The new top value.
                */
                setTop(valueNew: number | null): void;
                /**
                * Processes the current top and top unit
                * @function
                */
                protected __processTop(): void;
                /**
                * Sets the unit of the top attribute.
                * @function
                * @param    {MeasurementUnit}    valueNew   -   The new top unit.
                */
                setTopUnit(valueNew: DimensionUnit | null): void;
                /**
                * Processes the current top and top unit
                * @function
                */
                protected __processTopUnit(): void;
                /**
                * Sets the value of the left attribute.
                * @function
                * @param    {number}    valueNew   -   The new left value.
                */
                setLeft(valueNew: number | null): void;
                /**
                * Processes the current left and left unit value.
                * @function
                */
                protected __processLeft(): void;
                /**
                * Sets the unit of the left attribute.
                * @function
                * @param    {MeasurementUnit}    valueNew   -   The new left unit.
                */
                setLeftUnit(valueNew: DimensionUnit | null): void;
                /**
                * Processes the current left and left unit value.
                * @function
                */
                protected __processLeftUnit(): void;
                /**
                * Sets the value of the bottom attribute.
                * @function
                * @param    {number}    valueNew   -   The new bottom value.
                */
                setBottom(valueNew: number | null): void;
                /**
                * Processes the current bottom and bottom unit value.
                * @function
                */
                protected __processBottom(): void;
                /**
                * Sets the unit of the bottom attribute.
                * @function
                * @param    {MeasurementUnit}    valueNew   -   The new bottom unit.
                */
                setBottomUnit(valueNew: DimensionUnit | null): void;
                /**
                * Processes the current bottom and bottom unit value.
                * @function
                */
                protected __processBottomUnit(): void;
                /**
                * Sets the value of the right attribute.
                * @function
                * @param    {number}    valueNew   -   The new right value.
                */
                setRight(valueNew: number | null): void;
                /**
                * Processes the current right and right unit value.
                * @function
                */
                protected __processRight(): void;
                /**
                * Sets the unit of the right attribute.
                * @function
                * @param    {MeasurementUnit}    valueNew   -   The new right unit.
                */
                setRightUnit(valueNew: DimensionUnit | null): void;
                /**
                * Processes the current right and right unit value.
                * @function
                */
                protected __processRightUnit(): void;
                /**
                * Sets the value of the minwidth attribute.
                * @function
                * @param    {number}    valueNew   -   The new width value..
                */
                setMinWidth(valueNew: number | null): void;
                /**
                * Processes the current minwidth and minwidth unit.
                * @function
                */
                protected __processMinWidth(): void;
                /**
                * Sets the unit of the minwidth attribute.
                * @function
                * @param    {MeasurementUnit}    valueNew   -   The new width unit.
                */
                setMinWidthUnit(valueNew: DimensionUnit | null): void;
                /**
                * Processes the current width and width unit.
                * @function
                */
                protected __processMinWidthUnit(): void;
                /**
                * Sets the value of the minheight attribute.
                * @function
                * @param    {number}    valueNew   -   The new height value..
                */
                setMinHeight(valueNew: number | null): void;
                /**
                * Processes the current minheight and minheight unit.
                * @function
                */
                protected __processMinHeight(): void;
                /**
                * Sets the unit of the minheight attribute.
                * @function
                * @param    {MeasurementUnit}    valueNew   -   The new height unit.
                */
                setMinHeightUnit(valueNew: DimensionUnit | null): void;
                /**
                * Processes the current height and height unit.
                * @function
                */
                protected __processMinHeightUnit(): void;
                /**
                * Sets the value of the maxheight attribute.
                * @function
                * @param    {number}    valueNew   -   The new height value..
                */
                setMaxHeight(valueNew: number | null): void;
                /**
                * Sets the value of the maxwidth attribute.
                * @function
                * @param    {number}    valueNew   -   The new width value..
                */
                setMaxWidth(valueNew: number | null): void;
                /**
                * Processes the current maxwidth and maxwidth unit.
                * @function
                */
                protected __processMaxWidth(): void;
                /**
                * Sets the unit of the maxwidth attribute.
                * @function
                * @param    {MeasurementUnit}    valueNew   -   The new width unit.
                */
                setMaxWidthUnit(valueNew: DimensionUnit | null): void;
                /**
                * Processes the current width and width unit.
                * @function
                */
                protected __processMaxWidthUnit(): void;
                /**
                * Processes the current maxheight and maxheight unit.
                * @function
                */
                protected __processMaxHeight(): void;
                /**
                * Sets the unit of the maxheight attribute.
                * @function
                * @param    {MeasurementUnit}    valueNew   -   The new height unit.
                */
                setMaxHeightUnit(valueNew: DimensionUnit | null): void;
                /**
                * Processes the current height and height unit.
                * @function
                */
                protected __processMaxHeightUnit(): void;
                /**
                * Sets the value of the zindex attribute.
                * @function
                * @param    {number}    valueNew   -   The new zindex value.
                */
                setZindex(valueNew: number | null): void;
                /**
                * Returns the current zindex value.
                * @function
                * @returns   {number}    The current zindex value.
                */
                getZindex(): number | null | undefined;
                /**
                * Processes the current zindex value.
                * @function
                */
                protected __processZindex(): void;
                /**
                * Sets the value of the opacity attribute. The value must be between 0 (0%) and 1 (100%).
                * @function
                * @param    {number}    valueNew   -   The new opacity value.
                */
                setOpacity(valueNew: number | null): void;
                /**
                * Returns the current opacity value.
                * @function
                * @returns   {number}    The current opacity value.
                */
                getOpacity(): number | null | undefined;
                /**
                * Processes the current opacity value.
                * @function
                */
                protected __processOpacity(): void;
                /**
                * Sets the value of the visibility attribute.
                * @function
                * @param    {string}    valueNew   -   The new visibility value.
                */
                setVisibility(valueNew: Visibility | null): void;
                /**
                * Returns the current visibility value.
                * @function
                * @returns   {string}    The current visibility value.
                */
                getVisibility(): "Visible" | "Hidden" | "Collapsed" | undefined;
                /**
                * Processes the current visibility value.
                * @function
                */
                protected __processVisibility(): void;
                /**
                * Sets the value of the transform attribute.
                * @function
                * @param    {Transform}    valueNew   -   The new transform value.
                */
                setTransform(valueNew: Transform[] | null): void;
                /**
                * Returns the current transform value.
                * @function
                * @returns   {Transform}    The current transform value.
                */
                getTransform(): Transform[] | null | undefined;
                /**
                * Processes the current transform value.
                * @function
                */
                protected __processTransform(): void;
                /**
                 * Processes the current background attributes.
                 * @function
                 */
                protected __processBackground(): void;
                /**
                * Sets the background value and calls the associated process function.
                * @function
                * @param   {string}    valueNew    -   The new value for the background attribute as json string.
                */
                setBackgroundColor(valueNew: Color | null): void;
                /**
                * Returns the current background value.
                * @function
                * @returns      {string}    The current value of the background member variable as json in string format.

                */
                getBackgroundColor(): SolidColor | LinearGradientColor | null | undefined;
                /**
                 * Processes the current border-color attribute.
                 * @function
                 */
                protected __processBackgroundColor(): void;
                /**
                * Sets the border-color attribute value and calls the associated process function (processBorderColor).
                * @function
                * @param    {Color}    valueNew    -   The new attribute value.
                */
                setBorderColor(valueNew: Color | null): void;
                /**
                * Returns the current border-color value.
                * @function
                * @returns    {SolidColor}    The current attribute value.
                */
                getBorderColor(): SolidColor | LinearGradientColor | null | undefined;
                /**
                * Processes the current border-color attribute.
                * @function
                */
                protected __processBorderColor(): void;
                /**
                * Sets the border-width attribute value and calls the associated process function (processBorderWidth).
                * @function
                * @param    {BorderWidth}    valueNew    -   The new attribute value.
                */
                setBorderWidth(valueNew: BorderWidth | null): void;
                /**
                * Returns the current border-width value.
                * @function
                * @returns    {BorderWidth}    The current attribute value.
                */
                getBorderWidth(): BorderWidth | null | undefined;
                /**
                * Processes the current border-width attribute.
                * @function
                */
                protected __processBorderWidth(): void;
                /**
                * Sets the border-radius attribute value and calls the associated process function (processBorderRadius).
                * @function
                * @param    {BorderRadius}    valueNew    -   The new attribute value.
                */
                setBorderRadius(valueNew: BorderRadius | null): void;
                /**
                * Returns the current border-radius value.
                * @function
                * @returns    {BorderRadius}    The current attribute value.
                */
                getBorderRadius(): BorderRadius | null | undefined;
                /**
                * Processes the current border-radius attribute.
                * @function
                */
                protected __processBorderRadius(): void;
                /**
                * Internal reference to the attribute "data-tchmi-border-style".
                * @type {BorderStyle}
                */
                setBorderStyle(valueNew: BorderStyle | null): void;
                /**
                * Returns the current border-style value.
                * @function
                * @returns    {BorderStyle}    The current attribute value.
                */
                getBorderStyle(): BorderStyle | null | undefined;
                /**
                * Processes the current border-style attribute.
                * @function
                */
                protected __processBorderStyle(): void;
                /**
                * Internal reference to the attribute "data-tchmi-box-shadow".
                * @type {BoxShadow}
                */
                setBoxShadow(valueNew: BoxShadow[] | null): void;
                /**
                * Returns the current box-shadow value.
                * @function
                * @returns    {BoxShadow}    The current attribute value.
                */
                getBoxShadow(): BoxShadow[] | null | undefined;
                /**
                * Processes the current box-shadow attribute.
                * @function
                */
                protected __processBoxShadow(): void;
                /**
                * Sets the value of the trigger attribute.
                */
                setTrigger(valueNew: TcHmi.System.Trigger[] | null): void;
                /**
                * Returns the current trigger value.
                */
                getTrigger(): TcHmi.System.Trigger[] | null | undefined;
                /**
                * Processes the current trigger value.
                * @function
                */
                protected __processTrigger(): void;
                /**
                * Returns the effective value of isEnabled based on own and parent isEnabled variable.
                * @function
                * @returns      {boolean}    The current value of isEnabled.
                */
                getIsEnabled(): boolean;
                /**
                * Sets the isEnabled attribute and calls the associated process function (processIsEnabled).
                * @function
                * @param   {boolean}    valueNew     -   The new value for isEnabled.
                */
                setIsEnabled(valueNew: boolean | null): void;
                /**
                * Processes the current isEnabled attribute value.
                * @function
                */
                __processIsEnabled(): void;
                /**
                * Sets the tooltip attribute and calls the associated process function (processTooltip).
                * @function
                * @param   {string}    valueNew     -   The new value for tooltip.
                */
                setTooltip(valueNew: string | null): void;
                /**
                * Returns the current value of tooltip.
                * @function
                * @returns      {string}    The current value of tooltip.
                */
                getTooltip(): string | null | undefined;
                /**
                * Processes the current tooltip attribute value.
                * @function
                */
                protected __processTooltip(): void;
                /**
                * Sets the value of the member variable "backgroundImage" if the new value is not equal to the current value.
                * and calls the associated process function (processBackgroundImage) after that.
                * @function
                * @param   {string.<{Path}>}    valueNew     -   The new value for backgroundImage.
                */
                setBackgroundImage(valueNew: string | null): void;
                /**
                * Returns the current value of the member variable backgroundImage.
                * @function
                * @returns {string.<{Path}>}
                */
                getBackgroundImage(): string | null | undefined;
                /**
                * Processes the current value of backgroundImage and forwards it to the target html container element.
                * @function
                */
                protected __processBackgroundImage(): void;
                /**
                * Sets the value of the member variable "backgroundImagePadding" if the new value is not equal to the current value
                * and calls the associated process function (processBackgroundImagePadding) after that.
                * @function
                * @param   {Padding}    valueNew     -   The new value for backgroundImagePadding.
                */
                setBackgroundImagePadding(valueNew: FourSidedCss | null): void;
                /**
                * Returns the current value of the member variable backgroundImagePadding.
                * @function
                * @returns {Padding}
                */
                getBackgroundImagePadding(): FourSidedCss | null | undefined;
                /**
                * Processes the current value of backgroundImagePadding and forwards it to the target span element in template html.
                * The current value of backgroundImagePadding is only forwarded if it is no binding expression.
                * @function
                */
                protected __processBackgroundImagePadding(): void;
                /**
                * Sets the value of the member variable "backgroundImageWidth" if the new value is not equal to the current value.
                * and calls the associated process function (processBackgroundImageWidth) after that.
                * @function
                * @param   {MeasurementValue}    valueNew     -   The new value for backgroundImageWidth.
                */
                setBackgroundImageWidth(valueNew: number | null): void;
                /**
                * Returns the current value of the member variable backgroundImageWidth.
                * @function
                * @returns {MeasurementValue}
                */
                getBackgroundImageWidth(): number | null | undefined;
                /**
                * Processes the current value of backgroundImageWidth and forwards it to the target html container element.
                * @function
                */
                protected __processBackgroundImageWidth(): void;
                /**
                * Sets the value of the member variable "backgroundImageWidthUnit" if the new value is not equal to the current value.
                * and calls the associated process function (processBackgroundImageWidthUnit) after that.
                * @function
                * @param   {MeasurementUnit}    valueNew     -   The new value for backgroundImageWidthUnit.
                */
                setBackgroundImageWidthUnit(valueNew: DimensionUnit | null): void;
                /**
                * Returns the current value of the member variable backgroundImageWidthUnit.
                * @function
                * @returns MeasurementUnit}
                */
                getBackgroundImageWidthUnit(): "px" | "%" | undefined;
                /**
                * Processes the current value of backgroundImageWidth and backgroundImageWidth unit and forwards it to the target html container element.
                * @function
                */
                protected __processBackgroundImageWidthUnit(): void;
                /**
                * Sets the value of the member variable "backgroundImageHeight" if the new value is not equal to the current value.
                * and calls the associated process function (processBackgroundImageHeight) after that.
                * @function
                * @param   {MeasurementValue}    valueNew     -   The new value for backgroundImageHeight.
                */
                setBackgroundImageHeight(valueNew: number | null): void;
                /**
                * Returns the current value of the member variable backgroundImageHeight.
                * @function
                * @returns {MeasurementValue}
                */
                getBackgroundImageHeight(): number | null | undefined;
                /**
                * Processes the current value of backgroundImageHeight and forwards it to the target html container element.
                * @function
                */
                protected __processBackgroundImageHeight(): void;
                /**
                * Sets the value of the member variable "backgroundImageHeightUnit" if the new value is not equal to the current value.
                * and calls the associated process function (processBackgroundImageHeightUnit) after that.
                * @function
                * @param   {MeasurementUnit}    valueNew     -   The new value for backgroundImageHeightUnit.
                */
                setBackgroundImageHeightUnit(valueNew: DimensionUnit | null): void;
                /**
                * Returns the current value of the member variable backgroundImageHeightUnit.
                * @function
                * @returns {MeasurementUnit}
                */
                getBackgroundImageHeightUnit(): "px" | "%" | undefined;
                /**
                * Processes the current value of backgroundImageHeight and forwards it to the target html container element.
                * @function
                */
                protected __processBackgroundImageHeightUnit(): void;
                /**
                * Sets the backgroundImageHorizontalAlignment value and calls the associated process function (processBackgroundImageHorizontalAlignment).
                * @function
                * @param   {string}    valueNew     -   The new value for backgroundImageHorizontalAlignment.
                */
                setBackgroundImageHorizontalAlignment(valueNew: TcHmi.HorizontalAlignment | null): void;
                /**
                * Returns the current value of horizontalBackgroundImageAligment.
                * @function
                * @returns      {string}       The current value of horizontalBackgroundImageAligment.
                */
                getBackgroundImageHorizontalAlignment(): "Left" | "Center" | "Right" | undefined;
                /**
                * Processes the current backgroundImageHorizontalAlignment attribute value.
                * @function
                */
                protected __processBackgroundImageHorizontalAlignment(): void;
                /**
                * Sets the backgroundImageVerticalAlignment value and calls the associated process function (processBackgroundImageVerticalAlignment).
                * @function
                * @param   {string}      valueNew     -   The new value for backgroundImageVerticalAlignment.
                */
                setBackgroundImageVerticalAlignment(valueNew: VerticalAlignment | null): void;
                /**
                * Returns the current value of backgroundImageVerticalAlignment.
                * @function
                * @returns      {string}     The current value of backgroundImageVerticalAlignment.
                */
                getBackgroundImageVerticalAlignment(): "Center" | "Top" | "Bottom" | undefined;
                /**
                * Processes the current backgroundImageVerticalAlignment attribute value.
                * @function
                */
                protected __processBackgroundImageVerticalAlignment(): void;
            }
            namespace TcHmiControl {
                interface IDomEventObj {
                    eventName: keyof HTMLElementEventMap;
                    listener: EventListener | EventListenerObject;
                    options: EventListenerOptions | boolean;
                }
            }
        }
    }
}
