var TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi;
/**
* Encodes HTML
* @param {string} html The html to encode
* @return {string} The encoded representation of parameter html.
* @preserve (Part of the public API)
*/
function tchmi_encode_html(e){return String(e).replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/"/g,"&#39;")}
/**
* Decodes HTML
* @param {string} text The text to decode
* @return {string} The decoded representation of parameter text.
"&#176;!\"&#167;$%&/()=?~#|&#233;&#232;€…™&#174;&#169;"
"°     !\"§     $%&/()=?~#|é     è     €…™®     ©"
 @preserve (Part of the public API)
*/function tchmi_decode_html(e){return String(e).replace(/\&amp;/g,"&").replace(/\&lt;/g,"<").replace(/\&gt;/g,">").replace(/\&quot;/g,'"').replace(/\&#39;/g,"'").replace(/\&#228;/g,"ä").replace(/\&#196;/g,"Ä").replace(/\&#246;/g,"ö").replace(/\&#214;/g,"Ö").replace(/\&#252;/g,"ü").replace(/\&#220;/g,"Ü").replace(/\&#223;/g,"ß").replace(/\&#233;/g,"é").replace(/\&#232;/g,"è").replace(/\&#176;/g,"°").replace(/\&#167;/g,"§").replace(/\&#174;/g,"®").replace(/\&#169;/g,"©").replace(/\&#181;/g,"µ")}
/**
* Converts formatted text to formatted html.
* @param {string} text The text which contains the formatting placeholders which shall be encoded.
* @return {string} The encoded representation of parameter text.
* @preserve (Part of the public API)
*/function tchmi_text_to_html(e){for(var r=e,t=0,o=r.length-1,n=0;n<=o;o--){if(" "!==r[o])break;t++}r=(r=(r=(r=r.substr(0,r.length-t)).replace(/\\s\\s/g," &nbsp;")).replace(/  /g," &nbsp;")).replace(/\\t/g,"&nbsp;&nbsp;&nbsp;");var i=[];for(o=0,n=t;o<n;o++)o%2==0?i.push("&nbsp;"):i.push(" ");for(o=i.length-1,n=0;n<=o;o--)r+=i[o];return r=(r=r.replace(/\\r\\n/g,"<br/>")).replace(/\\n/g,"<br/>")}
/**
* Decode base64 strings
* Attention: JS strings are UTF16!
* @param input
* @return {string} returns the String or null
* @preserve (Part of the public API)
*/function tchmi_base64decode(e){return window.atob(e)}
/**
* Encode base64 strings
* Attention: JS strings are UTF16!
* @param {string} input String to encode
* @return {string} returns the String or null
* @preserve (Part of the public API)
*/function tchmi_base64encode(e){return window.btoa(e)}
/**
* Creates a Guid string.
* @return {string} Guid
* @preserve (Part of the public API)
*/function tchmi_create_guid(){var t=Date.now();return"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(e){var r=(t+16*Math.random())%16|0;return t=Math.floor(t/16),("x"===e?r:7&r|8).toString(16)})}
/**
 * Compares 2 values for equality.
 * @param value1 Value 1
 * @param value2 Value 2
 * @param {boolean} bTypeSafe If set to "true" the comparison will return "false" if a {string} "1" is compared with {number} 1. If it is set to "false" the same comparison will return "true" because the value is rough equal.
 * @returns {boolean}
 * @preserve (Part of the public API)
 */function tchmi_equal(e,r,t){void 0===t&&(t=!0);var o=!1;switch(typeof e){case"undefined":switch(typeof r){case"undefined":o=!0;break;case"object":case"boolean":case"number":case"string":break;default:throw new ReferenceError("Type mismatch in tchmi_equal")}break;case"object":if(null===e)switch(typeof r){case"object":null===r&&(o=!0);break;case"undefined":case"boolean":case"number":case"string":break;default:throw new ReferenceError("Type mismatch in tchmi_equal")}else if(Array.isArray(e))switch(typeof r){case"object":null!==r&&(e instanceof TcHmi.Controls.System.baseTcHmiControl==!0&&r instanceof TcHmi.Controls.System.baseTcHmiControl==!0?o=e===r:e instanceof TcHmi.Controls.System.baseTcHmiControl==!0||r instanceof TcHmi.Controls.System.baseTcHmiControl==!0||Array.isArray(r)&&(o=JSON.stringify(e)===JSON.stringify(r)));break;case"undefined":case"boolean":case"number":case"string":break;default:throw new ReferenceError("Type mismatch in tchmi_equal")}else switch(typeof r){case"object":null!==r&&(e instanceof TcHmi.Controls.System.baseTcHmiControl==!0&&r instanceof TcHmi.Controls.System.baseTcHmiControl==!0?o=e===r:e instanceof TcHmi.Controls.System.baseTcHmiControl==!0||r instanceof TcHmi.Controls.System.baseTcHmiControl==!0||Array.isArray(r)||(o=JSON.stringify(e)===JSON.stringify(r)));break;case"undefined":case"boolean":case"number":case"string":break;default:throw new ReferenceError("Type mismatch in tchmi_equal")}break;case"boolean":switch(typeof r){case"boolean":o=e===r;break;case"string":if(!0===t);else switch(r.toLowerCase()){case"true":o=!0===e;break;case"false":o=!1===e}break;case"undefined":case"object":case"number":break;default:throw new ReferenceError("Type mismatch in tchmi_equal")}break;case"number":switch(typeof r){case"undefined":case"object":break;case"number":o=!(!isNaN(e)||!isNaN(r))||e===r;break;case"boolean":case"string":!0===t||(o=e==r);break;default:throw new ReferenceError("Type mismatch in tchmi_equal")}break;case"string":switch(typeof r){case"number":!0===t||(o=e==r);break;case"undefined":case"object":break;case"boolean":if(!0===t);else switch(e.toLowerCase()){case"true":o=!0===r;break;case"false":o=!1===r}break;case"string":o=e===r;break;default:throw new ReferenceError("Type mismatch in tchmi_equal")}break;default:throw new ReferenceError("Type mismatch in tchmi_equal")}return o}
/**
 * Clones the data {Object} in param obj and returns a clone of it.
 * Do not use this function to create clones of objects which contain functions or are based on a prototype definition!
 * String, null, undefined are returned directly as they are immutable / handled by value.
 * @function
 * @param {Object} obj The {Object} to clone.
 * @returns {Object} Clone of param obj.
 * @preserve (Part of the public API)
 */function tchmi_clone_object(e){var a=!1,s=function(e){void 0===s.__objectPrototype&&(s.__objectPrototype=Object.getPrototypeOf({})),void 0===s.__arrayPrototype&&(s.__arrayPrototype=Object.getPrototypeOf([]));var r=Object.getPrototypeOf(e);return null!==r&&r!==s.__objectPrototype&&r!==s.__arrayPrototype},l=function(e){var r,t=typeof e;if("function"===t)return a=!0,null;if(null===e||"object"!==t||s(e))return e;if(Array.isArray(e)){r=[];for(var o=0,n=e.length;o<n;o++)if(r[o]=l(e[o]),a)return null}else for(var i in r={},e)if(r[i]=l(e[i]),a)return null;return r},r=l(e);return a?e:r}
/**
 * Unify a path {string}.
 * Replace all backslashes with slashes, replace multiple slashes with single slashes, remove leading slash
 * @function
 * @param {string} path The path {string}
 * @return {string} Unified path {string}.
 * @preserve (Part of the public API)
 */function tchmi_path(e){return"string"==typeof e?e.replace(/\\+/g,"/").replace(/\/+/g,"/").replace(/^\/+/g,""):e}
/**
* Converts a String to a valid CSS id pattern by escaping all reserved characters.
* @param {string} id The target id.
* @returns {string} Converted id.
* @preserve (Part of the public API)
*/function tchmi_css_escape_selector(e){if("string"!=typeof e)return e;for(var r,t=e.length,o=-1,n="",i=e.charCodeAt(0);++o<t;)0!==(r=e.charCodeAt(o))?n+=1<=r&&r<=31||127===r||0===o&&48<=r&&r<=57||1===o&&48<=r&&r<=57&&45===i?"\\"+r.toString(16)+" ":(0!==o||1!==t||45!==r)&&(128<=r||45===r||95===r||48<=r&&r<=57||65<=r&&r<=90||97<=r&&r<=122)?e.charAt(o):"\\"+e.charAt(o):n+="�";return n}
/**
 * tchmi_escape_regex
 * @param {string} s
 * @returns {string}
 * @preserve (Part of the public API)
 */function tchmi_escape_regex(e){return e.replace(/[.*+?^${}()|[\]\\]/g,"\\$&")}!function(e){var r;(r=e.Errors||(e.Errors={}))[r.NONE=0]="NONE",r[r.ERROR=1]="ERROR",r[r.E_PARAMETER_INVALID=2]="E_PARAMETER_INVALID",r[r.E_TIMEOUT=3]="E_TIMEOUT",r[r.E_EXCEPTION=4]="E_EXCEPTION",r[r.E_INVALID=5]="E_INVALID",r[r.E_NOT_SUPPORTED=100]="E_NOT_SUPPORTED",r[r.E_NOT_ALLOWED=110]="E_NOT_ALLOWED",r[r.E_UNKNOWN=115]="E_UNKNOWN",r[r.E_UNKNOWN_TYPE=120]="E_UNKNOWN_TYPE",r[r.E_KEY_NOT_FOUND=130]="E_KEY_NOT_FOUND",r[r.E_TYPE_INVALID=150]="E_TYPE_INVALID",r[r.E_WEBSOCKET_NOT_READY=1e3]="E_WEBSOCKET_NOT_READY",r[r.E_WEBSOCKET_NOT_SUPPORTED=1404]="E_WEBSOCKET_NOT_SUPPORTED",r[r.E_WEBSOCKET_OPEN_SERVER_LICENSE_CHECK_FAILED=1500]="E_WEBSOCKET_OPEN_SERVER_LICENSE_CHECK_FAILED",r[r.E_WEBSOCKET_OPEN_SERVER_LICENSE_MISSING=1501]="E_WEBSOCKET_OPEN_SERVER_LICENSE_MISSING",r[r.E_WEBSOCKET_OPEN_SERVER_NO_ACCESS=1502]="E_WEBSOCKET_OPEN_SERVER_NO_ACCESS",r[r.E_SYMBOL_STATE_INVALID=2e3]="E_SYMBOL_STATE_INVALID",r[r.E_SYMBOL_VALUE_INVALID=2001]="E_SYMBOL_VALUE_INVALID",r[r.E_SYMBOL_RESOLVE_SCHEMA=2002]="E_SYMBOL_RESOLVE_SCHEMA",r[r.E_SYMBOL_READONLY=2003]="E_SYMBOL_READONLY",r[r.E_SYMBOL_UNKNOWN=2010]="E_SYMBOL_UNKNOWN",r[r.E_SYMBOL_INVALID_DATA_PROVIDER_ENTRY=2020]="E_SYMBOL_INVALID_DATA_PROVIDER_ENTRY",r[r.E_SERVER_RESPONSE_ERROR=3e3]="E_SERVER_RESPONSE_ERROR",r[r.E_SERVER_COMMAND_ERROR=3005]="E_SERVER_COMMAND_ERROR",r[r.E_SERVER_INVALID_RESPONSE=3010]="E_SERVER_INVALID_RESPONSE",r[r.E_SERVER_COMMANDS_MISSING=3015]="E_SERVER_COMMANDS_MISSING",r[r.E_SERVER_COMMAND_MISSING=3016]="E_SERVER_COMMAND_MISSING",r[r.E_SERVER_READVALUE_MISSING=3020]="E_SERVER_READVALUE_MISSING",r[r.E_SERVER_WRITEVALUE_MISSING=3025]="E_SERVER_WRITEVALUE_MISSING",r[r.E_SERVER_RESPONSE_MISSING=3030]="E_SERVER_RESPONSE_MISSING",r[r.E_FUNCTION_MISSING_FUNCTION_REFERENCE=4e3]="E_FUNCTION_MISSING_FUNCTION_REFERENCE",r[r.E_FUNCTION_MISSING_FUNCTION_DESCRIPTION=4005]="E_FUNCTION_MISSING_FUNCTION_DESCRIPTION",r[r.E_FUNCTION_INVALID_CONFIGURATION=4010]="E_FUNCTION_INVALID_CONFIGURATION",r[r.E_FUNCTION_EXCEPTION=4020]="E_FUNCTION_EXCEPTION",r[r.E_FUNCTION_UNKNOWN=4030]="E_FUNCTION_UNKNOWN",r[r.E_FUNCTION_RESTPARAMETER_DEFINITION_MISSING=4040]="E_FUNCTION_RESTPARAMETER_DEFINITION_MISSING",r[r.E_FUNCTION_EXPRESSION_PARSER_ERROR=4100]="E_FUNCTION_EXPRESSION_PARSER_ERROR",r[r.E_FUNCTION_EXPRESSION_EXCEPTION=4120]="E_FUNCTION_EXPRESSION_EXCEPTION",r[r.E_TRIGGER_ACTION_EXCEPTION=5050]="E_TRIGGER_ACTION_EXCEPTION",r[r.E_TRIGGER_JAVASCRIPT_EVAL_EXCEPTION=5055]="E_TRIGGER_JAVASCRIPT_EVAL_EXCEPTION",r[r.E_TRIGGER_FUNCTION_EXPRESSION_EXCEPTION=5060]="E_TRIGGER_FUNCTION_EXPRESSION_EXCEPTION",r[r.E_TRIGGER_RESOLVE_CONDITION_EXPRESSION_EXCEPTION=5065]="E_TRIGGER_RESOLVE_CONDITION_EXPRESSION_EXCEPTION",r[r.E_CONTROL_INSTANCE_NOT_FOUND=6e3]="E_CONTROL_INSTANCE_NOT_FOUND",r[r.E_CONTROL_INVALID_CONFIGURATION=6001]="E_CONTROL_INVALID_CONFIGURATION",r[r.E_CONTROL_ATTRIBUTE_NOT_FOUND=6005]="E_CONTROL_ATTRIBUTE_NOT_FOUND",r[r.E_CONTROL_ATTRIBUTE_INVALID_CONFIGURATION=6010]="E_CONTROL_ATTRIBUTE_INVALID_CONFIGURATION"}(TcHmi||(TcHmi={})),function(t){var e=function(){function _(e,r){this.__canvas=null,this.__context=null,this.__run=!1,this.__color={r:0,g:0,b:0,a:0},this.__host=e,t.isSolidColor(r)&&(this.__color=t.StyleProvider.resolveSolidColorAsRGBA(r))}return _.prototype.setColor=function(e){t.isSolidColor(e)&&(this.__color=t.StyleProvider.resolveSolidColorAsRGBA(e),this.__key&&_.__clientMap[this.__key]&&(_.__clientMap[this.__key].color=this.__color))},_.__frame=function(){_.__frameRequestId=window.requestAnimationFrame(_.__frame);var e=(new Date).getTime();if(!(e-_.__then<=1e3/30))for(var r in _.__then=e,_.__clientMap){var t=_.__clientMap[r];if(t){var o=t.context,n=t.color,i=o.canvas.width,a=o.canvas.height;i===o.canvas.clientWidth&&a===o.canvas.clientHeight||(o.canvas.width=o.canvas.clientWidth,o.canvas.height=o.canvas.clientHeight);var s=Math.floor(((new Date).getTime()-_.__start.getTime())/1e3*_.__lines)/_.__lines;o.save(),o.lineCap="round",o.clearRect(0,0,i,a),o.translate(i/2,a/2),o.rotate(2*Math.PI*s);for(var l=0,c=_.__lines;l<c;l++)o.beginPath(),o.rotate(2*Math.PI/_.__lines),o.moveTo(i/10,0),o.lineTo(i/4,0),o.lineWidth=a/30,o.strokeStyle="rgba("+n.r+", "+n.g+", "+n.b+","+l/_.__lines+")",o.stroke();o.restore()}}},_.prototype.run=function(){!0!==this.__run&&this.__host&&(this.__run=!0,this.__canvas||(this.__canvas=document.createElement("canvas"),this.__canvas.setAttribute("style","width:100%;height:100%;display:block;"),this.__context=this.__canvas.getContext("2d")),this.__host.empty(),this.__host.append(this.__canvas),this.__key=_.__clientCount.toString(),_.__clientMap[this.__key]={context:this.__context,color:this.__color},_.__clientCount++,_.__frameRequestId||(_.__frameRequestId=window.requestAnimationFrame(_.__frame)))},_.prototype.stop=function(){!1!==this.__run&&this.__host&&(this.__host.empty(),_.__clientCount--,delete _.__clientMap[this.__key],_.__clientCount<=0&&_.__frameRequestId&&(window.cancelAnimationFrame(_.__frameRequestId),_.__frameRequestId=0),this.__run=!1)},_.prototype.destroy=function(){this.stop(),this.__canvas&&this.__canvas.parentElement&&this.__canvas.parentElement.removeChild(this.__canvas),this.__canvas=null,this.__context=null,this.__host=null},_.__frameRequestId=0,_.__then=0,_.__clientMap={},_.__clientCount=0,_.__start=new Date,_.__lines=16,_}();t.LoadingSpinner=e}(TcHmi||(TcHmi={})),function(e){if(!window.hasOwnProperty("jQuery")||null===jQuery)throw new ReferenceError('Object "jQuery" is missing!');if(!window.hasOwnProperty("$")||null===$)throw new ReferenceError('Object "$" is missing!');if(!window.hasOwnProperty("acorn")||null===acorn)throw new ReferenceError('Object "acorn" is missing!');TCHMI_DEBUG_TIME_LOAD_LIBRARY=Date.now(),TCHMI_DYNAMIC_INSTANCE_ID="unset",window.hasOwnProperty("TCHMI_ENABLE_DESIGNER_MODE")||(TCHMI_ENABLE_DESIGNER_MODE=!1),window.hasOwnProperty("TCHMI_ENABLE_DESIGNER_MODE_MASTER")||(TCHMI_ENABLE_DESIGNER_MODE_MASTER=!1),window.hasOwnProperty("TCHMI_ENABLE_DESIGNER_MODE_SLAVE")||(TCHMI_ENABLE_DESIGNER_MODE_SLAVE=!1),window.hasOwnProperty("TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL")?TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL=tchmi_path(TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL):TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL="",window.hasOwnProperty("TCHMI_ENABLE_DESIGNER_MODE_FALLBACK_CONFIG_JSON")||(TCHMI_ENABLE_DESIGNER_MODE_FALLBACK_CONFIG_JSON=null),window.hasOwnProperty("TCHMI_CONSOLE_LOG_LEVEL")||(TCHMI_CONSOLE_LOG_LEVEL=0),window.hasOwnProperty("TCHMI_CONSOLE_LOG_TCHMISERVER_MESSAGES")||(TCHMI_CONSOLE_LOG_TCHMISERVER_MESSAGES=!1),window.hasOwnProperty("TCHMI_CONSOLE_LOG_DESIGNER_MODE_COM_MESSAGES")||(TCHMI_CONSOLE_LOG_DESIGNER_MODE_COM_MESSAGES=!1),window.hasOwnProperty("TCHMI_UNITTEST_MODE")||(TCHMI_UNITTEST_MODE=!1),window.hasOwnProperty("TCHMI_BENCHMARK_MODE")||(TCHMI_BENCHMARK_MODE=!1),window.hasOwnProperty("TCHMI_EVENT_OPTION_OBJECT_SUPPORTED")||(TCHMI_EVENT_OPTION_OBJECT_SUPPORTED=!1);try{window.addEventListener("test",null,Object.defineProperty({},"capture",{get:function(){TCHMI_EVENT_OPTION_OBJECT_SUPPORTED=!0}}))}catch(e){}}(TcHmi||(TcHmi={})),function(l){
/**
    * Allows converting of values from any type to any type if types are compatible.
    * @class ValueConverter
    * @memberOf TcHmi
    * @preserve (Part of the public API)
    */
var e=function(){function s(){}
/**
         * Converts a value to {Object/Array} and returns the {Object/Array} as a clone or null if the type of value is not compatible to {Object/Array}.
         * No content check will be done!
         * @function toObject
         * @memberOf TcHmi.ValueConverter
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string|number|boolean|Object|Array} defaultValue The fallback value (null if not given)
         * @returns {Object|Array|null}
         * @preserve (Part of the public API)
         */return s.toObject=function(e,r){void 0===r&&(r=null);var t=r;if("string"==typeof e&&""!==e)try{t=JSON.parse(e)}catch(e){}else"object"==typeof e&&null!==e&&(t=tchmi_clone_object(e));return t},
/**
         * Converts a value to {string} and returns the {string} or null if the type of value is not compatible to {string}.
         * @function toString
         * @memberOf TcHmi.ValueConverter
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible to string (null if not given)
         * @returns {string} returns the {string} or defaultValue if the type of value is not compatible to {string}.
         * @preserve (Part of the public API)
         */
s.toString=function(e,r){void 0===r&&(r=null);var t=r;switch(typeof e){case"boolean":case"number":t=e.toString();break;case"object":null!==e&&e instanceof l.Controls.System.baseTcHmiControl!=!0&&e instanceof Element!=!0&&(t=JSON.stringify(e));break;case"string":t=e}return t},
/**
         * Converts a value to enum value and returns the string or null if the type of value is not compatible to the enum.
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible with the enum (null if not given)
         * @returns {string} returns the {string} or null if the type of value is not compatible to the enum.
         * @preserve (Part of the public API)
         */
s.toDimensionUnit=function(e,r){return s.toEnum(e,s.DimensionUnitList,r)},
/**
         * Converts a value to enum value and returns the string or null if the type of value is not compatible to the enum.
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible with the enum (null if not given)
         * @returns {string} returns the {string} or null if the type of value is not compatible to the enum.
         * @preserve (Part of the public API)
         */
s.toAngleUnit=function(e,r){return s.toEnum(e,s.AngleUnitList,r)},
/**
         * Converts a value to enum value and returns the string or null if the type of value is not compatible to the enum.
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible with the enum (null if not given)
         * @returns {string} returns the {string} or null if the type of value is not compatible to the enum.
         * @preserve (Part of the public API)
         */
s.toBorderStyleValue=function(e,r){return s.toEnum(e,s.BorderStyleValueList,r)},
/**
         * Converts a value to enum value and returns the string or null if the type of value is not compatible to the enum.
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible with the enum (null if not given)
         * @returns {string} returns the {string} or null if the type of value is not compatible to the enum.
         * @preserve (Part of the public API)
         */
s.toFontStyle=function(e,r){return s.toEnum(e,s.FontStyleList,r)},
/**
         * Converts a value to enum value and returns the string or null if the type of value is not compatible to the enum.
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible with the enum (null if not given)
         * @returns {string} returns the {string} or null if the type of value is not compatible to the enum.
         * @preserve (Part of the public API)
         */
s.toFontSizeUnit=function(e,r){return s.toEnum(e,s.FontSizeUnitList,r)},
/**
         * Converts a value to enum value and returns the string or null if the type of value is not compatible to the enum.
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible with the enum (null if not given)
         * @returns {string} returns the {string} or null if the type of value is not compatible to the enum.
         * @preserve (Part of the public API)
         */
s.toFontWeight=function(e,r){return s.toEnum(e,s.FontWeightList,r)},
/**
         * Converts a value to enum value and returns the string or null if the type of value is not compatible to the enum.
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible with the enum (null if not given)
         * @returns {string} returns the {string} or null if the type of value is not compatible to the enum.
         * @preserve (Part of the public API)
         */
s.toHorizontalAlignment=function(e,r){return s.toEnum(e,s.HorizontalAlignmentList,r)},
/**
         * Converts a value to enum value and returns the string or null if the type of value is not compatible to the enum.
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible with the enum (null if not given)
         * @returns {string} returns the {string} or null if the type of value is not compatible to the enum.
         * @preserve (Part of the public API)
         */
s.toScaleModeString=function(e,r){return s.toEnum(e,s.ScaleModeStringList,r)},
/**
         * Converts a value to enum value and returns the string or null if the type of value is not compatible to the enum.
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible with the enum (null if not given)
         * @returns {string} returns the {string} or null if the type of value is not compatible to the enum.
         * @preserve (Part of the public API)
         */
s.toSizeMode=function(e,r){return s.toEnum(e,s.SizeModeList,r)},
/**
         * Converts a value to enum value and returns the string or null if the type of value is not compatible to the enum.
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible with the enum (null if not given)
         * @returns {string} returns the {string} or null if the type of value is not compatible to the enum.
         * @preserve (Part of the public API)
         */
s.toSizeModeWithContent=function(e,r){return s.toEnum(e,s.SizeModeWithContentList,r)},
/**
         * Converts a value to enum value and returns the string or null if the type of value is not compatible to the enum.
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible with the enum (null if not given)
         * @returns {string} returns the {string} or null if the type of value is not compatible to the enum.
         * @preserve (Part of the public API)
         */
s.toVerticalAlignment=function(e,r){return s.toEnum(e,s.VerticalAlignmentList,r)},
/**
         * Converts a value to enum value and returns the string or null if the type of value is not compatible to the enum.
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible with the enum (null if not given)
         * @returns {string} returns the {string} or null if the type of value is not compatible to the enum.
         * @preserve (Part of the public API)
         */
s.toVisibility=function(e,r){return s.toEnum(e,s.VisibilityList,r)},
/**
         * Converts a value to enum value and returns the string or null if the type of value is not compatible to the enum.
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible with the enum (null if not given)
         * @returns {string} returns the {string} or null if the type of value is not compatible to the enum.
         * @preserve (Part of the public API)
         */
s.toToggleState=function(e,r){return s.toEnum(e,s.ToggleStateList,r)},
/**
         * Converts a value to fontFamily value and returns the string or null if the type of value is not compatible to {string}.
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible with the enum (null if not given)
         * @returns {string} returns the {string} or null if the type of value is not compatible to string.
         * @preserve (Part of the public API)
         */
s.toFontFamily=function(e,r){return s.toString(e,r)},
/**
         * Converts a value to {number}
         * @function toNumber
         * @memberOf TcHmi.ValueConverter
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible to number (null if not given)
         * @returns {number} returns the {number} or the defaultValue if the type of value is not compatible to {number}.
         * @preserve (Part of the public API)
         */
s.toNumber=function(e,r){void 0===r&&(r=null);var t=r;switch(typeof e){case"string":t=parseFloat(e),isNaN(t)&&(t=r);break;case"boolean":switch(e){case!0:t=1;break;case!1:t=0}break;case"number":t=e,isNaN(e)&&(t=r)}return t},
/**
         * Converts a value to {boolean} and returns the {boolean} or null if the type of value is not compatible to {boolean}.
         * @function toBoolean
         * @memberOf TcHmi.ValueConverter
         * @param {string|number|boolean|Object|Array} value The value to convert.
         * @param {string} defaultValue Value which should be returned if value is not compatible to boolean (null if not given)
         * @returns {boolean}
         * @preserve (Part of the public API)
         */
s.toBoolean=function(e,r){void 0===r&&(r=null);var t=r;switch(typeof e){case"string":switch(e.toLowerCase()){case"true":t=!0;break;case"false":t=!1}break;case"number":switch(e){case 1:t=!0;break;case 0:t=!1}break;case"boolean":t=e}return t},
/**
         * Converts a value to enum {number} and returns the enum {number} or null if the type of value is not compatible to enum {Object}.
         * @function toEnum
         * @memberOf TcHmi.ValueConverter
         * @param {string|number|boolean|Object|Array} value  The value to convert.
         * @param {Object} enumType The enum {Object}.
         * @param {number} defaultValue Value which should be returned if value is not compatible with the enum (null if not given)
         * @returns number
         * @preserve (Part of the public API)
         */
s.toEnum=function(e,r,t){void 0===t&&(t=null);var o=t;switch(typeof e){case"string":if(""===e)break;var n=parseInt(e,10);isNaN(n)?(void 0===(o=r[e])&&(o=r[e.toLowerCase()]),void 0===o&&(o=r[e.toUpperCase()]),void 0===o&&(o=t)):o=this.toEnum(n,r,t);break;case"number":void 0!==r[e]&&(o=e);break;case"boolean":o=this.toEnum(this.toNumber(e),r,t)}return o},
/**
         *
         * @function toType
         * @memberOf TcHmi.ValueConverter
         * @param {string|number|boolean|Object|Array} value
         * @param {string} typeString
         * @returns {string|number|boolean|Object|Array}
         * @preserve (Part of the public API)
         */
s.toType=function(e,r){var t=l.System.Services.typeManager.getSchema(r);return null===t?null:s.toSchemaType(e,t)},
/**
         *
         * @function toType
         * @memberOf TcHmi.ValueConverter
         * @param {string|number|boolean|Object|Array} value
         * @param {Object} schema
         * @returns {string|number|boolean|Object|Array}
         * @preserve (Part of the public API)
         */
s.toSchemaType=function(e,r){if(null==e)return null;if(null==r)return null;var t=l.System.Schema.resolveType(r);if("string"!=typeof t&&!Array.isArray(t))return null;if(Array.isArray(t)){var o=typeof e;if("string"===o||"number"===o||"boolean"===o||"object"===o){if(-1!==t.indexOf(o))return e;for(var n=0,i=t.length;n<i;n++){var a=null;switch(t[n]){case"object":case"array":a=s.toObject(e);break;case"string":a=s.toString(e);break;case"integer":case"number":a=s.toNumber(e);break;case"boolean":a=s.toBoolean(e)}if(null!==a)return a}}}else switch(t){case"object":case"array":return s.toObject(e);case"string":return s.toString(e);case"integer":case"number":return s.toNumber(e);case"boolean":return s.toBoolean(e)}return null},s.AngleUnitList={deg:"deg",rad:"rad",turn:"turn",grad:"grad"},s.BorderStyleValueList={Solid:"Solid",Dashed:"Dashed",Dotted:"Dotted",None:"None"},s.DimensionUnitList={px:"px","%":"%"},s.FontSizeUnitList={px:"px","%":"%",em:"em",rem:"rem"},s.FontStyleList={Normal:"Normal",Italic:"Italic",Oblique:"Oblique",Auto:"Auto"},s.FontWeightList={Normal:"Normal",Bold:"Bold",Auto:"Auto"},s.HorizontalAlignmentList={Left:"Left",Center:"Center",Right:"Right"},s.ScaleModeStringList={None:"None",ScaleToFill:"ScaleToFill",ScaleToFit:"ScaleToFit",ScaleToFitWidth:"ScaleToFitWidth",ScaleToFitHeight:"ScaleToFitHeight"},s.SizeModeList={Value:"Value",Parent:"Parent"},s.SizeModeWithContentList={Value:"Value",Parent:"Parent",Content:"Content"},s.ToggleStateList={Normal:"Normal",Active:"Active"},s.VerticalAlignmentList={Top:"Top",Center:"Center",Bottom:"Bottom"},s.VisibilityList={Visible:"Visible",Hidden:"Hidden",Collapsed:"Collapsed"},s}();l.ValueConverter=e}(TcHmi||(TcHmi={})),function(e){var r,t;e.isSolidColor=function(e){return null!=e&&"string"==typeof e.color},e.isLinearGradientColor=function(e){if(null==e)return!1;var r=e.angle;return!(!Array.isArray(e.stopPoints)||"number"!=typeof r&&("string"!=typeof r||isNaN(parseFloat(r))))},e.isBackground=
/**
     * Checks if the parameter is a TcHmi.Background
     * @param {object} background
     * @returns {boolean}
     * @preserve (Part of the public API)
     */
function(e){return null!=e&&void 0!==e.color&&void 0!==e.image&&void 0!==e.imageWidth&&void 0!==e.imageWidthUnit&&void 0!==e.imageHeight&&void 0!==e.imageHeightUnit&&void 0!==e.imageHorizontalAlignment&&void 0!==e.imageVerticalAlignment&&void 0!==e.imagePadding},e.isTranslate=
/**
     * Checks if the parameter is a TcHmi.checkTransform
     * @param {Transform | null} checkTransform
     * @returns {boolean}
     * @preserve (Part of the public API)
     */
function(e){return!!e&&"Translate"===e.transformType},e.isRotate=
/**
     * Checks if the parameter is a TcHmi.Rotate
     * @param {Transform | null} checkTransform
     * @returns {boolean}
     * @preserve (Part of the public API)
     */
function(e){return!!e&&"Rotate"===e.transformType},e.isScale=
/**
     * Checks if the parameter is a TcHmi.Scale
     * @param {Transform | null} checkTransform
     * @returns {boolean}
     * @preserve (Part of the public API)
     */
function(e){return!!e&&"Scale"===e.transformType},e.isSkew=
/**
     * Checks if the parameter is a TcHmi.Skew
     * @param {Transform | null} checkTransform
     * @returns {boolean}
     * @preserve (Part of the public API)
     */
function(e){return!!e&&"Skew"===e.transformType},e.isOrigin=
/**
     * Checks if the parameter is a TcHmi.Origin
     * @param {Transform | null} checkTransform
     * @returns {boolean}
     * @preserve (Part of the public API)
     */
function(e){return!!e&&"Origin"===e.transformType},e.isPerspective=
/**
     * Checks if the parameter is a TcHmi.Perspective
     * @param {Transform | null} checkTransform
     * @returns {boolean}
     * @preserve (Part of the public API)
     */
function(e){return!!e&&"Perspective"===e.transformType},(r=e.IFunction||(e.IFunction={})).isStaticValue=function(e){return e&&"StaticValue"===e.objectType},r.isSymbol=function(e){return e&&"Symbol"===e.objectType},r.isEventDataObject=function(e){return e&&"EventDataObject"===e.objectType},r.isFunctionExpression=function(e){return e&&"FunctionExpression"===e.objectType},(t=e.Endianness||(e.Endianness={}))[t.LittleEndian=0]="LittleEndian",t[t.BigEndian=1]="BigEndian",e.isComparison=function(e){var r=typeof e.value;return-1!==["==","!=","<",">","<=",">=","contains","contains not","== [ignore case]","!= [ignore case]","contains [ignore case]","contains not [ignore case]"].indexOf(e.comparator)&&("string"===r||"number"===r||"boolean"===r||e.value instanceof Date)},e.isLogicOperator=function(e){return"AND"===e.logic||"OR"===e.logic}}(TcHmi||(TcHmi={})),function(e){var r;(r=e.System||(e.System={})).SharedResources||(r.SharedResources={})}(TcHmi||(TcHmi={})),function(e){
/**
     *
     * @preserve (Part of the public API)
     */
var n,t;n=e.Log||(e.Log={}),t=null,n.error=
/**
        * Prints out an error message in the browsers console if TCHMI_CONSOLE_LOG_LEVEL is set to 1 or higher.
        * If the message is an object it will be inspectable in most debug tools
        * @function
        * @param {string | object} message The text which will be printed out in the browsers console.
        * @preserve (Part of the public API)
        */
function(e,r){void 0===r&&(r=!1),TCHMI_CONSOLE_LOG_LEVEL<1||console&&console.error&&(!1===r&&"object"!=typeof e?console.error("["+(new Date).toISOString()+"][Error] "+e):console.error(e))},n.warn=
/**
        * Prints out a warning message in the browsers console if TCHMI_CONSOLE_LOG_LEVEL is set to 2 or higher.
        * If the message is an object it will be inspectable in most debug tools
        * @function
        * @param {string | object} message The text which will be printed out in the browsers console
        * @preserve (Part of the public API)
        */
function(e,r){void 0===r&&(r=!1),TCHMI_CONSOLE_LOG_LEVEL<2||console&&console.warn&&(!1===r&&"object"!=typeof e?console.warn("["+(new Date).toISOString()+"][Warning] "+e):console.warn(e))},n.info=
/**
        * Prints out an info message in the browsers console if TCHMI_CONSOLE_LOG_LEVEL is set to 3 or higher.
        * If the message is an object it will be inspectable in most debug tools
        * @function
        * @param {string | object} message The text which will be printed out in the browsers console
        * @preserve (Part of the public API)
        */
function(e,r){void 0===r&&(r=!1),TCHMI_CONSOLE_LOG_LEVEL<3||console&&console.info&&(!1===r&&"object"!=typeof e?console.info("["+(new Date).toISOString()+"][Info] "+e):console.info(e))},n.debug=
/**
        * Prints out a debug message in the browsers console if TCHMI_CONSOLE_LOG_LEVEL is set to 4 or higher.
        * If the message is an object it will be inspectable in most debug tools
        * @function
        * @param {string | object} message The text which will be printed out in the browsers console.
        * @preserve (Part of the public API)
        */
function(e,r){void 0===r&&(r=!1),TCHMI_CONSOLE_LOG_LEVEL<4||console&&console.log&&(!1===r&&"object"!=typeof e?console.log("["+(new Date).toISOString()+"][Debug] "+e):console.log(e))},n.performanceLog=function(e){if(!(TCHMI_CONSOLE_LOG_LEVEL<4)&&window.console&&window.console.time&&window.console.timeEnd){var r="["+(new Date).toISOString()+"][Performance] "+e;null!==t&&window.console.timeEnd(t),"[Source=Framework, Module=TcHmi] End"!==e?(window.console.time(r),t=r):t=null}},n.buildMessage=function(e){if(!e)return"";var r="Error: ";if(e.code&&(r+="Code: "+e.code+"/0x"+e.code.toString(16)),e.message&&(r+=", Message: "+e.message),e.reason&&(r+=", Reason: "+e.reason),e.domain&&(r+=", Domain: "+e.domain),void 0!==e.errors&&e.errors.length){r+=", as result of:\n";for(var t=0,o=e.errors.length;t<o;t++)0<t&&(r+=", "),r+=n.buildMessage(e.errors[t])}return r}}(TcHmi||(TcHmi={}));var __extends=this&&this.__extends||function(){var o=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,r){e.__proto__=r}||function(e,r){for(var t in r)r.hasOwnProperty(t)&&(e[t]=r[t])};return function(e,r){function t(){this.constructor=e}o(e,r),e.prototype=null===r?Object.create(r):(t.prototype=r.prototype,new t)}}(),TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi,TcHmi;function gIsolatedEval_TcHmi_System_FunctionExpression_Results(s,resSE,resFCE){return eval(s)}function gIsolatedEval_TcHmi_System_FunctionExpression(s){return eval(s)}function gIsolatedEval_TcHmi_System_TriggerManager_JavaScriptAction(ctx,s){return eval(s)}function gIsolatedEval_TcHmi_System_TriggerManager_ConditionExpressionsResult(s,results){return eval(s)}!function(o){var e=function(r){function t(){var e=r.call(this)||this;return e.__proto__!==o.List.prototype&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t.prototype):e.__proto__=t.prototype),e}return __extends(t,r),t.prototype.first=function(e){for(var r=0,t=this.length;r<t;r++)if(e(this[r]))return this[r];throw new Error("Array does not contain elements")},t.prototype.firstOrDefault=function(e,r){void 0===r&&(r=null);for(var t=0,o=this.length;t<o;t++)if(e(this[t]))return this[t];return null},t.prototype.remove=function(e){for(var r=0,t=this.length;r<t;r++)if(this[r]===e)return this.splice(r,1),!0;return!1},t.prototype.addRange=function(e){for(var r=0,t=e.length;r<t;r++)this.push(e[r])},t.prototype.clearAll=function(){for(;0<this.length;)this.pop()},t.prototype.findIndex=function(e){for(var r=0,t=this.length;r<t;r++)if(e(this[r]))return r;return-1},t}(Array);o.List=e}(TcHmi||(TcHmi={})),function(o){var e,r,t,n;e=o.Engineering||(o.Engineering={}),n=function(){function e(){}return e.add=function(e,r,t){o.System.Services.Engineering.errorPane&&o.System.Services.Engineering.errorPane.add(e,r,t)},e.remove=function(e){o.System.Services.Engineering.errorPane&&o.System.Services.Engineering.errorPane.remove(e)},e}(),e.ErrorPane=n,r=n=e.ErrorPane||(e.ErrorPane={}),(t=r.MessageType||(r.MessageType={}))[t.Message=0]="Message",t[t.Error=1]="Error",t[t.Warning=2]="Warning",t[t.Information=3]="Information"}(TcHmi||(TcHmi={})),function(S){!function(e){var E,r,f,t;function o(e){for(var r=e.attr("data-tchmi-target-user-control"),t=e.attr("data-tchmi-type"),o={},n=void 0!==r?S.System.Caches.partialCompositeConfigCache[tchmi_path(r.replace(".usercontrol",".usercontrol.json"))]:null,i=e.children(),a=0,s=i.length;a<s;a++){var l=i.eq(a);if("application/json"===l.attr("type")&&void 0!==l.attr("data-tchmi-target-attribute")){var c=l.attr("data-tchmi-target-attribute");if(null!==(g={name:c,value:S.ValueConverter.toObject(l[0].innerHTML,null),valueType:f.Complex,type:E.General,descr:S.System.Services.controlManager.getDescriptionAttributeByName(t,c)}).descr&&(g.type=E.Control),null!=n&&void 0!==n.parameters&&null!==n.parameters)for(var _=0,u=n.parameters.length;_<u;_++)n.parameters[_].name===g.name&&(g.descr=n.parameters[_],null!==g.descr&&(g.type=E.UserControlParameter));o[g.name]=g}}for(a=0,s=e.length;a<s;a++)for(var d=e[a],m=d.attributes.length,h=0;h<m;h++){var g,p=d.attributes[h];if(null!==(g={name:p.name,value:p.value,type:E.Invalid,valueType:f.Simple,descr:S.System.Services.controlManager.getDescriptionAttributeByName(t,p.name)}).descr&&(g.type=E.Control),null!=n&&void 0!==n.parameters&&null!==n.parameters)for(_=0,u=n.parameters.length;_<u;_++)n.parameters[_].name===g.name&&(g.descr=n.parameters[_],null!==g.descr&&(g.type=E.UserControlParameter));o[g.name]=g}return o}(r=E=e.ControlAttributeType||(e.ControlAttributeType={}))[r.Invalid=0]="Invalid",r[r.General=1]="General",r[r.Control=2]="Control",r[r.UserControlParameter=3]="UserControlParameter",(t=f=e.ControlAttributeValueType||(e.ControlAttributeValueType={}))[t.Invalid=0]="Invalid",t[t.Simple=1]="Simple",t[t.Complex=2]="Complex",e.resolveControlHierarchy=function(e,r){void 0===r&&(r=null);var t=[];if("function"==typeof e.getChildren)for(var o=e.getChildren(),n=0,i=o.length;n<i;n++)t.push(S.System.resolveControlHierarchy(o[n],e));return{ctrl:e,children_hierarchy:t,pctrl:r}},e.resolveAttributesFromControlObject=function(e){return o(e.__pcElement)},e.resolveAttributesFromControlElement=o,e.resolveElementStyleDimensions=function(e){var r=e.clone(),t=$("<div></div>");t.css("display","none"),t.append(r),S.System.SharedResources.jqBody.append(t);var o=window.getComputedStyle(r[0],null),n={width:o.width?o.width:"auto",height:o.height?o.height:"auto",top:o.top?o.top:"auto",left:o.left?o.left:"auto",right:o.right?o.right:"auto",bottom:o.bottom?o.bottom:"auto"};return t.remove(),n},e.toCamelCase=function(e){var r="";if(null==e||""===e)return r;for(var t=e,o=0,n=t.length;o<n;o++){var i=t[o];0!==o?"-"===t[o-1]?r+=i.toUpperCase():"-"!==i&&(r+=i):r+=i.toUpperCase()}return r},e.toDashCase=function(e){var r="";if(null==e||""===e)return r;for(var t=e,o=0,n=t.length;o<n;o++){var i=t[o];"-"!==i&&i.toUpperCase()===i&&0<o?r+="-"+i:r+=i}return r.toLowerCase()},e.tchmi_utf8str_base64decode=function(e){try{return decodeURIComponent(Array.prototype.map.call(window.atob(e),function(e){return"%"+("00"+e.charCodeAt(0).toString(16)).slice(-2)}).join(""))}catch(e){return null}},e.tchmi_utf8str_base64encode=function(e){try{return window.btoa(encodeURIComponent(e).replace(/%([0-9A-F]{2})/g,function(e,r){return String.fromCharCode(parseInt("0x"+r,16))}))}catch(e){return null}},e.resolveSymbolPathToTokenArray=function(e){for(var r=[],t=e.split("::"),o=0,n=t.length;o<n;o++)for(var i=t[o],a="",s=0,l=i.length;s<l;s++){var c=i[s];"["===c&&0<a.length?(r.push(a),a="",a+=c):"]"===c?(a+=c,r.push(a),a=""):(a+=c,s===l-1&&0<a.length&&r.push(a))}return r},e.__unload=function(){S.EventProvider.raise("System.onUnload")}}(S.System||(S.System={}))}(TcHmi||(TcHmi={})),function(e){var r,t;r=e.System||(e.System={}),function(e){var a=acorn.tokTypes,n=acorn.tokContexts;n.symbolExpressionOpenTag=new acorn.TokContext("%tag",!1),n.symbolExpressionCloseTag=new acorn.TokContext("%/tag",!1),n.symbolExpressionExpression=new acorn.TokContext("%tag%...%/tag%",!0,!0),a.symbolExpressionTagName=new acorn.TokenType("symbolExpressionTagName"),a.symbolExpressionSymbolName=new acorn.TokenType("symbolExpressionSymbolName",{beforeExpr:!0}),a.symbolExpressionOpenTagStart=new acorn.TokenType("symbolExpressionOpenTagStart"),a.symbolExpressionOpenTagEnd=new acorn.TokenType("symbolExpressionOpenTagEnd"),a.symbolExpressionCloseTagStart=new acorn.TokenType("symbolExpressionCloseTagStart"),a.symbolExpressionCloseTagEnd=new acorn.TokenType("symbolExpressionCloseTagEnd"),a.symbolExpressionOpenTagStart.updateContext=function(){this.context.push(n.symbolExpressionExpression),this.context.push(n.symbolExpressionOpenTag),this.exprAllowed=!1},a.symbolExpressionOpenTagEnd.updateContext=function(e){this.context.pop(),this.exprAllowed=!0},a.symbolExpressionCloseTagStart.updateContext=function(){this.context.pop(),this.context.push(n.symbolExpressionCloseTag),this.exprAllowed=!1},a.symbolExpressionCloseTagEnd.updateContext=function(e){this.context.pop(),this.exprAllowed=!1};var r=acorn.Parser.prototype;r.symbolExpression_readToken=function(){for(var e="",r=this.pos;;){this.pos>=this.input.length&&this.raise(this.start,"Unterminated BEX contents");var t=this.input.charCodeAt(this.pos);switch(t){case 37:return this.pos===this.start?this.getTokenFromCode(t):(e+=this.input.slice(r,this.pos),this.finishToken(a.symbolExpressionSymbolName,e));default:++this.pos}}},r.symbolExpression_readWord=function(){for(var e,r=this.pos;e=this.input.charCodeAt(++this.pos),acorn.isIdentifierChar(e)||45===e;);return this.finishToken(a.symbolExpressionTagName,this.input.slice(r,this.pos))},r.symbolExpression_parseString=function(){var e=this.value;return this.next(),e},r.symbolExpression_parseOpeningTagName=function(){var e=this.symbolExpression_parseString();return this.expect(a.symbolExpressionOpenTagEnd),e},r.symbolExpression_parseClosingTagName=function(){var e=this.symbolExpression_parseString();return this.expect(a.symbolExpressionCloseTagEnd),e},r.symbolExpression_parseElementAt=function(e,r){var t=this.startNodeAt(e,r),o="",n=this.symbolExpression_parseOpeningTagName(),i="";e:for(;;)switch(this.type){case a.symbolExpressionOpenTagStart:this.next();break;case a.symbolExpressionSymbolName:o=this.symbolExpression_parseString();break;case a.symbolExpressionCloseTagStart:if(this.next(),this.eat(a.slash)){i=this.symbolExpression_parseClosingTagName();break e}default:this.unexpected()}return i!==n&&this.raise(t.start,"Expected corresponding closing tag for %/"+n+"%"),t.passAsSymbol=!1,t.expression="%"+n+"%"+o+"%/"+i+"%",this.options.plugins.symbolExpression.onSymbol&&this.options.plugins.symbolExpression.onSymbol(t),this.finishNode(t,"SymbolExpression")},r.symbolExpression_parseElement=function(){var e=this.start,r=this.startLoc;return this.next(),this.symbolExpression_parseElementAt(e,r)},acorn.plugins.symbolExpression=function(e,r){var t,o;r&&("object"!=typeof r&&(r={}),Array.isArray(r.onSymbol)&&(t=r.onSymbol,r.onSymbol=function(e){return t.push(e)}),Array.isArray(r.onCallExpression)&&(o=r.onCallExpression,r.onSymbol=function(e){return o.push(e)}),e.extend("parseExprAtom",function(r){return function(e){return this.type===a.symbolExpressionSymbolName?this.parseLiteral(this.value):this.type===a.symbolExpressionOpenTagStart?this.symbolExpression_parseElement():r.call(this,e)}}),e.extend("readToken",function(t){return function(e){var r=this.curContext();if(r===n.symbolExpressionExpression)return 37===e?(++this.pos,this.finishToken(a.symbolExpressionCloseTagStart)):this.symbolExpression_readToken();if(r===n.symbolExpressionOpenTag||r===n.symbolExpressionCloseTag){if(acorn.isIdentifierStart(e))return this.symbolExpression_readWord();if(37===e)return++this.pos,r===n.symbolExpressionCloseTag?this.finishToken(a.symbolExpressionCloseTagEnd):this.finishToken(a.symbolExpressionOpenTagEnd)}return 37===e&&this.exprAllowed?(++this.pos,this.finishToken(a.symbolExpressionOpenTagStart)):t.call(this,e)}}),e.extend("updateContext",function(r){return function(e){return r.call(this,e)}}),e.extend("finishNode",function(t){return function(e,r){return"CallExpression"===r&&this.options.plugins.symbolExpression.onCallExpression&&this.options.plugins.symbolExpression.onCallExpression(e),t.call(this,e,r)}}))}}((t=r.Parser||(r.Parser={})).SymbolExpressionExtension||(t.SymbolExpressionExtension={}))}(TcHmi||(TcHmi={})),function(t){
/**
    * Provides functions for checking rights
    * @class Access
    * @memberOf TcHmi
    * @preserve (Part of the public API)
    */
var e=function(){function e(){}
/**
        * Checks if an right is allowed for the current user on this control or its parents
        * Rules for granting access:
        *      - Designer Mode Master => true
        *
        *      - Server Auth is not restricted (IsAuthRequired == false in Server) => TRUE
        *
        *      - Server Auth is not known right now => null
        *      - Server Auth loading error => false
        *
        *      - On this control: 1 Group  has  ALLOW => TRUE
        *      - On this control: 0 Groups have ALLOW, but 1 Group has DENY => FALSE
        *      - On this control: 0 Groups have ALLOW, 0 Groups have DENY => Ask Parent
        *
        *      - use control default of the bottom most control with this right. tchmi-view has operate/observe set to TRUE
        *      - control has no Parent (should not be possible) => FALSE
        *
        * @param {TcHmi.Controls.System.baseTcHmiControl} control Control to check
        * @param {string} accessright name of the access right
        * @returns true/false or null if the state is not known right now
        * @preserve (Part of the public API)
        */return e.checkAccess=function(e,r){return e instanceof t.Controls.System.baseTcHmiControl!=!1&&("string"==typeof r&&t.System.Services.accessManager.checkAccess(e,r))},e}();t.Access=e}(TcHmi||(TcHmi={})),function(t){var e=function(){function e(){}
/**
         * Creates a new animation
         * @function
         * @param {string} controlName       The name of the control for which the animation is intendend.
         * @param {string} selector          A CSS selector to identify the element inside the control to animate.
         * @preserve (Part of the public API)
         */return e.create=function(e,r){return void 0===r&&(r=""),t.System.Services.animationProvider.create(e,r)},e}();t.AnimationProvider=e;var r,o,n=function(){
/**
         * Creates a new animation
         * @constructor
         * @param {string} controlName      The name of the control for which the animation is intendend.
         * @param {string} selector         A CSS selector to identify the element inside the control to animate.
         * @preserve (Part of the public API)
        */
function o(e,r){var t=this;this.__keyframes=[],this.__duration=0,this.__delay=0,this.__iterationCount=1,this.__direction="normal",this.__timingFunction="ease",this.__fillMode="none",this.__cleanup=!1,this.__useCss=!0,this.__eventHandlers=[],this.__state=o.Status.CONFIGURE,this.__stateUpdater=function(e){return t.__state=e},this.__animationController=null,this.__controlName=e,this.__selector=r,this.__animationName="anim-"+tchmi_create_guid()}
/**
         * Returns the name of the control the animation is intended for.
         * @function
         * @returns {string} The name of the control.
         * @preserve (Part of the public API)
         */return o.prototype.controlName=function(){return this.__controlName},
/**
         * Returns the selector of the element to animate.
         * @function
         * @returns {string} The selector.
         * @preserve (Part of the public API)
         */
o.prototype.selector=function(){return this.__selector},
/**
         * Returns the name of the animation.
         * @function
         * @returns {string} The name of the animation.
         * @preserve (Part of the public API)
         */
o.prototype.animationName=function(){return this.__animationName},
/**
         * Returns the state of the animation.
         * @function
         * @returns {Status} The state.
         * @preserve (Part of the public API)
         */
o.prototype.state=function(){return this.__state},o.prototype.addKeyframe=function(e,r,t){if(!this.__configAllowed())return this;if(1===arguments.length){if(e.progressPoint<0||1<e.progressPoint)throw new Error("Argument out of range: progressPoint must be between 0 and 1 inclusive.");this.__keyframes.push(e)}else if(2===arguments.length&&"number"==typeof r){if(r<0||1<r)throw new Error("Argument out of range: progressPoint must be between 0 and 1 inclusive.");var o={styles:{},progressPoint:r};for(var n in e)e.hasOwnProperty(n)&&("string"==typeof e[n]?o.styles[n]=[e[n]]:o.styles[n]=e[n]);this.__keyframes.push(o)}else if("string"==typeof e&&("string"==typeof r||Array.isArray(r))){if(void 0===t||t<0||1<t)throw new Error("Argument out of range: progressPoint must be between 0 and 1 inclusive.");(o={styles:{},progressPoint:t}).styles[e]="string"==typeof r?[r]:r,this.__keyframes.push(o)}return this},
/**
         * Removes all keyframes.
         * @function
         * @preserve (Part of the public API)
         */
o.prototype.clearKeyframes=function(){return this.__configAllowed()&&(this.__keyframes=[]),this},
/**
         * Reverses the keyframes by subtracting the progressPoint from 1 and setting that as the new progressPoint.
         * @preserve (Part of the public API)
         */
o.prototype.reverseKeyframes=function(){return this.__keyframes.forEach(function(e){return e.progressPoint=1-e.progressPoint}),this},
/**
         * Gets the keyframes of this animation.
         * @function
         * @returns {Animation.Keframe[]} The keyframes.
         * @preserve (Part of the public API)
         */
o.prototype.keyframes=function(){return this.__keyframes},o.prototype.duration=function(e){return void 0===e?this.__duration:(this.__configAllowed()&&(this.__duration=null===e?0:e),this)},o.prototype.delay=function(e){return void 0===e?this.__delay:(this.__configAllowed()&&(this.__delay=null===e?0:e),this)},o.prototype.iterationCount=function(e){return void 0===e?this.__iterationCount:(this.__configAllowed()&&(this.__iterationCount=null===e?1:e),this)},o.prototype.direction=function(e){return void 0===e?this.__direction:(this.__configAllowed()&&(this.__direction=null===e?"normal":e),this)},o.prototype.timingFunction=function(e){return void 0===e?this.__timingFunction:(this.__configAllowed()&&(this.__timingFunction=null===e?"ease":e),this)},o.prototype.fillMode=function(e){return void 0===e?this.__fillMode:(this.__configAllowed()&&(this.__fillMode=null===e?"none":e),this)},o.prototype.cleanup=function(e){return void 0===e?this.__cleanup:(this.__cleanup=null!==e&&e,this.__state===o.Status.ENDED&&null!==this.__animationController&&this.__animationController.cleanup(),this)},o.prototype.useCss=function(e){return void 0===e?this.__canUseCss()&&this.__useCss:(this.__configAllowed()&&(this.__useCss=null===e||e),this)},
/**
         * Registers an event handler for one of the events animationstart, animationend or animationiteration.
         * @function
         * @param {string} name     The name of the event.
         * @param callback          The callback function.
         * @preserve (Part of the public API)
         */
o.prototype.registerEventHandler=function(e,r){return this.__eventHandlers.push({name:e,callback:r}),this},
/**
         * Unregisters a previously registered event handler.
         * @function
         * @param {string} name     The name of the event.
         * @param callback          The callback function to unregister.
         * @preserve (Part of the public API)
         */
o.prototype.unregisterEventHandler=function(r,t){return this.__eventHandlers=this.__eventHandlers.filter(function(e){return!(e.name===r&&(void 0===t||e.callback===t))}),this},
/**
         * Gets all event handlers
         * @function
         * @returns The event handlers.
         * @preserve (Part of the public API)
         */
o.prototype.eventHandlers=function(){return this.__eventHandlers},
/**
         * Run the animation.
         * @function
         * @preserve (Part of the public API)
         */
o.prototype.run=function(){return 0===this.__keyframes.length?t.Log.error("[Source=Framework, Module=TcHmi.Animation] This animation has no keyframes defined."):0===this.__keyframes.filter(function(e){return 0===e.progressPoint}).length?t.Log.error("[Source=Framework, Module=TcHmi.Animation] This animation has no start keyframe with progressPoint 0 defined."):0===this.__keyframes.filter(function(e){return 1===e.progressPoint}).length?t.Log.error("[Source=Framework, Module=TcHmi.Animation] This animation has no end keyframe with progressPoint 1 defined."):(null!==this.__animationController&&this.__animationController.isValid()||(this.__animationController=t.System.Services.animationProvider.createAnimationController(this,this.__stateUpdater)),this.__animationController.run()),this},
/**
         * Pause the animation.
         * @function
         * @preserve (Part of the public API)
         */
o.prototype.pause=function(){return null!==this.__animationController&&this.__animationController.pause(),this},
/**
         * Cancels the animation and writes the last keyframe styles into the element CSS.
         * @function
         * @preserve (Part of the public API)
         */
o.prototype.skip=function(){return null!==this.__animationController&&this.__animationController.skip(),this},
/**
         * Resets the animation. This is an asynchronous operation.
         * @function
         * @param callback The function to call when the animation has been reset.
         * @preserve (Part of the public API)
         */
o.prototype.reset=function(e){return null!==this.__animationController&&this.__animationController.reset(e),this},o.prototype.__canUseCss=function(){return"string"==typeof this.__timingFunction},o.prototype.__configAllowed=function(){return this.__state===o.Status.CONFIGURE||this.__state===o.Status.ENDED||(t.Log.warn("[Source=Framework, Module=TcHmi.AnimationProvider] Configurating an animation is only allowed when it has the state CONFIGURE or ENDED."),!1)},o}();t.Animation=n,r=n=t.Animation||(t.Animation={}),(o=r.Status||(r.Status={}))[o.CONFIGURE=0]="CONFIGURE",o[o.INITIALIZED=1]="INITIALIZED",o[o.RUNNING=2]="RUNNING",o[o.PAUSED=3]="PAUSED",o[o.ENDED=4]="ENDED"}(TcHmi||(TcHmi={})),function(i){
/**
     * Provides methods to read base64 encoded data.
     * @class Base64BinaryReader
     * @memberOf TcHmi
     * @preserve (Part of the public API)
     */
var e=function(){
/**
         * Creates a new Base64BinaryReader.
         * @constructor
         * @param {string} data          The base64 encoded string to read from.
         * @param endianness    Whether the encoded data uses little endian (default) or big endian to store numbers.
         * @preserve (Part of the public API)
         */
function e(e,r){void 0===r&&(r=i.Endianness.LittleEndian),this.__offset=0,this.__stringEncodings={"UTF-8":{decode:function(e,r){for(var t=[],o=0,n=e.length;o<n;o++){var i=e[o];if(0===i)return{codePoints:t,byteCount:o+1};if(i<=127)t.push(i);else if(194<=i&&i<=244){for(var a=1,s=31,l=32;0<l;)0<(i&l)?(a++,s>>>=1,l>>>=1):l=0;var c=i&s,_=o+a;if(n<=_)c=65533;else for(;o<_;){var u=e[++o];if(u<128||191<u){c=65533,o--;break}c=c<=67108863?(c<<6|63&u)>>>0:c*Math.pow(2,6)+(63&u)}t.push(c)}else t.push(65533)}return{codePoints:t,byteCount:e.length}}}};var t=tchmi_base64decode(e);if(null===t)throw new Error('Could not decode string "'+e+'" as base64.');this.__data=[];for(var o=0,n=t.length;o<n;o++)this.__data.push(t.charCodeAt(o));this.__endianness=r}return e.prototype.__getChunk=function(e){if(this.__offset+e>this.__data.length)throw new RangeError("Trying to read "+e+" bytes from offset "+this.__offset+" exceeds the length of the data.");var r=this.__data.slice(this.__offset,this.__offset+e);return this.__offset+=e,this.__endianness===i.Endianness.BigEndian&&(r=r.reverse()),r},e.prototype.__readInteger=function(e,r){for(var t=this.__getChunk(e),o=0,n=0,i=t.length;n<i;n++){var a=255&t[n];n<4?o=(o|a<<8*n)>>>0:o+=a*Math.pow(256,n)}if(r){var s=Math.pow(2,8*e-1);e<=4?o=(o&~s)-((o&s)>>>0):128==(128&t[t.length-1])&&(o-=2*s)}return o},e.prototype.__readFloatingPointNumber=function(e){var r,t,o=this.__getChunk(e);switch(e){case 4:r=8,t=23;break;case 8:r=11,t=52}for(var n=Math.pow(2,r-1)-1,i=[{value:0,bitsToRead:t},{value:0,bitsToRead:r},{value:0,bitsToRead:1}],a=0,s=0,l=0;l<e||i[a].bitsToRead<0;l++){var c=0;i[a].bitsToRead<0?(c=8+i[a].bitsToRead,l--,a++,s=0):0===i[a].bitsToRead&&(a++,s=0);var _=(255&o[l])>>>c;i[a].bitsToRead<8&&(_&=Math.pow(2,i[a].bitsToRead)-1),s<=24?i[a].value=(i[a].value|_<<s)>>>0:i[a].value+=_*Math.pow(2,s),s+=8-c,i[a].bitsToRead-=8-c}var u=i[0].value,d=i[1].value,m=i[2].value;return d===Math.pow(2,r)-1?0<u?NaN:1/0*(1===m?-1:1):0===d&&0===u?0*(1===m?-1:1):0===d?(1===m?-1:1)*u*Math.pow(2,1-n-t):(1===m?-1:1)*(1+u/Math.pow(2,t))*Math.pow(2,d-n)},
/**
         * Reads a boolean value.
         * @preserve (Part of the public API)
         */
e.prototype.readBoolean=function(){return 0!==this.__readInteger(1,!1)},
/**
         * Reads a single byte of data.
         * @preserve (Part of the public API)
         */
e.prototype.readByte=function(){return this.__readInteger(1,!1)},
/**
         * Reads a signed byte.
         * @preserve (Part of the public API)
         */
e.prototype.readSByte=function(){return this.__readInteger(1,!0)},
/**
         * Reads a signed 16-bit integer.
         * @preserve (Part of the public API)
         */
e.prototype.readInt16=function(){return this.__readInteger(2,!0)},
/**
         * Reads an unsigned 16-bit integer.
         * @preserve (Part of the public API)
         */
e.prototype.readUInt16=function(){return this.__readInteger(2,!1)},
/**
         * Reads a signed 32-bit integer.
         * @preserve (Part of the public API)
         */
e.prototype.readInt32=function(){return this.__readInteger(4,!0)},
/**
         * Reads an unsigned 32-bit integer.
         * @preserve (Part of the public API)
         */
e.prototype.readUInt32=function(){return this.__readInteger(4,!1)},
/**
         * Reads a single precision floating point number.
         * @preserve (Part of the public API)
         */
e.prototype.readFloat=function(){return this.__readFloatingPointNumber(4)},
/**
         * Reads a double precision floating point number.
         * @preserve (Part of the public API)
         */
e.prototype.readDouble=function(){return this.__readFloatingPointNumber(8)},
/**
         * Reads a string. Will read until a zero byte is encountered, or until the specified length has been reached, or, if no length has been specified, until the end of the data.
         * @param {number} length The length of the string to read in bytes.
         * @preserve (Part of the public API)
         */
e.prototype.readString=function(e){var r;if(void 0!==e){if(e<0)throw new RangeError("Length of the string to read must be positive.");if(this.__offset+e>this.__data.length)throw new RangeError("Trying to read "+e+" bytes from offset "+this.__offset+" exceeds the length of the data.");r=this.__data.slice(this.__offset,this.__offset+e)}else r=this.__data.slice(this.__offset);var t=this.__stringEncodings["UTF-8"].decode(r,this.__endianness);return this.__offset+=void 0!==e?e:t.byteCount,this.__getStringFromCodePoints(t.codePoints)},e.prototype.__getStringFromCodePoints=function(e){for(var r=[],t=0,o=e.length;t<o;t++){var n=e[t];if(n<=65535)r.push(n);else{var i=55296+((n-=65536)>>10),a=n%1024+56320;r.push(i,a)}}return String.fromCharCode.apply(String,r)},
/**
         *
         * @preserve (Part of the public API)
         */
e.prototype.getLength=function(){return this.__data.length},
/**
         *
         * @preserve (Part of the public API)
         */
e.prototype.getOffset=function(){return this.__offset},
/**
         *
         * @preserve (Part of the public API)
         */
e.prototype.setOffset=function(e){var r=Math.floor(i.ValueConverter.toNumber(e,0));this.__offset=r},e}();i.Base64BinaryReader=e}(TcHmi||(TcHmi={})),function(t){
/**
     * Provides methods to write base64 encoded data.
     * @class Base64BinaryWriter
     * @memberOf TcHmi
     * @preserve (Part of the public API)
     */
var e=function(){
/**
         * Creates a new Base64BinaryWriter.
         * @param endianness    Whether to use little endian (default) or big endian when encoding numbers.
         * @param {number} length        The desired length of the data. If this parameter is omitted the data will be expanded dynamically.
         * @preserve (Part of the public API)
         */
function e(e,r){void 0===e&&(e=t.Endianness.LittleEndian),this.__data=[],this.__stringEncodings={"UTF-8":{encode:function(e,r){for(var t=[],o=0,n=e.length;o<n;o++){var i=e[o];if(i<=127)t.push(i);else{for(var a=[],s=192,l=31;0<i&&a.length<=6;)a.push(128|63&i),i<=4294967295?i>>>=6:i=Math.floor(i/Math.pow(2,6)),i<=l?(a.push(s|i&l),i=0):(s=128|s>>>1,l>>>=1);t=t.concat(a.reverse())}}return t}}},this.__endianness=e,this.__length=void 0!==r?r:1/0}return e.prototype.__addChunk=function(e){if(this.__data.length+e.length>this.__length)throw new RangeError("Trying to write "+e.length+" bytes exceeds the length of the data.");this.__endianness===t.Endianness.BigEndian&&(e=e.reverse()),this.__data=this.__data.concat(e)},e.prototype.__checkIntegerBounds=function(e,r,t){if(e%1!=0)return!1;var o=Math.pow(2,8*r)-1,n=t?-Math.ceil(o/2):0;return n<=e&&e<=o+n},e.prototype.__writeInteger=function(e,r){for(var t=[],o=0;o<r;o++)t.push(255&e),r-o<=4?e>>>=8:e=Math.floor(e/256);this.__addChunk(t)},e.prototype.__writeFloatingPointNumber=function(e,r){var t,o;switch(r){case 4:t=8,o=23;break;case 8:t=11,o=52}var n,i,a=Math.pow(2,t-1)-1,s=e<0?1:0;if(isFinite(e))if(0===e)s=1/e==-1/0?1:0,i=n=0;else{e=Math.abs(e);for(var l=Math.floor(e),c=e-l,_=0,u=l;0<u;)_++,u<=4294967295?u>>>=1:u=Math.floor(u/2);i=0<l?l-Math.pow(2,_-1):0;var d=0<_?_-1:0;o<d&&(i<=4294967295?i>>>=d-o:i=Math.floor(i/Math.pow(2,d-o)),d=o);var m=-1;u=c;for(p=0;d<o;){var h=1<=(u*=2)?1:0;a-1<=p&&-1===m&&(m=p),h&&(u--,-1===m&&(m=p,0===_&&(h=0))),i=d<32?(i<<1|h)>>>0:2*i+h,(0<_||-1<m||0===c)&&d++,p++}n=0<_?_-1:-m-1,n+=a;var g=Math.pow(2,t)-1;n<1?n=0:g-1<n&&(n=g,i=0)}else{for(var p=n=0;p<t;p++)n=n<<1|1;i=isNaN(e)?1:0}var E=[{value:i,length:o},{value:n,length:t},{value:s,length:1}],f=[],S=0;for(p=0;p<r||E[S].length<0;p++){var y=0;E[S].length<0?(y=8+E[S].length,p--,S++):0===E[S].length&&S++,void 0===f[p]&&(f[p]=0),f[p]|=E[S].value<<y&255,E[S].length<=32?E[S].value=E[S].value>>>8-y:E[S].value=Math.floor(E[S].value/Math.pow(2,8-y)),E[S].length-=8-y}this.__addChunk(f)},
/**
         * Writes a boolean value.
         * @param {boolean} value The boolean value to write.
         * @preserve (Part of the public API)
         */
e.prototype.writeBoolean=function(e){return this.writeByte(e?1:0),this},
/**
         * Writes a single byte of data.
         * @param {number} value The byte to write.
         * @preserve (Part of the public API)
         */
e.prototype.writeByte=function(e){if(!this.__checkIntegerBounds(e,1,!1))throw new RangeError("The value "+e+" does not fit into a byte.");return this.__writeInteger(e,1),this},
/**
         * Writes a signed byte.
         * @param {number} value The byte to write.
         * @preserve (Part of the public API)
         */
e.prototype.writeSByte=function(e){if(!this.__checkIntegerBounds(e,1,!0))throw new RangeError("The value "+e+" does not fit into a signed byte.");return this.__writeInteger(e,1),this},
/**
         * Writes a signed 16-bit integer.
         * @param {number} value The number to write.
         * @preserve (Part of the public API)
         */
e.prototype.writeInt16=function(e){if(!this.__checkIntegerBounds(e,2,!0))throw new RangeError("The value "+e+" does not fit into an int16.");return this.__writeInteger(e,2),this},
/**
         * Writes an unsigned 16-bit integer.
         * @param {number} value The number to write.
         * @preserve (Part of the public API)
         */
e.prototype.writeUInt16=function(e){if(!this.__checkIntegerBounds(e,2,!1))throw new RangeError("The value "+e+" does not fit into an uint16.");return this.__writeInteger(e,2),this},
/**
         * Writes a signed 32-bit integer.
         * @param {number} value The number to write.
         * @preserve (Part of the public API)
         */
e.prototype.writeInt32=function(e){if(!this.__checkIntegerBounds(e,4,!0))throw new RangeError("The value "+e+" does not fit into a int32.");return this.__writeInteger(e,4),this},
/**
         * Writes an unsigned 32-bit integer.
         * @param {number} value The number to write.
         * @preserve (Part of the public API)
         */
e.prototype.writeUInt32=function(e){if(!this.__checkIntegerBounds(e,4,!1))throw new RangeError("The value "+e+" does not fit into an uint32.");return this.__writeInteger(e,4),this},
/**
         * Writes a single precision floating point number.
         * @param {number} value The number to write.
         * @preserve (Part of the public API)
         */
e.prototype.writeFloat=function(e){return this.__writeFloatingPointNumber(e,4),this},
/**
         * Writes a double precision floating point number.
         * @param {number} value The number to write.
         * @preserve (Part of the public API)
         */
e.prototype.writeDouble=function(e){return this.__writeFloatingPointNumber(e,8),this},
/**
         * Writes a string.
         * @param {string} value The string to write.
         * @param {number} length (Optional) The length of the string to write. If the string is shorter, the remaining space is filled with 0.
         * @preserve (Part of the public API)
         */
e.prototype.writeString=function(e,r){var t=this.__stringEncodings["UTF-8"].encode(this.__getCodePointsFromString(e),this.__endianness);if(void 0!==r){for(;t.length<r;)t.push(0);if(t.length>r)throw new RangeError("The specified string does not fit into the specified length.")}if(this.__data.length+t.length>this.__length)throw new RangeError("Trying to write "+t.length+" bytes exceeds the length of the data.");return this.__data=this.__data.concat(t),this},e.prototype.__getCodePointsFromString=function(e){for(var r=[],t=0,o=e.length;t<o;t++){var n=e.charCodeAt(t);if(55296<=n&&n<=56319&&t<o-1){var i=e.charCodeAt(t+1);56320<=i&&i<=57343?(r.push(1024*(n-55296)+i-56320+65536),t++):r.push(n)}else r.push(n)}return r},
/**
         * Returns the base64 encoded string. If not enough data was written to fill the length the data should have, the rest is filled up with zeros.
         * @preserve (Part of the public API)
         */
e.prototype.getEncodedString=function(){for(var e=this.__data.length;isFinite(this.__length)&&this.__data.length<this.__length;)this.__data.push(0);var r=String.fromCharCode.apply(String,this.__data);return this.__data.length=e,tchmi_base64encode(r)},
/**
         * Returns the length of the data that has been written.
         * @preserve (Part of the public API)
         */
e.prototype.getLength=function(){return this.__data.length},e}();t.Base64BinaryWriter=e}(TcHmi||(TcHmi={})),function(a){
/**
    * Reserved
    * @class Binding
    * @memberOf TcHmi
    * @preserve (Part of the public API)
    */
var e=function(){function i(){}return i.__getFuncName=function(e,r){var t=null;for(var o in r)if(r[o]===e){t=o;break}return t},
/**
         * Creates a binding between a symbol and a control attribute setter function.
         * @function create
         * @param {string} expr The target symbol expression.
         * @param {(value: any) => void} fn The target function as prototype reference.
         * @param {fnThis: TcHmi.Controls.System.baseTcHmiControl} control The target control instance.
         * @preserve (Part of the public API)
         */
i.create=function(e,r,t){var o=i.__getFuncName(r,t);null!==o&&i.createEx(e,o,t)},
/**
         * Creates a binding between a symbol and a control attribute setter function by name.
         * @function remove
         * @param {string} expr The target symbol expression.
         * @param {string} fn The name of the control setter function.
         * @param {TcHmi.Controls.System.baseTcHmiControl} control The target control instance.
         * @preserve (Part of the public API)
         */
i.createEx=function(e,r,t){var o=a.System.Services.controlManager.getAttributeByPropertySetterName(t,r);o?a.System.Services.bindingManager.createBinding(e,o.propertyName,t):a.Log.error("[Source=Framework, Module=TcHmi.Binding] The attribute with the setter "+r+" is not included in the description.json of "+t.getType()+". Creating a binding with this attribute failed.")},
/**
        * Creates a binding between a symbol and a control attribute setter function by name of property.
        * @function remove
        * @param {string} expr The target symbol expression.
        * @param {string} propertyName The name of the control property.
        * @param {TcHmi.Controls.System.baseTcHmiControl} control
        * @preserve (Part of the public API)
        */
i.createEx2=function(e,r,t){a.System.Services.bindingManager.createBinding(e,r,t)},
/**
         * Removes a binding between a symbol and a control attribute setter function.
         * @function remove
         * @param {string} expr [OBSOLETE] The target symbol expression.
         * @param {(value: any) => void} fn
         * @param {TcHmi.Controls.System.baseTcHmiControl} control The target control instance.
         * @param {boolean} bReset [Optional] If set to false the setter will not resetted with null.
         * @preserve (Part of the public API)
         */
i.remove=function(e,r,t,o){void 0===o&&(o=!0);var n=i.__getFuncName(r,t);null!==n&&i.removeEx(e,n,t,o)},
/**
         * Removes a binding between a symbol and a control attribute setter function.
         * @function remove
         * @param {string} expr [OBSOLETE] The target symbol expression.
         * @param {string} fn The name of the control setter function.
         * @param {TcHmi.Controls.System.baseTcHmiControl} control The target control instance.
         * @param {boolean} bReset [Optional] If set to false the setter will not resetted with null.
         * @preserve (Part of the public API)
         */
i.removeEx=function(e,r,t,o){void 0===o&&(o=!0);var n=a.System.Services.controlManager.getAttributeByPropertySetterName(t,r);n?i.removeEx2(e,n.propertyName,t,o):a.Log.error("[Source=Framework, Module=TcHmi.Binding] The attribute with the setter "+r+" is not included in the description.json of "+t.getType()+". Removing a binding with this attribute failed.")},
/**
        * Removes a binding between a symbol and a control attribute setter function by name of property.
        * @function remove
        * @param {string} expr [OBSOLETE] The target symbol expression.
        * @param {string} propertyName The name of the control attribute property.
        * @param {TcHmi.Controls.System.baseTcHmiControl} control The target control instance.
        * @param {boolean} bReset [Optional] If set to false the setter will not resetted with null.
        * @preserve (Part of the public API)
        */
i.removeEx2=function(e,r,t,o){void 0===o&&(o=!0),a.System.Services.bindingManager.removeBinding(r,t,o)},
/**
         * Returns true if a symbol is bound to the target control property.
         * @param {string} propertyName The name of the control attribute property.
         * @param {TcHmi.Controls.System.baseTcHmiControl} control The target control instance.
         * @preserve (Part of the public API)
         */
i.exists=function(e,r){return!!i.resolve(e,r)},
/**
         * Returns the symbol expression of a binding as string or null if no symbol is bound to the target control property.
         * @param {string} propertyName The name of the control attribute property.
         * @param {TcHmi.Controls.System.baseTcHmiControl} control The target control instance.
         * @preserve (Part of the public API)
         */
i.resolve=function(e,r){var t=a.System.Services.bindingManager.getBinding(e,r);if(t){var o=t.getSymbol();if(o)return o.getExpression().toString()}return null},
/**
         * Returns the symbol expression of a binding as SymbolExpression object or null if no symbol is bound to the target control property.
         * @param {string} propertyName The name of the control attribute property.
         * @param {TcHmi.Controls.System.baseTcHmiControl} control The target control instance.
         * @preserve (Part of the public API)
         */
i.resolveEx=function(e,r){var t=a.System.Services.bindingManager.getBinding(e,r);if(t){var o=t.getSymbol();if(o)return new a.SymbolExpression(o.getExpression().toString())}return null},i}();a.Binding=e}(TcHmi||(TcHmi={})),function(d){var e=function(){function e(){}return e.callSafe=function(e,r){for(var t=[],o=2;o<arguments.length;o++)t[o-2]=arguments[o];var n=void 0;if(e&&"function"==typeof e)try{e.call.apply(e,[r].concat(t))}catch(e){n=e}return n},e.callSafeArray=function(e,r){for(var t=[],o=2;o<arguments.length;o++)t[o-2]=arguments[o];for(var n,i=[],a=0,s=e.length;a<s;a++)i.push(e[a]);for(var l=0,c=i;l<c.length;l++){var _=c[l];if(-1!==e.indexOf(_)){var u=(n=d.Callback).callSafe.apply(n,[_,r].concat(t));if(void 0!==u)return u}}},e}();d.Callback=e}(TcHmi||(TcHmi={})),function(o){
/**
    * @class Theme
    * @memberOf TcHmi
    * @preserve (Part of the public API)
    */
var e=function(){function e(){}
/**
         * Returns the active theme.
         *
         * @preserve (Part of the public API)
         * @returns {string}
         */return e.get=function(){return o.System.Services.themeManager.getTheme()},
/**
         * Sets the active theme.
         *
         * @preserve (Part of the public API)
         * @returns {TcHmi.Errors}
         */
e.set=function(e){return o.System.Services.themeManager.setTheme(e,!0)},e}();o.Theme=e,function(e){
/**
         * Control property related API
         * @preserve (Part of the public API)
         */
var r=function(){function e(){}
/**
            * Parses every source of implicit properties and returns this or null
            * Can have different value after the event onThemeDataChanged.
            * The order of resources are
            * 1) control class
            * 2) theme definition of the control type in project
            * 3) theme definition in control
            * 4) defaultValueInternal in Description.json of the control
            * @param {TcHmi.Controls.System.baseTcHmiControl} control Control which needs the resource
            * @param {string} propertyName name of the property
            * @preserve (Part of the public API)
            */return e.getDefaultValue=function(e,r){return e instanceof o.Controls.System.baseTcHmiControl==!1?{error:o.Errors.E_PARAMETER_INVALID,origin:"system",originThemeName:o.System.Services.themeManager.getTheme(),value:null}:r?o.System.Services.themeManager.getDefaultPropertyValue(e,r):{error:o.Errors.E_PARAMETER_INVALID,origin:"system",originThemeName:o.System.Services.themeManager.getTheme(),value:null}},
/**
             * Sets the default value of a property and change it (if needed) on theme change.
             *
             * @param {TcHmi.Controls.System.baseTcHmiControl}
             * @param {string} propertyName
             * @returns {TcHmi.Errors} returns an Error code
             * @preserve (Part of the public API)
             */
e.setThemeValue=function(e,r){return e instanceof o.Controls.System.baseTcHmiControl==!1?o.Errors.E_PARAMETER_INVALID:r?o.System.Services.controlManager.setControlProperty(e,r,null):o.Errors.E_PARAMETER_INVALID},e}();e.Properties=r;
/**
         * Control resource related API
         * @preserve (Part of the public API)
         */
var t=function(){function e(){}
/**
            * Gets a themed resource.
            * Parses every source of properties and returns this or null
            * Can have different value after the event onThemeDataChanged.
            * The order of resources are
            * 1) control class
            * 2) theme definition of the control type in project
            * 3) theme definition in control
        
            * @param {TcHmi.Controls.System.baseTcHmiControl} control Control which needs the resource
            * @param {string} resourceName name of the resource
            * @return {TcHmi.Theme.Resource<T> | null} returns the resource or null
            * @preserve (Part of the public API)
            */return e.get=function(e,r){return e instanceof o.Controls.System.baseTcHmiControl==!1?{error:o.Errors.E_PARAMETER_INVALID,origin:"system",originThemeName:o.System.Services.themeManager.getTheme(),value:null}:r?o.System.Services.themeManager.getThemeResource(e,r):{error:o.Errors.E_PARAMETER_INVALID,origin:"system",originThemeName:o.System.Services.themeManager.getTheme(),value:null}},e}();e.Resources=t}(e=o.Theme||(o.Theme={}))}(TcHmi||(TcHmi={})),function(n){var e;(e=n.Controls||(n.Controls={})).register=
/**
         * Register a TcHmi Control.
         * The Framework will fetch and interprete the Description.json in the Control Directory and optionally load a HTML Template file
         * @param {string} name Name of the Control.
         * @param {TcHmi.Controls.baseTcHmiControlConstructor} constructor Constructor which generates the TcHmi Control.
         * @param {string} directory Directory of the Control (base path is the Controls directory).
         * @param {string} templatePath Template file of the Control (base path is the Controls directory).
         * @preserve (Part of the public API)
         */
function(e,r,t,o){n.System.Caches.registeredControls[e]={name:e,constructor:r,directory:t,templatePath:o}},e.get=
/**
         * Get control by name. Returns the control or undefined
         * @param {string} name Name of the Control.
         * @preserve (Part of the public API)
         */
function(e){if(e)return n.control[e]},e.tachControls=
/**
         * DEPRECATED
         * Does no longer do anything
         * @deprecated  Does no longer do anything
         * @function tachControls
         * @memberOf TcHmi.Controls
         * @param {((this: void, data: TcHmi.IResultObject) => void} callback
         * @preserve (Part of the public API)
         */
function(e){void 0===e&&(e=null),n.Log.warn("[Source=Framework, Module=TcHmi.Controls] The function 'TcHmi.Controls.tachControls(callback: null | ((this: void) => void) = null)' has been marked as deprecated and should no longer be used because it does no longer do anything."),"function"==typeof e&&e.apply(null)},e.tachControlsAsync=function(e){void 0===e&&(e=null),n.Log.warn("[Source=Framework, Module=TcHmi.Controls] The function 'TcHmi.Controls.tachControlsAsync(callback: null | ((this: void) => void) = null)' has been marked as deprecated and should no longer be used because it does no longer do anything."),"function"==typeof e&&e.apply(null)}}(TcHmi||(TcHmi={})),function(e){e.control={};var r=function(){};e.Control=r}(TcHmi||(TcHmi={})),function(l){var e=function(){function e(){}
/**
        * Creates a new control.
        * @function
        * @param {string} type The type of the control.
        * @param {string} name The name of the control.
        * @param {Dictionary<{}>}
        * @param {TcHmi.Controls.System.baseTcHmiControl} parent Optional. The logical parent control.
        * @preserve (Part of the public API)
         */return e.createEx=function(e,r,t,o){var n=$('<div id="'+r+'" data-tchmi-type="'+e+'"></div>');for(var i in t){var a=t[i];if(null!=a)if("object"!=typeof a)n.attr(i,a);else{var s=$('<script data-tchmi-target-attribute="'+i+'" type="application/json"><\/script>');s.text(JSON.stringify(a)),n.append(s)}}return l.System.Services.controlManager.compile(n[0].outerHTML,o)},
/**
        * DEPRECATED
        * Creates a new control.
        * @function
        * @param {string|jQuery} htmlOrElementOrType The HTML, jQuery element or type of the control.
        * @param {string} [name] Optional the name of the control.
        * @param {TcHmi.Controls.System.baseTcHmiControl} [parent] Optional. The logical parent control.
        * @deprecated Please use createEx()
        * @preserve (Part of the public API)
        */
e.create=function(e,r,t){var o;if(null==r)o="string"==typeof e?$(e):e;else{if("string"!=typeof e)return void l.Log.error("[Source=Framework, Module=TcHmi.ControlFactory] Error compiling control. Wrong input parameter given.");o=$('<div id="'+r+'" data-tchmi-type="'+e+'"></div>')}if(0!==o.length){if(void 0===l.Controls.get(o[0].id))return l.System.Services.controlManager.compile(o[0].outerHTML,t);l.Log.error("[Source=Framework, Module=TcHmi.ControlFactory] Error compiling control. A control with the name "+o[0].id+" already exists.")}},e}();l.ControlFactory=e}(TcHmi||(TcHmi={})),function(n){
/**
    * Provides multiple types of dialogs to the user
    *
    * @class DialogManager
    * @preserve (Part of the public API)
    */
var e,r,t,o=function(){function o(){}
/**
        * Change visibility of dialog and set its DialogType when showing
        *
        * @param {string} dialogOwner Caller Id to prevent overwriting forreign dialogs
        * @param {boolean} bVisibility Toggling visiblity of Dialog
        * @param {TcHmi.DialogManager.DialogType} dialogType?
        * @param {object} options?
        * @param {string} options.cancelable The dialog should have an button to close the dialog
        * @preserve (Part of the public API)
        */return o.showDialog=function(e,r,t,o){return n.System.Services.dialogManager.showDialog(e,r,t,o)},
/**
         * Changes the output content of the Dialog to a new value
         * The default Severity is Info
         *
         * @param {string} dialogOwner Caller Id to prevent overwriting forreign dialogs
         * @param {string} newHtmlContent
         * @param [severity = DialogManager.DialogSeverity.Info]
         * @returns {boolean} Success of the text update
         * @preserve (Part of the public API)
         */
o.updateText=function(e,r,t){return void 0===t&&(t=o.DialogSeverity.Info),n.System.Services.dialogManager.updateText(e,r,t)},
/**
        * Returns the current dialog owner or null
        * @returns {string, null}
        * @preserve (Part of the public API)
        */
o.getDialogOwner=function(){return n.System.Services.dialogManager.getDialogOwner()},o}();n.DialogManager=o,e=o=n.DialogManager||(n.DialogManager={}),(r=e.DialogSeverity||(e.DialogSeverity={}))[r.Info=0]="Info",r[r.Error=1]="Error",(t=e.DialogType||(e.DialogType={}))[t.Overlay=1]="Overlay",t[t.SYSTEMLoading=100]="SYSTEMLoading"}(TcHmi||(TcHmi={})),function(r){
/**
    * Reserved
    * @class Environment
    * @memberOf TcHmi
    * @preserve (Part of the public API)
    */
var e=function(){function e(){}
/**
         * Returns the base path in this environment.
         * You have to add '/Controls/Custom' if you want to address your own control dir
         *
         * @preserve (Part of the public API)
         * @returns {string}
         */return e.getBasePath=function(){return r.System.config.basePath},e}();r.Environment=e}(TcHmi||(TcHmi={})),function(n){
/**
    * Reserved
    * @class StyleProvider
    * @memberOf TcHmi
    * @preserve (Part of the public API)
    */
var e=function(){function e(){}
/**
         * Returns the given computed CSS property on the first given element. Does return values set by CSS files, the other Style APIs and AnimationProvider
         * Unset or unknown CSS values will not be set in the result object.
         * @param {JQuery|HTMLElement|SVGElement} element The jQuery collection or single HTML/SVG element.
         * @param {string|string[]} propertyNames  The CSS property (string) or properties (string array) to get.
         * @preserve (Part of the public API)
         */return e.getComputedElementStyle=function(e,r){return n.System.Services.styleManager.__getElementStyle(e,r,!0)},
/**
         * Returns the given CSS property on the first given element. Does not return values set by CSS files, the other Style APIs and AnimationProvider
         * @param {JQuery | undefined} element The jQuery element.
         * @param {string|string[]} propertyNames  The CSS property (string) or properties (string array) to get.
         * @returns {object}
         * @preserve (Part of the public API)
         */
e.getSimpleElementStyle=function(e,r){return n.System.Services.styleManager.__getElementStyle(e,r,!1)},
/**
         * Style setter for simple styles in a collection of JQuery elements or single HTML or SVG Elements.
         * @param {JQuery | undefined} element The jQuery element.
         * @param {string|object} property      The CSS property to process or a dictionary of property value pairs.
         * @param {string} [value]         The value for the CSS property or an array of values. Only used if second parameter is no object.
         * @preserve (Part of the public API)
         */
e.setSimpleElementStyle=function(e,r,t){return void 0===t&&(t=null),n.System.Services.styleManager.__setSimpleElementStyle(e,r,t)},e.processGenericStyle=function(e,r,t,o){return void 0===o&&(o=null),n.System.Services.styleManager.processGenericStyle(e,r,t,o)},
/**
         * Resolves a SolidColor object to a string representation for use as css color property.
         * Has to be called with a valid SolidColor. Use isSolidColor to check
         * @param colorObject The SolidColor to resolve.
         * @preserve (Part of the public API)
        */
e.resolveSolidColorAsCssValue=function(e){return"none"===e.color.toLowerCase()?"transparent":e.color},
/**
        * Resolve a SolidColor object to a RGBAColor object.
        * Has to be called with a valid SolidColor. Use isSolidColor to check
        * @param colorObject The SolidColor to resolve.
        * @preserve (Part of the public API)
        */
e.resolveSolidColorAsRGBA=function(e){var r=document.createElement("canvas");r.width=r.height=1;var t=r.getContext("2d");t.clearRect(0,0,1,1),t.fillStyle=e.color,t.fillRect(0,0,1,1);var o=t.getImageData(0,0,1,1).data;return{r:o[0],g:o[1],b:o[2],a:o[3]}},
/**
         * Resolves a LinearGradientColor object to a string representation for use in css background-image property.
         * Has to be called with a valid LinearGradientColor. Use isLinearGradientColor to check
         * @param colorObject The LinearGradientColor to resolve.
         * @preserve (Part of the public API)
        */
e.resolveLinearGradientColorAsCssValue=function(e){var r=e.angle;null==r&&(r=0);var t="linear-gradient(";if(t+=r+"deg",e.stopPoints)for(var o=0,n=e.stopPoints.length;o<n;o++){var i=e.stopPoints[o];void 0!==i.stop&&null!==i.stop?t+=","+i.color+" "+i.stop:t+=","+i.color}return t+=")"},
/**
         * Style Processor for background.
         * @param {JQuery | undefined} element The jQuery element.
         * @param valueNew  The new value for the background.
         * @preserve (Part of the public API)
         */
e.processBackground=function(e,r){return n.System.Services.styleManager.processBackground(e,r)},
/**
         * Style Processor for background colors and gradients.
         * @param {JQuery} element   The jQuery element.
         * @param valueNew  The new value for the background.
         * @preserve (Part of the public API)
         */
e.processBackgroundColor=function(e,r){return n.System.Services.styleManager.processBackground(e,{color:r})},
/**
         * Style Processor for background images.
         * @param {JQuery | undefined} element The jQuery element.
         * @param valueNew  The URL of the image.
         * @preserve (Part of the public API)
         */
e.processBackgroundImage=function(e,r){return n.System.Services.styleManager.processBackground(e,{image:r})},
/**
         * Style processor for SVG fill color.
         * @param {JQuery | SVGElement | undefined} element The jQuery element.
         * @param valueNew The new fill color.
         * @preserve (Part of the public API)
         */
e.processFillColor=function(e,r){return n.System.Services.styleManager.processFillColor(e,r)},
/**
         * Style processor for SVG stroke color.
         * @param {JQuery | undefined} element The jQuery element.
         * @param valueNew      The new stroke color.
         * @preserve (Part of the public API)
         */
e.processStrokeColor=function(e,r){return n.System.Services.styleManager.processStrokeColor(e,r)},
/**
         * Style processor for text color.
         * @param {JQuery | undefined} element The jQuery element.
         * @param valueNew      The new text color.
         * @preserve (Part of the public API)
         */
e.processTextColor=function(e,r){return n.System.Services.styleManager.processTextColor(e,r)},
/**
         * Style processor for border color.
         * @param {JQuery | undefined} element The jQuery element.
         * @param {object} valueNew      The new border color.
         * @preserve (Part of the public API)
         */
e.processBorderColor=function(e,r){return n.System.Services.styleManager.processBorderColor(e,r)},
/**
         * Style processor for border width.
         * @param {JQuery | undefined} element The jQuery element.
         * @param {object} valueNew      The new border widths.
         * @preserve (Part of the public API)
         */
e.processBorderWidth=function(e,r){return n.System.Services.styleManager.processBorderWidth(e,r)},
/**
         * Style processor for border radius.
         * @param {JQuery | undefined} element The jQuery element.
         * @param {object} valueNew      The new border radii.
         * @preserve (Part of the public API)
         */
e.processBorderRadius=function(e,r){return n.System.Services.styleManager.processBorderRadius(e,r)},
/**
         * Style processor for border style.
         * @param {JQuery | undefined} element The jQuery element.
         * @param {object} valueNew      The new border styles.
         * @preserve (Part of the public API)
         */
e.processBorderStyle=function(e,r){return n.System.Services.styleManager.processBorderStyle(e,r)},
/**
         * Style processor for box shadow.
         * @param {JQuery | undefined} element The jQuery element.
         * @param valueNew      The new border styles.
         * @preserve (Part of the public API)
         */
e.processBoxShadow=function(e,r){return n.System.Services.styleManager.processBoxShadow(e,r)},
/**
         * Style processor for font family.
         * @param {JQuery | undefined} element The jQuery element.
         * @param valueNew      The new font family.
         * @preserve (Part of the public API)
         */
e.processFontFamily=function(e,r){return n.System.Services.styleManager.processFontFamily(e,r)},
/**
         * Style processor for font size.
         * @param {JQuery | undefined} element The jQuery element.
         * @param valueNew      The new font size.
         * @param unitNew       The new font size unit. Defaults to "px".
         * @preserve (Part of the public API)
         */
e.processFontSize=function(e,r,t){return void 0===t&&(t="px"),n.System.Services.styleManager.processFontSize(e,r,t)},
/**
         * Style processor for font style.
         * @param {JQuery | undefined} element The jQuery element.
         * @param valueNew      The new font style. Allowed values are "Normal", "Italic" and "Oblique".
         * @preserve (Part of the public API)
         */
e.processFontStyle=function(e,r){return n.System.Services.styleManager.processFontStyle(e,r)},
/**
         * Style processor for font weight.
         * @param {JQuery | undefined} element The jQuery element.
         * @param valueNew      The new font weight. Allowed values are "Normal" and "Bold".
         * @preserve (Part of the public API)
         */
e.processFontWeight=function(e,r){return n.System.Services.styleManager.processFontWeight(e,r)},
/**
         * Style processor for visibility.
         * Visibility also effects pointer events, i.e. a hidden element will not receive mouse click events.
         * Hidden still uses space in fluid calculations, collapsed is ignored there.
         * @param {JQuery | undefined} element The jQuery element.
         * @param valueNew      The new visibility. Allowed values are "Visible", "Collapsed" and "Hidden". Hidden still uses space in fluid calculations, collapsed is ignored there.
         * @preserve (Part of the public API)
         */
e.processVisibility=function(e,r){return n.System.Services.styleManager.processVisibility(e,r)},
/**
         * Style processor for horizontal alignment. This aligns the content of the target element, not the target element itself.
         * @param {JQuery | undefined} element The jQuery element.
         * @param valueNew      The new horizontal alignment. Allowed values are "Left", "Center" and "Right".
         * @preserve (Part of the public API)
         */
e.processContentHorizontalAlignment=function(e,r){return n.System.Services.styleManager.processContentHorizontalAlignment(e,r)},
/**
         * Style processor for vertical alignment. This aligns the content of the target element, not the target element itself.
         * @param {JQuery | undefined} element The jQuery element.
         * @param valueNew      The new vertical alignment. Allowed values are "Top", "Center" and "Bottom".
         * @preserve (Part of the public API)
         */
e.processContentVerticalAlignment=function(e,r){return n.System.Services.styleManager.processContentVerticalAlignment(e,r)},
/**
         * Style processor for content padding.
         * @param {JQuery | undefined} element The jQuery element.
         * @param valueNew      The new content padding.
         * @preserve (Part of the public API)
         */
e.processContentPadding=function(e,r){return n.System.Services.styleManager.processContentPadding(e,r)},
/**
         * Theme processor for transforms.
         * @param {JQuery | undefined} element The jQuery element.
         * @param valueNew      The new transform value or an array of transform values.
         * @param order         If this parameter is passed, the transforms in valueNew will replace the transform at the specified place, instead of replacing all transforms.
         * @preserve (Part of the public API)
         */
e.processTransform=function(e,r,t){return n.System.Services.styleManager.processTransform(e,r,t)},e}();n.StyleProvider=e}(TcHmi||(TcHmi={})),function(o){
/**
    * Provides a layer to show elements above the normal visualization
    * @class TopMostLayer
    * @memberOf TcHmi
    * @preserve (Part of the public API)
    */
var e=function(){function e(){}
/**
        * Appends the elements to the top layer above the normal visualization
        * A reference to the element should be kept to be able to call remove() function
        * The parent element will be a div with style="width:<browserwindowwidth>;height:<browserwindowheight>;"
        * Your element could have style="min-width:50%;min-height:50%;"
        *
        * @param {TcHmi.Controls.System.baseTcHmiControl} control control which requests this
        * @param {JQuery} element jQuery Collection with exactly one element which should be moved to TopMostLayer
        * @param {object} options optional options
        * @param options.resizeCb optional callback which will be called after resizing the element or parent. Will be called after add, too. ("this" will be the calling control in this function)
        * @param options.removeCb optional callback which will be called after removing the element ("this" will be the calling control in this function)
        * @param {boolean} options.centerHorizontal bool to center the given element
        * @param {boolean} options.centerVertical bool to center the given element
        * @param {boolean} options.dimBackground Should the overlay be darken over the background. Default is true
        * @returns {boolean} success of the add
        * @preserve (Part of the public API)
        */return e.add=function(e,r,t){return!!e&&o.System.Services.topMostLayer.add(e,r,t)},
/**
         * Removes the element from the top layer and returns it for later use by the caller
         * If the element is not inside the TopMostLayer it will be returned without change.
         * @param {TcHmi.Controls.System.baseTcHmiControl} control control which requests this
         * @param {JQuery} element jQuery Collection with the element which should be removed from TopMostLayer
         * @returns {JQuery} jQuery Collection
         * @preserve (Part of the public API)
         */
e.remove=function(e,r){return e?o.System.Services.topMostLayer.remove(e,r,!1):r},
/**
        * Appends the elements to the top layer above the normal visualization (not control namespaced)
        * A reference to the element should be kept to be able to call remove() function
        * The parent element will be a div with style="width:<browserwindowwidth>;height:<browserwindowheight>;"
        * Your element could have style="min-width:50%;min-height:50%;"
        *
        * @param {JQuery} element jQuery Collection with exactly one element which should be moved to TopMostLayer
        * @param {object} options optional options
        * @param options.resizeCb optional callback which will be called after resizeing the element or parent ("this" will be the calling control in this function)
        * @param options.removeCb optional callback which will be called after removing the element ("this" will be the calling control in this function)
        * @param {boolean} options.centerHorizontal bool to center the given element
        * @param {boolean} options.centerVertical bool to center the given element
        * @returns {boolean} success of the add
        * @preserve (Part of the public API)
        */
e.addEx=function(e,r){return!!o.control&&o.System.Services.topMostLayer.add(null,e,r)},
/**
         * Removes the element from the top layer and returns it for later use by the caller (not control namespaced)
         * If the element is not inside the TopMostLayer it will be returned without change.
         * @param {JQuery} element jQuery Collection with the element which should be removed from TopMostLayer
         * @returns {JQuery} jQuery Collection
         * @preserve (Part of the public API)
         */
e.removeEx=function(e){return o.control?o.System.Services.topMostLayer.remove(null,e,!1):e},e}();o.TopMostLayer=e}(TcHmi||(TcHmi={})),function(_){
/**
    *
    * @class EventProvider
    * @memberOf TcHmi
    * @preserve (Part of the public API)
    */
var e,r,t=function(){function s(){}
/**
         * Register a callback to an event name.
         * If the name is a binding expression the callback will be initially called if there is a binding with this name
         * @function
         * @param {string} name Name of the event.
         * @param {function} callback Callback which will be called
         * @returns {function} Destroy function which cleans up/unregisters
         * @preserve (Part of the public API)
         */return s.register=function(t,o,e){var n=this;void 0===this.__registeredEventNameCount[t]?this.__registeredEventNameCount[t]=1:this.__registeredEventNameCount[t]++,void 0===this.__events[t]&&(this.__events[t]={});var i,a=this.__internalEventId++,s=null,l=null,c=function(){l||_.EventProvider.raise("System.EventProvider.onDestroyCallback<"+t+">",s);var e=!1;void 0===n.__registeredEventNameCount[t]||(n.__registeredEventNameCount[t]<=1?(delete n.__registeredEventNameCount[t],e=!0):n.__registeredEventNameCount[t]--),i&&(i(),i=null),l&&(l.destroy(),l=null);var r=n.__events;r[t]&&(delete r[t][a],e&&delete r[t])};return s={id:a,name:t,callback:o,options:e,destroy:c},this.__events[t][a]=s,!0===_.Symbol.isSymbolExpression(t)?(l=new _.System.Symbol(t),i=l.watch(function(e){if(i||(i=e.destroy),e.error===_.Errors.NONE){var r=_.Callback.callSafe(o,null,{name:t,destroy:c},e.value);r&&_.Log.error(r)}})):_.EventProvider.raise("EventProvider.onRegisterCallback<"+t+">",s),c},
/**
         * Calls all registered callbacks related to event name.
         * @function
         * @param {string} name Name of the event.
         * @param args optional parameter(s) which will be transfered to the callbacks
         * @preserve (Part of the public API)
         */
s.raise=function(e){for(var r=[],t=1;t<arguments.length;t++)r[t-1]=arguments[t];var o=this.__events[e];if(o)for(var n in o){var i=o[n];s.raiseEx.apply(s,[i].concat(r))}},
/**
         * Calls the callback of an specific event registration.
         * @function
         * @param {EventProvider.IEventEntry} event
         * @param args optional parameter(s) which will be transfered to the callbacks
         * @preserve (Part of the public API)
         */
s.raiseEx=function(e){for(var r=[],t=1;t<arguments.length;t++)r[t-1]=arguments[t];var o,n=(o=_.Callback).callSafe.apply(o,[e.callback,null,{name:e.name,destroy:e.destroy}].concat(r));n&&_.Log.error(n)},s.watchEventRegistration=function(r,t){var o=function(e){_.EventProvider.register("System.EventProvider.onDestroyCallback<"+r+">",function(e,r){_.Callback.callSafe(t,s,{error:_.Errors.NONE,type:s.EventRegWatchType.DESTROY,event:r}),e.destroy()}),_.Callback.callSafe(t,s,{error:_.Errors.NONE,type:s.EventRegWatchType.REGISTER,event:e})},e=s.__events[r];for(var n in e){var i=e[n];i&&o(i)}var a=_.EventProvider.register("EventProvider.onRegisterCallback<"+r+">",function(e,r){o(r)});return function(){a()}},s.__events={},s.__internalEventId=0,s.__registeredEventNameCount={},s}();_.EventProvider=t,e=t=_.EventProvider||(_.EventProvider={}),(r=e.EventRegWatchType||(e.EventRegWatchType={}))[r.REGISTER=100]="REGISTER",r[r.DESTROY=200]="DESTROY"}(TcHmi||(TcHmi={})),function(y){var e=function(){function e(e){this.__f=e,this.__fn=y.System.Services.functionProvider.getFunction(e.fn),this.__fnDescr=y.System.Services.functionProvider.getFunctionDescription(e.fn)}return e.prototype.__execute=function(n,e){var i=[],r=this.__f.fnParams;Array.isArray(r)||(r=[]);var a=this.__fnDescr,t=a.function.arguments,s=!1,o=0,l=this;!0===a.function.injectContextObject&&o++;var c=function(e,r){if(!s)if(s=!0,e===y.Errors.NONE){var t=void 0;!0===a.function.injectContextObject&&(a.function&&a.function.waitMode&&"Asynchronous"===a.function.waitMode?i.unshift(n):i.unshift({}));try{t=(o=l.__fn).call.apply(o,[l].concat(i))}catch(e){return void n.error(y.Errors.E_FUNCTION_EXCEPTION,{code:y.Errors.E_FUNCTION_EXCEPTION,message:y.Errors[y.Errors.E_FUNCTION_EXCEPTION],reason:'Exception: "'+e+'"',domain:"TcHmi.Function"})}if(a.function&&(!a.function.waitMode||a.function.waitMode&&"Synchronous"===a.function.waitMode))n.success(t);else var o}else n.error(e,r)};if(a.function&&a.function.waitMode&&"Asynchronous"===a.function.waitMode&&!1===a.function.injectContextObject)c(y.Errors.E_FUNCTION_INVALID_CONFIGURATION,{code:y.Errors.E_FUNCTION_INVALID_CONFIGURATION,message:y.Errors[y.Errors.E_FUNCTION_INVALID_CONFIGURATION],reason:a.function.name+", Setting waitMode=Asynchronous and injectContextObject="+a.function.injectContextObject+" is an invalid function configuration. Please define a context object if you want to use waitMode=Asynchronous.",domain:"TcHmi.Function"});else{var _=e.length+r.length,u=function(e,r,t){if(r){var o=y.System.Services.typeManager.getSchema(r.type);"TcHmi.Symbol"===o.frameworkInstanceOf?t instanceof y.Symbol?i[e]=t:i[e]=null:i[e]=y.ValueConverter.toSchemaType(t,o)}else i[e]=t;0===--_&&c(y.Errors.NONE)},d=function(r,t,e){e.readEx(function(e){e.error===y.Errors.NONE?u(r,t,e.value):c(y.Errors.ERROR,{code:y.Errors.ERROR,message:y.Errors[y.Errors.ERROR],reason:a.function.name+", Resolving symbol failed.",domain:"TcHmi.Function",errors:[e.details]})})};if(!s)if(0===_)c(y.Errors.NONE);else{for(var m=0,h=e.length;m<h;m++){var g=e[m],p=void 0;m<t.length?p=t[m+o]:(p=t[t.length-1+o]).restParameter||(p=null),u(m,p,g)}for(m=0,h=r.length;m<h;m++){if(s)return;var E=r[m];p=void 0;if(m<t.length-e.length?p=t[m+e.length+o]:(p=t[t.length-1+o]).restParameter||(p=null),!p)return void c(y.Errors.E_FUNCTION_INVALID_CONFIGURATION,{code:y.Errors.E_FUNCTION_INVALID_CONFIGURATION,message:y.Errors[y.Errors.E_FUNCTION_INVALID_CONFIGURATION],reason:a.function.name,domain:"TcHmi.Function"});if(y.IFunction.isStaticValue(E))u(m+e.length,p,E.value);else if(y.IFunction.isSymbol(E)){var f=new y.Symbol(E.symbolExpression),S=y.System.Services.typeManager.getSchema(p.type);S&&"TcHmi.Symbol"===S.frameworkInstanceOf?u(m+e.length,p,f):d(m+e.length,p,f)}else c(y.Errors.E_PARAMETER_INVALID,{code:y.Errors.E_PARAMETER_INVALID,message:y.Errors[y.Errors.E_PARAMETER_INVALID],reason:a.function.name,domain:"TcHmi.Function"})}}}},
/**
         * Will raise the function defined in constructor argument f: IFunction.
         * @param requiredArgs Optional required arguments. Will be injected before arguments defined in IFunction and after context object dummy if context object is required.
         * @preserve (Part of the public API)
         */
e.prototype.execute=function(e){if(void 0===e&&(e=[]),!this.__fn)return y.Log.error("[Source=Framework, Module=TcHmi.Function] Function="+this.__f.fn+" is not registered."),null;if(!this.__fnDescr)return y.Log.error("[Source=Framework, Module=TcHmi.Function] Description for function="+this.__f.fn+" missing."),null;var r=null;return this.__execute({success:function(e){r=e},error:function(e){r=null}},e),r},
/**
         * Will raise the function defined in constructor argument f: IFunction and raises a callback afterwards.
         * @param requiredArgs Optional required arguments. Will be injected before arguments defined in IFunction and after context object dummy if context object is required.
         * @param callback
         * @preserve (Part of the public API)
         */
e.prototype.executeEx=function(e,t){void 0===e&&(e=[]);var o=this,r=this.__fn,n=this.__fnDescr;r?n?(e||(e=[]),this.__execute({success:function(e){y.Callback.callSafe(t,o,{error:y.Errors.NONE,result:e})},error:function(e,r){y.Callback.callSafe(t,o,{error:e,details:r})}},e)):y.Callback.callSafe(t,this,{error:y.Errors.E_FUNCTION_MISSING_FUNCTION_DESCRIPTION,details:{code:y.Errors.E_FUNCTION_MISSING_FUNCTION_DESCRIPTION,message:y.Errors[y.Errors.E_FUNCTION_MISSING_FUNCTION_DESCRIPTION],domain:"TcHmi.Function"}}):y.Callback.callSafe(t,this,{error:y.Errors.E_FUNCTION_MISSING_FUNCTION_REFERENCE,details:{code:y.Errors.E_FUNCTION_MISSING_FUNCTION_REFERENCE,message:y.Errors[y.Errors.E_FUNCTION_MISSING_FUNCTION_REFERENCE],domain:"TcHmi.Function"}})},
/**
         * Releases all resources of the function
         * @preserve (Part of the public API)
         */
e.prototype.destroy=function(){this.__f=null,this.__fn=null,this.__fnDescr=null},e}();y.Function=e}(TcHmi||(TcHmi={})),function(o){
/**
     * @namespace TcHmi.Functions
     * @preserve (Part of the public API)
     */
var e;(e=o.Functions||(o.Functions={})).registerFrameworkFunction=
/**
         * @function registerFrameworkFunction
         * @memberOf TcHmi.Functions
         * @param {string} name
         * @param {function} func
         * @param {string} descriptionUrl
         * @preserve (Part of the public API)
         */
function(e,r,t){void 0===t&&(t=""),null!=t&&0!==t.length&&o.System.Caches.registeredFrameworkFunctionDescription.push({name:e,func:r,descriptionUrl:t})},e.registerFunction=
/**
         * @function registerFunction
         * @memberOf TcHmi.Functions
         * @param {string} name
         * @param {(...args)} func
         * @preserve (Part of the public API)
         */
function(e,r){if(void 0===o.System.Services.functionProvider)var t=o.EventProvider.register("System.onInitializedServices",function(){o.System.Services.functionProvider.registerFunction(e,r),t()});else o.System.Services.functionProvider.registerFunction(e,r)},e.getFunction=
/**
         * Returns a registered HMI function
         * @function getFunction
         * @memberOf TcHmi.Functions
         * @param {string} name
         * @returns {function}
         * @preserve (Part of the public API)
         */
function(e){return o.System.Services.functionProvider.getFunction(e)}}(TcHmi||(TcHmi={})),function(d){
/**
    * Provides functions for interaction with the TwinCAT HMI Server.
    * @class Server
    * @memberOf TcHmi
    * @preserve (Part of the public API)
    */
var e=function(){function i(){}
/**
         * Returns the current readyState value of the underlying websocket which is connected to the TwinCAT HMI Server.
         * @function getWebsocketReadyState
         * @memberOf TcHmi.Server
         * @returns {number | null} The current readyState value of the underlying websocket which is connected to the TwinCAT HMI Server or null.
         * @preserve (Part of the public API)
         */return i.getWebsocketReadyState=function(){var e=d.System.Services.serverManager;return null==e?null:e.getWebSocketReadyState()},
/**
         * Returns true if the websocket is ready and false if its not.
         * @function isWebsocketReady
         * @returns {boolean} If true the websocket is ready for connectivity.
         * @preserve (Part of the public API)
         */
i.isWebsocketReady=function(){var e=d.System.Services.serverManager;return null!=e&&e.getWebSocketReadyState()===WebSocket.OPEN},
/**
         * Write one or more values to a TwinCAT HMI Server symbol.
         * @function writeSymbol
         * @memberOf TcHmi.Server
         * @param {string|string[]} symbolName The target TwinCAT HMI Server symbolname.
         * @param {string|number|boolean|Object|Array} value The value which should be written to the target symbol.
         * @param {null | ((this: void, data: TcHmi.Server.IResultObject) => void)} callback Asynchronous response callback which will be raised if the operation has finished.
         * @returns {number} Request id
         * @preserve (Part of the public API)
         */
i.writeSymbol=function(e,r,t){return i.writeSymbolEx(e,r,null,t)},
/**
       * Write one or more values to a TwinCAT HMI Server symbol.
       * @function writeSymbol
       * @memberOf TcHmi.Server
       * @param {string|string[]} symbolName The target TwinCAT HMI Server symbolname.
       * @param {string|number|boolean|Object|Array} value The value which should be written to the target symbol.
       * @param {TcHmi.Server.IRequestOptions} options Request options
       * @param {null | ((this: void, data: TcHmi.Server.IResultObject) => void)} callback Asynchronous response callback which will be raised if the operation has finished.
       * @returns {number} Request id
       * @preserve (Part of the public API)
       */
i.writeSymbolEx=function(e,r,t,o){var n,i,a=d.System.Services.serverManager;if(null==a)return d.Callback.callSafe(o,null,{error:d.Errors.E_WEBSOCKET_NOT_READY}),null;if(Array.isArray(e)){if(!Array.isArray(r)||e.length!==r.length)return d.Callback.callSafe(o,null,{error:d.Errors.E_PARAMETER_INVALID}),null;n=e,i=r}else n=[e],i=[r];for(var s={requestType:"ReadWrite",commands:[]},l=0;l<n.length;l++){var c=n[l],_=i[l];if("string"!=typeof c)return d.Callback.callSafe(o,null,{error:d.Errors.E_PARAMETER_INVALID}),null;s.commands.push({commandOptions:["SendErrorMessage","SendWriteValue"],symbol:c,writeValue:_})}return a.requestEx(s,t,function(e){var r=d.Callback.callSafe(o,null,e);r&&d.Log.error(r)})},
/**
         * Reads the value of a TwinCAT HMI Server symbol.
         * @function readSymbol
         * @memberOf TcHmi.Server
         * @param {string|string[]} symbolName The target TwinCAT HMI Server symbolname.
         * @param {null | ((this: void, data: TcHmi.Server.IResultObject) => void)} callback Asynchronous response callback which will be raised if the operation has finished. The callback function gets 'error' (TcHmi.Errors.E_WEBSOCKET_NOT_READY or TcHmi.Errors.NONE) and the response
         * @returns {number} Request id
         * @preserve (Part of the public API)
         */
i.readSymbol=function(e,r){return i.readSymbolEx(e,null,r)},
/**
        * Reads the value of a TwinCAT HMI Server symbol.
        * @function readSymbol
        * @memberOf TcHmi.Server
        * @param {string|string[]} symbolName The target TwinCAT HMI Server symbolname.
        * @param {TcHmi.Server.IRequestOptions} options Request options
        * @param {null | ((this: void, data: TcHmi.Server.IResultObject) => void)} callback Asynchronous response callback which will be raised if the operation has finished. The callback function gets 'error' (TcHmi.Errors.E_WEBSOCKET_NOT_READY or TcHmi.Errors.NONE) and the response
        * @returns {number} Request id
        * @preserve (Part of the public API)
        */
i.readSymbolEx=function(e,r,t){var o,n=d.System.Services.serverManager;if(null==n)return d.Callback.callSafe(t,null,{error:d.Errors.E_WEBSOCKET_NOT_READY}),null;o=Array.isArray(e)?e:[e];for(var i={requestType:"ReadWrite",commands:[]},a=0;a<o.length;a++){var s=o[a];if("string"!=typeof s)return d.Callback.callSafe(t,null,{error:d.Errors.E_PARAMETER_INVALID}),null;i.commands.push({commandOptions:["SendErrorMessage","SendWriteValue"],symbol:s})}return n.requestEx(i,{},function(e){var r=d.Callback.callSafe(t,null,e);r&&d.Log.error(r)})},
/**
         * Requests a message to the hmi server with default connection parameter
         * @function request
         * @memberOf TcHmi.Server
         * @param {Object} request Request object
         * @param {null | ((this: void, data: TcHmi.Server.IResultObject) => void)} callback Asynchronous response callback which will be raised if the operation has finished. The callback function gets 'error' (TcHmi.Errors.E_WEBSOCKET_NOT_READY or TcHmi.Errors.NONE) and the response
         * @returns {number} Request id
         * @preserve (Part of the public API)
         */
i.request=function(e,r){return i.requestEx(e,null,r)},
/**
        * Requests a message to the hmi server with given connection parameter
        * @function requestEx
        * @memberOf TcHmi.Server
        * @param {Object} request Request object
        * @param {TcHmi.Server.IRequestOptions} options Request options
        * @param {null | ((this: void, data: TcHmi.Server.IResultObject) => void)} callback Asynchronous response callback which will be raised if the operation has finished. The callback function gets 'error' (TcHmi.Errors.E_WEBSOCKET_NOT_READY or TcHmi.Errors.NONE) and the response
        * @returns {number} Request id
        * @preserve (Part of the public API)
        */
i.requestEx=function(e,r,t){var o=d.System.Services.serverManager;return null==o?(d.Callback.callSafe(t,null,{error:d.Errors.E_WEBSOCKET_NOT_READY}),null):o.requestEx(e,r,function(e){var r=d.Callback.callSafe(t,null,e);r&&d.Log.error(r)})},
/**
         * Subscribe to a to a list of commands.
         * Subscription have to be unsubscribed by use of the TcHmi.Server.unsubscribe function.
         * @function subscribe
         * @memberOf TcHmi.Server
         * @param {Object[]} commands
         * @param {number} interval Subscription refresh interval.
         * @param {null | ((this: void, data: TcHmi.Server.IResultObject) => void)} callback Asynchronous response callback which will be raised if the operation has finished.
         * @returns {number} Request id
         * @preserve (Part of the public API)
         */
i.subscribe=function(e,r,t){return i.subscribeEx(e,r,null,t)},
/**
         * Subscribe to a to a list of commands.
         * Subscription have to be unsubscribed by use of the TcHmi.Server.unsubscribe function.
         * @function subscribe
         * @memberOf TcHmi.Server
         * @param {Object[]} commands
         * @param {number} interval Subscription refresh interval.
         * @param {TcHmi.Server.IRequestOptions} options Request options
         * @param {null | ((this: void, data: TcHmi.Server.IResultObject) => void)} callback Asynchronous response callback which will be raised if the operation has finished.
         * @returns {number} Request id
         * @preserve (Part of the public API)
         */
i.subscribeEx=function(e,r,t,o){var n=d.System.Services.serverManager;if(null==n)return d.Callback.callSafe(o,null,{error:d.Errors.E_WEBSOCKET_NOT_READY}),null;var i={requestType:"Subscription",commands:e};return null!=r&&"number"==typeof r&&(i.intervalTime=r),n.requestEx(i,t,function(e){var r=d.Callback.callSafe(o,null,e);r&&d.Log.error(r)})},
/**
         * Unsubscribe a list of commands.
         * @function unsubscribe
         * @memberOf TcHmi.Server
         * @param {number} requestId The id of the subscription request which shall be unsubscribed.
         * @param {null | ((this: void, data: TcHmi.Server.IResultObject) => void)} callback Asynchronous response callback which will be raised if the operation has finished.
         * @returns {number} Request id
         * @preserve (Part of the public API)
         */
i.unsubscribe=function(e,r){return i.unsubscribeEx(e,null,r)},
/**
         * Unsubscribe a list of commands.
         * @function unsubscribe
         * @memberOf TcHmi.Server
         * @param {number} requestId The id of the subscription request which shall be unsubscribed.
         * @param {TcHmi.Server.IRequestOptions} options Request options
         * @param {null | ((this: void, data: TcHmi.Server.IResultObject) => void)} callback Asynchronous response callback which will be raised if the operation has finished.
         * @returns {number} Request id
         * @preserve (Part of the public API)
         */
i.unsubscribeEx=function(e,r,t){var o=d.System.Services.serverManager;if(null==o)return d.Callback.callSafe(t,null,{error:d.Errors.E_WEBSOCKET_NOT_READY}),null;var n={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"Unsubscribe",writeValue:e}]};return i.releaseRequest(e),o.requestEx(n,r,function(e){var r=d.Callback.callSafe(t,null,e);r&&d.Log.error(r)})},i.releaseRequest=function(e){var r=d.System.Services.serverManager;null!=r&&r.releaseRequest(e)},
/**
         * Get current username as string or null.
         * @returns {string|null}
         * @preserve (Part of the public API)
         */
i.getCurrentUser=function(){return d.System.Services.accessManager.getCurrentUserConfig().name},
/**
         * Get groups membership of current user as array (can be empty).
         * @returns {string[]}
         * @preserve (Part of the public API)
         */
i.getGroupsOfCurrentUser=function(){return d.System.Services.accessManager.getCurrentUserConfig().userIsInGroups},
/**
         * Get current user config.
         * @preserve (Part of the public API)
         */
i.getCurrentUserConfig=function(){return d.System.Services.accessManager.getCurrentUserConfig()},
/**
         * Login into a TcHmiServer, reloads the page on success, call of a callback on failure
         * @param {string | null | undefined} username String with the username
         * @param {string | null | undefined} password String with the password
         * @param {boolean = true} persistent Should the session be valid even after browser restart
         * @param {null | ((this: void, data: TcHmi.Server.IResultObject) => void)} callback? This callback is called if the login was not successful
         * @return {boolean} returns a boolean if the login was called
         * @preserve (Part of the public API)
         */
i.login=function(e,r,t,o){return void 0===t&&(t=!0),i.loginEx(e,r,t,null,o)},
/**
         * Login into a TcHmiServer, reloads the page on success, call of a callback on failure
         * @param {string | null | undefined} username String with the username
         * @param {string | null | undefined} password String with the password
         * @param {boolean = true} persistent Should the session be valid even after browser restart
         * @param {TcHmi.Server.IRequestOptions} options Request options
         * @param {null | ((this: void, data: TcHmi.ResultObject) => void)} callback? This callback is called if the login was not successful
         * @return {boolean} returns a boolean if the login was called
         * @preserve (Part of the public API)
         */
i.loginEx=function(e,r,t,o,n){void 0===t&&(t=!0);var i=d.System.Services.serverManager;return null==i?(d.Callback.callSafe(n,null,{error:d.Errors.E_WEBSOCKET_NOT_READY}),!1):null==e||"string"!=typeof e?(d.Callback.callSafe(n,null,{error:d.Errors.E_PARAMETER_INVALID}),!1):null==r||"string"!=typeof r?(d.Callback.callSafe(n,null,{error:d.Errors.E_PARAMETER_INVALID}),!1):i.login(e,r,t,o,n)},
/**
         * Logout from a TcHmiServer, reloads the page on success, call of a callback on failure
         * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback This callback is called if the logout was not successful
         * @return {boolean} returns a boolean if the logout was called
         * @preserve (Part of the public API)
         */
i.logout=function(e){return i.logoutEx(null,e)},
/**
         * Logout from a TcHmiServer, reloads the page on success, call of a callback on failure
         * @param {TcHmi.Server.IRequestOptions} options Request options
         * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback This callback is called if the logout was not successful
         * @return {boolean} returns a boolean if the logout was called
         * @preserve (Part of the public API)
         */
i.logoutEx=function(e,r){var t=!1,o=d.System.Services.serverManager;return null==o?(d.Callback.callSafe(r,null,{error:d.Errors.E_WEBSOCKET_NOT_READY}),t):t=o.logout(e,r)},
/**
         * Logout all users with a specific username or all users from a TcHmiServer
         * @param {string} username username to logout. If empty string or null is provided, all users are logged out
         * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback This callback is called if the logout was not successful
         * @return {boolean} returns a boolean if the logout was called
         * @preserve (Part of the public API)
         */
i.forceLogout=function(e,r){return i.forceLogoutEx(e,null,r)},
/**
         * Logout all users with a specific username or all users from a TcHmiServer
         * @param {string} username username to logout. If empty string or null is provided, all users are logged out
         * @param {TcHmi.Server.IRequestOptions} options Request options
         * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback This callback is called if the logout was not successful
         * @return {boolean} returns a boolean if the logout was called
         * @preserve (Part of the public API)
         */
i.forceLogoutEx=function(e,r,t){var o=d.System.Services.serverManager;if(null==o)return d.Callback.callSafe(t,null,{error:d.Errors.E_WEBSOCKET_NOT_READY}),!1;if(void 0===e||""===e)e=null;else if(null!==e&&"string"!=typeof e)return!1;return o.forceLogout(e,r,function(e){if("function"==typeof t){if(e.error!==d.Errors.NONE||!e.response)return void d.Callback.callSafe(t,null,{error:d.Errors.E_WEBSOCKET_NOT_READY});e.response.commands&&1===e.response.commands.length&&e.response.commands[0].error&&e.response.commands[0].error.code&&d.Callback.callSafe(t,null,{error:d.Errors.ERROR})}})},i.__handleCallbackVoid=function(s,l){return function(e){var r;if(e.error!==d.Errors.NONE)d.Callback.callSafe(s,null,{error:e.error,details:e.details});else{var t=e.response;if(!t)return void((r=d.Callback.callSafe(s,null,{error:d.Errors.E_SERVER_RESPONSE_MISSING}))&&d.Log.error(r));if(t.error)return void((r=d.Callback.callSafe(s,null,{error:d.Errors.E_SERVER_RESPONSE_ERROR,details:{code:d.Errors.E_SERVER_RESPONSE_ERROR,message:d.Errors[d.Errors.E_SERVER_RESPONSE_ERROR],errors:[t.error]}}))&&d.Log.error(r));var o=t.commands;if(!o)return void((r=d.Callback.callSafe(s,null,{error:d.Errors.E_SERVER_COMMANDS_MISSING}))&&d.Log.error(r));if(0===o.length)return void((r=d.Callback.callSafe(s,null,{error:d.Errors.E_SERVER_COMMAND_MISSING}))&&d.Log.error(r));for(var n=0,i=o;n<i.length;n++){var a=i[n];if(a.error)return void((r=d.Callback.callSafe(s,null,{error:d.Errors.E_SERVER_COMMAND_ERROR,details:{code:d.Errors.E_SERVER_COMMAND_ERROR,message:d.Errors[d.Errors.E_SERVER_COMMAND_ERROR],errors:[a.error]}}))&&d.Log.error(r))}l?l(e):d.Callback.callSafe(s,null,{error:d.Errors.NONE})}}},i}();d.Server=e,function(c){var e;(e=c.Error||(c.Error={}))[e.HMI_SUCCESS=0]="HMI_SUCCESS",e[e.HMI_E_FAIL=257]="HMI_E_FAIL",e[e.HMI_E_SYMBOL_IN_USE=274]="HMI_E_SYMBOL_IN_USE",e[e.HMI_E_SYMBOL_NOT_MAPPED=513]="HMI_E_SYMBOL_NOT_MAPPED",e[e.HMI_E_MISSING_LICENSE_HANDSHAKE=781]="HMI_E_MISSING_LICENSE_HANDSHAKE",e[e.HMI_E_LICENSE_VERIFY=782]="HMI_E_LICENSE_VERIFY",e[e.HMI_E_INSUFFICIENT_ACCESS=4101]="HMI_E_INSUFFICIENT_ACCESS";var r=function(){function e(){}
/**
             * Add a new user with a given password
             * @param {string} userName
             * @param {string} password
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */return e.addUser=function(e,r,t){return void 0===t&&(t=null),this.addUserEx(e,r,null,null,t)},
/**
             * Add a new user with a given password
             * @param {string} userName
             * @param {string} password
             * @param {object} options optional options
             * @param {string} options.domain domain of user management. defaults to TcHmiUserManagement
             * @param {boolean} options.enabled a new user can be disabled
             * @param {string} options.autoLogout ISO8601 TimeSpan for logout after user interaction
             * @param {string} options.locale locale of this user
             * @param {string[]} options.groups list of groups the user will be part of
             * @param {TcHmi.Server.IRequestOptions} requestOptions Request options
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
e.addUserEx=function(t,e,o,n,i){if(void 0===o&&(o=null),void 0===n&&(n=null),void 0===i&&(i=null),!t)return d.Callback.callSafe(i,null,{error:d.Errors.E_PARAMETER_INVALID}),d.Errors.E_PARAMETER_INVALID;if(!e)return d.Callback.callSafe(i,null,{error:d.Errors.E_PARAMETER_INVALID}),d.Errors.E_PARAMETER_INVALID;var a="TcHmiUserManagement",r={userName:t,password:e};o&&("string"==typeof o.domain&&(a=o.domain),"boolean"==typeof o.enabled&&(r.enabled=o.enabled));var s={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:a+".AddUser",writeValue:r}]};return c.requestEx(s,n,c.__handleCallbackVoid(i,function(e){var r={requestType:"ReadWrite",commands:[]};o&&("string"==typeof o.locale&&r.commands.push({commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"TcHmiSrv.Config::USERGROUPUSERS::"+a+"::"+t+"::USERGROUPUSERS_LOCALE",writeValue:o.locale}),"string"==typeof o.autoLogout&&r.commands.push({commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"TcHmiSrv.Config::USERGROUPUSERS::"+a+"::"+t+"::USERGROUPUSERS_AUTO_LOGOFF",writeValue:o.autoLogout}),Array.isArray(o.groups)&&r.commands.push({commandOptions:["SendErrorMessage","SendWriteValue","Add"],symbol:"TcHmiSrv.Config::USERGROUPUSERS::"+a+"::"+t+"::USERGROUPUSERS_GROUPS",writeValue:o.groups})),r.commands.length?c.requestEx(r,n,c.__handleCallbackVoid(i)):d.Callback.callSafe(i,null,{error:d.Errors.NONE})})),d.Errors.NONE},
/**
             * Lists all usernames as a string array
             * @param {null | ((this: void, data: TcHmi.Server.UserManagement.IUserListResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
e.listUsernames=function(e){return void 0===e&&(e=null),this.listUsernamesEx(null,null,e)},
/**
             * Lists all usernames as a string array
             * @param {object} options optional options
             * @param {string} options.domain domain of user management. defaults to TcHmiUserManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.Server.UserManagement.IUserListResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
e.listUsernamesEx=function(e,r,t){void 0===r&&(r=null),void 0===t&&(t=null);var o="TcHmiUserManagement";e&&"string"==typeof e.domain&&(o=e.domain);var n={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:o+".ListUsers"}]};return c.requestEx(n,r,c.__handleCallbackVoid(t,function(e){d.Callback.callSafe(t,null,{error:d.Errors.NONE,details:e.response.commands[0].readValue})})),d.Errors.NONE},
/**
             * Lists all username as a dictionary with all meta data
             * @param {null | ((this: void, data: TcHmi.Server.UserManagement.IUserResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
e.listUsers=function(e){return void 0===e&&(e=null),this.listUsersEx(null,null,e)},
/**
             * Lists all username as a dictionary with all meta data
             * @param {object} options optional options
             * @param {string} options.domain domain of user management. defaults to TcHmiUserManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions Request options
             * @param {null | ((this: void, data: TcHmi.Server.UserManagement.IUserResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
e.listUsersEx=function(e,r,i){void 0===r&&(r=null),void 0===i&&(i=null);var a="TcHmiUserManagement";e&&"string"==typeof e.domain&&(a=e.domain);var t={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:a+".Config::USERS"},{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"TcHmiSrv.Config::USERGROUPUSERS::"+a}]};return c.requestEx(t,r,c.__handleCallbackVoid(i,function(e){var r={},t=e.response.commands[0].readValue,o=e.response.commands[1].readValue;for(var n in t)r[n]={domain:a,enabled:t[n].ENABLED,autoLogout:o[n].USERGROUPUSERS_AUTO_LOGOFF,locale:o[n].USERGROUPUSERS_LOCALE,groups:o[n].USERGROUPUSERS_GROUPS};d.Callback.callSafe(i,null,{error:d.Errors.NONE,userDetails:r})})),d.Errors.NONE},
/**
             * Lists all users of a group as a string array
             * @param {null | ((this: void, data: TcHmi.Server.UserManagement.IUserListResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
e.listUsersInGroup=function(e,r){return void 0===r&&(r=null),this.listUsersInGroupEx(e,null,null,r)},
/**
             * Lists all users of a group as a string array
             * @param {object} options optional options
             * @param {string} options.domain domain of user management. defaults to TcHmiUserManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.Server.UserManagement.IUserListResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
e.listUsersInGroupEx=function(n,e,r,i){void 0===r&&(r=null),void 0===i&&(i=null);var t="TcHmiUserManagement";e&&"string"==typeof e.domain&&(t=e.domain);var o={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"TcHmiSrv.Config::USERGROUPUSERS::"+t}]};return c.requestEx(o,r,c.__handleCallbackVoid(i,function(e){var r=[],t=e.response.commands[0].readValue;for(var o in t)t[o].USERGROUPUSERS_GROUPS&&-1!==t[o].USERGROUPUSERS_GROUPS.indexOf(n)&&r.push(o);d.Callback.callSafe(i,null,{error:d.Errors.NONE,userList:r})})),d.Errors.NONE},
/**
             * Removes a user
             * @param userName
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
e.removeUser=function(e,r){return void 0===r&&(r=null),this.removeUserEx(e,null,null,r)},
/**
              * Removes a user
              * @param {string} userName
              * @param {object} options optional options
              * @param {string} options.domain defaults to TcHmiUserManagement
              * @param {TcHmi.Server.IRequestOptions} requestOptions Request options
              * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
              * @preserve (Part of the public API)
              */
e.removeUserEx=function(e,r,t,o){if(void 0===t&&(t=null),void 0===o&&(o=null),!e)return d.Callback.callSafe(o,null,{error:d.Errors.E_PARAMETER_INVALID}),d.Errors.E_PARAMETER_INVALID;var n="TcHmiUserManagement";r&&"string"==typeof r.domain&&(n=r.domain);var i={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:n+".RemoveUser",writeValue:e}]};return c.requestEx(i,t,c.__handleCallbackVoid(o)),d.Errors.NONE},
/**
             * Update user config
             * @param userName
             * @param {object} options optional options
             * @param {string} options.domain domain of user management. defaults to TcHmiUserManagement
             * @param {boolean} options.enabled a new user can be disabled
             * @param {string} options.autoLogout ISO8601 TimeSpan for logout after user interaction
             * @param {string} options.locale locale of this user
             * @param {string} options.newName new name for this user
             * @param {string} options.password new password for this user
             * @param {string[]} options.addGroups List of groups the user will be added
             * @param {string[]} options.removeGroups List of groups the user will be removed
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
e.updateUser=function(e,r,t){return void 0===t&&(t=null),this.updateUserEx(e,r,null,t)},
/**
             * Update user config
             * @param userName
             * @param {object} options optional options
             * @param {string} options.domain domain of user management. defaults to TcHmiUserManagement
             * @param {boolean} options.enabled a new user can be disabled
             * @param {string} options.autoLogout ISO8601 TimeSpan for logout after user interaction
             * @param {string} options.locale locale of this user
             * @param {string[]} options.addGroups List of groups the user will be added
             * @param {string[]} options.removeGroups List of groups the user will be removed
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
e.updateUserEx=function(e,r,t,o){if(void 0===t&&(t=null),void 0===o&&(o=null),!e)return d.Callback.callSafe(o,null,{error:d.Errors.E_PARAMETER_INVALID}),d.Errors.E_PARAMETER_INVALID;var n="TcHmiUserManagement",i={requestType:"ReadWrite",commands:[]};if(r){if("string"==typeof r.domain&&(n=r.domain),"string"==typeof r.password&&i.commands.push({commandOptions:["SendErrorMessage","SendWriteValue"],symbol:n+".AddUser",writeValue:{userName:e,password:r.password}}),"boolean"==typeof r.enabled&&i.commands.push({commandOptions:["SendErrorMessage","SendWriteValue"],symbol:n+".Config::USERS::"+e+"::ENABLED",writeValue:r.enabled}),"string"==typeof r.autoLogout&&i.commands.push({commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"TcHmiSrv.Config::USERGROUPUSERS::"+n+"::"+e+"::USERGROUPUSERS_AUTO_LOGOFF",writeValue:r.autoLogout}),"string"==typeof r.locale&&i.commands.push({commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"TcHmiSrv.Config::USERGROUPUSERS::"+n+"::"+e+"::USERGROUPUSERS_LOCALE",writeValue:r.locale}),Array.isArray(r.addGroups)&&i.commands.push({commandOptions:["SendErrorMessage","SendWriteValue","Add"],symbol:"TcHmiSrv.Config::USERGROUPUSERS::"+n+"::"+e+"::USERGROUPUSERS_GROUPS",writeValue:r.addGroups}),Array.isArray(r.removeGroups))for(var a=0,s=r.removeGroups;a<s.length;a++){var l=s[a];i.commands.push({commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"Remove",writeValue:{domain:"TcHmiSrv",path:"USERGROUPUSERS::"+n+"::"+e+"::USERGROUPUSERS_GROUPS",value:l}})}"string"==typeof r.newName&&i.commands.push({commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"Rename",writeValue:{domain:n,old:"Config::USERS::"+e,new:"Config::USERS::"+r.newName}})}return i.commands.length?c.requestEx(i,t,c.__handleCallbackVoid(o)):d.Callback.callSafe(o,null,{error:d.Errors.NONE}),d.Errors.NONE},e}();c.UserManagement=r;var t=function(){function l(){}
/**
             * Lists all available recipe types
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */return l.listRecipeTypes=function(e){return void 0===e&&(e=null),this.listRecipeTypesEx(null,null,e)},
/**
             * Lists all available recipe types
             * This function provides more options to manipulate the request
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.listRecipeTypesEx=function(e,r,t){void 0===r&&(r=null),void 0===t&&(t=null);var o="TcHmiRecipeManagement";e&&"string"==typeof e.domain&&(o=e.domain);var n={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:o+".Config::recipeTypeList"}]};c.requestEx(n,r,d.Server.__handleCallbackVoid(t,function(e){d.Callback.callSafe(t,null,{error:d.Errors.NONE,value:e.response.commands[0].readValue})}))},
/**
             * Creates a recipe type folder
             * @param {string} path name of the new folder
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.createRecipeTypeFolder=function(e,r){return void 0===r&&(r=null),this.createRecipeTypeFolderEx(e,null,null,r)},
/**
             * Creates a recipe type folder
             * This function provides more options to manipulate the request
             * @param {string} path name of the new folder
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.createRecipeTypeFolderEx=function(e,r,t,o){if(void 0===t&&(t=null),void 0===o&&(o=null),"string"==typeof e&&""!==e){var n="TcHmiRecipeManagement";r&&"string"==typeof r.domain&&(n=r.domain);var i={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:n+".Config::recipeTypeList::"+e,writeValue:{}}]};c.requestEx(i,t,d.Server.__handleCallbackVoid(o))}else d.Callback.callSafe(o,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Deletes a recipe type folder
             * @param {string} path name of the folder
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.deleteRecipeTypeFolder=function(e,r){return void 0===r&&(r=null),this.deleteRecipeTypeFolderEx(e,null,null,r)},
/**
             * Deletes a recipe type folder
             * This function provides more options to manipulate the request
             * @param {string} path name of the folder
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.deleteRecipeTypeFolderEx=function(e,r,t,o){if(void 0===t&&(t=null),void 0===o&&(o=null),"string"==typeof e&&""!==e){var n="TcHmiRecipeManagement";r&&"string"==typeof r.domain&&(n=r.domain);var i={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue","Replace"],symbol:n+".Config::recipeTypeList::"+e}]};c.requestEx(i,t,d.Server.__handleCallbackVoid(o))}else d.Callback.callSafe(o,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Creates a new recipe type
             * @param {string} recipeTypeName name of the recipe type
             * @param {TcHmi.Server.RecipeManagement.RecipeType} recipeType recipe type definition
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.createRecipeType=function(e,r,t,o){return void 0===o&&(o=null),this.createRecipeTypeEx(e,r,t,null,null,o)},
/**
             * Creates a new recipe type
             * This function provides more options to manipulate the request
             * @param {string} recipeTypeName name of the recipe type
             * @param {TcHmi.Server.RecipeManagement.RecipeType} recipeType recipe type definition
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.createRecipeTypeEx=function(e,r,t,o,n,i){if(void 0===n&&(n=null),void 0===i&&(i=null),"string"==typeof e&&""!==e){var a="TcHmiRecipeManagement";o&&"string"==typeof o.domain&&(a=o.domain);var s={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:a+".Config::recipeTypeList::"+(t?t+"::":"")+e,writeValue:r}]};c.requestEx(s,n,d.Server.__handleCallbackVoid(i))}else d.Callback.callSafe(i,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Renames or moves a recipe type
             * @param {string} recipeTypeName old name of the recipe type
             * @param {string | null} path old path of the recipe type (root folder if set to null)
             * @param {string} newName new name of the recipe type
             * @param {string | null} newPath new path of the recipe type (root folder if set to null)
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.renameRecipeType=function(e,r,t,o,n){return void 0===n&&(n=null),this.renameRecipeTypeEx(e,r,t,o,null,null,n)},
/**
             * Renames or moves a recipe type
             * This function provides more options to manipulate the request
             * @param {string} recipeTypeName old name of the recipe type
             * @param {string | null} path old path of the recipe type (root folder if set to null)
             * @param {string} newName new name of the recipe type
             * @param {string | null} newPath new path of the recipe type (root folder if set to null)
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.renameRecipeTypeEx=function(e,r,t,o,n,i,a){if(void 0===i&&(i=null),void 0===a&&(a=null),"string"==typeof e&&""!==e&&"string"==typeof t&&""!==t){var s="TcHmiRecipeManagement";n&&"string"==typeof n.domain&&(s=n.domain);var l={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue","Replace"],symbol:"Rename",writeValue:{domain:s,configuration:"default",old:"recipeTypeList::"+(r?r+"::":"")+e,new:"recipeTypeList::"+(o?o+"::":"")+t}}]};c.requestEx(l,i,d.Server.__handleCallbackVoid(a))}else d.Callback.callSafe(a,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Deletes a recipe type
             * @param {string} recipeTypeName name of the recipe type
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.deleteRecipeType=function(e,r,t){return void 0===t&&(t=null),this.deleteRecipeTypeEx(e,r,null,null,t)},
/**
             * Deletes a recipe type
             * This function provides more options to manipulate the request
             * @param {string} recipeTypeName name of the recipe type
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.deleteRecipeTypeEx=function(e,r,t,o,n){if(void 0===o&&(o=null),void 0===n&&(n=null),"string"==typeof e&&""!==e){var i="TcHmiRecipeManagement";t&&"string"==typeof t.domain&&(i=t.domain);var a={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue","Replace"],symbol:i+".Config::recipeTypeList::"+(r?r+"::":"")+e}]};c.requestEx(a,o,d.Server.__handleCallbackVoid(n))}else d.Callback.callSafe(n,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Lists all available recipes
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.listRecipes=function(e){return void 0===e&&(e=null),this.listRecipesEx(null,null,e)},
/**
             * Lists all available recipes
             * This function provides more options to manipulate the request
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.listRecipesEx=function(e,r,t){void 0===r&&(r=null),void 0===t&&(t=null);var o="TcHmiRecipeManagement";e&&"string"==typeof e.domain&&(o=e.domain);var n={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:o+".Config::recipeList"}]};c.requestEx(n,r,d.Server.__handleCallbackVoid(t,function(e){d.Callback.callSafe(t,null,{error:d.Errors.NONE,value:e.response.commands[0].readValue})}))},
/**
             * Creates a recipe folder
             * @param {string} path name of the new folder
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.createRecipeFolder=function(e,r){return void 0===r&&(r=null),this.createRecipeFolderEx(e,null,null,r)},
/**
             * Creates a recipe folder
             * This function provides more options to manipulate the request
             * @param {string} path name of the new folder
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.createRecipeFolderEx=function(e,r,t,o){if(void 0===t&&(t=null),void 0===o&&(o=null),"string"==typeof e&&""!==e){var n="TcHmiRecipeManagement";r&&"string"==typeof r.domain&&(n=r.domain);var i={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:n+".Config::recipeList::"+e,writeValue:{}}]};c.requestEx(i,t,d.Server.__handleCallbackVoid(o))}else d.Callback.callSafe(o,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Deletes a recipe folder
             * @param {string} path name of the folder
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.deleteRecipeFolder=function(e,r){return void 0===r&&(r=null),this.deleteRecipeFolderEx(e,null,null,r)},
/**
             * Deletes a recipe folder
             * This function provides more options to manipulate the request
             * @param {string} path name of the folder
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.deleteRecipeFolderEx=function(e,r,t,o){if(void 0===t&&(t=null),void 0===o&&(o=null),"string"==typeof e&&""!==e){var n="TcHmiRecipeManagement";r&&"string"==typeof r.domain&&(n=r.domain);var i={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue","Replace"],symbol:n+".Config::recipeList::"+e}]};c.requestEx(i,t,d.Server.__handleCallbackVoid(o))}else d.Callback.callSafe(o,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Creates a new recipe
             * @param {string} recipeName name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {TcHmi.Server.RecipeManagement.Recipe} recipe recipe definition
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.createRecipe=function(e,r,t,o){return void 0===o&&(o=null),this.createRecipeEx(e,r,t,null,null,o)},
/**
             * Creates a new recipe
             * This function provides more options to manipulate the request
             * @param {string} recipeName name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {TcHmi.Server.RecipeManagement.Recipe} recipe recipe definition
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.createRecipeEx=function(e,r,t,o,n,i){if(void 0===n&&(n=null),void 0===i&&(i=null),"string"==typeof e&&""!==e){var a="TcHmiRecipeManagement";o&&"string"==typeof o.domain&&(a=o.domain);var s={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:a+".Config::recipeList"+(r?"::"+r:"")+"::"+e,writeValue:t}]};c.requestEx(s,n,d.Server.__handleCallbackVoid(i))}else d.Callback.callSafe(i,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Lists one recipe
             * @param {string} recipeName name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.getRecipe=function(e,r,t){return void 0===t&&(t=null),this.getRecipeEx(e,r,null,null,t)},
/**
             * Lists one recipe
             * This function provides more options to manipulate the request
             * @param {string} recipeName name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.getRecipeEx=function(e,r,t,o,n){if(void 0===o&&(o=null),void 0===n&&(n=null),"string"==typeof e&&""!==e){var i="TcHmiRecipeManagement";t&&"string"==typeof t.domain&&(i=t.domain);var a={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:i+".Config::recipeList"+(r?"::"+r:"")+"::"+e}]};c.requestEx(a,o,d.Server.__handleCallbackVoid(n,function(e){d.Callback.callSafe(n,null,{error:d.Errors.NONE,value:e.response.commands[0].readValue})}))}else d.Callback.callSafe(n,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Updates a recipe
             * @param {string} recipeName name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {Dictionary<any>} newValues dictionary of the new values
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.updateRecipe=function(e,r,t,o){return void 0===o&&(o=null),this.updateRecipeEx(e,r,t,null,null,o)},
/**
             * Updates a recipe
             * This function provides more options to manipulate the request
             * @param {string} recipeName name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {Dictionary<any>} newValues dictionary of the new values
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.updateRecipeEx=function(e,r,t,o,n,i){if(void 0===n&&(n=null),void 0===i&&(i=null),"string"==typeof e&&""!==e){var a="TcHmiRecipeManagement";o&&"string"==typeof o.domain&&(a=o.domain);var s={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:a+".Config::recipeList"+(r?"::"+r:"")+"::"+e+"::values",writeValue:t}]};c.requestEx(s,n,d.Server.__handleCallbackVoid(i))}else d.Callback.callSafe(i,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Reads all values which is referenced by a recipe
             * @param {string} recipeName name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.readFromTarget=function(e,r,t){return void 0===t&&(t=null),this.readFromTargetEx(e,r,null,null,t)},
/**
             * Reads all values which is referenced by a recipe
             * This function provides more options to manipulate the request
             * @param {string} recipeName name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.readFromTargetEx=function(e,r,t,o,n){if(void 0===o&&(o=null),void 0===n&&(n=null),"string"==typeof e&&""!==e){var i="TcHmiRecipeManagement";t&&"string"==typeof t.domain&&(i=t.domain);var a={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:i+".ReadFromTarget",writeValue:{path:(r?r+"::":"")+e}}]};c.requestEx(a,o,d.Server.__handleCallbackVoid(n,function(e){d.Callback.callSafe(n,null,{error:d.Errors.NONE,value:e.response.commands[0].readValue})}))}else d.Callback.callSafe(n,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Reads the current values which are referenced from a base recipe and write it back
             * @param {string} recipeName name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.teach=function(e,r,t){return void 0===t&&(t=null),this.teachEx(e,r,null,null,t)},
/**
             * Reads the current values which are referenced from a base recipe and write it back
             * This function provides more options to manipulate the request
             * @param {string} recipeName name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.teachEx=function(r,t,o,n,i){void 0===n&&(n=null),void 0===i&&(i=null),this.readFromTargetEx(r,t,o,n,function(e){e.error===d.Errors.NONE?l.createRecipeEx(r,t,e.value[(t?t+"::":"")+r],o,n,i):d.Callback.callSafe(i,null,e)})},
/**
             * Reads the current values which are referenced from a base recipe and write it into a new recipe
             * @param {string} recipeName name of the base recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {string} newRecipeName name of the new recipe. (could be prefixed with a path if seperated with ::)
             * @param {string | null} newRecipePath path of the new recipe. (root folder if set to null)
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.teachAsNewRecipe=function(e,r,t,o,n){return void 0===n&&(n=null),this.teachAsNewRecipeEx(e,r,t,o,null,null,n)},
/**
             * Reads the current values which are referenced from a base recipe and write it into a new recipe
             * This function provides more options to manipulate the request
             * @param {string} recipeName name of the base recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {string} newRecipeName name of the new recipe. (could be prefixed with a path if seperated with ::)
             * @param {string | null} newRecipePath path of the new recipe. (root folder if set to null)
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.teachAsNewRecipeEx=function(r,t,o,n,i,a,s){void 0===a&&(a=null),void 0===s&&(s=null),"string"==typeof o&&""!==o?this.readFromTargetEx(r,t,i,a,function(e){e.error===d.Errors.NONE?l.createRecipeEx(o,n,e.value[(t?t+"::":"")+r],i,a,s):d.Callback.callSafe(s,null,e)}):d.Callback.callSafe(s,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Activates a recipe (writes all values)
             * @param {string} recipeName name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.activate=function(e,r,t){return void 0===t&&(t=null),this.activateEx(e,r,null,null,t)},
/**
             * Activates a recipe (writes all values)
             * This function provides more options to manipulate the request
             * @param {string} recipeName name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.activateEx=function(e,r,t,o,n){if(void 0===o&&(o=null),void 0===n&&(n=null),"string"==typeof e&&""!==e){var i="TcHmiRecipeManagement";t&&"string"==typeof t.domain&&(i=t.domain);var a={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:i+".ActivateRecipe",writeValue:{path:(r?r+"::":"")+e}}]};c.requestEx(a,o,d.Server.__handleCallbackVoid(n))}else d.Callback.callSafe(n,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Renames or moves a recipe
             * @param {string} recipeName old name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path old path of the recipe (root folder if set to null)
             * @param {string} newName new name of the recipe
             * @param {string | null} newPath new path of the recipe (root folder if set to null)
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.renameRecipe=function(e,r,t,o,n){return void 0===n&&(n=null),this.renameRecipeEx(e,r,t,o,null,null,n)},
/**
             * Renames or moves a recipe
             * This function provides more options to manipulate the request
             * @param {string} recipeName old name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path old path of the recipe (root folder if set to null)
             * @param {string} newName new name of the recipe
             * @param {string | null} newPath new path of the recipe (root folder if set to null)
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.renameRecipeEx=function(e,r,t,o,n,i,a){if(void 0===i&&(i=null),void 0===a&&(a=null),"string"==typeof e&&""!==e&&"string"==typeof t&&""!==t){var s="TcHmiRecipeManagement";n&&"string"==typeof n.domain&&(s=n.domain);var l={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue","Replace"],symbol:"Rename",writeValue:{domain:s,configuration:"default",old:"recipeList::"+(r?r+"::":"")+e,new:"recipeList::"+(o?o+"::":"")+t}}]};c.requestEx(l,i,d.Server.__handleCallbackVoid(a))}else d.Callback.callSafe(a,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Deletes a recipe
             * @param {string} recipeName name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.deleteRecipe=function(e,r,t){return void 0===t&&(t=null),this.deleteRecipeEx(e,r,null,null,t)},
/**
             * Deletes a recipe
             * This function provides more options to manipulate the request
             * @param {string} recipeName name of the recipe (could be prefixed with a path if seperated with ::)
             * @param {string | null} path path of the recipe (root folder if set to null)
             * @param {object} options optional options
             * @param {string} options.domain domain of recipe management. defaults to recipeManagement
             * @param {TcHmi.Server.IRequestOptions} requestOptions for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
l.deleteRecipeEx=function(e,r,t,o,n){if(void 0===o&&(o=null),void 0===n&&(n=null),"string"==typeof e&&""!==e){var i="TcHmiRecipeManagement";t&&"string"==typeof t.domain&&(i=t.domain);var a={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue","Replace"],symbol:i+".Config::recipeList::"+(r?r+"::":"")+e}]};c.requestEx(a,o,d.Server.__handleCallbackVoid(n))}else d.Callback.callSafe(n,null,{error:d.Errors.E_PARAMETER_INVALID})},l}();c.RecipeManagement=t;var o=function(){function o(){}
/**
             * Adding a Symbol to the Historize Configuration of the server
             * @param {string} symbolName Name of the Symbol to manipulate
             * @param {TcHmi.Server.Historize.IEntrySettings} settings
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */return o.add=function(e,r,t){void 0===t&&(t=null),o.addEx(e,r,null,t)},
/**
             * Adding a Symbol to the Historize Configuration of the server
             * @param {string} symbolName Name of the Symbol to manipulate
             * @param {TcHmi.Server.Historize.IEntrySettings} settings
             * @param {TcHmi.Server.IRequestOptions} options for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
o.addEx=function(e,r,t,o){if(void 0===o&&(o=null),e)if(null!=r&&"object"==typeof r){var n={INTERVAL:"PT1S",MAXENTRIES:1e4,ROWLIMIT:1e4,RECORDINGENABLED:!0};void 0!==r.INTERVAL&&(n.INTERVAL=r.INTERVAL),void 0!==r.MAXENTRIES&&(n.MAXENTRIES=r.MAXENTRIES),void 0!==r.ROWLIMIT&&(n.ROWLIMIT=r.ROWLIMIT),void 0!==r.RECORDINGENABLED&&(n.RECORDINGENABLED=r.RECORDINGENABLED);var i={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"TcHmiSqliteHistorize.Config::HISTORIZEDSYMBOLLIST::"+e,writeValue:n}]};c.requestEx(i,t,d.Server.__handleCallbackVoid(o))}else d.Callback.callSafe(o,null,{error:d.Errors.E_PARAMETER_INVALID});else d.Callback.callSafe(o,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Removing a Symbol from the Historize Configuration of the server
             * @param {string} symbolName Name of the Symbol to manipulate
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
o.remove=function(e,r){void 0===r&&(r=null),o.removeEx(e,null,r)},
/**
             * Removing a Symbol from the Historize Configuration of the server
             * @param {string} symbolName Name of the Symbol to manipulate
             * @param {TcHmi.Server.IRequestOptions} options for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
o.removeEx=function(e,r,t){if(void 0===t&&(t=null),e){var o={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue","Replace"],symbol:"TcHmiSqliteHistorize.Config::HISTORIZEDSYMBOLLIST::"+e,writeValue:null}]};c.requestEx(o,r,d.Server.__handleCallbackVoid(t))}else d.Callback.callSafe(t,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Update a config of a Symbol in the Historize Configuration of the server
             * @param {string} symbolName Name of the Symbol to manipulate
             * @param {TcHmi.Server.Historize.IEntrySettings} settings
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
o.update=function(e,r,t){void 0===t&&(t=null),o.updateEx(e,r,null,t)},
/**
             * Update a config of a Symbol in the Historize Configuration of the server
             * @param {string} symbolName Name of the Symbol to manipulate
             * @param {TcHmi.Server.Historize.IEntrySettings} settings
             * @param {TcHmi.Server.IRequestOptions} options for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
o.updateEx=function(n,i,a,s){if(void 0===s&&(s=null),n)if(null!=i&&"object"==typeof i){var e={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage"],symbol:"TcHmiSqliteHistorize.Config::HISTORIZEDSYMBOLLIST::"+n}]};c.requestEx(e,a,c.__handleCallbackVoid(s,function(e){var r=e.response.commands[0].readValue;if(r){var t=tchmi_clone_object(r);void 0!==i.INTERVAL&&(t.INTERVAL=i.INTERVAL),void 0!==i.MAXENTRIES&&(t.MAXENTRIES=i.MAXENTRIES),void 0!==i.ROWLIMIT&&(t.ROWLIMIT=i.ROWLIMIT),void 0!==i.RECORDINGENABLED&&(t.RECORDINGENABLED=i.RECORDINGENABLED);var o={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"TcHmiSqliteHistorize.Config::HISTORIZEDSYMBOLLIST::"+n,writeValue:t}]};c.requestEx(o,a,d.Server.__handleCallbackVoid(s))}else d.Callback.callSafe(s,null,{error:d.Errors.E_SERVER_READVALUE_MISSING})}))}else d.Callback.callSafe(s,null,{error:d.Errors.E_PARAMETER_INVALID});else d.Callback.callSafe(s,null,{error:d.Errors.E_PARAMETER_INVALID})},
/**
             * Gets the current config of a Symbol in the Historize Configuration of the server
             * @param {string} symbolName Name of the Symbol to manipulate
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
o.get=function(e,r){void 0===r&&(r=null),o.getEx(e,null,r)},
/**
             * Gets the current config of a Symbol in the Historize Configuration of the server
             * @param {string} symbolName Name of the Symbol to manipulate
             * @param {TcHmi.Server.IRequestOptions} options for the request itself
             * @param {null | ((this: void, data: TcHmi.IResultObject) => void)} callback
             * @preserve (Part of the public API)
             */
o.getEx=function(o,e,n){if(void 0===n&&(n=null),o){var r={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"TcHmiSqliteHistorize.Config::HISTORIZEDSYMBOLLIST::"+o}]};c.requestEx(r,e,c.__handleCallbackVoid(n,function(e){var r=e.response.commands[0].readValue;if(r){var t=tchmi_clone_object(r);d.Callback.callSafe(n,null,{error:d.Errors.NONE,key:o,settings:t})}else d.Callback.callSafe(n,null,{error:d.Errors.E_SERVER_READVALUE_MISSING})}))}else d.Callback.callSafe(n,null,{error:d.Errors.E_PARAMETER_INVALID})},o}();c.Historize=o;var n,i,a,s,l,_,u=function(){function c(){}return c.confirmAlarm=function(e,r){var t={name:e.name,domain:e.domain,severity:e.severity,timeRaised:e.timeRaised.toISOString(),params:e.params,id:e.id,timeCleared:e.timeCleared.toISOString(),timeConfirmed:e.timeConfirmed.toISOString(),confirmationState:e.confirmationState};d.System.Services.serverEventManager.confirmAlarm(t,r)},c.registerConsumer=function(e,r){var t,o=this;try{t=d.System.Filter.parse(e,d.Type.getSchema("tchmi:server#/definitions/eventFilter"))}catch(e){return d.Callback.callSafe(r.list,null,{error:d.Errors.E_PARAMETER_INVALID,details:{code:d.Errors.E_PARAMETER_INVALID,message:d.Errors[d.Errors.E_PARAMETER_INVALID],reason:e.message}}),d.Callback.callSafe(r.subscription,null,{error:d.Errors.E_PARAMETER_INVALID,details:{code:d.Errors.E_PARAMETER_INVALID,message:d.Errors[d.Errors.E_PARAMETER_INVALID],reason:e.message}}),null}var n={filter:t,rawFilter:e,activeAlarmIds:[],listCallback:r.list,subscriptionCallback:r.subscription};return this.__consumersToAdd.push(n),-1!==this.__registerTimeoutId&&window.clearTimeout(this.__registerTimeoutId),this.__registerTimeoutId=window.setTimeout(function(){o.__registerTimeoutId=-1,o.__addConsumers()},200),function(){var e=o.__consumersToAdd.indexOf(n),r=o.__consumers.indexOf(n);-1!==e&&o.__consumersToAdd.splice(e,1),-1!==r&&(o.__consumers.splice(r,1),n.subscriptionCallback&&(-1!==o.__unregisterTimeoutId&&window.clearTimeout(o.__unregisterTimeoutId),o.__unregisterTimeoutId=window.setTimeout(function(){o.__unregisterTimeoutId=-1,o.__updateSubscription()},500)))}},c.__addConsumers=function(){var e;this.__listEvents(this.__consumersToAdd),(e=this.__consumers).push.apply(e,this.__consumersToAdd),this.__consumersToAdd=[],this.__updateSubscription()},c.__feedListConsumers=function(e,r){for(var t=0,o=e.length;t<o;t++){var n=e[t];if(n.listCallback){n.activeAlarmIds=[];for(var i=[],a=0,s=r.length;a<s;a++){var l=this.__parseServerEvent(r[a]);n.filter.test(l)&&(i.push(l),c.isAlarm(l)&&-1<l.id&&-1===n.activeAlarmIds.indexOf(l.id)&&n.activeAlarmIds.push(l.id))}d.Callback.callSafe(n.listCallback,null,{error:d.Errors.NONE,events:i})}}},c.__feedSubscriptionConsumers=function(e){for(var r=0,t=this.__consumers.length;r<t;r++){var o=this.__consumers[r];if(o.subscriptionCallback){var n=this.__parseServerEvent(e);if(o.filter.test(n))c.isAlarm(n)&&-1<n.id&&-1===o.activeAlarmIds.indexOf(n.id)&&o.activeAlarmIds.push(n.id),o.subscriptionCallback({error:d.Errors.NONE,event:n,changeType:this.__toServerEventChangeType(e.changeType),removedByFilter:!1});else if(c.isAlarm(n)&&-1<n.id){var i=o.activeAlarmIds.indexOf(n.id);-1!==i&&(o.activeAlarmIds.splice(i,1),d.Callback.callSafe(o.subscriptionCallback,null,{error:d.Errors.NONE,event:n,changeType:this.__toServerEventChangeType(e.changeType),removedByFilter:!0}))}}}},c.__listEvents=function(e){var t=this,r=this.__accumulateFilters(e,!1);void 0!==r&&d.System.Services.serverEventManager.listEvents(r,function(r){r.error===d.Errors.NONE?t.__feedListConsumers(e,r.events):e.forEach(function(e){return d.Callback.callSafe(e.listCallback,null,{error:r.error})})})},c.__updateSubscription=function(){var e=this.__accumulateFilters(this.__consumers,!0);void 0!==e?-1===this.__subscriptionId?(this.__subscriptionId=d.System.Services.serverEventManager.subscribe(e,this.__onEventReveived()),this.__onLocaleChangedDestroyer=d.EventProvider.register("onLocaleChanged",this.__onLocaleChanged())):d.System.Services.serverEventManager.updateSubscription(this.__subscriptionId,e):-1!==this.__subscriptionId&&(d.System.Services.serverEventManager.unsubscribe(this.__subscriptionId),this.__subscriptionId=-1,this.__onLocaleChangedDestroyer&&(this.__onLocaleChangedDestroyer(),this.__onLocaleChangedDestroyer=null))},c.__onEventReveived=function(){var e=this;return function(r){r.error===d.Errors.NONE?e.__feedSubscriptionConsumers(r.event):e.__consumers.forEach(function(e){return d.Callback.callSafe(e.subscriptionCallback,null,{error:r.error})})}},c.__onLocaleChanged=function(){var e=this;return function(){e.__listEvents(e.__consumers)}},c.__accumulateFilters=function(e,r){var t;if(1===e.length)t=r&&e[0].subscriptionCallback||!r&&e[0].listCallback?e[0].rawFilter:void 0;else{t=[];for(var o=0,n=e.length;o<n;o++)if((!r||e[0].subscriptionCallback)&&(r||e[0].listCallback)){if(null===e[o].rawFilter){t=null;break}t.push(e[o].rawFilter),o+1!==n&&t.push({logic:"OR"})}null!==t&&0===t.length&&(t=void 0)}return t},c.__parseServerEvent=function(e){return e.message?{type:c.Type.Message,severity:e.message.severity,domain:e.message.domain,name:e.message.name,text:e.localizedString,timeRaised:new Date(e.message.timeRaised),params:e.message.params}:e.alarm?{type:c.Type.Alarm,severity:e.alarm.severity,id:e.alarm.id,domain:e.alarm.domain,name:e.alarm.name,text:e.localizedString,timeRaised:new Date(e.alarm.timeRaised),timeCleared:new Date(e.alarm.timeCleared),timeConfirmed:new Date(e.alarm.timeConfirmed),confirmationState:e.alarm.confirmationState,params:e.alarm.params}:null},c.__toServerEventChangeType=function(e){if(void 0===e)return c.ChangeType.MessageSent;switch(e){case d.System.ServerEventManager.ServerAlarmChangeType.Raise:return c.ChangeType.AlarmRaised;case d.System.ServerEventManager.ServerAlarmChangeType.Change:return c.ChangeType.AlarmChanged;case d.System.ServerEventManager.ServerAlarmChangeType.Dispose:return c.ChangeType.AlarmDisposed}},c.__consumers=[],c.__consumersToAdd=[],c.__registerTimeoutId=-1,c.__unregisterTimeoutId=-1,c.__subscriptionId=-1,c.__onLocaleChangedDestroyer=null,c}();c.Events=u,n=u=c.Events||(c.Events={}),(a=i=n.Type||(n.Type={}))[a.Message=0]="Message",a[a.Alarm=1]="Alarm",(s=n.Severity||(n.Severity={}))[s.Verbose=0]="Verbose",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error",s[s.Critical=4]="Critical",(l=n.ConfirmationState||(n.ConfirmationState={}))[l.NotSupported=0]="NotSupported",l[l.NotRequired=1]="NotRequired",l[l.WaitForConfirmation=2]="WaitForConfirmation",l[l.Confirmed=3]="Confirmed",l[l.Reset=4]="Reset",(_=n.ChangeType||(n.ChangeType={}))[_.AlarmRaised=0]="AlarmRaised",_[_.AlarmChanged=1]="AlarmChanged",_[_.AlarmDisposed=2]="AlarmDisposed",_[_.MessageSent=3]="MessageSent",n.isAlarm=function(e){return e.type===i.Alarm}}(e=d.Server||(d.Server={}))}(TcHmi||(TcHmi={})),function(g){var e=function(){function h(e){this.__path=null,this.__type=g.SymbolType.Invalid,this.__options={};var r=(this.__expression=e).match(h.RegExpExpression);if(null!=r&&3===r.length){switch(this.__tag=r[1],this.__tag){case"s":this.__type=g.SymbolType.Server;break;case"i":this.__type=g.SymbolType.Internal;break;case"l":this.__type=g.SymbolType.LocalizedText;break;case"pp":this.__type=g.SymbolType.PartialParam;break;case"tp":this.__type=g.SymbolType.TemplateParam;break;case"f":this.__type=g.SymbolType.Function;break;case"ctrl":this.__type=g.SymbolType.Control;break;default:this.__type=g.SymbolType.Invalid}switch(this.__tag){case"s":case"i":case"l":case"f":this.__content=this.__expression.substr(3,this.__expression.length-7);break;case"pp":case"tp":this.__content=this.__expression.substr(4,this.__expression.length-9);break;case"ctrl":this.__content=this.__expression.substr(6,this.__expression.length-13)}var t=r[2].match(h.RegExpExpressionGroupByPipe);if(null!=t&&0<t.length){if(this.__type!==g.SymbolType.Server&&this.__type!==g.SymbolType.Function){var o=t[0].indexOf("["),n=t[0].indexOf("::"),i=-1;-1!==(i=-1===o?n:-1===n?o:o<n?o:n)?(this.__name=t[0].substring(0,i),this.__path=t[0].substring(i),this.__pathTokens=g.System.resolveSymbolPathToTokenArray(this.__path)):(this.__name=t[0],this.__path=null,this.__pathTokens=null)}else this.__name=t[0];if(this.__type!==g.SymbolType.Function)for(var a=1,s=t.length;a<s;a++){if(this.__type===g.SymbolType.Server){var l=/^(?:Interval\s*=)\s*(\d+)\s*$/i.exec(t[a]);null!==l&&0!==l.length&&(this.__options.Interval=parseInt(l[1],10));var c=/^(?:Timeout\s*=)\s*(\d+)\s*$/i.exec(t[a]);null!==c&&0!==c.length&&(this.__options.Tinmeout=parseInt(c[1],10));var _=/^(?:Parallel\s*=)\s*([a-zA-Z]+)\s*$/i.exec(t[a]);if(null!==_&&0!==_.length){var u=!1;switch(_[1].toLowerCase()){case"true":u=!0;break;case"false":u=!1}this.__options.Parallel=u}}var d=/^(?:BindingMode\s*=)\s*([a-zA-Z]+)\s*$/i.exec(t[a]);null!==d&&0!==d.length&&(this.__options.BindingMode=d[1]);var m=/^(?:BindingEvent\s*=)\s*([a-zA-Z]+)\s*$/i.exec(t[a]);null!==m&&0!==m.length&&(this.__options.BindingEvent=m[1])}}}}
/**
        * Returns the expression as string.
        * @member
        * @preserve (Part of the public API)
        */return h.prototype.toString=function(){return this.__expression},
/**
         * @preserve (Part of the public API)
         */
h.prototype.getContent=function(){return this.__content},
/**
         *
         * @preserve (Part of the public API)
         */
h.prototype.getTag=function(){return this.__tag},h.prototype.getName=function(){return this.__name},
/**
         * @preserve (Part of the public API)
         */
h.prototype.getPath=function(){return this.__path},
/**
         * @preserve (Part of the public API)
         */
h.prototype.getPathTokens=function(){return this.__pathTokens},
/**
         * @preserve (Part of the public API)
         */
h.prototype.getType=function(){return this.__type},
/**
         * @preserve (Part of the public API)
         */
h.prototype.getOptions=function(){return this.__options},h.RegExpExpressionGroupByPipe=/([^|()]+|[(](['][^']*[']|["][^"]*["]|[^)])*[)])+/g,h.RegExpExpression=new RegExp("^\\%(s|i|l|pp|tp|f|ctrl)\\%([^]*)\\%/\\1\\%$"),h}();g.SymbolExpression=e}(TcHmi||(TcHmi={})),function(s){
/**
     * Provides methods to read and write symbol values and schemas.
     * @class Symbol
     * @memberOf TcHmi
     * @preserve (Part of the public API)
     */
var l,e,r=function(){function a(e){this.__symbol=null,this.__symbol=new s.System.Symbol(e)}
/**
        * Reads the value of the current symbol.
        * Throws an exception if the symbol is not available
        * @function read
        * @returns A copy of the value
        * @preserve (Part of the public API)
        */return a.prototype.read=function(){var r=void 0;return this.__symbol.getExpression().getType()===l.Server?s.Log.warn("[Source=Framework, Module=TcHmi.Symbol] The non static function 'TcHmi.Symbol.read()' does no longer support synchronous access to symbols of type Server. Please use the non static function 'TcHmi.Symbol.readEx(callback ?: (this: TcHmi.Symbol, data: TcHmi.Symbol.IReadResultObject | TcHmi.Symbol.IServerReadResultObject) => void)' instead."):this.__symbol.read(function(e){e.error===s.Errors.NONE&&(r=e.value)}),r},
/**
        * Reads the value of the current symbol and raises a callback with a copy of the result.
        * @param {string} expression
        * @param callback with gets a copy of the value
        * @returns
        * @preserve (Part of the public API)
        */
a.prototype.readEx=function(r){var t=this;this.__symbol.read(function(e){e.response?s.Callback.callSafe(r,t,{error:e.error,value:e.value,response:e.response}):s.Callback.callSafe(r,t,{error:e.error,value:e.value})})},
/**
         * Writes the value of the current symbol.
         * @param value
         * @param callback
         * @preserve (Part of the public API)
         */
a.prototype.write=function(e,r){var t=this;this.__symbol.write(e,function(e){e.response?s.Callback.callSafe(r,t,{error:e.error,value:e.value,response:e.response}):s.Callback.callSafe(r,t,{error:e.error,value:e.value})})},
/**
         * Watches for changes of the current symbol and raises the callback in case of a change.
         * @param callback
         * @preserve (Part of the public API)
         */
a.prototype.watch=function(r){var t=this;return this.__symbol.watch(function(e){e.response?s.Callback.callSafe(r,t,{error:e.error,value:e.value,response:e.response,destroy:e.destroy}):s.Callback.callSafe(r,t,{error:e.error,value:e.value,destroy:e.destroy})})},
/**
         * Returns the underlying TcHmi.SymbolExpression object.
         * @preserve (Part of the public API)
         */
a.prototype.getExpression=function(){return this.__symbol.getExpression()},
/**
         * Resolves the schema of the current symbol.
         * @param callback
         * @preserve (Part of the public API)
         */
a.prototype.resolveSchema=function(r){var t=this;this.__symbol.resolveSchema(function(e){e.error===s.Errors.NONE?s.Callback.callSafe(r,t,{error:e.error,schema:e.schema}):s.Callback.callSafe(r,t,{error:e.error})})},
/**
         * Destroys the current symbol object.
         * @preserve (Part of the public API)
         */
a.prototype.destroy=function(){null!==this.__symbol&&(this.__symbol.destroy(),this.__symbol=null)},
/**
         * Reads the value of a symbol by name and type.
         * @param {string} name
         * @param type
         * @returns
         * @preserve (Part of the public API)
         */
a.read=function(e,r){var t;switch(r){case l.Internal:t="i";break;case l.LocalizedText:t="l";break;case l.PartialParam:t="pp";break;case l.Server:t="s";break;case l.TemplateParam:t="tp";break;case l.Control:t="ctrl";break;default:throw new TypeError((s.SymbolType[r],s.SymbolType[r]))}var o=void 0;if(r===l.Server)return s.Log.warn("The static function 'TcHmi.Symbol.read(name: string, type: TcHmi.SymbolType)' does no longer support synchronous access to symbols of type Server. Please use the non static function 'TcHmi.Symbol.readEx2(expression: string, callback?: (this: void, data: TcHmi.Symbol.IReadResultObject)' instead."),o;var n=new a("%"+t+"%"+e+"%/"+t+"%");return n.readEx(function(e){e.error===s.Errors.NONE&&(o=e.value),n.destroy(),n=null}),o},
/**
         * Reads the value of a symbol by expression.
         * @function readEx
         * @param {string} expression
         * @returns
         * @preserve (Part of the public API)
         */
a.readEx=function(e){var r=new a(e);if(r.getExpression().getType()===l.Server)return s.Log.warn("[Source=Framework, Module=TcHmi.Symbol] The static function 'TcHmi.Symbol.readEx(expression: string)' does no longer support synchronous access to symbols of type Server. Please use the non static function 'TcHmi.Symbol.readEx2(expression: string, callback?: (this: void, data: TcHmi.Symbol.IReadResultObject)' instead."),r.destroy(),void(r=null);var t=r.read();return r.destroy(),r=null,t},
/**
         * Reads the value of a symbol by expression and raises a callback with the result.
         * @param {string} expression
         * @param callback
         * @returns
         * @preserve (Part of the public API)
         */
a.readEx2=function(e,r){var t=new a(e);t.readEx(function(e){e.response?s.Callback.callSafe(r,null,{error:e.error,value:e.value,response:e.response}):s.Callback.callSafe(r,null,{error:e.error,value:e.value}),t.destroy(),t=null})},
/**
         * Writes the value of a symbol by name and type.
         * @param {string} name
         * @param type
         * @param value
         * @param callback
         * @preserve (Part of the public API)
         */
a.write=function(e,r,t,o){var n;switch(r){case l.Internal:n="i";break;case l.LocalizedText:n="l";break;case l.PartialParam:n="pp";break;case l.Server:n="s";break;case l.TemplateParam:n="tp";break;case l.Control:n="ctrl";break;default:throw new TypeError((s.SymbolType[r],s.SymbolType[r]))}var i=new a("%"+n+"%"+e+"%/"+n+"%");i.write(t,function(e){e.response?s.Callback.callSafe(o,null,{error:e.error,response:e.response}):s.Callback.callSafe(o,null,{error:e.error,value:e.value}),i.destroy(),i=null})},
/**
         * Writes the value of a symbol by expression.
         * @function writeEx
         * @param {string} expression
         * @param value
         * @param callback
         * @preserve (Part of the public API)
         */
a.writeEx=function(e,r,t){var o=new a(e);o.write(r,function(e){e.response?s.Callback.callSafe(t,null,{error:e.error,response:e.response}):s.Callback.callSafe(t,null,{error:e.error,value:e.value}),o.destroy(),o=null})},
/**
         * Resolves the schema of the current symbol.
         * @param {string} expression
         * @param callback
         * @preserve (Part of the public API)
         */
a.resolveSchema=function(e,r){var t=new a(e);t.resolveSchema(function(e){e.error===s.Errors.NONE?s.Callback.callSafe(r,null,{error:e.error,schema:e.schema}):s.Callback.callSafe(r,null,{error:e.error}),t.destroy(),t=null})},
/**
         * @function isSymbolExpression
         * @param {string} expression
         * @preserve (Part of the public API)
         */
a.isSymbolExpression=function(e){if("string"!=typeof e)return!1;var r=e.match(s.SymbolExpression.RegExpExpression);return null!=r&&0===r.index},a}();s.Symbol=r,(e=l=s.SymbolType||(s.SymbolType={}))[e.Invalid=0]="Invalid",e[e.Server=10]="Server",e[e.Internal=20]="Internal",e[e.LocalizedText=30]="LocalizedText",e[e.PartialParam=40]="PartialParam",e[e.TemplateParam=50]="TemplateParam",e[e.Function=60]="Function",e[e.Control=70]="Control"}(TcHmi||(TcHmi={})),function(t){
/**
    * Provides functions to set partials as view.
    * @class View
    * @preserve (Part of the public API)
    */
var e=function(){function e(){}
/**
         * Loads a view partial into the dom.
         * @function load
         * @param {string} url
         * @param {null | function} callback
         * @preserve (Part of the public API)
         */return e.load=function(e,r){void 0===r&&(r=null),!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER?(t.Log.warn("[Source=Framework, Module=TcHmi.Symbol] Loading an additional view level element in designer context is not allowed and therefore blocked."),"function"==typeof r&&r.call(this,{error:t.Errors.E_NOT_ALLOWED})):t.System.Services.viewManager.loadView(e,r)},
/**
         * Returns the current view object.
         * @function get
         * @returns {TcHmi.Controls.System.baseTcHmiContro}
         * @preserve (Part of the public API)
         */
e.get=function(){return!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER?(t.Log.warn("[Source=Framework, Module=TcHmi.Symbol] Accessing a view level element is not allowed in designer context and therefore blocked."),null):t.System.Services.viewManager.getView()},e}();t.View=e}(TcHmi||(TcHmi={})),function(r){var e=function(){function e(){}
/**
         * Returns a TwinCAT HMI type schema associated with the type identified by typeName or null if no type schema is associated with typeName.
         * @param typeName
         * @preserve (Part of the public API)
         */return e.getSchema=function(e){return r.System.Services.typeManager.getSchema(e)},e}();r.Type=e}(TcHmi||(TcHmi={})),function(e){var r,t;r=e.System||(e.System={}),t=function(){function l(){}return l.resolveType=function(e){var r=e.type;if(!r){var t=e.oneOf;if(t||(t=e.anyOf),t){r=[];for(var o=0,n=t.length;o<n;o++){var i=l.resolveType(t[o]);if(Array.isArray(i))for(var a=0,s=i.length;a<s;a++)-1===r.indexOf(i[a])&&r.push(i[a]);else i&&-1===r.indexOf(i)&&r.push(i)}0===r.length?r=void 0:1===r.length&&(r=r[0])}else r=["string","number","object","boolean","integer","array","null"]}return r},l}(),r.Schema=t}(TcHmi||(TcHmi={})),function(u){var e,r;e=u.System||(u.System={}),r=function(){function e(e){this.__entries={}}return e.prototype.add=function(e,r){var t=r;if((this.__entries[e]=t).persist&&"undefined"!=typeof Storage&&window.localStorage){var o=window.localStorage.getItem("TCHMI_INTERNALSYMBOL_"+e);if(null!==o)try{t.value=JSON.parse(o)}catch(e){}}t.callbacks||(t.callbacks=[])},e.prototype.remove=function(e){delete this.__entries[e]},e.prototype.update=function(e,r){var t=this.__entries[e];if(t){var o=!1;if(tchmi_equal(t.value,r.value)||(t.value=r.value,o=!0),tchmi_equal(t.type,r.type)||(t.type=r.type,o=!0),tchmi_equal(t.persist,r.persist)||(t.persist=r.persist,o=!0),tchmi_equal(t.readonly,r.readonly)||(t.readonly=r.readonly,o=!0),o){for(var n=[],i=0,a=t.callbacks.length;i<a;i++)n.push(t.callbacks[i]);for(var s=0,l=n;s<l.length;s++){var c=l[s];-1!==t.callbacks.indexOf(c)&&u.Callback.callSafe(c.callback,this,{error:u.Errors.NONE,value:t.value,destroy:c.destroy})}}}},e.prototype.write=function(e,r,t){var o=this.__entries[e];if(o)if(o.readonly)u.Callback.callSafe(t,this,{error:u.Errors.E_SYMBOL_READONLY});else if(tchmi_equal(o.value,r))u.Callback.callSafe(t,this,{error:u.Errors.NONE});else{var n=o.value;if(o.value=r,o.persist){if("undefined"!=typeof Storage&&window.localStorage)try{window.localStorage.setItem("TCHMI_INTERNALSYMBOL_"+e,JSON.stringify(o.value))}catch(e){u.Log.error("[Source=Framework, Module=TcHmi.System.InternalSymbolManager] Unexpected exception="+e+".")}}else!0===n&&window.localStorage.removeItem("TCHMI_INTERNALSYMBOL_"+e);for(var i=[],a=0,s=o.callbacks.length;a<s;a++)i[a]=o.callbacks[a];for(var l=0,c=i;l<c.length;l++){var _=c[l];-1!==o.callbacks.indexOf(_)&&u.Callback.callSafe(_.callback,this,{error:u.Errors.NONE,value:o.value,destroy:_.destroy})}u.Callback.callSafe(t,this,{error:u.Errors.NONE})}else u.Callback.callSafe(t,this,{error:u.Errors.E_SYMBOL_UNKNOWN})},e.prototype.read=function(e,r){var t=this.__entries[e];return t?(u.Callback.callSafe(r,this,{error:u.Errors.NONE,value:t.value}),null):(u.Log.error("[Source=Framework, Module=TcHmi.System.InternalSymbolManager] Internal symbol with name="+e+" does not exist."),void u.Callback.callSafe(r,this,{error:u.Errors.E_SYMBOL_UNKNOWN}))},e.prototype.getType=function(e,r){var t=this.__entries[e];return t?(u.Callback.callSafe(r,this,{error:u.Errors.NONE,type:t.type}),null):(u.Log.error("[Source=Framework, Module=TcHmi.System.InternalSymbolManager] Internal symbol with name="+e+" does not exist."),void u.Callback.callSafe(r,this,{error:u.Errors.E_SYMBOL_UNKNOWN}))},e.prototype.watch=function(e,r){var t=this.__entries[e];if(!t)return u.Log.error("[Source=Framework, Module=TcHmi.System.InternalSymbolManager] Internal symbol with name="+e+" does not exist."),function(){};var o=null,n=function(){var e=t.callbacks.indexOf(o);-1!==e&&(t.callbacks.splice(e,1),o.callback=null)};return o={callback:r,destroy:n},t.callbacks.push(o),u.Callback.callSafe(r,this,{error:u.Errors.NONE,value:t.value,destroy:n}),n},e}(),e.InternalSymbolManager=r}(TcHmi||(TcHmi={})),function(t){var e,r;e=t.System||(t.System={}),r=function(){function e(e){this.__entries={}}return e.prototype.add=function(e,r,t){var o={name:e,type:r,value:t,callbacks:[]};this.__entries[e]=o},e.prototype.remove=function(e){var r=this.__entries[e];r&&(r.value instanceof t.System.Symbol&&r.value.destroy(),r.value=null,delete this.__entries[e])},e.prototype.get=function(e){return this.__entries[e]},e.prototype.destroy=function(){this.__entries=null},e.prototype.keepAlive=function(e){var r=this.__entries[e];return!!(r&&0<r.callbacks.length)},e}(),e.TemplateParamSymbolManager=r}(TcHmi||(TcHmi={})),function(e){
/**
     *  @preserve (Part of the public API)
     */
var r,t;r=e.Controls||(e.Controls={}),t=function(e,r,t){this.__children=[]},(r.System||(r.System={})).baseTcHmiControl=t}(TcHmi||(TcHmi={})),function(E){var e,r;e=E.System||(E.System={}),r=function(){function e(e){var t=this;this.__lastUserInteraction=Date.now(),this.__autoLogoffTimeoutID=0,this.__oldName=null,this.__accessCache={},this.__onAccessConfigChanged=function(e,r){t.__accessCache={}},!(this.__userConfigOnServer={state:0,userIsInGroups:[],name:null,domain:null,locale:"",autoLogOffMilliSeconds:null,session:null,errorMessage:""})===TCHMI_ENABLE_DESIGNER_MODE_MASTER?(E.EventProvider.register("onWebSocketOpened",this.__onWebsocketOpen()),E.EventProvider.register("onWebSocketClosed",this.__onWebsocketClosed()),E.EventProvider.register("System.AccessConfigChanged",this.__onAccessConfigChanged)):this.__userConfigOnServer.state=3}return e.prototype.getCurrentUserConfig=function(){return this.__userConfigOnServer},e.prototype.__onWebsocketClosed=function(){var r=this;return function(e){r.__oldName=r.__userConfigOnServer.name,r.__userConfigOnServer.state=0,r.__userConfigOnServer.userIsInGroups=[],r.__userConfigOnServer.name=null,r.__userConfigOnServer.domain=null,r.__userConfigOnServer.locale="",r.__userConfigOnServer.autoLogOffMilliSeconds=null,r.__userConfigOnServer.session=null,r.__userConfigOnServer.errorMessage="","__TcHmiViewAccess"===E.System.Services.dialogManager.getDialogOwner()&&E.System.Services.dialogManager.updateText("__TcHmiViewAccess","Connection to server lost. Reopening connection...",E.DialogManager.DialogSeverity.Error)}},e.prototype.__onWebsocketOpen=function(){var r=this;return function(e){E.Server.readSymbol(["IsAuthRequired","GetCurrentUser"],r.__handleConfigAnswer)}},e.prototype.__handleConfigAnswer=function(e){return E.System.Services.accessManager.__handleServerAnswer(e,!1)},e.prototype.__handleSubscriptionAnswer=function(e){return E.System.Services.accessManager.__handleServerAnswer(e,!0)},e.prototype.__handleServerAnswer=function(e,r){var t=!1,o=!1,n=E.System.Services.accessManager.__userConfigOnServer;if(e.error===E.Errors.E_WEBSOCKET_NOT_READY)n.state=1,n.errorMessage="Communication not ready.",t=!0;else if(void 0!==e.response.error)n.state=1,n.errorMessage="Unknown Server error: "+e.response.error.message,t=!0,e.response.error.code===E.Server.Error.HMI_E_MISSING_LICENSE_HANDSHAKE&&(!0===TCHMI_ENABLE_DESIGNER_MODE?n.errorMessage="Server is not licensed. Please try is a few seconds again.":n.errorMessage="Server is not licensed.");else if(e.error===E.Errors.NONE){0===n.state&&(n.state=1),n.errorMessage="Got no valid answer.";var i=e.response.commands;void 0===i&&(i=[]);for(var a=0,s=i.length;a<s;a++){var l=i[a];if("GetCurrentUser"===l.symbol){if(void 0!==l.error){n.errorMessage="Got no valid answer for "+l.symbol+". Error code: "+l.error.code,t=!0;break}if(void 0===l.readValue){n.errorMessage="Got no valid answer for "+l.symbol+".",t=!0;break}if(r&&(n.errorMessage=""),void 0!==l.readValue.name&&n.name!==l.readValue.name){if(!1===r&&null!==E.System.Services.accessManager.__oldName&&E.System.Services.accessManager.__oldName!==l.readValue.name){n.state=1,E.System.Services.dialogManager.showDialog(null,!1),E.System.Services.dialogManager.updateText("__AccessManager",'Connection to Server recovered but Authentification is not valid anymore. <input type="submit" value="Relogin" style="padding:10px;" onclick="window.location = \'/Logout?Location='+window.location.pathname+"&Name="+encodeURIComponent(E.System.Services.accessManager.__oldName)+"'\">",E.DialogManager.DialogSeverity.Error),E.System.Services.dialogManager.showDialog("__AccessManager",!0,E.DialogManager.DialogType.SYSTEMLoading),o=t=!(n.errorMessage="Reconnect to Server needs Reauthentification.");break}t=!0,n.name=l.readValue.name}if(n.autoLogOffMilliSeconds=null,l.readValue.autoLogoff){var c=/^(-)?P(?:(-?[0-9,.]*)Y)?(?:(-?[0-9,.]*)M)?(?:(-?[0-9,.]*)W)?(?:(-?[0-9,.]*)D)?(?:T(?:(-?[0-9,.]*)H)?(?:(-?[0-9,.]*)M)?(?:(-?[0-9,.]*)S)?)?$/.exec(l.readValue.autoLogoff);if(null===c)break;var _=parseInt(c[2],10)||0,u=parseInt(c[3],10)||0,d=parseInt(c[4],10)||0,m=parseInt(c[5],10)||0,h=parseInt(c[6],10)||0,g=parseInt(c[7],10)||0,p=1e3*((parseFloat(c[8])||0)+60*(g+60*(h+24*(m+30*u+7*d)+365*_)));n.autoLogOffMilliSeconds!==p&&(n.autoLogOffMilliSeconds=p,t=!0,E.System.Services.accessManager.__rearmAutoLogoffTimer())}void 0===l.readValue.groups||tchmi_equal(n.userIsInGroups.sort(),l.readValue.groups.sort())||(t=!0,n.userIsInGroups=l.readValue.groups),void 0!==l.readValue.domain&&n.domain!==l.readValue.domain&&(t=!0,n.domain=l.readValue.domain),void 0!==l.readValue.session&&n.session!==l.readValue.session&&(t=!0,n.session=l.readValue.session),void 0!==l.readValue.locale&&n.locale!==l.readValue.locale&&(n.locale=l.readValue.locale,!0===r&&E.System.Services.localizationManager.loadLocale(l.readValue.locale,null))}else if("IsAuthRequired"===l.symbol){if(t=!0,void 0!==l.error){n.errorMessage="Got no valid answer for "+l.symbol+". Error code: "+l.error.code;break}if(void 0===l.readValue){n.errorMessage="Got no valid answer for "+l.symbol+".";break}if(!0===l.readValue)n.state=4,o=!(n.errorMessage="");else{if(!1!==l.readValue){n.state=1,n.errorMessage="Got no valid answer for "+l.symbol+".";break}n.state=2,o=!(n.errorMessage="")}}}4===n.state&&(n.name?0===n.userIsInGroups.length&&(t=!0,n.state=1,n.errorMessage="Got no group membership but should have one."):(t=!0,n.state=1,n.errorMessage="Got no user login but should have one.")),!0===o&&1!==n.state&&E.Server.subscribe([{symbol:"GetCurrentUser"}],null,E.System.Services.accessManager.__handleSubscriptionAnswer)}!0===t&&E.System.Services.accessManager.__handleUsergroupChanged()},e.prototype.__handleUsergroupChanged=function(){if(this.__accessCache={},1===this.__userConfigOnServer.state){var e=E.System.Services.dialogManager.getDialogOwner();"__TcHmiMain"!==e&&"__TcHmiViewAccess"!==e||E.System.Services.dialogManager.showDialog(e,!1),E.System.Services.dialogManager.updateText("__AccessManager","Loading User Config from Server failed"+(this.__userConfigOnServer.errorMessage?": "+this.__userConfigOnServer.errorMessage:".")+' <input type="submit" value="Logout" style="padding:10px;" onclick="window.location = \'/Logout?Location='+window.location.pathname+"'\">",E.DialogManager.DialogSeverity.Error),E.System.Services.dialogManager.showDialog("__AccessManager",!0,E.DialogManager.DialogType.SYSTEMLoading),E.Log.error("[Source=Framework, Module=TcHmi.System.AccessManager] Internal Error. Loading Userconfig from Server failed.")}2!==this.__userConfigOnServer.state&&4!==this.__userConfigOnServer.state||E.EventProvider.raise("onUserInGroupChanged",this.__userConfigOnServer.userIsInGroups);var r=E.System.Services.viewManager.getView();null!==r&&r.__processAccessConfig()},e.prototype.checkAccess=function(e,r){if(!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER)return!0;if(2===this.__userConfigOnServer.state)return!0;if(-1!==this.__userConfigOnServer.userIsInGroups.indexOf("__SystemAdministrators"))return!0;if(1===this.__userConfigOnServer.state)return!1;if(0===this.__userConfigOnServer.state)return null;if(!e.__isAttached)return null;if(void 0===this.__accessCache[e.__id]&&(this.__accessCache[e.__id]={}),void 0!==this.__accessCache[e.__id][r])return this.__accessCache[e.__id][r];var t=!1,o=r,n=e;do{for(var i=!1,a=0,s=n.getVirtualControlRightMappings();a<s.length;a++){var l=s[a];if(l.controlRight===o){o=l.virtualControlRight;break}}for(var c=0,_=n.getAccessConfig();c<_.length;c++){var u=_[c];if(u.accessright===o&&-1!==this.__userConfigOnServer.userIsInGroups.indexOf(u.group)){if("Allow"===u.permission)return this.__accessCache[e.__id][r]=!0;if("Deny"===u.permission)i=!0;else if("Inherit"!==u.permission)return E.Log.error("[Source=Framework, Module=TcHmi.System.AccessManager] Access check failed on control "+e.__id+": Invalid config found! Access rejected!"),!1}}if(!0===i){n=null;break}var d=n.getType(),m=E.System.Services.controlManager.getDescriptionAccessByName(d,o);if(null===m&&"function"==typeof n.getDescriptionAccessByName&&(m=n.getDescriptionAccessByName(o)),null===m||!0!==m.defaultValueInternal&&!1!==m.defaultValueInternal||(t=m.defaultValueInternal),null===n.__parent){if("tchmi-view"===d){n=null;break}n=null,t=!1;break}n=n.__parent}while(null!==n);return this.__accessCache[e.__id][r]=t},e.prototype.__updateLastUserinteraction=function(e){E.System.Services.accessManager.__lastUserInteraction=Date.now()},e.prototype.__rearmAutoLogoffTimer=function(){if(4===this.__userConfigOnServer.state&&null!==this.__userConfigOnServer.autoLogOffMilliSeconds&&0!==this.__userConfigOnServer.autoLogOffMilliSeconds){window.clearTimeout(this.__autoLogoffTimeoutID);var e={passive:!0,capture:!0};document.removeEventListener("keydown",this.__updateLastUserinteraction,e),document.removeEventListener("mouseover",this.__updateLastUserinteraction,e),document.removeEventListener("touchstart",this.__updateLastUserinteraction,e),document.addEventListener("keydown",this.__updateLastUserinteraction,e),document.addEventListener("mouseover",this.__updateLastUserinteraction,e),document.addEventListener("touchstart",this.__updateLastUserinteraction,e);var r=this.__lastUserInteraction+this.__userConfigOnServer.autoLogOffMilliSeconds-Date.now();r<0?this.__logoutIfNoInteraction()():(2147483647<r&&(r=2147483647),this.__autoLogoffTimeoutID=window.setTimeout(this.__logoutIfNoInteraction(),r))}},e.prototype.__logoutIfNoInteraction=function(){var e=this;return function(){null!==e.__userConfigOnServer.autoLogOffMilliSeconds&&e.__lastUserInteraction+e.__userConfigOnServer.autoLogOffMilliSeconds<Date.now()?E.Server.logout():e.__rearmAutoLogoffTimer()}},e}(),e.AccessManager=r}(TcHmi||(TcHmi={})),function(m){!function(t){var e=function(){function e(e){}return e.prototype.create=function(e,r){return new m.Animation(e,r)},e.prototype.createAnimationController=function(e,r){return e.useCss()?new o(e,r):new n(e,r)},e}();t.AnimationProvider=e;var o=function(){function e(e,r){this.__hasStarted=!1,this.__animation=e,this.__statusChangeCallback=r,this.__styleManager=t.Services.styleManager}return e.prototype.isValid=function(){return this.__animation.useCss()},e.prototype.run=function(){var r=this,e=function(){if(void 0!==m.control[r.__animation.controlName()])if(r.__animation.state()===m.Animation.Status.CONFIGURE||r.__animation.state()===m.Animation.Status.INITIALIZED){r.__statusChangeCallback(m.Animation.Status.INITIALIZED);var e=r.__animation.animationName();r.__getElement().on("animationstart."+e+".animationcontrol",r.__onAnimationStart()).on("animationiteration."+e+".animationcontrol",r.__onAnimationIteration()).on("animationend."+e+".animationcontrol",r.__onAnimationEnd()),r.__writeAnimationToCss()}else r.__animation.state()===m.Animation.Status.PAUSED&&(r.__setPlayState("running"),r.__hasStarted?r.__statusChangeCallback(m.Animation.Status.RUNNING):r.__statusChangeCallback(m.Animation.Status.INITIALIZED))};this.__animation.state()===m.Animation.Status.ENDED?(this.reset(e),this.__statusChangeCallback(m.Animation.Status.INITIALIZED)):e()},e.prototype.pause=function(){this.__animation.state()!==m.Animation.Status.RUNNING&&this.__animation.state()!==m.Animation.Status.INITIALIZED||(this.__setPlayState("paused"),this.__statusChangeCallback(m.Animation.Status.PAUSED))},e.prototype.skip=function(){this.cleanup(!0),this.__statusChangeCallback(m.Animation.Status.ENDED),this.__getElement().off("animationstart."+this.__animation.animationName()+".animationcontrol").off("animationiteration."+this.__animation.animationName()+".animationcontrol").off("animationend."+this.__animation.animationName()+".animationcontrol")},e.prototype.reset=function(o){var n=this,i=this.__styleManager.expandSelector(this.__animation.selector(),this.__animation.controlName()),a=this.__styleManager.getExistingStyleOverwrites(this.__animation.controlName());if(void 0!==a[i]&&void 0!==a[i]["animation-name"]){var s=a[i]["animation-name"][0].split(",").map(function(e){return e.trim()}).indexOf(this.__animation.animationName());if(-1!==s){for(var e=0,r=a[i]["animation-name"].length;e<r;e++){(t=a[i]["animation-name"][e].split(",").map(function(e){return e.trim()})).splice(s,1,"reset"),a[i]["animation-name"][e]=t.join(", ")}for(e=0,r=a[i]["animation-play-state"].length;e<r;e++){var t;(t=a[i]["animation-play-state"][e].split(",").map(function(e){return e.trim()})).splice(s,1,"paused"),a[i]["animation-play-state"][e]=t.join(", ")}this.__styleManager.writeStyles(this.__animation.controlName(),a),requestAnimationFrame(function(){requestAnimationFrame(function(){if(void 0!==m.Controls.get(n.__animation.controlName())){for(var e=0,r=a[i]["animation-name"].length;e<r;e++){var t=a[i]["animation-name"][e].split(",").map(function(e){return e.trim()});t.splice(s,1,n.__animation.animationName()),a[i]["animation-name"][e]=t.join(", ")}n.__styleManager.writeStyles(n.__animation.controlName(),a),n.__statusChangeCallback(m.Animation.Status.CONFIGURE)}"function"==typeof o&&o()})}),this.__hasStarted=!1}else requestAnimationFrame(function(){requestAnimationFrame(function(){n.__statusChangeCallback(m.Animation.Status.CONFIGURE),"function"==typeof o&&o()})})}else requestAnimationFrame(function(){requestAnimationFrame(function(){n.__statusChangeCallback(m.Animation.Status.CONFIGURE),"function"==typeof o&&o()})})},e.prototype.cleanup=function(e){void 0===e&&(e=!1);var r=null;if("forwards"===this.__animation.fillMode()||"both"===this.__animation.fillMode()||e)switch(this.__animation.direction()){case"normal":r=1;break;case"reverse":r=0;break;case"alternate":r=this.__animation.iterationCount()%2==0?0:1;break;case"alternate-reverse":r=this.__animation.iterationCount()%2==0?1:0}var n=this.__styleManager.expandSelector(this.__animation.selector(),this.__animation.controlName()),i=this.__styleManager.getExistingStyleOverwrites(this.__animation.controlName());if(void 0!==i[n]&&void 0!==i[n]["animation-name"]){var a=i[n]["animation-name"][0].split(",").map(function(e){return e.trim()}).indexOf(this.__animation.animationName());if(-1!==a&&(s("animation-name"),s("animation-duration"),s("animation-delay"),s("animation-iteration-count"),s("animation-direction"),s("animation-timing-function"),s("animation-fill-mode"),s("animation-play-state"),delete i["@keyframes "+this.__animation.animationName()],this.__styleManager.writeStyles(this.__animation.controlName(),i),null!==r)){var t=this.__animation.keyframes().filter(function(e){return e.progressPoint===r});if(0===t.length)return;var o=t[0].styles;m.StyleProvider.setSimpleElementStyle(this.__getElement(),o)}}function s(e){if(void 0!==i[n][e])for(var r=0,t=i[n][e].length;r<t;r++){var o=i[n][e][r].split(",").map(function(e){return e.trim()});o.splice(a,1),i[n][e][r]=o.join(", ")}}},e.prototype.__writeAnimationToCss=function(e){void 0===e&&(e=!0);var i=this.__styleManager.expandSelector(this.__animation.selector(),this.__animation.controlName()),a=this.__styleManager.getExistingStyleOverwrites(this.__animation.controlName());void 0===a[i]&&(a[i]={});var s=-1;if(void 0!==a[i]["animation-name"]){var r=a[i]["animation-name"][0].split(",").map(function(e){return e.trim()});s=r.indexOf(this.__animation.animationName())}function t(e,r){if(void 0===a[i][e])a[i][e]=[r];else for(var t=0,o=a[i][e].length;t<o;t++){var n=l(a[i][e][t],",").map(function(e){return e.trim()});-1===s?n.push(r):n.splice(s,1,r),a[i][e][t]=n.join(", ")}}function l(e,r){for(var t=0,o=0,n=[],i=0,a=e.length;i<a;i++)switch(e.charAt(i)){case"(":o++;break;case")":0<o&&o--;break;case r:0===o&&t<i&&n.push(e.substring(t,i).trim()),t=i+1}return(0===e.length||t<e.length)&&n.push(e.substring(t).trim()),n}t("animation-name",this.__animation.animationName()),t("animation-duration",this.__animation.duration()+"ms"),t("animation-delay",this.__animation.delay()+"ms"),t("animation-iteration-count",this.__animation.iterationCount().toString()),t("animation-direction",this.__animation.direction()),t("animation-timing-function",this.__animation.timingFunction()),t("animation-fill-mode",this.__animation.fillMode()),t("animation-play-state",e?"running":"paused");for(var o={},n=this.__animation.keyframes(),c=0,_=n.length;c<_;c++)o[100*n[c].progressPoint+"%"]=n[c].styles;a["@keyframes "+this.__animation.animationName()]=o,this.__styleManager.writeStyles(this.__animation.controlName(),a)},e.prototype.__setPlayState=function(e){var r=this.__styleManager.expandSelector(this.__animation.selector(),this.__animation.controlName()),t=this.__styleManager.getExistingStyleOverwrites(this.__animation.controlName());if(void 0!==t[r]["animation-name"]){var o=t[r]["animation-name"][0].split(",").map(function(e){return e.trim()}).indexOf(this.__animation.animationName());if(-1!==o){for(var n=0,i=t[r]["animation-play-state"].length;n<i;n++){var a=t[r]["animation-play-state"][n].split(",").map(function(e){return e.trim()});a.splice(o,1,e),t[r]["animation-play-state"][n]=a.join(", ")}this.__styleManager.writeStyles(this.__animation.controlName(),t)}}},e.prototype.__onAnimationStart=function(){var e=this;return function(r){var t=r.originalEvent;t.animationName===e.__animation.animationName()&&(e.__statusChangeCallback(m.Animation.Status.RUNNING),e.__animation.eventHandlers().filter(function(e){return"animationstart"===e.name}).forEach(function(e){return e.callback({error:m.Errors.NONE,animationName:t.animationName,elapsedTime:t.elapsedTime,JQueryEvent:r})}))}},e.prototype.__onAnimationIteration=function(){var e=this;return function(r){var t=r.originalEvent;t.animationName===e.__animation.animationName()&&e.__animation.eventHandlers().filter(function(e){return"animationiteration"===e.name}).forEach(function(e){return e.callback({error:m.Errors.NONE,animationName:t.animationName,elapsedTime:t.elapsedTime,JQueryEvent:r})})}},e.prototype.__onAnimationEnd=function(){var e=this;return function(r){var t=r.originalEvent;t.animationName===e.__animation.animationName()&&(e.__statusChangeCallback(m.Animation.Status.ENDED),e.__getElement().off("animationstart."+e.__animation.animationName()+".animationcontrol").off("animationiteration."+e.__animation.animationName()+".animationcontrol").off("animationend."+e.__animation.animationName()+".animationcontrol"),e.__animation.cleanup()&&e.cleanup(),e.__animation.eventHandlers().filter(function(e){return"animationend"===e.name}).forEach(function(e){return e.callback({error:m.Errors.NONE,animationName:t.animationName,elapsedTime:t.elapsedTime,JQueryEvent:r})}))}},e.prototype.__getElement=function(){return $(this.__styleManager.expandSelector(this.__animation.selector(),this.__animation.controlName()))},e}();t.CssAnimationController=o;var n=function(){function e(e,r){this.__animationFrameID=null,this.__start=null,this.__iteration=0,this.__elapsedTime=0,this.__resetToInitial=!0,this.__delayTimer=null,this.__animation=e,this.__statusChangeCallback=r,this.__element=$(t.Services.styleManager.expandSelector(this.__animation.selector(),this.__animation.controlName()))}return e.prototype.isValid=function(){return!this.__animation.useCss()},e.prototype.run=function(){var r=this;if(this.__animation.state()===m.Animation.Status.CONFIGURE||this.__animation.state()===m.Animation.Status.ENDED){this.__animationRunner=this.__getAnimationRunner(),this.__iteration=0,this.__start=null,this.__elapsedTime=0,this.__resetToInitial=!0,0<this.__animation.delay()?this.__delayTimer=new s(function(){r.__animationFrameID=window.requestAnimationFrame(r.__animationRunner),r.__delayTimer=null},this.__animation.delay()):this.__animationFrameID=window.requestAnimationFrame(this.__animationRunner),this.__statusChangeCallback(m.Animation.Status.INITIALIZED),this.__animatedStyles={};for(var e=this.__animation.keyframes(),t=0,o=e.length;t<o;t++)for(var n in e[t].styles)e[t].styles.hasOwnProperty(n)&&(void 0===this.__animatedStyles[n]&&(this.__animatedStyles[n]=[]),this.__animatedStyles[n].push({progressPoint:e[t].progressPoint,values:e[t].styles[n].map(function(e){return r.__parseKeyframeStyle(e)})}));var i=m.StyleProvider.getSimpleElementStyle(this.__element);for(var n in this.__initialStyles={},this.__animatedStyles)if(this.__animatedStyles.hasOwnProperty(n)){if(this.__animatedStyles[n].sort(function(e,r){return e.progressPoint-r.progressPoint}),0!==this.__animatedStyles[n][0].progressPoint||1!==this.__animatedStyles[n][this.__animatedStyles[n].length-1].progressPoint)throw new Error("Start and end keyframes with progress points 0 and 1 must be defined for all animated properties.");this.__initialStyles[n]=i&&void 0!==i[n]?i[n]:null}var a=this.__animation.fillMode();if("backwards"===a||"both"===a)switch(this.__animation.direction()){case"normal":case"alternate":m.StyleProvider.setSimpleElementStyle(this.__element,e.filter(function(e){return 0===e.progressPoint})[0].styles);break;case"reverse":case"alternate-reverse":m.StyleProvider.setSimpleElementStyle(this.__element,e.filter(function(e){return 1===e.progressPoint})[0].styles)}}else this.__animation.state()===m.Animation.Status.PAUSED&&(null!==this.__delayTimer?this.__delayTimer.resume():this.__animationFrameID=window.requestAnimationFrame(this.__animationRunner))},e.prototype.pause=function(){this.__animation.state()===m.Animation.Status.RUNNING?(null!==this.__animationFrameID&&window.cancelAnimationFrame(this.__animationFrameID),this.__statusChangeCallback(m.Animation.Status.PAUSED)):this.__animation.state()===m.Animation.Status.INITIALIZED&&null!==this.__delayTimer&&(this.__delayTimer.pause(),this.__statusChangeCallback(m.Animation.Status.PAUSED))},e.prototype.skip=function(){this.__animation.state()!==m.Animation.Status.ENDED&&(null!==this.__animationFrameID&&window.cancelAnimationFrame(this.__animationFrameID),this.cleanup(!0),this.__statusChangeCallback(m.Animation.Status.ENDED))},e.prototype.reset=function(e){if(this.__resetToInitial&&this.__animation.state()!==m.Animation.Status.CONFIGURE)for(var r in this.__initialStyles)this.__initialStyles.hasOwnProperty(r)&&m.StyleProvider.setSimpleElementStyle(this.__element,r,this.__initialStyles[r]);this.__statusChangeCallback(m.Animation.Status.CONFIGURE),"function"==typeof e&&e()},e.prototype.cleanup=function(e){void 0===e&&(e=!1);var r=null;if("forwards"===this.__animation.fillMode()||"both"===this.__animation.fillMode()||e)switch(this.__animation.direction()){case"normal":r=1;break;case"reverse":r=0;break;case"alternate":r=this.__animation.iterationCount()%2==0?0:1;break;case"alternate-reverse":r=this.__animation.iterationCount()%2==0?1:0}null===r?m.StyleProvider.setSimpleElementStyle(this.__element,this.__initialStyles):m.StyleProvider.setSimpleElementStyle(this.__element,this.__animation.keyframes().filter(function(e){return e.progressPoint===r})[0].styles)},e.prototype.__parseKeyframeStyle=function(e){var r=/^(-?\d*\.?\d+)(?:%|px)?$/.exec(e);if(null!==r)return[parseFloat(r[1]),e.substring(r[1].length)];for(var t=[],o=/#[0-9a-fA-F]{6}|#[0-9a-fA-F]{3}/g,n=o.exec(e);null!==n;){var i=n[0].slice(1);t.push({value:N.fromHexString(i),replaceIndex:n.index,replaceLength:n[0].length}),n=o.exec(e)}for(var a=/rgba?\( *(-?\d+) *, *(-?\d+) *, *(-?\d+) *(?:, *(-?\d*\.?\d+) *)?\)/g,s=a.exec(e);null!==s;){var l=parseInt(s[1],10),c=parseInt(s[2],10),_=parseInt(s[3],10),u=s[4]?parseFloat(s[4]):1;t.push({value:N.fromRgb(l,c,_,u),replaceIndex:s.index,replaceLength:s[0].length}),s=a.exec(e)}for(var d=/hsla?\( *(-?\d*\.?\d+) *, *(-?\d*\.?\d+)% *, *(-?\d*\.?\d+)% *(?:, *(-?\d*\.?\d+) *)?\)/g,m=d.exec(e);null!==m;){var h=parseFloat(m[1]),g=parseFloat(m[2])/100,p=parseFloat(m[3])/100;u=m[4]?parseFloat(m[4]):1;t.push({value:N.fromHsl(h,g,p,u),replaceIndex:m.index,replaceLength:m[0].length}),m=d.exec(e)}var E=[];if(0<t.length){t.sort(function(e,r){return e.replaceIndex-r.replaceIndex});for(var f=t.length-1,S=0;S<=f;f--){var y=t[f].replaceIndex+t[f].replaceLength,v=f<t.length-1?t[f+1].replaceIndex:void 0;y!==v&&y<e.length&&E.unshift(e.substring(y,v)),E.unshift(t[f].value)}0<t[0].replaceIndex&&E.unshift(e.substring(0,t[0].replaceIndex-1))}else E.push(e);var C=/-?\d*\.?\d+/;for(f=0,S=E.length;f<S;f++){var T=E[f];if("string"==typeof T){var M=C.exec(T);if(null!==M){var b=[],R=0;0<M.index&&(b.push(T.substring(0,M.index)),S++,R++),b.push(parseFloat(M[0])),M.index+M[0].length<T.length&&(b.push(T.substring(M.index+M[0].length)),S++),E.splice.apply(E,[f,1].concat(b)),f+=R}}}return E},e.prototype.__getTimingFunction=function(){var e=this.__animation.timingFunction();if("function"==typeof e)return e;function r(e,r,t,o){var s=[{x:0,y:0},{x:e,y:r},{x:t,y:o},{x:1,y:1}];return function(e){function a(e,r){for(var t=[],o=0;o<e.length-1;o++){var n=e[o].x+(e[o+1].x-e[o].x)*r,i=e[o].y+(e[o+1].y-e[o].y)*r;t.push({x:n,y:i})}return 1===t.length?t[0]:a(t,r)}for(var r={x:0,y:0},t=.5,o=0,n=1,i=0;i<10;i++){if(r=a(s,t),Math.abs(r.x-e)<5e-4)return r.y;r.x<e?o=t:n=t,t=o+(n-o)/2}return r.y}}function t(e,r){var t=1/e;return function(e){return r?Math.ceil(e/t)*t:Math.floor(e/t)*t}}switch(e){case"linear":return function(e){return e};case"ease":return r(.25,.1,.25,1);case"ease-in":return r(.42,0,1,1);case"ease-out":return r(0,0,.58,1);case"ease-in-out":return r(.42,0,.58,1);case"step-start":return t(1,!0);case"step-end":return t(1,!1);default:var o=/cubic-bezier\( *(1(?:.0+)?|0|0?\.\d+) *, *(-?\d*\.?\d+) *, *(1(?:.0+)?|0|0?\.\d+) *, *(-?\d*\.?\d+) *\)/.exec(e);if(null!==o)return r(parseFloat(o[1]),parseFloat(o[2]),parseFloat(o[3]),parseFloat(o[4]));var n=/steps\( *([1-9][0-9]*) *(?:, *(start|end) *)?\)/.exec(e);if(null!==n)return t(parseInt(n[1],10),"start"===n[2])}return m.Log.error("[Source=Framework, Module=TcHmi.System.AnimationProvider] Unknown timing function "+e+"."),r(.25,.1,.25,1)},e.prototype.__getAnimationRunner=function(){var l,c=this,_=this.__animation.duration(),u=this.__getTimingFunction();switch(this.__animation.direction()){case"normal":l=function(e){return e};break;case"reverse":l=function(e){return 1-e};break;case"alternate":l=function(e){return c.__iteration%2==0?e:1-e};break;case"alternate-reverse":l=function(e){return c.__iteration%2==0?1-e:e}}var d=function(r){if(null===c.__start)c.__started=c.__start=r,c.__statusChangeCallback(m.Animation.Status.RUNNING),c.__animation.eventHandlers().filter(function(e){return"animationstart"===e.name}).forEach(function(e){return e.callback({error:m.Errors.NONE,animationName:c.__animation.animationName(),elapsedTime:0})});else if(c.__animation.state()===m.Animation.Status.PAUSED){var e=r-c.__elapsedTime-c.__start;c.__start+=e,c.__started+=e,c.__statusChangeCallback(m.Animation.Status.RUNNING)}c.__elapsedTime=r-c.__start;var t=c.__elapsedTime/_;t=l(t);var o={};for(var n in c.__animatedStyles)if(c.__animatedStyles.hasOwnProperty(n)){var i=c.__getBorderingKeyframes(n,t);if(1===i.length)o[n]=i[0].values.map(function(e){return e.join("")});else{var a=(t-i[0].progressPoint)/(i[1].progressPoint-i[0].progressPoint);o[n]=c.__interpolate(i[0].values,i[1].values,u(a))}}try{m.StyleProvider.setSimpleElementStyle(c.__element,o)}catch(e){return void c.__statusChangeCallback(m.Animation.Status.PAUSED)}if(0<=t&&t<=1)c.__animationFrameID=window.requestAnimationFrame(d);else{c.__iteration++;var s=c.__animation.iterationCount();"infinite"===s||c.__iteration<s?(c.__start=r,c.__animationFrameID=window.requestAnimationFrame(d),c.__animation.eventHandlers().filter(function(e){return"animationiteration"===e.name}).forEach(function(e){return e.callback({error:m.Errors.NONE,animationName:c.__animation.animationName(),elapsedTime:(r-c.__started)/1e3})})):(c.__animationFrameID=null,c.__statusChangeCallback(m.Animation.Status.ENDED),c.__animation.cleanup()&&(c.__resetToInitial=!1),c.cleanup(),c.__animation.eventHandlers().filter(function(e){return"animationend"===e.name}).forEach(function(e){return e.callback({error:m.Errors.NONE,animationName:c.__animation.animationName(),elapsedTime:(r-c.__started)/1e3})}))}};return d},e.prototype.__getBorderingKeyframes=function(e,r){for(var t=this.__animatedStyles[e],o=0,n=t.length;o<n;o++){if(t[o].progressPoint===r)return[t[o]];if(t[o].progressPoint>r)return o<1?[t[o]]:[t[o-1],t[o]]}return[t[t.length-1]]},e.prototype.__interpolate=function(e,r,t){var o=[];function n(e,r){return e+(r-e)*t}for(var i=0,a=Math.min(e.length,r.length);i<a;i++){for(var s=[],l=0,c=Math.max(e[i].length,r[i].length);l<c;l++){var _=e[i][l],u=r[i][l],d=typeof _,m=typeof u;if(void 0===_){switch(m){case"string":_=u;break;case"number":_=0;break;case"object":_=N.fromRgb(0,0,0,0)}d=m}if(void 0===u){switch(d){case"string":u=_;break;case"number":u=0;break;case"object":u=N.fromRgb(0,0,0,0)}m=d}if(d!==m||"string"===d)s.push(t<.5?_:u);else switch(d){case"number":s.push(n(_,u));break;case"object":s.push(N.fromRgb(n(_.red,u.red),n(_.green,u.green),n(_.blue,u.blue),n(_.alpha,u.alpha)))}}o.push(s.join(""))}return o},e}();t.JavaScriptAnimationController=n;var s=function(){function e(e,r){this.__timerId=0,this.__callback=e,this.__delay=r,this.__remaining=r,this.resume()}return e.prototype.pause=function(){window.clearTimeout(this.__timerId),this.__remaining-=Date.now()-this.__start},e.prototype.resume=function(){this.__start=Date.now(),window.clearTimeout(this.__timerId),this.__timerId=window.setTimeout(this.__callback,this.__remaining)},e}(),N=function(){function u(e,r,t,o){function n(e,r,t){return e<=r?r:t<=e?t:e}this.red=Math.round(n(e,0,255)),this.green=Math.round(n(r,0,255)),this.blue=Math.round(n(t,0,255)),this.alpha=n(o,0,1)}return u.fromRgb=function(e,r,t,o){return void 0===o&&(o=1),new u(e,r,t,o)},u.fromHsl=function(e,r,t,o){function n(e,r,t){return e<=r?r:t<=e?t:e}var i,a,s;if(void 0===o&&(o=1),e=n(e%360/360,0,1),r=n(r,0,1),t=n(t,0,1),0===r)i=a=s=t;else{var l=function(e,r,t){return t<0&&(t+=1),1<t&&(t-=1),t<1/6?e+6*(r-e)*t:t<.5?r:t<2/3?e+(r-e)*(2/3-t)*6:e},c=t<.5?t*(1+r):t+r-t*r,_=2*t-c;i=l(_,c,e+1/3),a=l(_,c,e),s=l(_,c,e-1/3)}return new u(255*i,255*a,255*s,o)},u.fromHexString=function(e){return 3===e.length&&(e=e.replace(/./g,"$&$&")),new u(parseInt(e.substr(0,2),16),parseInt(e.substr(2,2),16),parseInt(e.substr(4,2),16),1)},u.prototype.toString=function(){return"rgba("+this.red+", "+this.green+", "+this.blue+", "+this.alpha+")"},u}()}(m.System||(m.System={}))}(TcHmi||(TcHmi={})),function(o){var n,e,r,t;n=o.System||(o.System={}),t=function(){function _(e,r,t){this.__state=_.State.Invalid,this.__attr=null,this.__attrSchema=null,this.__onControlAttachedDestroyCallback=null,this.__onControlDetachedDestroyCallback=null,this.__onBindingEventDestroyCallback=null,this.__onFunctionResultChangedDestroyCallback=null,this.__expression=e,this.__propertyName=r,this.__control=t,this.__state=_.State.Initializing,this.__symbol=new n.Symbol(e),this.__attr=o.System.Services.controlManager.getAttributeByPropertyName(this.__control,this.__propertyName),this.__attrSchema=o.System.Services.typeManager.getSchema(this.__attr.type),this.__onControlAttachedDestroyCallback=o.EventProvider.register(this.__control.getId()+".System.onAttached",this.__onControlAttached()),this.__onControlDetachedDestroyCallback=o.EventProvider.register(this.__control.getId()+".System.onDetached",this.__onControlDetached()),this.__control.getIsAttached()&&this.__resume()}return _.prototype.destroy=function(){this.__state!==_.State.Destroyed&&(this.__propertyName=null,this.__control=null,this.__destroyWatch&&(this.__destroyWatch(),this.__destroyWatch=null),this.__watchCallback=null,this.__symbol&&(this.__symbol.destroy(),this.__symbol=null),null!==this.__onFunctionResultChangedDestroyCallback&&(this.__onFunctionResultChangedDestroyCallback(),this.__onFunctionResultChangedDestroyCallback=null),null!==this.__onBindingEventDestroyCallback&&(this.__onBindingEventDestroyCallback(),this.__onBindingEventDestroyCallback=null),null!==this.__onControlAttachedDestroyCallback&&(this.__onControlAttachedDestroyCallback(),this.__onControlAttachedDestroyCallback=null),null!==this.__onControlDetachedDestroyCallback&&(this.__onControlDetachedDestroyCallback(),this.__onControlDetachedDestroyCallback=null),this.__state=_.State.Destroyed)},_.prototype.__resume=function(){if(this.__state===_.State.Initializing||this.__state===_.State.Suspended){if(this.__state=_.State.Resuming,TCHMI_ENABLE_DESIGNER_MODE_MASTER&&this.__symbol.getExpression().getType()===o.SymbolType.Server)return this.__state=_.State.Ready,void this.__callSetter(null);if(this.__attrSchema&&"TcHmi.Symbol"===this.__attrSchema.frameworkInstanceOf)this.__state=_.State.Ready,this.__callSetter(new o.Symbol(this.__symbol.getExpression().toString()));else{var e=this.__symbol.getExpression().getOptions().BindingMode,r=o.System.Services.controlManager.getAttributeTypeByPropertyName(this.__control,this.__propertyName);if("TwoWay"===e||!e&&r===n.ControlAttributeType.UserControlParameter){var t=this.__symbol.getExpression().getOptions().BindingEvent;t?this.__onBindingEventDestroyCallback=o.EventProvider.register(this.__control.getId()+"."+t,this.__onBindingEvent()):this.__onFunctionResultChangedDestroyCallback=o.EventProvider.register(this.__control.getId()+".onFunctionResultChanged",this.__onFunctionResultChanged())}this.__watchCallback=this.__onWatchCallback(),this.__destroyWatch=this.__symbol.watch(this.__watchCallback)}}},_.prototype.__suspend=function(){this.__destroyWatch&&(this.__destroyWatch(),this.__destroyWatch=null),(this.__watchCallback=null)!==this.__onFunctionResultChangedDestroyCallback&&(this.__onFunctionResultChangedDestroyCallback(),this.__onFunctionResultChangedDestroyCallback=null),null!==this.__onBindingEventDestroyCallback&&(this.__onBindingEventDestroyCallback(),this.__onBindingEventDestroyCallback=null),this.__state=_.State.Suspended},_.prototype.getExpression=function(){return this.__expression},_.prototype.getSymbol=function(){return this.__symbol},_.prototype.getPropertyName=function(){return this.__propertyName},_.prototype.getControl=function(){return this.__control},_.prototype.__onControlAttached=function(){var t=this;return function(e,r){t.__resume()}},_.prototype.__onControlDetached=function(){var t=this;return function(e,r){t.__suspend()}},_.prototype.__onBindingEvent=function(){var r=this;return function(){if(r.__state===_.State.Ready&&void 0!==r.__control[r.__attr.propertyGetterName])try{var e=r.__control[r.__attr.propertyGetterName].call(r.__control);r.__lock=!0,r.__lockValue=tchmi_clone_object(e),r.__symbol.write(tchmi_clone_object(e),function(e){r.__lock=!1,r.__lockValue=void 0})}catch(e){}finally{r.__lock=!1,r.__lockValue=void 0}}},_.prototype.__onFunctionResultChanged=function(){var c=this;return function(e,r,t){if(c.__state===_.State.Ready&&r){var o,n=!1;if(t)for(a=0,s=t.length;a<s;a++){var i=t[a].propertyName;if(c.__attr&&c.__attr.propertyName===i){n=!0,o=t[a].dirtyPaths;break}}else for(var a=0,s=r.length;a<s;a++)if(c.__attr&&c.__attr.propertyGetterName===r[a]){n=!0;break}if(n&&void 0!==c.__control[c.__attr.propertyGetterName]){var l=c.__control[c.__attr.propertyGetterName].call(c.__control);if(c.__lock&&tchmi_equal(c.__lockValue,l,!1))return;c.__lock&&(c.__lock=!1,c.__lockValue=void 0),c.__symbol.writeEx(tchmi_clone_object(l),o)}}}},_.prototype.__onWatchCallback=function(){var t=this;return function(e){if(!(t.__state!==_.State.Ready&&t.__state!==_.State.Resuming||t.__lock&&tchmi_equal(t.__lockValue,e.value,!1)))if(e.error===o.Errors.NONE)t.__state===_.State.Resuming&&(t.__state=_.State.Ready),t.__callSetter(e.value,e.dirtyPaths);else{var r="[Source=Framework, Module=TcHmi.System.Binding, Control="+t.__control.getId()+", Property="+t.__propertyName+", Symbol="+t.__symbol.getExpression().toString()+"] ";e.details?r+=o.Log.buildMessage(e.details):r+=o.Log.buildMessage({code:e.error,message:o.Errors[e.error]}),o.Log.error(r),t.__callSetter(null)}}},_.prototype.__callSetter=function(e,r){if(void 0===e&&(e=void 0),void 0===r&&(r=void 0),void 0!==e){this.__lock=!0,this.__lockValue=tchmi_clone_object(e);try{o.System.Services.controlManager.setControlPropertyByAttribute(this.__control,this.__attr,e,r)}catch(r){try{o.Log.error("[Source=Framework, Module=TcHmi.System.Binding, Control="+this.__control.getId()+", Property="+this.__propertyName+", Symbol="+this.__symbol.getExpression().toString()+"] Unexpected exception="+r+" in setter function of attribute with propertyName="+this.__propertyName+" of control="+this.__control.getId()+".")}catch(e){o.Log.error("[Source=Framework, Module=TcHmi.System.Binding, Control="+this.__control.getId()+", Property="+this.__propertyName+", Symbol="+this.__symbol.getExpression().toString()+"] Unexpected exception="+r+".")}}finally{this.__lock=!1,this.__lockValue=void 0}}},_}(),n.Binding=t,e=t=n.Binding||(n.Binding={}),(r=e.State||(e.State={}))[r.Invalid=0]="Invalid",r[r.Initializing=5]="Initializing",r[r.Resuming=7]="Resuming",r[r.Ready=10]="Ready",r[r.Suspended=15]="Suspended",r[r.Destroyed=20]="Destroyed"}(TcHmi||(TcHmi={})),function(s){var a,e;a=s.System||(s.System={}),e=function(){function e(e){this.__bindingsByControl={}}return e.prototype.getBinding=function(e,r){var t=null,o=r.getId(),n=this.__bindingsByControl[o];if(!n)return t;if(!s.System.Services.controlManager.getAttributeByPropertyName(r,e))return t;var i=n[e];return i?t=i:t},e.prototype.getBindingsByControl=function(e){var r=e.getId(),t=this.__bindingsByControl[r];return void 0===t?{}:t},e.prototype.createBinding=function(e,r,t){this.removeBinding(r,t,!1);var o=t.getId(),n=this.__bindingsByControl[o];n||(n={},this.__bindingsByControl[o]=n);var i=new a.Binding(e,r,t);return n[r]=i},e.prototype.removeBinding=function(e,r,t){void 0===t&&(t=!0);var o=r.getId(),n=this.__bindingsByControl[o];if(n){var i=s.System.Services.controlManager.getAttributeByPropertyName(r,e);if(i){var a=n[e];if(a&&(delete n[e],a.destroy(),t))try{s.System.Services.controlManager.setControlPropertyByAttribute(r,i,null)}catch(r){try{s.Log.error("[Source=Framework, Module=TcHmi.System.BindingManager] Unexpected exception="+r+" in setter function of attribute with propertyName="+e+" of control="+o+".")}catch(e){s.Log.error("[Source=Framework, Module=TcHmi.System.BindingManager] Unexpected exception="+r+".")}}}}},e}(),a.BindingManager=e}(TcHmi||(TcHmi={})),function(b){var R,e;R=b.System||(b.System={}),e=function(){function M(e){var p=this;if(this.__controlsGeoMap={},this.__onAttributeMutation=function(e,r){for(var t=[],o=0,n=e.length;o<n;o++){var i=e[o].target;if(i.nodeType===Node.ELEMENT_NODE){var a=p.__controlsGeoMap[i.id];a&&-1===t.indexOf(a)&&t.push(a);for(var s=i.querySelectorAll("div[id][data-tchmi-type]"),l=0,c=s.length;l<c;l++){var _=p.__controlsGeoMap[s[l].id];-1===t.indexOf(_)&&t.push(_)}}}p.checkControlGeometry(t)},this.__onDomMutation=function(e,r){for(var n=!1,o=[],i=[],t=function(e){var r=p.__controlsGeoMap[e];if(r){delete p.__controlsGeoMap[e];var t=r.ctrl;if(t){var o=t.getElement();if(!(o.length<1))if(!1===(void 0!==o[0].isConnected?o[0].isConnected:!!document.getElementById(e))&&!0===t.getIsAttached()){b.EventProvider.raise("System.onPrevControlDetached",t),b.EventProvider.raise(e+".System.onPrevDetached",t);try{t.__detach()}catch(e){b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Control __detach of "+t.__id+" failed with exception="+e+".")}i.push(t),n=!0}}}},a=function(e){var r=p.__controls[e];if(r){var t=r.getElement();if(!(t.length<1))if(p.__controlsGeoMap[e]={ctrl:r,bounds:{offsetLeft:null,offsetTop:null,width:null,height:null}},!0===(void 0!==t[0].isConnected?t[0].isConnected:!!document.getElementById(e))&&!1===r.getIsAttached()){b.EventProvider.raise("System.onPrevControlAttached",r),b.EventProvider.raise(e+".System.onPrevAttached",r);try{r.__attach()}catch(e){b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Control __attach of "+r.__id+" failed with exception="+e+".")}o.push(r),n=!0}}},s=0,l=e.length;s<l;s++){for(var c=e[s],_=0,u=c.removedNodes.length;_<u;_++){if((h=c.removedNodes[_]).nodeType===Node.ELEMENT_NODE){for(var d=0,m=(g=h.querySelectorAll("div[id][data-tchmi-type]")).length;d<m;d++)t(g[d].id);h.id&&t(h.id)}}for(_=0,u=c.addedNodes.length;_<u;_++){var h;if((h=c.addedNodes[_]).nodeType===Node.ELEMENT_NODE){h.id&&a(h.id),p.__attributeMutationObserver.observe(h,{attributes:!0,attributeFilter:["style","class"],subtree:!0});var g;for(d=0,m=(g=h.querySelectorAll("div[id][data-tchmi-type]")).length;d<m;d++)a(g[d].id)}}}n&&p.checkControlGeometry(),0!==i.length&&b.EventProvider.raise("System.onPrevControlsDetached",i),0!==o.length&&b.EventProvider.raise("System.onPrevControlsAttached",o)},this.__descriptions={},this.__controls={},b.control=this.__controls,"function"==typeof MutationObserver)this.__domMutationObserver=new MutationObserver(this.__onDomMutation),this.__domMutationObserver.observe(document.body,{childList:!0,subtree:!0}),this.__attributeMutationObserver=new MutationObserver(this.__onAttributeMutation);else if("function"==typeof e){var r={servicesName:"ControlManager",error:b.Errors.E_NOT_SUPPORTED,dialogManagerMessage:"Browser support for MutationObserver missing."};e.call(null,r)}window.addEventListener("resize",this.__onWindowResized())}return M.prototype.__onWindowResized=function(){var r=this;return function(e){r.checkControlGeometry()}},M.prototype.checkControlGeometry=function(e){var r;if(void 0!==e)r=e;else{r=[];var t=this.__controlsGeoMap;for(var o in t)r.push(t[o])}for(var n=[],i=[],a=0,s=r.length;a<s;a++){var l=r[a];if(l){var c=l.ctrl;if(c&&!c.getIsDestroyed()&&c.getIsAttached()){var _=c.getElement()[0],u=_.getBoundingClientRect(),d=_.offsetLeft,m=_.offsetTop;if(c.__parent)if("tchmi-grid"!==c.__parent.getType())d+=parseFloat(c.__parent.__element.css("border-left-width")),m+=parseFloat(c.__parent.__element.css("border-top-width"));else{var h=c.getElement().parent().parent();d+=parseFloat(h.css("border-left-width"))+parseFloat(h.css("padding-left")),m+=parseFloat(h.css("border-top-width"))+parseFloat(h.css("padding-top"))}this.__checkResize(l,u.width,u.height)&&n.push(c),this.__checkMoved(l,d,m)&&i.push(c)}}}if(n.length){for(a=0,s=n.length;a<s;a++){var g=n[a];b.EventProvider.raise(g.getId()+".System.onPrevResized",g),b.EventProvider.raise("System.onControlResized",g),b.EventProvider.raise(g.getId()+".onResized",g)}b.EventProvider.raise("System.onControlsResized",n)}if(i.length){for(a=0,s=i.length;a<s;a++){var p=i[a];b.EventProvider.raise(p.getId()+".System.onPrevMoved",p),b.EventProvider.raise("System.onControlMoved",p),b.EventProvider.raise(p.getId()+".onMoved",p)}b.EventProvider.raise("System.onControlsMoved",i)}},M.prototype.__checkResize=function(e,r,t){var o=!1;return r=Math.round(r),t=Math.round(t),null===e.bounds.width&&null===e.bounds.height?(e.bounds.width=r,e.bounds.height=t,o=!0):e.bounds.width===r&&e.bounds.height===t||(e.bounds.width=r,e.bounds.height=t,o=!0),o},M.prototype.__checkMoved=function(e,r,t){var o=!1;return null===e.bounds.offsetTop&&null===e.bounds.offsetLeft?(e.bounds.offsetTop=r,e.bounds.offsetLeft=t,o=!0):e.bounds.offsetTop===r&&e.bounds.offsetLeft===t||(e.bounds.offsetTop=r,e.bounds.offsetLeft=t,o=!0),o},M.prototype.getControlsCache=function(){return this.__controls},M._procConstructor=function(r,e,t,o){try{return new o(r,e,t)}catch(e){return void b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Control constructor of "+r.attr("id")+" failed with exception="+e+".")}},M._procPrevinit=function(r,e){try{return r.__previnit(),!0}catch(e){b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Control previnit of "+r.__id+" failed with exception="+e+".");try{r.destroy()}catch(e){}return!1}},M._procInit=function(r,e){try{return r.__init(),!0}catch(e){b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Control init of "+r.__id+" failed with exception="+e+".");try{r.destroy()}catch(e){}return!1}},M.prototype.setControlProperty=function(e,r,t,o){var n=this.getAttributeByPropertyName(e,r);return n?n.readOnly?b.Errors.E_SYMBOL_READONLY:n.propertySetterName?this.setControlPropertyByAttribute(e,n,t,o):(b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] No setter for control attribute="+r+" defined for control type "+e.getType()+"."),b.Errors.E_PARAMETER_INVALID):(r&&b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Did not found Control attribute description of "+r+" for control type "+e.getType()+"."),b.Errors.E_PARAMETER_INVALID)},M.prototype.setControlPropertyByAttribute=function(r,t,e,o){var n=r[t.propertySetterName];if(void 0===n)return b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Setting value for Control attribute="+t.propertyName+" of control type "+r.getType()+" failed: Could not find implementation of PropertySetter."),b.Errors.E_PARAMETER_INVALID;var i=!1,a=e;null===a&&(a=R.Services.themeManager.getDefaultPropertyValue(r,t.propertyName).value,i=!0),a=b.ValueConverter.toType(a,t.type);try{n.call(r,a,o)}catch(e){return b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Control attribute="+t.propertyName+" setter function of control="+r.getId()+" failed with exception="+e+"."),b.Errors.ERROR}return i?R.Services.themeManager.watchAttributeDefaults(r,t.propertyName):R.Services.themeManager.unwatchAttributeDefaults(r,t.propertyName),b.Errors.NONE},M.prototype.destruct=function(e){void 0!==this.__controls[e.__id]?delete this.__controls[e.__id]:b.Log.warn("[Source=Framework, Module=TcHmi.System.ControlManager] Unable to destroy control with id="+e.getId()+" because its already destroyed!")},M.prototype.compile=function(e,r,t){var o;if(1===(o="string"==typeof e?$(e):e).length||1===(o=o.filter("div[data-tchmi-type]")).length){var n=o.attr("data-tchmi-type");if(n){var i=o.attr("id");if(i){var a=void 0,s=b.System.Caches.registeredControls[n];if(void 0===s){var l="[Source=Framework, Module=TcHmi.System.ControlManager] Internal Error: Compile of control "+(o.attr("id")||"")+" not successful: Control class "+n+" was not loaded. Mostly this is the case if the control source files are not included or not included in proper order in the document. ";return TCHMI_ENABLE_DESIGNER_MODE||(l+='If a control uses a foreign control this information must be added in your controls description as description.json#uses: ["'+n+'"]'),void b.Log.error(l)}var c=$(o[0].cloneNode(!0));o.empty();var _=b.System.resolveAttributesFromControlElement(c);if(void 0===this.__controls[i]){if(void 0!==(a=M._procConstructor(o,c,_,s.constructor))){if(a.__parent=r||null,this.__controls[i]=a,r&&r.__addChild(a,t),null!==s.templatePath&&void 0!==s.templatePath){var u=b.System.Caches.templateMarkupCache[s.templatePath];if(void 0!==u){var d=$(u.replace(/{Id}/g,i)),m=this,h=function(e){for(var r=e.children(),t=0,o=r.length;t<o;t++){var n=r.eq(t);if(void 0!==n.attr("data-tchmi-type")){var i=m.compile(n,a);a.__addChild(i)}else h(n)}};h(d),o.append(d)}else b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Template markup for control type="+a.getType()+" is not available.")}if(!0===M._procPrevinit(a,c)){var g={"data-tchmi-trigger":!0},p=a.__attrs;if(null!=p)for(var E in p){var f=p[E];void 0!==f.descr&&null!==f.descr&&("data-tchmi-trigger"!==E&&((g[E]=!0)===f.descr.readOnly||(b.Symbol.isSymbolExpression(f.value)?b.System.Services.bindingManager.createBinding(f.value,f.descr.propertyName,a):this.setControlPropertyByAttribute(a,f.descr,f.value))))}for(var S=0,y=this.getDescriptionAttributes(n);S<y.length;S++){var v=y[S];if(!g[v.name.toLowerCase()]&&!v.readOnly){if(v.requiredOnCompile)return b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Error compiling control id="+i+" type="+a.getType()+". Attribute "+v.propertyName+" is required but has not been set in HTML."),void delete this.__controls[i];this.setControlPropertyByAttribute(a,v,null)}}R.Services.themeManager.startAttributeSetterWatcher(i);var C=p["data-tchmi-trigger"];if(null!=C&&void 0!==C.descr&&null!==C.descr&&(!0===C.descr.readOnly||(b.Symbol.isSymbolExpression(C.value)?b.System.Services.bindingManager.createBinding(C.value,C.descr.propertyName,a):this.setControlPropertyByAttribute(a,C.descr,C.value))),!0===M._procInit(a,c))return a;delete this.__controls[i]}else delete this.__controls[i]}}else{var T=this.__controls[i].__element.attr("data-tchmi-partial-url");!b.System.isInitialized&&T&&T===o.attr("data-tchmi-partial-url")||b.Log.error('[Source=Framework, Module=TcHmi.System.ControlManager] Failed to create instance of control. Id: "'+i+'" does already exist.')}}else b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Error compiling control. Missing required attribute=id in html="+o[0].outerHTML+".")}else b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Error compiling control. Missing required attribute=data-tchmi-type in html="+o[0].outerHTML+".")}else b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Error compiling control. Only one control is allowed but got "+o.length+".")},M.prototype.addDescription=function(e,r){this.__descriptions[r.name]={type:r.name,path:e,fullDescription:r}},M.prototype.__resolveDescriptionTypes=function(e){e.fullDescription.inheritedTypes=[];var r=e.fullDescription.base;if(null!=r){var t=this.getDescriptionCacheEntry(r);if(null===t)return void b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Base class of "+e.fullDescription.name+" ("+e.fullDescription.base+") not loaded.");this.__resolveDescriptionTypes(t);for(var o=this.getDescriptionTypes(r),n=0,i=o.length;n<i;n++){var a=o[n];e.fullDescription.inheritedTypes.push(a)}}e.fullDescription.inheritedTypes.push(e.type)},M.prototype.__resolveDescriptionAttributes=function(e){var r=[],t=[];e.fullDescription.inheritedAttributes=[],e.fullDescription.inheritedAttributesNameMap={},e.fullDescription.inheritedAttributesPropertyNameMap={},e.fullDescription.inheritedAttributesPropertyGetterNameMap={},e.fullDescription.inheritedAttributesPropertySetterNameMap={},e.fullDescription.inheritedAccess=[];var o=e.fullDescription.base;if(null!=o){var n=this.getDescriptionCacheEntry(o);if(null===n)return void b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Base class of "+e.fullDescription.name+" ("+e.fullDescription.base+") not loaded.");this.__resolveDescriptionAttributes(n);var i=n.fullDescription.inheritedAttributes;if(void 0!==i)for(var a=0,s=i.length;a<s;a++)!1!==i[a].heritable&&r.push(i[a]);var l=n.fullDescription.inheritedAccess;void 0!==l&&0!==l.length&&(t=t.concat(l))}var c=tchmi_clone_object(e.fullDescription.attributes);null==c&&(c=[]);for(a=0,s=r.length;a<s;a++){for(var _=!1,u=0,d=c.length;u<d;u++)if(c[u].name===r[a].name){_=!0;break}!1===_&&e.fullDescription.inheritedAttributes.push(r[a])}e.fullDescription.inheritedAttributes=e.fullDescription.inheritedAttributes.concat(c);for(var m=0,h=e.fullDescription.inheritedAttributes.length;m<h;m++){var g=e.fullDescription.inheritedAttributes[m];(e.fullDescription.inheritedAttributesNameMap[g.name.toLowerCase()]=g).propertyName?e.fullDescription.inheritedAttributesPropertyNameMap[g.propertyName.toLowerCase()]=g:b.Log.error('[Source=Framework, Module=TcHmi.System.ControlManager] Description.json of control type "'+e.fullDescription.displayName+'" attribute "'+g.name+'" has no propertyName entry. Handling this attribute will not work.'),g.propertyGetterName?e.fullDescription.inheritedAttributesPropertyGetterNameMap[g.propertyGetterName.toLowerCase()]=g:b.Log.error('[Source=Framework, Module=TcHmi.System.ControlManager] Description.json of control type "'+e.fullDescription.displayName+'" attribute "'+g.name+'" has no propertyGetterName entry. Handling this attribute will not work.'),g.propertySetterName?e.fullDescription.inheritedAttributesPropertySetterNameMap[g.propertySetterName.toLowerCase()]=g:g.readOnly||b.Log.error('[Source=Framework, Module=TcHmi.System.ControlManager] Description.json of control type "'+e.fullDescription.displayName+'" attribute "'+g.name+'" has no propertySetterName entry. Handling this attribute will not work.')}var p=e.fullDescription.access;null==p&&(p=[]);for(a=0,s=t.length;a<s;a++){for(_=!1,u=0,d=p.length;u<d;u++)if(p[u].name===t[a].name){_=!0;break}!1===_&&e.fullDescription.inheritedAccess.push(t[a])}0!==p.length&&(e.fullDescription.inheritedAccess=e.fullDescription.inheritedAccess.concat(p))},M.prototype.__resolveInheritanceHierarchy=function(n){var i=this;if(!n)return null;var e={controlType:n.type,children:[]};if(n.fullDescription.base){var a=function(e,r){if(!r)return i.__resolveInheritanceHierarchy(i.getDescriptionCacheEntry(n.fullDescription.base));if(e===r.controlType)return r;for(var t=0;t<r.children.length;t++){var o=r.children[t];return o.controlType===e?o:a(e,o)}return null},r=a(n.fullDescription.base,this.__inheritanceHierarchyTree);if(null===r){var t=this.__resolveInheritanceHierarchy(this.getDescriptionCacheEntry(n.fullDescription.base));if(!t)return null;t.children.push(e)}else{for(var o=0;o<r.children.length;o++){var s=r.children[o];if(s.controlType===n.type)return s}r.children.push(e)}}else{if(this.__inheritanceHierarchyTree)return this.__inheritanceHierarchyTree;this.__inheritanceHierarchyTree=e}return e},M.prototype.resolveDescriptionInheritation=function(){try{for(var e in this.__descriptions){b.Log.debug("[Source=Framework, Module=TcHmi.System.ControlManager] Resolving "+e);var r=this.__descriptions[e];this.__resolveDescriptionTypes(r),this.__resolveDescriptionAttributes(r),this.__resolveInheritanceHierarchy(r)}}catch(e){b.Log.error("[Source=Framework, Module=TcHmi.System.ControlManager] Unexpected exception="+e)}},M.prototype.getInheritanceTree=function(){return this.__inheritanceHierarchyTree},M.prototype.getDescriptionCache=function(){return this.__descriptions},M.prototype.getDescriptionTypes=function(e){var r=this.getDescriptionCacheEntry(e);return r&&r.fullDescription&&r.fullDescription.inheritedTypes?r.fullDescription.inheritedTypes:[]},M.prototype.isRegisteredDescriptionType=function(e){return void 0!==this.__descriptions[e]},M.prototype.getDescriptionCacheEntry=function(e){return void 0!==this.__descriptions[e]?this.__descriptions[e]:null},M.prototype.getDescription=function(e){var r=this.getDescriptionCacheEntry(e);return null===r?null:r.fullDescription},M.prototype.getDescriptionPath=function(e){var r=this.getDescriptionCacheEntry(e);return null===r?null:r.path},M.prototype.getDescriptionAttributes=function(e){var r=this.getDescriptionCacheEntry(e);return r&&r.fullDescription&&r.fullDescription.inheritedAttributes?r.fullDescription.inheritedAttributes:null},M.prototype.getDescriptionAccess=function(e){var r=this.getDescriptionCacheEntry(e);return r&&r.fullDescription&&r.fullDescription.inheritedAccess?r.fullDescription.inheritedAccess:null},M.prototype.getDescriptionAttributeByName=function(e,r){if(!r)return null;var t=r.toLowerCase(),o=this.getDescriptionCacheEntry(e);return o&&o.fullDescription&&o.fullDescription.inheritedAttributesNameMap&&o.fullDescription.inheritedAttributesNameMap[t]?o.fullDescription.inheritedAttributesNameMap[t]:null},M.prototype.getDescriptionAttributeByPropertyName=function(e,r){if(!r)return null;var t=r.toLowerCase(),o=this.getDescriptionCacheEntry(e);return o&&o.fullDescription&&o.fullDescription.inheritedAttributesPropertyNameMap&&o.fullDescription.inheritedAttributesPropertyNameMap[t]?o.fullDescription.inheritedAttributesPropertyNameMap[t]:null},M.prototype.getDescriptionAttributeByPropertySetterName=function(e,r){if(null==r)return null;var t=r.toLowerCase(),o=this.getDescriptionCacheEntry(e);return o&&o.fullDescription&&o.fullDescription.inheritedAttributesPropertySetterNameMap&&o.fullDescription.inheritedAttributesPropertySetterNameMap[t]?o.fullDescription.inheritedAttributesPropertySetterNameMap[t]:null},M.prototype.getDescriptionAttributeByPropertyGetterName=function(e,r){if(null==r)return null;var t=r.toLowerCase(),o=this.getDescriptionCacheEntry(e);return o&&o.fullDescription&&o.fullDescription.inheritedAttributesPropertyGetterNameMap&&o.fullDescription.inheritedAttributesPropertyGetterNameMap[t]?o.fullDescription.inheritedAttributesPropertyGetterNameMap[t]:null},M.prototype.getAttributeByPropertyName=function(e,r){var t=e.getType(),o=b.System.Services.controlManager.getDescriptionAttributeByPropertyName(t,r);if(null==o&&"tchmi-user-control-host"===t){var n=e.getTargetUserControl();if(null!=n){var i=tchmi_path(n.replace(".usercontrol",".usercontrol.json")),a=b.System.Caches.partialCompositeConfigCache[i];if(null!=a){var s=a.parameters;if(null!=s)for(var l=0,c=s.length;l<c;l++){var _=s[l];if(null!=_&&_.propertyName===r){o=_;break}}}}}return o},M.prototype.getAttributeTypeByPropertyName=function(e,r){var t=R.ControlAttributeType.Invalid;if(!e)return t;var o=e.getType(),n=b.System.Services.controlManager.getDescriptionAttributeByPropertyName(o,r);if(null==n&&"tchmi-user-control-host"===o){var i=e.getTargetUserControl();if(null!=i){var a=tchmi_path(i.replace(".usercontrol",".usercontrol.json")),s=b.System.Caches.partialCompositeConfigCache[a];if(null!=s){var l=s.parameters;if(null!=l)for(var c=0,_=l.length;c<_;c++){var u=l[c];if(null!=u&&u.propertyName===r){t=R.ControlAttributeType.UserControlParameter;break}}}}}else t=R.ControlAttributeType.Control;return t},M.prototype.getAttributeByPropertySetterName=function(e,r){if(!e)return null;var t=e.getType(),o=b.System.Services.controlManager.getDescriptionAttributeByPropertySetterName(t,r);if(null==o&&"tchmi-user-control-host"===t){var n=e.getTargetUserControl();if(null!=n){var i=tchmi_path(n.replace(".usercontrol",".usercontrol.json")),a=b.System.Caches.partialCompositeConfigCache[i];if(null!=a){var s=a.parameters;if(null!=s)for(var l=0,c=s.length;l<c;l++){var _=s[l];if(null!=_&&_.propertySetterName===r){o=_;break}}}}}return o},M.prototype.getDescriptionAccessByName=function(e,r){var t=null;if(null==r)return null;var o=this.getDescriptionAccess(e);if(null!=o)for(var n=0,i=o.length;n<i;n++){var a=o[n];if(a.name===r){t=a;break}}return t},M.prototype.resolveTemplateInheritation=function(){var o=function(e){var r=b.System.Services.controlManager.getDescription(e);if(r){var t=b.System.Caches.registeredControls[r.base];if(t)return t.templatePath?t.templatePath:o(r.base)}return null};for(var e in b.System.Caches.registeredControls){var r=b.System.Caches.registeredControls[e];r&&!r.templatePath&&(r.templatePath=o(e))}},M}(),R.ControlManager=e}(TcHmi||(TcHmi={})),function(l){var e,r;e=l.System||(l.System={}),r=function(){function e(){this.__currentDialogType=0;var e=document.createElement("style");e.id="tchmi-dialogmanager-loading-styles",e.innerHTML="\nbody {\n    margin:0;\n}\n/**\n * LoadingDialog\n */\n#tchmi-loadingsystemdialog-container {\n    width: 100%;\n    height: 100%;\n    text-align: center;\n}\n\n#tchmi-loadingsystemdialog-container #tchmi-loadingsystemdialog-progress {\n    width: 100%;\n    height: 5px;\n    display: block;\n    background: #7493CC;\n}\n\n#tchmi-loadingsystemdialog-container #tchmi-loadingsystemdialog-progress[value] {\n    display: block;\n    color: #7493CC;\n    background: #ccc;\n    border:0px;\n}\n\n#tchmi-loadingsystemdialog-container #tchmi-loadingsystemdialog-progress::-moz-progress-bar {\n    display: block;\n    background: #7493CC;\n}\n\n#tchmi-loadingsystemdialog-container #tchmi-loadingsystemdialog-progress::-webkit-progress-bar {\n    background: #ccc;\n}\n\n#tchmi-loadingsystemdialog-container #tchmi-loadingsystemdialog-progress::-webkit-progress-value {\n    background: #7493CC;\n}\n\n#tchmi-loadingsystemdialog-container.tchmi-systemdialog-error #tchmi-loadingsystemdialog-progress[value] {\n    color: rgb(230, 80, 80);\n}\n\n#tchmi-loadingsystemdialog-container.tchmi-systemdialog-error #tchmi-loadingsystemdialog-progress {\n    background: rgb(230, 80, 80);\n}\n\n#tchmi-loadingsystemdialog-container.tchmi-systemdialog-error #tchmi-loadingsystemdialog-progress::-moz-progress-bar {\n    background: rgb(230, 80, 80);\n}\n\n#tchmi-loadingsystemdialog-container.tchmi-systemdialog-error #tchmi-loadingsystemdialog-progress::-webkit-progress-value {\n    background: rgb(230, 80, 80);\n} \n\n#tchmi-loadingsystemdialog-container .tchmi-systemdialog-message {\n    -moz-box-sizing: border-box;\n    -webkit-box-sizing: border-box;\n    box-sizing: border-box;\n\n    /* we have no other css loaded and thus no defined font */\n    font-family: sans-serif;\n    font-style: normal;\n    font-weight: normal;\n    font-size: x-large;\n    text-align: center;\n    padding: 5px;\n    width: 100%;\n    word-wrap: break-word;\n    z-index: 20000; /* We have to be on top of all select containers */\n\n    /** Reenable Text Selection for Errors */\n    -webkit-touch-callout: text;\n    -webkit-user-select: text;\n    -moz-user-select: text;\n    -ms-user-select: text;\n    user-select: text;\n}\n",document.head.appendChild(e),this.__dialogOwner=null,this.__jqLoadingDialogContainer=$('<div id="tchmi-loadingsystemdialog-container"><progress id="tchmi-loadingsystemdialog-progress"></progress><div class="tchmi-systemdialog-message"></div></div>'),this.__progressElem=this.__jqLoadingDialogContainer[0].getElementsByTagName("progress")[0],this.__jqOverlayDialogContainer=$('<div id="tchmi-overlaysystemdialog-container" class="tchmi-box"><div id="tchmi-overlaysystemdialog-background" class="tchmi-box"></div><div class="tchmi-systemdialog-message tchmi-box"></div><input id="tchmi-systemdialog-dismissbutton" type="button" value="Close" style="display:none;"></input></div>');var r,t=function(e){e.stopPropagation()},o=this.__jqOverlayDialogContainer.find("#tchmi-overlaysystemdialog-background")[0];r=!!TCHMI_EVENT_OPTION_OBJECT_SUPPORTED&&{passive:!1,capture:!1},o.addEventListener("mousedown",t,r),o.addEventListener("click",t,r),o.addEventListener("mouseup",t,r),o.addEventListener("touchstart",t,r),o.addEventListener("touchend",t,r)}return e.prototype.showDialog=function(e,r,t,o){if(null!==e&&null!==this.__dialogOwner&&this.__dialogOwner!==e)return!1;if(!0===r){if((this.__currentDialogType=t)===l.DialogManager.DialogType.SYSTEMLoading){if(document.body&&!document.body.contains(this.__jqLoadingDialogContainer[0])&&(this.__jqOverlayDialogContainer.detach(),l.System.SharedResources.jqBody.append(this.__jqLoadingDialogContainer),window.localStorage&&window.performance&&window.performance.timing&&window.performance.timing.domInteractive)){var n=window.localStorage.getItem("TCHMI_LAST_LOADING_TIME"),i=parseFloat(n);if(!isNaN(i)){this.__progressElem.max=i;var a=(new Date).getTime()-window.performance.timing.domInteractive;this.__progressElem.value=a}}}else if(t===l.DialogManager.DialogType.Overlay){var s=this.__jqOverlayDialogContainer.find("#tchmi-systemdialog-dismissbutton");o&&!0===o.cancelable?(s.on("click.DialogManager",function(e){l.System.Services.dialogManager.showDialog(null,!1)}),s.css("display","")):s.css("display","none"),document.body&&!document.body.contains(this.__jqOverlayDialogContainer[0])&&(this.__jqLoadingDialogContainer.detach(),l.System.SharedResources.jqBody.append(this.__jqOverlayDialogContainer))}}else if(!1===r&&(this.__jqLoadingDialogContainer.detach(),this.__jqOverlayDialogContainer.detach(),this.__jqOverlayDialogContainer.find("#tchmi-systemdialog-dismissbutton").off("click.DialogManager"),this.__dialogOwner=null,this.__currentDialogType===l.DialogManager.DialogType.SYSTEMLoading&&window.performance&&window.performance.timing&&window.performance.timing.domInteractive&&window.localStorage)){i=(new Date).getTime()-window.performance.timing.domInteractive;try{window.localStorage.setItem("TCHMI_LAST_LOADING_TIME",i.toString())}catch(e){}}return!0},e.prototype.updateText=function(e,r,t){if(void 0===t&&(t=l.DialogManager.DialogSeverity.Info),null!==e&&null!==this.__dialogOwner&&this.__dialogOwner!==e)return!1;switch(this.__dialogOwner=e,this.__jqLoadingDialogContainer.find(".tchmi-systemdialog-message").add(this.__jqOverlayDialogContainer.find(".tchmi-systemdialog-message")).html(r),this.updateProgress(),t){case l.DialogManager.DialogSeverity.Info:this.__jqLoadingDialogContainer[0].classList.remove("tchmi-systemdialog-error"),this.__jqOverlayDialogContainer[0].classList.remove("tchmi-systemdialog-error");break;case l.DialogManager.DialogSeverity.Error:this.__jqLoadingDialogContainer[0].classList.add("tchmi-systemdialog-error"),this.__jqOverlayDialogContainer[0].classList.add("tchmi-systemdialog-error"),this.__progressElem.max=1,this.__progressElem.value=1}return!0},e.prototype.updateProgress=function(){if(-1!==this.__progressElem.position&&window.performance&&window.performance.timing&&window.performance.timing.domInteractive){var e=(new Date).getTime()-window.performance.timing.domInteractive;this.__progressElem.value=e}},e.prototype.getDialogOwner=function(){return this.__dialogOwner},e}(),e.DialogManager=r}(TcHmi||(TcHmi={})),function(S){var _,e;_=S.System||(S.System={}),e=function(){function f(e){this.__comparisons=[],this.__subfilters=[],this.__parent=null,this.__logic=e}return f.parse=function(e,o){var n=this;if(o&&("array"!==o.type||!o.items))throw new Error("Filter schema must describe an array.");if(!e||0===e.length)return new f("AND");if(!Array.isArray(e))throw new Error("Filter must be an array.");if(1===e.length){var r=e[0];if(S.isComparison(r)){var t=new f("AND");return o&&(r=this.__parseComparison(r,o)),t.__comparisons.push(r),t}if(Array.isArray(r))return this.parse(r,o);throw new Error("Invalid filter. Expected comparison or nested filter at position 0.")}var i=e[0],a=e[1];if(!S.isLogicOperator(a))throw new Error("Invalid filter. Expected logic operator at position 1.");var s=function(e,r,t){if(S.isComparison(r))o&&(r=n.__parseComparison(r,o)),e.__comparisons.push(r);else{if(!Array.isArray(r))throw new Error("Invalid filter. Expected comparison or nested filter at position "+t+".");e.__subfilters.push(n.parse(r,o))}},l=new f(a.logic);s(l,i,0);for(var c=l,_=null,u="comparison",d=2,m=e.length;d<m;d++)switch(u){case"comparison":_=e[d],u="logic";break;case"logic":var h=e[d];if(!S.isLogicOperator(h))throw new Error("Invalid filter. Expected logic operator at position "+d+".");var g=h.logic;if(g===c.__logic)s(c,_,d-1);else if("OR"===g)if(s(c,_,d-1),c.__parent&&c.__parent.__logic===g)c=c.__parent;else{var p=new f(g);p.__subfilters.push(c),p.__parent=c.__parent,null===(c.__parent=p).__parent&&(l=p),c=p}else if("AND"===g){var E=new f(g);s(E,_,d-1),(E.__parent=c).__subfilters.push(E),c=E}u="comparison"}if("comparison"===u)throw new Error("Filter must not end with a logic operator.");return s(c,_,e.length-1),l},f.prototype.test=function(e){for(var r=0,t=this.__comparisons.length;r<t;r++){if((o=this.__resolveComparison(this.__comparisons[r],e))&&"OR"===this.__logic)return!0;if(!o&&"AND"===this.__logic)return!1}for(r=0,t=this.__subfilters.length;r<t;r++){var o;if((o=this.__subfilters[r].test(e))&&"OR"===this.__logic)return!0;if(!o&&"AND"===this.__logic)return!1}return"AND"===this.__logic},f.__parseComparison=function(n,e){n=tchmi_clone_object(n);var i=function(e){if(e.oneOf)for(var r=0,t=e.oneOf.length;r<t;r++){if(o=i(e.oneOf[r]))return o}else if(e.anyOf)for(r=0,t=e.anyOf.length;r<t;r++){var o;if(o=i(e.anyOf[r]))return o}else if("object"===e.type&&e.properties){if(e.properties.path){if("string"!==e.properties.path.type)return null;if(-1!==e.required.indexOf("path")){if(!n.path)return null;if(e.properties.path.enum&&-1===e.properties.path.enum.indexOf(n.path))return null}}return e.properties.comparator&&e.properties.comparator.enum&&-1!==e.properties.comparator.enum.indexOf(n.comparator)&&(e.properties.value&&e.properties.value.type===typeof n.value)?e:null}return null},r=null;if(Array.isArray(e.items))for(var t=0,o=e.items.length;t<o;t++){var a=i(e.items[t]);if(a){r=a;break}}else r=i(e.items);if(r&&"date-time"===r.properties.value.format&&"string"==typeof n.value){var s=new Date(n.value);if(isNaN(s.getTime()))throw new Error('Filter contains an invalid date: "'+n.value+'".');n.value=new Date(n.value)}return n},f.prototype.__resolveComparison=function(e,r){var t=r,o=e.value;if(e.path)for(var n=_.resolveSymbolPathToTokenArray(e.path),i=0,a=n.length;i<a;i++){var s=n[i],l=!1;if(s.match(/\[.*\]/)&&(s=s.slice(1,-1),l=!0),Array.isArray(t)&&l){var c=parseInt(s,10);t=t[isNaN(c)?s:c]}else{if("object"!=typeof t)throw new Error("Could not read property "+s+" of type "+typeof t);t=t[s]}}switch(t instanceof Date&&(t=t.getTime()),o instanceof Date&&(o=o.getTime()),e.comparator){case"==":return t===o;case"!=":return t!==o;case"<":if("number"==typeof t&&"number"==typeof o)return t<o;throw new Error("Cannot compare "+typeof t+" with "+typeof o+" using <.");case">":if("number"==typeof t&&"number"==typeof o)return o<t;throw new Error("Cannot compare "+typeof t+" with "+typeof o+" using >.");case"<=":if("number"==typeof t&&"number"==typeof o)return t<=o;throw new Error("Cannot compare "+typeof t+" with "+typeof o+" using <=.");case">=":if("number"==typeof t&&"number"==typeof o)return o<=t;throw new Error("Cannot compare "+typeof t+" with "+typeof o+" using >=.");case"contains":if("string"==typeof t&&"string"==typeof o)return-1!==t.indexOf(o);throw new Error("Cannot compare "+typeof t+" with "+typeof o+" using contains.");case"contains not":if("string"==typeof t&&"string"==typeof o)return-1===t.indexOf(o);throw new Error("Cannot compare "+typeof t+" with "+typeof o+" using contains not.");case"== [ignore case]":if("string"==typeof t&&"string"==typeof o)return t.toLowerCase()===o.toLowerCase();throw new Error("Cannot compare "+typeof t+" with "+typeof o+" using == [ignore case].");case"!= [ignore case]":if("string"==typeof t&&"string"==typeof o)return t.toLowerCase()!==o.toLowerCase();throw new Error("Cannot compare "+typeof t+" with "+typeof o+" using != [ignore case].");case"contains [ignore case]":if("string"==typeof t&&"string"==typeof o)return-1!==t.toLowerCase().indexOf(o.toLowerCase());throw new Error("Cannot compare "+typeof t+" with "+typeof o+" using contains [ignore case].");case"contains not [ignore case]":if("string"==typeof t&&"string"==typeof o)return-1===t.toLowerCase().indexOf(o.toLowerCase());throw new Error("Cannot compare "+typeof t+" with "+typeof o+" using contains not [ignore case].")}},f}(),_.Filter=e}(TcHmi||(TcHmi={})),function(D){var n,e;n=D.System||(D.System={}),e=function(){function e(e,r){void 0===r&&(r=!1);var s=this;this.__isDestroyed=!1,this.__symbolExpressions=[],this.__functionCallExpressions=[],this.__watchMap={},this.__callbacks=[],this.__expression=e,this.__enableWatchMode=r;try{this.__originalAst=acorn.parse(e,{plugins:{symbolExpression:{onSymbol:this.__symbolExpressions,onCallExpression:function(e){if("Identifier"===e.callee.type){var r=e.callee.name;if(D.System.Services.functionProvider.isFunctionRegistered(r)){var t=D.System.Services.functionProvider.getFunctionDescription(r),o=0;if(!0===t.function.injectContextObject&&o++,void 0!==e.arguments&&null!==e.arguments)for(var n=0,i=e.arguments.length;n<i;n++)if("SymbolExpression"===e.arguments[n].type&&t&&t.function&&t.function.arguments){var a=void 0;if(n+o<t.function.arguments.length?a=t.function.arguments[n+o]:!0!==(a=t.function.arguments[t.function.arguments.length-1]).restParameter&&(a=null),a)"TcHmi.Symbol"===D.System.Services.typeManager.getSchema(a.type).frameworkInstanceOf&&(e.arguments[n].passAsSymbol=!0)}s.__functionCallExpressions.push(e)}}}}}})}catch(e){D.Log.error(e)}r&&(this.__fillWatchMap(),this.__doWatch())}return e.prototype.__fillWatchMap=function(){for(var e,r=this,t=0,o=this.__symbolExpressions.length;t<o;t++)e=this.__symbolExpressions[t],r.__watchMap[e.expression]||(r.__watchMap[e.expression]={symbol:new n.Symbol(e.expression),ready:!1,error:D.Errors.NONE})},e.prototype.__doWatch=function(){for(var e in this.__watchMap){var r=this.__watchMap[e];r.destroy=r.symbol.watch(this.__onSubSymbolWatch())}},e.prototype.__onSubSymbolWatch=function(){var l=this;return function(e){var r=l.__watchMap[this.getExpression().toString()];if(r){e.error===D.Errors.NONE?(r.value=e.value,r.error=null,r.details=null):(r.value=null,r.error=e.error,r.details=e.details);var t=r.ready=!0;for(var o in l.__watchMap){if(!1===l.__watchMap[o].ready){t=!1;break}}t&&l.execute({success:function(e){for(var r=[],t=0,o=l.__callbacks.length;t<o;t++)r.push(l.__callbacks[t]);for(var n=0,i=r;n<i.length;n++){var a=i[n];-1!==l.__callbacks.indexOf(a)&&D.Callback.callSafe(a.callback,l,{error:D.Errors.NONE,value:tchmi_clone_object(e),destroy:a.destroy})}},error:function(e,r){for(var t=[],o=0,n=l.__callbacks.length;o<n;o++)t.push(l.__callbacks[o]);for(var i=0,a=t;i<a.length;i++){var s=a[i];-1!==l.__callbacks.indexOf(s)&&D.Callback.callSafe(s.callback,l,{error:e,details:r,destroy:s.destroy})}}})}}},e.prototype.execute=function(t){void 0===t&&(t={success:function(){},error:function(){}});var O=this,c=void 0,I=[],A=[];if(TCHMI_ENABLE_DESIGNER_MODE_MASTER){var e=!1;if(this.__symbolExpressions)for(var r=0,o=this.__symbolExpressions.length;r<o;r++){var n=new D.SymbolExpression(this.__symbolExpressions[r].expression);if(!n){e=!0;break}if(n.getType()===D.SymbolType.Server){e=!0;break}}if(e)return void t.success(null)}var i,a,s=function(t){var o=function(r){!function(t,e){if(e){var r=e.callee.name,o=[],n=D.System.Services.functionProvider.isFunctionRegistered(r);if(n){var i=D.System.Services.functionProvider.getFunctionDescription(e.callee.name);if(!n||i){var a=D.System.Services.functionProvider.getFunction(e.callee.name);if(!n||a){var s=0;if("Asynchronous"===i.function.waitMode){if(!0!==i.function.injectContextObject)return t.error(D.Errors.E_FUNCTION_INVALID_CONFIGURATION,{code:D.Errors.E_FUNCTION_INVALID_CONFIGURATION,message:D.Errors[D.Errors.E_FUNCTION_INVALID_CONFIGURATION],reason:O.__expression+", Invalid configuration for hmi function with name="+r+". Setting waitMode=Asynchronous and injectContextObject="+i.function.injectContextObject+" is an invalid function configuration. Please define a context object if you want to use waitMode=Asynchronous.",domain:"TcHmi.System.FunctionExpression"});o.unshift({success:function(e){t.success(e)},error:function(e,r){t.error(e,r)}}),s++}else!0===i.function.injectContextObject&&(o.unshift({}),s++);e.start,e.end;for(var l,c=0,_=e.arguments.length;c<_;c++){var u=null;if(n)if(c+s<i.function.arguments.length)u=i.function.arguments[c+s];else if(!0!==(u=i.function.arguments[i.function.arguments.length-1]).restParameter)return t.error(D.Errors.E_FUNCTION_RESTPARAMETER_DEFINITION_MISSING,{code:D.Errors.E_FUNCTION_RESTPARAMETER_DEFINITION_MISSING,message:D.Errors[D.Errors.E_FUNCTION_RESTPARAMETER_DEFINITION_MISSING],domain:"TcHmi.System.FunctionExpression"});if(!u)return t.error(D.Errors.E_FUNCTION_INVALID_CONFIGURATION,{code:D.Errors.E_FUNCTION_INVALID_CONFIGURATION,message:D.Errors[D.Errors.E_FUNCTION_INVALID_CONFIGURATION],domain:"TcHmi.System.FunctionExpression"});var d=D.System.Services.typeManager.getSchema(u.type);if(!d)return t.error(D.Errors.E_UNKNOWN_TYPE,{code:D.Errors.E_UNKNOWN_TYPE,message:D.Errors[D.Errors.E_UNKNOWN_TYPE],domain:"TcHmi.System.FunctionExpression"});var m=e.arguments[c].start,h=e.arguments[c].end,g=O.__expression.substr(m,h-m);if(D.Symbol.isSymbolExpression(g)){for(var p=void 0,E=0,f=O.__symbolExpressions.length;E<f;E++){var S=(b=O.__symbolExpressions[E]).start,y=b.end;if(m<=S&&y<=h){p=I[E],b.handled=!0;break}}if("TcHmi.Symbol"===d.frameworkInstanceOf){if(!(p instanceof D.Symbol))return t.error(D.Errors.E_TYPE_INVALID,{code:D.Errors.E_TYPE_INVALID,message:D.Errors[D.Errors.E_TYPE_INVALID],domain:"TcHmi.System.FunctionExpression"});o[c+s]=p}else{if(null===(N=D.ValueConverter.toSchemaType(p,d))&&null!==p)return t.error(D.Errors.E_TYPE_INVALID,{code:D.Errors.E_TYPE_INVALID,message:D.Errors[D.Errors.E_TYPE_INVALID],reason:O.__expression+", Unable to cast value of type "+typeof p+" for parameter: "+u.name+" of function: "+i.function.name+" to "+u.type+".",domain:"TcHmi.System.FunctionExpression"});o[c+s]=N}}else{var v=g.split("");for(E=0,f=O.__symbolExpressions.length;E<f;E++){var C=(R=(S=(b=O.__symbolExpressions[E]).start)-m)+((y=b.end)-S);if(m<=S&&y<=h){for(var T=R,M=C;T<M;T++)v[T]="";v[R]=I[E],b.handled=!0;break}}for(E=0,f=O.__functionCallExpressions.length;E<f;E++){var b,R;if(C=(R=(S=(b=O.__functionCallExpressions[E]).start)-m)+((y=b.end)-S),m<=S&&y<=h){for(T=R,M=C;T<M;T++)v[T]="";v[R]=A[E],b.handled=!0;break}}p=void 0;var N,w=v.join("");w+="\n//# sourceURL=TcHmi_System_FunctionExpression_resolveExpression_Eval";try{p=gIsolatedEval_TcHmi_System_FunctionExpression(w)}catch(e){return D.Log.error(e),t.error(D.Errors.E_FUNCTION_EXPRESSION_EXCEPTION,{code:D.Errors.E_FUNCTION_EXPRESSION_EXCEPTION,message:D.Errors[D.Errors.E_FUNCTION_EXPRESSION_EXCEPTION],reason:O.__expression+', Exception: "'+e+'"',domain:"TcHmi.System.FunctionExpression"})}if(null===(N=D.ValueConverter.toSchemaType(p,d))&&null!==p)return t.error(D.Errors.E_TYPE_INVALID,{code:D.Errors.E_TYPE_INVALID,message:D.Errors[D.Errors.E_TYPE_INVALID],reason:O.__expression+", Unable to cast value of type "+typeof p+" for parameter: "+u.name+" of function: "+i.function.name+" to "+u.type+".",domain:"TcHmi.System.FunctionExpression"});o[c+s]=N}}try{l=a.apply(void 0,o)}catch(e){return D.Log.error(e),t.error(D.Errors.E_FUNCTION_EXPRESSION_EXCEPTION,{code:D.Errors.E_FUNCTION_EXPRESSION_EXCEPTION,message:D.Errors[D.Errors.E_FUNCTION_EXPRESSION_EXCEPTION],reason:O.__expression+', Exception: "'+e+'"',domain:"TcHmi.System.FunctionExpression"})}"Asynchronous"===i.function.waitMode||t.success(l)}else t.error(D.Errors.E_FUNCTION_MISSING_FUNCTION_REFERENCE,{code:D.Errors.E_FUNCTION_MISSING_FUNCTION_REFERENCE,message:D.Errors[D.Errors.E_FUNCTION_MISSING_FUNCTION_REFERENCE],reason:O.__expression,domain:"TcHmi.System.FunctionExpression"})}else t.error(D.Errors.E_FUNCTION_MISSING_FUNCTION_DESCRIPTION,{code:D.Errors.E_FUNCTION_MISSING_FUNCTION_DESCRIPTION,message:D.Errors[D.Errors.E_FUNCTION_MISSING_FUNCTION_DESCRIPTION],reason:O.__expression,domain:"TcHmi.System.FunctionExpression"})}else t.error(D.Errors.E_FUNCTION_UNKNOWN,{code:D.Errors.E_FUNCTION_UNKNOWN,message:D.Errors[D.Errors.E_FUNCTION_UNKNOWN],reason:O.__expression,domain:"TcHmi.System.FunctionExpression"})}else t.error(D.Errors.E_PARAMETER_INVALID,{code:D.Errors.E_PARAMETER_INVALID,message:D.Errors[D.Errors.E_PARAMETER_INVALID],reason:O.__expression,domain:"TcHmi.System.FunctionExpression"})}({success:function(e){A[r]=e,r+1<O.__functionCallExpressions.length?o(r+1):t.success()},error:function(e,r){t.error(e,r)}},O.__functionCallExpressions[r])};0<O.__functionCallExpressions.length?o(0):t.success()};return i={success:function(e){s({success:function(e){!function(r){for(var e=O.__expression.split(""),t=0,o=O.__symbolExpressions.length;t<o;t++)if((s=O.__symbolExpressions[t])&&!s.handled){for(var n=[],i=0,a=s.end-s.start;i<a;i++)n.push("");e.splice.apply(e,[s.start,s.end-s.start].concat(n)),e[s.start]="resSE["+t+"]"}for(t=0,o=O.__functionCallExpressions.length;t<o;t++){var s;if((s=O.__functionCallExpressions[t])&&!s.handled){for(n=[],i=0,a=s.end-s.start;i<a;i++)n.push("");e.splice.apply(e,[s.start,s.end-s.start].concat(n)),e[s.start]="resFCE["+t+"]"}}try{var l=e.join("");c=gIsolatedEval_TcHmi_System_FunctionExpression_Results(l+="\n//# sourceURL=TcHmi_System_FunctionExpression_resolveExpression_Results_Eval",I,A)}catch(e){return D.Log.error(e),r.error(D.Errors.E_FUNCTION_EXPRESSION_EXCEPTION,{code:D.Errors.E_FUNCTION_EXPRESSION_EXCEPTION,message:D.Errors[D.Errors.E_FUNCTION_EXPRESSION_EXCEPTION],reason:O.__expression+', Exception: "'+e+'"',domain:"TcHmi.System.FunctionExpression"})}r.success(c)}({success:function(e){c=e,t.success(e)},error:function(e,r){t.error(e,r)}})},error:function(e,r){t.error(e,r)}})},error:function(e,r){t.error(e,r)}},a=function(r){!function(r,e){if(e)if(e.passAsSymbol){var t=new D.Symbol(e.expression);r.success(t)}else{if(!0===O.__enableWatchMode){var o=O.__watchMap[e.expression];return o&&(o.error?r.error(o.error,o.details):r.success(tchmi_clone_object(o.value)))}var n=new D.System.Symbol(e.expression);n.read(function(e){return e.error?r.error(e.error,e.details):r.success(e.value),n.destroy(),void(n=null)})}else r.error(D.Errors.E_PARAMETER_INVALID,{code:D.Errors.E_PARAMETER_INVALID,message:D.Errors[D.Errors.E_PARAMETER_INVALID],reason:O.__expression,domain:"TcHmi.System.FunctionExpression"})}({success:function(e){I[r]=e,r+1<O.__symbolExpressions.length?a(r+1):i.success()},error:function(e,r){i.error(e,r)}},O.__symbolExpressions[r])},0<O.__symbolExpressions.length?a(0):i.success(),c},e.prototype.watch=function(t){if(!0===this.__isDestroyed)return D.Callback.callSafe(t,this,{error:D.Errors.ERROR,destroy:function(){}}),function(){};if(!1===this.__enableWatchMode)return D.Callback.callSafe(t,this,{error:D.Errors.ERROR,destroy:function(){}}),function(){};var r=this,o=null,n=function(){var e=r.__callbacks.indexOf(o);-1!==e&&r.__callbacks.splice(e,1)};o={callback:t,destroy:n},this.__callbacks.push(o);var e=!0;for(var i in r.__watchMap){if(!1===r.__watchMap[i].ready){e=!1;break}}return e&&this.execute({success:function(e){D.Callback.callSafe(t,this,{error:D.Errors.NONE,value:tchmi_clone_object(e),destroy:n})},error:function(e,r){D.Callback.callSafe(t,this,{error:e,details:r,destroy:n})}}),n},e.prototype.destroy=function(){if(!0!==this.__isDestroyed){if(!0===this.__enableWatchMode)for(var e in this.__watchMap){var r=this.__watchMap[e];r.destroy&&r.destroy(),r.symbol.destroy(),r=null,delete this.__watchMap[e]}this.__isDestroyed=!0}},e}(),n.FunctionExpression=e}(TcHmi||(TcHmi={})),function(R){var e,r;e=R.System||(R.System={}),r=function(){function e(e){this.__styleOverwriteCache={},R.EventProvider.register("System.onPrevControlsAttached",this.__onPrevControlsAttached()),R.EventProvider.register("System.onPrevControlsDetached",this.__onPrevControlsDetached()),R.EventProvider.register("onControlDestroyed",this.__onControlDestroyed())}return e.prototype.__onPrevControlsAttached=function(){var t=this;return function(e,r){t.writeStylesFromCache(r)}},e.prototype.__onPrevControlsDetached=function(){var t=this;return function(e,r){t.removeStylesFromDom(r)}},e.prototype.__onControlDestroyed=function(){var n=this;return function(e,r){if(null!=r&&"string"==typeof r.__id){var t=r.__id;if(void 0!==n.__styleOverwriteCache[t]){var o=n.__styleOverwriteCache[t][0].elementInHead;null!==o&&document.head.removeChild(o),delete n.__styleOverwriteCache[t]}}}},e.prototype.__getElementStyle=function(e,r,t){void 0===t&&(t=!1);var o,n,i={};if(!e)return i;if(e instanceof jQuery){if(!e.length||!e[0].style)return i;o=e[0]}else o=e;if(n=t?window.getComputedStyle(o):o.style)if(null!=r){if(n.getPropertyValue)if("string"==typeof r){var a=n.getPropertyValue(r);a&&(i[r]=a)}else if(Array.isArray(r))for(var s=0;s<r.length;s++){var l=r[s],c=n.getPropertyValue(l);c&&(i[l]=c)}}else if(void 0!==n.length&&0!==n.length&&n.getPropertyValue)for(var _=0;_<n.length;_++){var u=n[_];i[u]=n.getPropertyValue(u)}return i},e.prototype.__setSimpleElementStyle=function(e,r,t){var o;if(void 0===t&&(t=null),e){if(e instanceof jQuery){if(!e.length||!e[0])return;o=e}else o=[e];for(var n=0,i=o.length;n<i;n++){var a=o[n].style;if(a&&a.removeProperty&&a.setProperty){if("string"==typeof r)if("string"==typeof t&&""!==t)a.setProperty(r,t);else if(Array.isArray(t))for(var s=0;s<t.length;s++)a.setProperty(r,t[s]);else a.removeProperty(r);else if(null!==r)for(var l in r)if(r.hasOwnProperty(l)){var c=r[l];if("string"==typeof c&&""!==c)a.setProperty(l,c);else if(Array.isArray(c))for(var _=0;_<c.length;_++)a.setProperty(l,c[_]);else a.removeProperty(l)}}else o[n].nodeType===Node.ELEMENT_NODE?o[n].id?R.Log.error("[Source=Framework, Module=TcHmi.System.StyleManager] Internal error: Element with the id "+o[n].id+" has no CSSStyleDeclaration in this browser."):R.Log.error("[Source=Framework, Module=TcHmi.System.StyleManager] Internal error: Element of type "+o[n].nodeName+" has no CSSStyleDeclaration in this browser."):R.Log.error("[Source=Framework, Module=TcHmi.System.StyleManager] Internal error: Setting style for Elements of type "+o[n].nodeName+" not supported.")}}},e.prototype.writeStylesFromCache=function(e){for(var r=!1,t=document.createDocumentFragment(),o=0,n=e.length;o<n;o++){var i=e[o].__id;if(void 0!==this.__styleOverwriteCache[i])for(var a=0;a<this.__styleOverwriteCache[i].length;a++)if(this.__styleOverwriteCache[i][a].strCss){var s=document.createElement("style");s.type="text/css",s.className=this.__styleOverwriteCache[i][a].strClass,s.appendChild(document.createTextNode(this.__styleOverwriteCache[i][a].strCss)),t.appendChild(s),this.__styleOverwriteCache[i][a].elementInHead=s,r=!0}}r&&document.head.appendChild(t)},e.prototype.removeStylesFromDom=function(e){for(var r=0,t=e.length;r<t;r++){var o=e[r].__id;if(this.__styleOverwriteCache[o]){var n=this.__styleOverwriteCache[o][0].elementInHead;null!==n&&(document.head.removeChild(n),this.__styleOverwriteCache[o][0].elementInHead=null)}}},e.prototype.getExistingStyleOverwrites=function(e){for(var r="",t=this.__styleOverwriteCache[e]||[{strClass:"",strCss:""}],o=0;o<t.length;o++)-1!==t[o].strClass.indexOf("overwrite")&&(r+=t[o].strCss);return this.__deserializeCss(r)},e.prototype.__deserializeCss=function(e){for(var r={},t=0,o=(e=this.__removeComments(e.trim())).indexOf("@charset",t);-1!==o;){var n=this.__splitOutsideOfBraces(e.substring(o),";")[0];void 0===r["@-rules"]&&(r["@-rules"]=[]),r["@-rules"].push(n),t=o+n.length+1,o=e.indexOf("@charset",t)}for(var i=e.indexOf("@import",t);-1!==i;){var a=this.__splitOutsideOfBraces(e.substring(i),";")[0];void 0===r["@-rules"]&&(r["@-rules"]=[]),r["@-rules"].push(a),t=i+a.length+1,i=e.indexOf("@import",t)}for(var s=e.indexOf("@namespace",t);-1!==s;){var l=this.__splitOutsideOfBraces(e.substring(s),";")[0];void 0===r["@-rules"]&&(r["@-rules"]=[]),r["@-rules"].push(l),t=s+l.length+1,s=e.indexOf("@namespace",t)}function c(e,r){for(var t in r)if(r.hasOwnProperty(t))if(void 0===e[t])e[t]=r[t];else for(var o=0,n=r[t].length;o<n;o++)-1===e[t].indexOf(r[t][o])&&e[t].push(r[t][o]);return e}for(;t<e.length;){var _=e.indexOf("{",t),u=this.__findMatchingBrace(e,_),d=e.substring(t,_).trim(),m=e.substring(_+1,u);if(0===d.indexOf("@")){var h=this.__deserializeCss(m);if(void 0===r[d])r[d]=h;else for(var g in h)h.hasOwnProperty(g)&&(void 0===r[d][g]?r[d][g]=h[g]:r[d][g]=c(r[d][g],h[g]))}else{var p=this.__getDeclarations(m);void 0===r[d]?r[d]=p:r[d]=c(r[d],p)}t=u+1}return r},e.prototype.__getDeclarations=function(e){for(var r={},t=this.__splitOutsideOfBraces(e,";"),o=0,n=t.length;o<n;o++){var i=t[o].indexOf(":");if(-1<i){var a=t[o].substring(0,i).trim().toLowerCase(),s=t[o].substring(i+1).trim();void 0===r[a]?r[a]=[s]:-1===r[a].indexOf(s)&&r[a].push(s)}}return r},e.prototype.__removeComments=function(e){if(-1===e.indexOf("/*"))return e;var r="",t=!1;function o(e){t||(r+=e)}for(var n=0,i=e.length;n<i;n++){var a=e.charAt(n);switch(a){case"/":n+1<i&&"*"===e.charAt(n+1)&&(t=!0,n++),o(a);break;case"*":o(a),n+1<i&&"/"===e.charAt(n+1)&&(t=!1,n++);break;case'"':case"'":var s=this.__findMatchingQuote(e,n);n<s&&(o(e.substring(n,s+1)),n=s);break;default:o(a)}}return r},e.prototype.__getExistingStyleOverwritesForSelector=function(e,r){var t=e;return t[r]||(t[r]={}),t[r]},e.prototype.getStyle=function(e,r,t){if(!r){var o=R.Controls.get(e);if(void 0!==o&&0!==o.__element.length){if(null==t)return;return[R.StyleProvider.getSimpleElementStyle(o.__element,t)[t]]}}r=this.expandSelector(r,e);var n=this.getExistingStyleOverwrites(e),i=this.__getExistingStyleOverwritesForSelector(n,r);if(void 0!==i)return null!=t?i[t]:i},e.prototype.writeStyles=function(e,r){var t=this.__serializeCss(r),o=this.__styleOverwriteCache[e];if(void 0===o)o=[{strClass:"tchmi-theme overwrite "+e,strCss:t,elementInHead:null}],this.__styleOverwriteCache[e]=o;else{for(var n=!1,i=0;i<o.length;i++)if(-1!==o[i].strClass.indexOf("overwrite")){o[i].strCss=t,n=!0;break}n||o.push({strClass:"tchmi-theme overwrite "+e,strCss:t,elementInHead:null})}for(i=0;i<o.length;i++)if(-1!==o[i].strClass.indexOf("overwrite"))if(null===o[i].elementInHead){var a=this.__getControl(e);if(!a||!a.__isAttached||!o[i].strClass)continue;var s=document.createElement("style");s.className=o[i].strClass,s.appendChild(document.createTextNode(o[i].strCss)),document.head.appendChild(s),o[i].elementInHead=s}else o[i].elementInHead.innerHTML=o[i].strCss},e.prototype.__serializeCss=function(e){var a="";function s(e,r,t){for(var o in void 0===t&&(t=""),a+=t+e+" {\n",r)if(r.hasOwnProperty(o)&&void 0!==r[o]&&null!==r[o]&&"@-rules"!==o)if(0===e.indexOf("@"))s(o,r[o],t+"\t");else for(var n=0,i=r[o].length;n<i;n++)void 0!==r[o][n]&&null!==r[o][n]&&""!==r[o][n]&&(a+=t+"\t"+o+": "+r[o][n]+";\n");a+=t+"}\n\n"}if(void 0!==e["@-rules"])for(var r=0,t=e["@-rules"].length;r<t;r++)a+=e["@rules"][r]+";\n";for(var o in a+="\n",e)e.hasOwnProperty(o)&&void 0!==e[o]&&null!==e[o]&&"@-rules"!==o&&0!==Object.keys(e[o]).length&&s(o,e[o]);return a=a.trim()},e.prototype.__getControl=function(e){var r=R.control[e];if(void 0===r)throw new Error("Control '"+e+"' could not be found!");return r},e.prototype.expandSelector=function(e,r){0!==(r=tchmi_css_escape_selector(r)).indexOf(".")&&0!==r.indexOf("#")&&(r="#"+r);for(var t=this.__splitOutsideOfBraces(e,",",["(","["]),o=0,n=t.length;o<n;o++)-1===t[o].indexOf(r)&&(-1===t[o].indexOf("%id%")?t[o]=r+" "+t[o]:t[o]=t[o].replace("%id%",r));return t.join(", ").trim()},e.prototype.__splitOutsideOfBraces=function(e,r,t){void 0===t&&(t=["("]);for(var o=0,n=[],i=0,a=e.length;i<a;i++){var s=e.charAt(i);if(-1!==t.indexOf(s)){var l=this.__findMatchingBrace(e,i);i<l&&(i=l)}else if('"'===s||"'"===s){var c=this.__findMatchingQuote(e,i);i<c&&(i=c)}else s===r&&(o<i&&n.push(e.substring(o,i).trim()),o=i+1)}return(0===e.length||o<e.length)&&n.push(e.substring(o).trim()),n},e.prototype.__findMatchingBrace=function(e,r){var t=e.charAt(r),o="";switch(t){case"(":o=")";break;case"{":o="}";break;case"[":o="]";break;case"<":o=">";break;default:return-1}for(var n=0,i=r+1,a=e.length;i<a;i++)switch(e.charAt(i)){case t:n++;break;case o:if(0===n)return i;n--;break;case'"':case"'":var s=this.__findMatchingQuote(e,i);0<s&&(i=s)}return-1},e.prototype.__findMatchingQuote=function(e,r){for(var t=e.charAt(r),o=r+1,n=e.length;o<n;o++)switch(e.charAt(o)){case"\\":o++;break;case t:return o}return-1},e.prototype.processGenericStyle=function(e,r,t,o){if(void 0===o&&(o=null),!r){var n=R.Controls.get(e);if(void 0!==n&&0!==n.__element.length){if(null==t)return;return void R.StyleProvider.setSimpleElementStyle(n.__element,t,o)}}r=this.expandSelector(r,e);var i=this.getExistingStyleOverwrites(e),a=this.__getExistingStyleOverwritesForSelector(i,r);if("string"==typeof t)"string"==typeof o?""===o?delete a[t]:a[t]=[o]:null===o?delete a[t]:a[t]=o;else if(null!=t)for(var s in t)if(t.hasOwnProperty(s)){var l=t[s];"string"==typeof l?""===l?delete a[s]:a[s]=[l]:null===l?delete a[s]:a[s]=l}this.writeStyles(e,i)},e.prototype.processBackground=function(a,s){var l=this,c={};if(s){var _=!1,u=!1,e=function(e,r){_?(c[e]=[r],u&&c[e].push(r)):c[e]=null};!function(){if(void 0!==s.color)if(R.isSolidColor(s.color)){var e=R.StyleProvider.resolveSolidColorAsCssValue(s.color);c["background-color"]=null!==e?[e]:null}else c["background-color"]=null}(),function(){var e=null,r=null,t=R.StyleProvider.getSimpleElementStyle(a,"background-image")["background-image"],o=[];if(void 0!==t&&(o=l.__splitOutsideOfBraces(t,",")),void 0!==s.image?e=null!==s.image&&""!==s.image?'url("'+s.image+'")':null:0<o.length&&0===o[0].indexOf("url(")&&(e=o[0]),void 0!==s.color)r=null!==s.color?R.isLinearGradientColor(s.color)?R.StyleProvider.resolveLinearGradientColorAsCssValue(s.color):"none":null;else if(0<o.length){var n=1<o.length?o[1]:o[0];0!==n.indexOf("linear-gradient(")&&0!==n.indexOf("radial-gradient(")||(r=n)}if(_=null!==e,u=null!==r&&"none"!==r,null===e&&null===r)0<o.length&&(c["background-image"]=null);else{var i=[];_&&i.push(e),(u||"none"===r&&!_&&null!==c["background-color"])&&i.push(r),c["background-image"]=0<i.length?i:null}}(),function(){if(_){var e="auto",r="auto";if(void 0!==s.imageWidth&&null!==s.imageWidth&&(e=s.imageWidth+(s.imageWidthUnit||"px")),void 0!==s.imageHeight&&null!==s.imageHeight&&(r=s.imageHeight+(s.imageHeightUnit||"px")),void 0!==s.imagePadding&&null!==s.imagePadding){if("%"===s.imageWidthUnit&&s.imageWidth){var t="";0<s.imagePadding.left&&(t+=" - "+s.imagePadding.left*(s.imageWidth?s.imageWidth/100:1)+(s.imagePadding.leftUnit||"px")),0<s.imagePadding.right&&(t+=" - "+s.imagePadding.right*(s.imageWidth?s.imageWidth/100:1)+(s.imagePadding.rightUnit||"px")),""!==t&&(e="calc("+e+t+")")}if("%"===s.imageHeightUnit&&s.imageHeight){var o="";0<s.imagePadding.top&&(o+=" - "+s.imagePadding.top*(s.imageHeight?s.imageHeight/100:1)+(s.imagePadding.topUnit||"px")),0<s.imagePadding.bottom&&(o+=" - "+s.imagePadding.bottom*(s.imageHeight?s.imageHeight/100:1)+(s.imagePadding.bottomUnit||"px")),""!==o&&(r="calc("+r+o+")")}}c["background-size"]=[e+" "+r],u&&c["background-size"].push("auto auto")}else c["background-size"]=null}(),function(){if(_){var e="50%",r="50%";switch(s.imageHorizontalAlignment){case"Left":e="0%";break;case"Center":e="50%";break;case"Right":e="100%"}switch(s.imageVerticalAlignment){case"Top":r="0%";break;case"Center":r="50%";break;case"Bottom":r="100%"}if(void 0!==s.imagePadding&&null!==s.imagePadding){var t="";0<s.imagePadding.left&&"Right"!==s.imageHorizontalAlignment&&(t+=" + "+s.imagePadding.left*("Center"===s.imageHorizontalAlignment?.5:1)+(s.imagePadding.leftUnit||"px")),0<s.imagePadding.right&&"Left"!==s.imageHorizontalAlignment&&(t+=" - "+s.imagePadding.right*("Center"===s.imageHorizontalAlignment?.5:1)+(s.imagePadding.rightUnit||"px")),""!==t&&(e="calc("+e+t+")");var o="";0<s.imagePadding.top&&"Bottom"!==s.imageVerticalAlignment&&(o+=" + "+s.imagePadding.top*("Center"===s.imageVerticalAlignment?.5:1)+(s.imagePadding.topUnit||"px")),0<s.imagePadding.bottom&&"Top"!==s.imageVerticalAlignment&&(o+=" - "+s.imagePadding.bottom*("Center"===s.imageVerticalAlignment?.5:1)+(s.imagePadding.bottomUnit||"px")),""!==o&&(r="calc("+r+o+")")}c["background-position"]=[e+" "+r],u&&c["background-position"].push("50% 50%")}else c["background-position"]=null}(),e("background-repeat","no-repeat"),e("background-attachment","scroll"),e("background-clip","border-box"),e("background-origin","padding-box")}else for(var r=["color","image","size","position","repeat","origin","clip","attachment"],t=0,o=r.length;t<o;t++)c["background-"+r[t]]=null;var n={};for(var i in c)c.hasOwnProperty(i)&&(null===c[i]?n[i]=null:n[i]=c[i].join(", "));R.StyleProvider.setSimpleElementStyle(a,n)},e.prototype.processFillColor=function(e,r){var t,o="tchmi-styleprovider-linear-gradient";if(e){if(e instanceof jQuery){if(!e.length||!e[0])return;t=e}else t=[e];for(var n=0,i=t.length;n<i;n++){var a=t[n];if(a instanceof a.ownerDocument.defaultView.SVGElement){var s=a.ownerSVGElement||a,l=s.querySelector("defs");if(l){var c="",_=R.StyleProvider.getSimpleElementStyle(a,"fill").fill;if(_){c=_.replace(/url\('?"?\#|'?"?\)/g,"");for(var u=l.querySelectorAll("linearGradient."+o),d=0;d<u.length;d++){var m=u[d];if(c===m.id){m.parentElement.removeChild(m);break}}}}else R.isLinearGradientColor(r)&&(l=a.ownerDocument.createElementNS("http://www.w3.org/2000/svg","defs"),s.insertBefore(l,s.firstElementChild));if(!r||R.isSolidColor(r))r?R.StyleProvider.setSimpleElementStyle(a,"fill",R.StyleProvider.resolveSolidColorAsCssValue(r)):R.StyleProvider.setSimpleElementStyle(a,"fill",null);else if(R.isLinearGradientColor(r)){var h=r,g=a.ownerDocument.createElementNS("http://www.w3.org/2000/svg","linearGradient");g.setAttribute("x1","0"),g.setAttribute("y1","1"),g.setAttribute("x2","0"),g.setAttribute("y2","0"),g.classList.add(o),g.id="tchmi-styleprovider-"+tchmi_create_guid(),g.setAttribute("gradientTransform","rotate("+h.angle+", 0.5, 0.5)");for(var p=0,E=h.stopPoints.length;p<E;p++){var f=h.stopPoints[p];if(void 0===f.stop||null===f.stop)if(0===p)f.stop="0%";else if(p===E-1)f.stop="100%";else{var S=0;h.stopPoints[p-1].stop&&(S=parseFloat(h.stopPoints[p-1].stop));for(var y=null,v=p+1,C=h.stopPoints.length;v<C;v++){var T=h.stopPoints[v].stop;if(null!=T){y=parseFloat(T);break}}null===y&&(y=100,v--);var M="";h.stopPoints[p-1].stop&&(M=h.stopPoints[p-1].stop.replace(/[0-9\.]/g,"")),f.stop=S+(y-S)/(v-p)+M}var b=document.createElementNS("http://www.w3.org/2000/svg","stop");b.setAttribute("offset",f.stop),b.setAttribute("stop-color",f.color),g.appendChild(b)}l.appendChild(g),R.StyleProvider.setSimpleElementStyle(a,"fill","url(#"+g.id+")")}}}}},e.prototype.processStrokeColor=function(e,r){R.isSolidColor(r)?R.StyleProvider.setSimpleElementStyle(e,"stroke",R.StyleProvider.resolveSolidColorAsCssValue(r)):R.StyleProvider.setSimpleElementStyle(e,"stroke",null)},e.prototype.processTextColor=function(e,r){R.isSolidColor(r)?R.StyleProvider.setSimpleElementStyle(e,"color",R.StyleProvider.resolveSolidColorAsCssValue(r)):R.StyleProvider.setSimpleElementStyle(e,"color",null)},e.prototype.processBorderColor=function(e,r){var t={};if(R.isSolidColor(r))t["border-color"]=R.StyleProvider.resolveSolidColorAsCssValue(r),t["border-image-source"]=null,t["border-image-slice"]=null;else if(R.isLinearGradientColor(r))t["border-image-source"]=R.StyleProvider.resolveLinearGradientColorAsCssValue(r),t["border-image-slice"]="1",t["border-color"]=null;else for(var o=["color","image","image-source","image-slice"],n=0,i=o.length;n<i;n++)t["border-"+o[n]]=null;R.StyleProvider.setSimpleElementStyle(e,t)},e.prototype.processBorderWidth=function(e,r){for(var t=["top","right","bottom","left"],o={},n=0,i=t.length;n<i;n++)if(r){var a=r[t[n]];o["border-"+t[n]+"-width"]=null==a?"0":a+"px"}else o["border-"+t[n]+"-width"]="0";R.StyleProvider.setSimpleElementStyle(e,o)},e.prototype.processBorderRadius=function(e,r){for(var t=["topLeft","topRight","bottomRight","bottomLeft"],o=["top-left","top-right","bottom-right","bottom-left"],n={},i=0,a=t.length;i<a;i++)if(r){var s=r[t[i]],l=r[t[i]+"Unit"];l=l||"px",n["border-"+o[i]+"-radius"]=null==s?"":s+l}else n["border-"+o[i]+"-radius"]="";R.StyleProvider.setSimpleElementStyle(e,n)},e.prototype.processBorderStyle=function(e,r){for(var t=["top","right","bottom","left"],o={},n=0,i=t.length;n<i;n++)if(r){var a,s=r[t[n]];switch(s){case"Solid":case"Dotted":case"Dashed":case"None":a=s.toLowerCase();break;default:a=""}o["border-"+t[n]+"-style"]=a}else o["border-"+t[n]+"-style"]="";R.StyleProvider.setSimpleElementStyle(e,o)},e.prototype.processBoxShadow=function(e,r){if(r)if(0===r.length)R.StyleProvider.setSimpleElementStyle(e,"box-shadow","none");else{for(var t=[],o=0,n=r.length;o<n;o++){var i="";r[o].inset&&(i+="inset "),void 0!==r[o].offsetX?i+=r[o].offsetX+(r[o].offsetXUnit||"px")+" ":i+="0px ",void 0!==r[o].offsetY?i+=r[o].offsetY+(r[o].offsetYUnit||"px")+" ":i+="0px ",void 0!==r[o].blur&&(i+=r[o].blur+(r[o].blurUnit||"px")+" "),void 0!==r[o].spread&&(i+=r[o].spread+(r[o].spreadUnit||"px")+" "),R.isSolidColor(r[o].color)?i+=R.StyleProvider.resolveSolidColorAsCssValue(r[o].color):i+="transparent",t.push(i)}R.StyleProvider.setSimpleElementStyle(e,"box-shadow",t.join(", "))}else R.StyleProvider.setSimpleElementStyle(e,"box-shadow",null)},e.prototype.processFontFamily=function(e,r){R.StyleProvider.setSimpleElementStyle(e,"font-family",r)},e.prototype.processFontSize=function(e,r,t){null==r?R.StyleProvider.setSimpleElementStyle(e,"font-size",null):R.StyleProvider.setSimpleElementStyle(e,"font-size",r+t)},e.prototype.processFontStyle=function(e,r){var t;switch(r){case"Normal":case"Italic":case"Oblique":t=r.toLowerCase();break;case"Auto":default:t=null}R.StyleProvider.setSimpleElementStyle(e,"font-style",t)},e.prototype.processFontWeight=function(e,r){var t;switch(r){case"Normal":case"Bold":t=r.toLowerCase();break;case"Auto":default:t=null}R.StyleProvider.setSimpleElementStyle(e,"font-weight",t)},e.prototype.processVisibility=function(e,r){var t={};switch(r){case"Collapsed":t.display="none",t.visibility="";break;case"Hidden":t.display="",t.visibility="hidden";break;case"Visible":default:t.display="",t.visibility=""}R.StyleProvider.setSimpleElementStyle(e,t)},e.prototype.processContentHorizontalAlignment=function(e,r){R.StyleProvider.setSimpleElementStyle(e,"display",["-ms-flexbox","-webkit-flex","flex"]);var t={};switch(r){case"Center":t["-ms-flex-pack"]="center",t["-webkit-justify-content"]="center",t["justify-content"]="center";break;case"Right":t["-ms-flex-pack"]="end",t["-webkit-justify-content"]="flex-end",t["justify-content"]="flex-end";break;case"Left":default:t["-ms-flex-pack"]="start",t["-webkit-justify-content"]="flex-start",t["justify-content"]="flex-start"}R.StyleProvider.setSimpleElementStyle(e,t)},e.prototype.processContentVerticalAlignment=function(e,r){R.StyleProvider.setSimpleElementStyle(e,"display",["-ms-flexbox","-webkit-flex","flex"]);var t={};switch(r){case"Center":t["-ms-flex-align"]="center",t["-webkit-align-items"]="center",t["align-items"]="center";break;case"Bottom":t["-ms-flex-align"]="end",t["-webkit-align-items"]="flex-end",t["align-items"]="flex-end";break;case"Top":default:t["-ms-flex-align"]="start",t["-webkit-align-items"]="flex-start",t["align-items"]="flex-start"}R.StyleProvider.setSimpleElementStyle(e,t)},e.prototype.processContentPadding=function(e,r){for(var t=["top","right","bottom","left"],o={},n=0,i=t.length;n<i;n++)if(r){var a=r[t[n]],s=r[t[n]+"Unit"];s=s||"px",o["padding-"+t[n]]=null==a?"":a+s}else o["padding-"+t[n]]="";R.StyleProvider.setSimpleElementStyle(e,o)},e.prototype.processTransform=function(e,r,t){var o={};if(void 0===t&&(o={"transform-origin":"","-webkit-transform-origin":"",perspective:"","-webkit-perspective":"","perspective-origin":"","-webkit-perspective-origin":""}),r){for(var n,i=[],a=0,s=(n=Array.isArray(r)?r:[r]).length;a<s;a++){var l="",c=n[a];switch(c.transformType){case"Translate":c.x=c.x||0,c.xUnit=c.xUnit||"px",c.y=c.y||0,c.yUnit=c.yUnit||"px",c.z=c.z||0,c.zUnit=c.zUnit||"px",l="translate3d("+c.x+c.xUnit+", "+c.y+c.yUnit+", "+c.z+c.zUnit+")";break;case"Rotate":l=void 0===c.vector?"rotate(":"rotate3d("+c.vector.x+", "+c.vector.y+", "+c.vector.z+", ",l+=c.angle+(void 0!==c.angleUnit?c.angleUnit:"deg"),l+=")";break;case"Scale":l="scale3d(",l+=(void 0!==c.x?c.x:1)+", ",l+=(void 0!==c.y?c.y:1)+", ",l+=void 0!==c.z?c.z:1,l+=")";break;case"Skew":for(var _=[c.xAngle,c.yAngle],u=[c.xAngleUnit,c.xAngleUnit],d=0,m=_.length;d<m;d++)switch(_[d]=_[d]||0,u[d]){case"grad":_[d]=_[d]*(Math.PI/200);break;case"turn":_[d]=_[d]*(Math.PI/.5);break;case"rad":break;case"deg":default:_[d]=_[d]*(Math.PI/180)}l="matrix(1, "+Math.tan(_[1])+", "+Math.tan(_[0])+", 1, 0, 0)";break;case"Origin":void 0===c.x&&(c.x=50,c.xUnit="%"),void 0===c.y&&(c.y=50,c.yUnit="%"),void 0===c.z&&(c.z=0,c.zUnit=void 0),o["-webkit-transform-origin"]=c.x+(void 0!==c.xUnit?c.xUnit:"px")+" "+c.y+(void 0!==c.yUnit?c.yUnit:"px")+" "+c.z+(void 0!==c.zUnit?c.zUnit:"px"),o["transform-origin"]=o["-webkit-transform-origin"];break;case"Perspective":o["-webkit-perspective"]=c.distance+(void 0!==c.distanceUnit?c.distanceUnit:"px"),o.perspective=o["-webkit-perspective"],void 0!==c.origin&&(void 0===c.origin.x&&(c.origin.x=50,c.origin.xUnit="%"),void 0===c.origin.y&&(c.origin.y=50,c.origin.yUnit="%"),o["-webkit-perspective-origin"]=c.origin.x+(void 0!==c.origin.xUnit?c.origin.xUnit:"px")+" "+c.origin.y+(void 0!==c.origin.yUnit?c.origin.yUnit:"px"),o["perspective-origin"]=o["-webkit-perspective-origin"])}i.push(l)}i=i.reverse(),o["-webkit-transform"]=i.join(" "),o.transform=o["-webkit-transform"]}else o["-webkit-transform"]="",o.transform="";R.StyleProvider.setSimpleElementStyle(e,o)},e}(),e.StyleManager=r}(TcHmi||(TcHmi={})),function(l){var e,r;e=l.System||(l.System={}),r=function(){function e(e){this.__types={},this.__error=l.Errors.NONE,this.__watching=!1,this.__subscrId=null,this.__subscrCommands=[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"GetDefinitions",writeValue:{resolve:"MergeRefs",type:"general"}},{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"GetDefinitions",writeValue:{resolve:"MergeRefs",type:"framework"}},{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"GetDefinitions",writeValue:{resolve:"MergeRefs",type:"server"}},{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"GetDefinitions",writeValue:{resolve:"MergeRefs",type:"project"}}],this.__bGeneralTypesInitialized=!1,this.__bServerTypesInitialized=!1,this.__bFrameworkTypesInitialized=!1,this.__bProjectTypesInitialized=!1,l.EventProvider.register("onWebsocketOpened",this.__onWebsocketOpened()),l.EventProvider.register("onWebsocketClosed",this.__onWebsocketClosed())}return e.prototype.__onWebsocketOpened=function(){var t=this;return function(e,r){t.__error=l.Errors.NONE,t.doWatchTypeDefinitions()}},e.prototype.__onWebsocketClosed=function(){var t=this;return function(e,r){t.__error=l.Errors.E_WEBSOCKET_NOT_READY}},e.prototype.__cacheSchema=function(e,r){if(void 0!==e.definitions)for(var t in e.definitions){var o="tchmi:"+r+"#/definitions/"+t,n=!1;void 0!==this.__types[o]&&(n=!0),this.__types[o]=e.definitions[t],this.__types[o].id=o,!1===n?(l.EventProvider.raise("System.onTypeDefinitionCreated<"+o+">",{typeId:o,typeSchema:e.definitions[t]}),l.EventProvider.raise("System.onTypeDefinitionCreated",{typeId:o,typeSchema:e.definitions[t]})):(l.EventProvider.raise("System.onTypeDefinitionChanged<"+o+">",{typeId:o,typeSchema:e.definitions[t]}),l.EventProvider.raise("System.onTypeDefinitionChanged",{typeId:o,typeSchema:e.definitions[t]}))}},e.prototype.__processTypeDefinitions=function(e){if(this.__error!==l.Errors.NONE)return this.__error;if(!e)return l.Errors.ERROR;if(e.error!==l.Errors.NONE)return e.error;var r=e.response;if(!r)return l.Errors.ERROR;if(r.error)return l.Log.error("[Source=Framework, Module=TcHmi.System.TypeManager] Server responds with error. "+l.Log.buildMessage(r.error)),l.Errors.ERROR;var t=r.commands;if(!t)return l.Log.error("[Source=Framework, Module=TcHmi.System.TypeManager] Failed to resolve types due to invalid response. Missing commands property."),l.Errors.ERROR;for(var o=0,n=t.length;o<n;o++){var i=t[o];if(!i)return l.Errors.ERROR;if(i.error)return l.Log.error("[Source=Framework, Module=TcHmi.System.TypeManager] Server responds with error for command for symbol="+i.symbol+". "+l.Log.buildMessage(i.error)),l.Errors.ERROR;var a=i.writeValue;if(a)if(a.type){var s=i.readValue;if(s)switch(a.type){case"general":this.__cacheSchema(s,a.type),this.__bGeneralTypesInitialized=!0;break;case"framework":this.__cacheSchema(s,a.type),this.__bFrameworkTypesInitialized=!0;break;case"server":this.__cacheSchema(s,a.type),this.__bServerTypesInitialized=!0;break;case"project":this.__cacheSchema(s,a.type),this.__bProjectTypesInitialized=!0}else l.Log.error("[Source=Framework, Module=TcHmi.System.TypeManager] Failed to resolve types for namespace="+a.type+" due to invalid response command for symbol="+i.symbol+". Missing readValue property.")}else l.Log.error("[Source=Framework, Module=TcHmi.System.TypeManager] Failed to resolve type due to invalid response command for symbol="+i.symbol+". Missing type property in writeValue.");else l.Log.error("[Source=Framework, Module=TcHmi.System.TypeManager] Failed to resolve type due to invalid response command for symbol="+i.symbol+". Missing writeValue property.")}return this.__bGeneralTypesInitialized||l.Log.error("[Source=Framework, Module=TcHmi.System.TypeManager] Failed to resolve type definitions for namespace=general."),this.__bServerTypesInitialized||l.Log.error("[Source=Framework, Module=TcHmi.System.TypeManager] Failed to resolve type definitions for namespace=server."),this.__bFrameworkTypesInitialized||l.Log.error("[Source=Framework, Module=TcHmi.System.TypeManager] Failed to resolve type definitions for namespace=framework."),this.__bProjectTypesInitialized||l.Log.error("[Source=Framework, Module=TcHmi.System.TypeManager] Failed to resolve type definitions for namespace=project."),this.__bGeneralTypesInitialized&&this.__bServerTypesInitialized&&this.__bFrameworkTypesInitialized&&this.__bProjectTypesInitialized?l.Errors.NONE:l.Errors.ERROR},e.prototype.doWatchTypeDefinitions=function(t){if(this.__watching)"function"==typeof t&&t.call(this,{error:l.Errors.ERROR});else if(!1!==l.Server.isWebsocketReady()){var o=this,n=!1,e=5e3;TCHMI_ENABLE_DESIGNER_MODE&&(e=1e3),this.__watching=!0,this.__subscrId=l.Server.subscribeEx(this.__subscrCommands,e,{},function(e){var r=o.__processTypeDefinitions(e);n||("function"==typeof t&&t.call(o,{error:r}),n=!0)})}else"function"==typeof t&&t.call(this,{error:l.Errors.ERROR})},e.prototype.getSchema=function(e){var r=this.__types[e];return void 0===r?(l.Log.error("[Source=Framework, Module=TcHmi] Failed to resolve type="+e+". Type is not known."),null):r},e}(),e.TypeManager=r}(TcHmi||(TcHmi={})),function(R){!function(b){var E,e;(e=E=b.SymbolState||(b.SymbolState={}))[e.Invalid=0]="Invalid",e[e.Ready=10]="Ready",e[e.Destroyed=20]="Destroyed";var r=function(){function e(e){if(this.__expression=null,this.__state=E.Invalid,this.__schema=null,this.__destroyTypeDefinitionChanged=null,this.__expression=new R.SymbolExpression(e),this.__expression.getType()===R.SymbolType.Invalid)throw new Error("Expression="+e+" is not a valid symbol expression.");this.__state=E.Ready}return e.prototype.__onTypeDefinitionChanged=function(){var n=this;return function(e,r){n.__schema=null;var t=R.System.Services.typeManager.getSchema(r.typeId);if(t){var o=n.resolveSubSchema(t,n.__expression.getPathTokens());o&&(n.__schema=o)}}},e.prototype.getExpression=function(){return this.__expression},e.prototype.getState=function(){return this.__state},e.prototype.isDestroyed=function(){return this.__state===E.Destroyed},e.prototype.isReady=function(){return this.__state===E.Ready},e.prototype.destroy=function(){this.isDestroyed()||(this.__destroyTypeDefinitionChanged&&(this.__destroyTypeDefinitionChanged(),this.__destroyTypeDefinitionChanged=null),this.__expression=null,this.__state=E.Destroyed)},e.prototype.__readSubValue=function(e,r){if(void 0===e)return null;if(null===e)return null;if("object"!=typeof e)return R.Log.debug("[Source=Framework, Module=TcHmi.System.Symbol, Expression="+this.__expression.toString()+"] Failed to read value by path of symbol="+this.__expression.toString()+" because current symbol value has type="+typeof e+" instead of type=object."),null;for(var t=e,o=tchmi_clone_object(r),n="",i=o.shift();;){var a=!1;if("["===i[0]&&"]"===i[i.length-1]&&(a=!0,i=i.replace("[","").replace("]","")),void 0===t[i])return null;if(!(0<o.length))break;t=t[i],n+=a?"["+i+"]":"::"+i,i=o.shift()}return void 0===t[i]?(R.Log.debug("[Source=Framework, Module=TcHmi.System.Symbol, Expression="+this.__expression.toString()+"] Failed to read value by path of symbol="+this.__expression.toString()+". The token="+i+" does not exist under path="+this.__expression.getName()+n+". Change log verbosity to debug to get further information about the current value of the symbol."),R.Log.debug(e),null):t[i]},e.prototype.__writeSubValue=function(e,r,t){if(void 0===e)return null;if(null===e)return null;if("object"!=typeof e)return R.Log.debug("[Source=Framework, Module=TcHmi.System.Symbol, Expression="+this.__expression.toString()+"] Failed to write value by path of symbol="+this.__expression.toString()+" because current symbol value has type="+typeof e+" instead of type=object."),null;for(var o=e,n=tchmi_clone_object(t),i="",a=n.shift();;){var s=!1;if("["===a[0]&&"]"===a[a.length-1]&&(s=!0,a=a.replace("[","").replace("]","")),void 0===o[a])return R.Log.debug("[Source=Framework, Module=TcHmi.System.Symbol, Expression="+this.__expression.toString()+"] Failed to write value by path of symbol="+this.__expression.toString()+". The token="+a+" does not exist under path="+this.__expression.getName()+i+". Change log verbosity to debug to get further information about the current value of the symbol."),null;if(!(0<n.length))break;o=o[a],i+=s?"["+a+"]":"::"+a,a=n.shift()}void 0!==o[a]?o[a]=r:R.Log.debug("[Source=Framework, Module=TcHmi.System.Symbol, Expression="+this.__expression.toString()+"] Failed to write value by path of symbol="+this.__expression.toString()+". The token="+a+" does not exist under path="+this.__expression.getName()+i+". Change log verbosity to debug to get further information about the current value of the symbol.")},e.prototype.resolveSchema=function(i){var a=this;if(null===this.__schema){var e=this.__expression.getType();if(e===R.SymbolType.Server){var r={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage"],symbol:"GetSchema",writeValue:{resolve:"MergeRefs",symbol:this.__expression.getName()}}]},t=this.__expression.getOptions().Timeout,o=this.__expression.getOptions().Parallel;o||(o=!1),R.Server.requestEx(r,{timeout:t,parallel:o},function(e){if(void 0===e.error||e.error===R.Errors.NONE){var r=e.response;if(void 0!==r)if(r&&r.error&&r.error)R.Callback.callSafe(i,a,{error:R.Errors.E_SERVER_RESPONSE_ERROR,details:{code:R.Errors.E_SERVER_RESPONSE_ERROR,message:R.Errors[R.Errors.E_SERVER_RESPONSE_ERROR],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol",errors:[r.error]}});else{var t=r.commands;t||R.Callback.callSafe(i,a,{error:R.Errors.E_SERVER_COMMANDS_MISSING,details:{code:R.Errors.E_SERVER_COMMANDS_MISSING,message:R.Errors[R.Errors.E_SERVER_COMMANDS_MISSING],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}});var o=t[0];if(o||R.Callback.callSafe(i,a,{error:R.Errors.E_SERVER_COMMAND_MISSING,details:{code:R.Errors.E_SERVER_COMMANDS_MISSING,message:R.Errors[R.Errors.E_SERVER_COMMANDS_MISSING],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}}),!o.error){var n=o.readValue;return n?(a.__schema=n,a.__destroyTypeDefinitionChanged&&(a.__destroyTypeDefinitionChanged(),a.__destroyTypeDefinitionChanged=null),a.__destroyTypeDefinitionChanged=R.EventProvider.register("System.onTypeDefinitionChanged<"+n.id+">",a.__onTypeDefinitionChanged()),void R.Callback.callSafe(i,a,{error:R.Errors.NONE,schema:n})):void R.Callback.callSafe(i,a,{error:R.Errors.E_SERVER_READVALUE_MISSING,details:{code:R.Errors.E_SERVER_READVALUE_MISSING,message:R.Errors[R.Errors.E_SERVER_READVALUE_MISSING],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}})}R.Callback.callSafe(i,a,{error:R.Errors.E_SERVER_COMMAND_ERROR,details:{code:R.Errors.E_SERVER_COMMAND_ERROR,message:R.Errors[R.Errors.E_SERVER_COMMAND_ERROR],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol",errors:[o.error]}})}else R.Callback.callSafe(i,a,{error:R.Errors.E_SERVER_INVALID_RESPONSE,details:{code:R.Errors.E_SERVER_INVALID_RESPONSE,message:R.Errors[R.Errors.E_SERVER_INVALID_RESPONSE],reason:a.__expression.toString()+": Missing response from server.",domain:"TcHmi.System.Symbol"}})}else R.Callback.callSafe(i,a,{error:e.error,details:e.details})})}else{if(e!==R.SymbolType.Internal){if(e===R.SymbolType.LocalizedText)return(p=R.System.Services.typeManager.getSchema("tchmi:general#/definitions/String"))?(this.__schema=p,void R.Callback.callSafe(i,a,{error:R.Errors.NONE,schema:this.__schema})):void R.Callback.callSafe(i,a,{error:R.Errors.E_UNKNOWN_TYPE,details:{code:R.Errors.E_UNKNOWN_TYPE,message:R.Errors[R.Errors.E_UNKNOWN_TYPE],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}});if(e===R.SymbolType.Function)return void R.Callback.callSafe(i,a,{error:R.Errors.E_NOT_SUPPORTED,details:{code:R.Errors.E_NOT_SUPPORTED,message:R.Errors[R.Errors.E_NOT_SUPPORTED],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}});if(e===R.SymbolType.Control){var n=this.__expression.getName(),s=this.__expression.getPathTokens(),l=R.Controls.get(n);if(!l)return void R.Callback.callSafe(i,a,{error:R.Errors.E_CONTROL_INSTANCE_NOT_FOUND,details:{code:R.Errors.E_CONTROL_INSTANCE_NOT_FOUND,message:R.Errors[R.Errors.E_CONTROL_INSTANCE_NOT_FOUND],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}});var c=null;if(s&&0<s.length){var _=tchmi_clone_object(s);return c=_.shift(),null==(u=R.System.Services.controlManager.getAttributeByPropertyName(l,c))?void R.Callback.callSafe(i,a,{error:R.Errors.E_CONTROL_ATTRIBUTE_NOT_FOUND,details:{code:R.Errors.E_CONTROL_ATTRIBUTE_NOT_FOUND,message:R.Errors[R.Errors.E_CONTROL_ATTRIBUTE_NOT_FOUND],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}}):(g=R.System.Services.typeManager.getSchema(u.type))&&(p=this.resolveSubSchema(g,_))?(this.__schema=p,this.__destroyTypeDefinitionChanged&&(this.__destroyTypeDefinitionChanged(),this.__destroyTypeDefinitionChanged=null),this.__destroyTypeDefinitionChanged=R.EventProvider.register("System.onTypeDefinitionChanged<"+u.type+">",this.__onTypeDefinitionChanged()),void R.Callback.callSafe(i,a,{error:R.Errors.NONE,schema:this.__schema})):void R.Callback.callSafe(i,a,{error:R.Errors.E_UNKNOWN_TYPE,details:{code:R.Errors.E_UNKNOWN_TYPE,message:R.Errors[R.Errors.E_UNKNOWN_TYPE],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}})}return void R.Callback.callSafe(i,a,{error:R.Errors.E_NOT_SUPPORTED,details:{code:R.Errors.E_NOT_SUPPORTED,message:R.Errors[R.Errors.E_NOT_SUPPORTED],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}})}if(e===R.SymbolType.PartialParam){var u,d=this.__expression.getName().split("."),m=(c=d.pop(),d.join(".")),h=(s=this.__expression.getPathTokens(),R.Controls.get(m));return h?null==(u=R.System.Services.controlManager.getAttributeByPropertyName(h,c))?void R.Callback.callSafe(i,a,{error:R.Errors.E_CONTROL_ATTRIBUTE_NOT_FOUND,details:{code:R.Errors.E_CONTROL_ATTRIBUTE_NOT_FOUND,message:R.Errors[R.Errors.E_CONTROL_ATTRIBUTE_NOT_FOUND],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}}):(g=R.System.Services.typeManager.getSchema(u.type))&&(p=this.resolveSubSchema(g,s))?(this.__schema=p,this.__destroyTypeDefinitionChanged&&(this.__destroyTypeDefinitionChanged(),this.__destroyTypeDefinitionChanged=null),this.__destroyTypeDefinitionChanged=R.EventProvider.register("System.onTypeDefinitionChanged<"+u.type+">",this.__onTypeDefinitionChanged()),void R.Callback.callSafe(i,a,{error:R.Errors.NONE,schema:this.__schema})):void R.Callback.callSafe(i,a,{error:R.Errors.E_UNKNOWN_TYPE,details:{code:R.Errors.E_UNKNOWN_TYPE,message:R.Errors[R.Errors.E_UNKNOWN_TYPE],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}}):void R.Callback.callSafe(i,a,{error:R.Errors.E_CONTROL_INSTANCE_NOT_FOUND,details:{code:R.Errors.E_CONTROL_INSTANCE_NOT_FOUND,message:R.Errors[R.Errors.E_CONTROL_INSTANCE_NOT_FOUND],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}})}if(e===R.SymbolType.TemplateParam){var g,p,E=this.__expression.getName(),f=(s=this.__expression.getPathTokens(),b.Services.templateParamSymbolManager.get(E));return f&&f.type?(g=R.System.Services.typeManager.getSchema(f.type))&&(p=this.resolveSubSchema(g,s))?(this.__schema=p,this.__destroyTypeDefinitionChanged&&(this.__destroyTypeDefinitionChanged(),this.__destroyTypeDefinitionChanged=null),this.__destroyTypeDefinitionChanged=R.EventProvider.register("System.onTypeDefinitionChanged<"+f.type+">",this.__onTypeDefinitionChanged()),void R.Callback.callSafe(i,a,{error:R.Errors.NONE,schema:this.__schema})):void R.Callback.callSafe(i,a,{error:R.Errors.E_UNKNOWN_TYPE,details:{code:R.Errors.E_UNKNOWN_TYPE,message:R.Errors[R.Errors.E_UNKNOWN_TYPE],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}}):void R.Callback.callSafe(i,a,{error:R.Errors.E_SYMBOL_UNKNOWN,details:{code:R.Errors.E_SYMBOL_UNKNOWN,message:R.Errors[R.Errors.E_SYMBOL_UNKNOWN],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}})}return void R.Callback.callSafe(i,a,{error:R.Errors.E_NOT_SUPPORTED,details:{code:R.Errors.E_NOT_SUPPORTED,message:R.Errors[R.Errors.E_NOT_SUPPORTED],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}})}var S=this.__expression.getName(),y=this.__expression.getPathTokens();R.System.Services.internalSymbolManager.getType(S,function(e){if(e.error!==R.Errors.NONE)R.Callback.callSafe(i,a,{error:e.error,details:{code:e.error,message:R.Errors[e.error],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0}});else{var r=R.System.Services.typeManager.getSchema(e.type);if(r){var t=a.resolveSubSchema(r,y);return t?(a.__schema=t,a.__destroyTypeDefinitionChanged&&(a.__destroyTypeDefinitionChanged(),a.__destroyTypeDefinitionChanged=null),a.__destroyTypeDefinitionChanged=R.EventProvider.register("System.onTypeDefinitionChanged<"+e.type+">",a.__onTypeDefinitionChanged()),void R.Callback.callSafe(i,a,{error:R.Errors.NONE,schema:this.__schema})):void R.Callback.callSafe(i,a,{error:R.Errors.E_UNKNOWN_TYPE,details:{code:R.Errors.E_UNKNOWN_TYPE,message:R.Errors[R.Errors.E_UNKNOWN_TYPE],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}})}R.Callback.callSafe(i,a,{error:R.Errors.E_UNKNOWN_TYPE,details:{code:R.Errors.E_UNKNOWN_TYPE,message:R.Errors[R.Errors.E_UNKNOWN_TYPE],reason:""+a.__expression.toString(),domain:"TcHmi.System.Symbol"}})}})}}else R.Callback.callSafe(i,a,{error:R.Errors.NONE,schema:this.__schema})},e.prototype.resolveSubSchema=function(e,r){var t=e,o=tchmi_clone_object(r);if(null==t||"object"!=typeof t)return null;if(!r||0===r.length)return t;for(;0<o.length;){for(var n=[],i=o.shift().split(""),a=0;0<i.length;){var s=i.shift();"["===s&&void 0!==n[a]&&0<n[a].length&&a++,void 0===n[a]&&(n[a]=""),n[a]=n[a]+s,"]"===s&&a++}for(var l=!1;0<n.length;){var c=n.shift();if(c.match(/\[*.\]/g)){if(void 0!==t.items&&"object"==typeof t.items&&!Array.isArray(t.items)){t=t.items,l=!0;continue}}else if(void 0!==t.properties&&"object"==typeof t.properties&&!1===Array.isArray(t.properties)&&void 0!==t.properties[c]){t=t.properties[c],l=!0;continue}}if(!1===l){t=null;break}}return null==t||"object"!=typeof t?null:t},e.prototype.read=function(e){R.Log.debug("[Source=Framework, Module=TcHmi.System.Symbol, Expression="+this.__expression.toString()+"] read symbol="+this.__expression.toString());var r=this.__expression.getType();return r===R.SymbolType.Server?void this.__readSymbolTypeServer(e):r===R.SymbolType.Internal?void this.__readSymbolTypeInternal(e):r===R.SymbolType.LocalizedText?void this.__readSymbolTypeLocalizedText(e):r===R.SymbolType.Function?void this.__readSymbolTypeFunction(e):r===R.SymbolType.Control?void this.__readSymbolTypeControl(e):r===R.SymbolType.PartialParam?void this.__readSymbolTypePartialParam(e):r===R.SymbolType.TemplateParam?void this.__readSymbolTypeTemplateParam(e):void R.Callback.callSafe(e,this,{error:R.Errors.E_NOT_SUPPORTED,details:{code:R.Errors.E_NOT_SUPPORTED,message:R.Errors[R.Errors.E_NOT_SUPPORTED],reason:""+this.__expression.toString(),domain:"TcHmi.System.Symbol"}})},e.prototype.__readSymbolTypeServer=function(n){var i=this,e={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage"],symbol:this.__expression.getName()}]},r=this.__expression.getOptions().Timeout,t=i.__expression.getOptions().Parallel;t||(t=!1),R.Server.requestEx(e,{timeout:r,parallel:t},function(e){if(void 0===e.error||e.error===R.Errors.NONE){var r=e.response;if(void 0!==r)if(r&&r.error&&r.error)R.Callback.callSafe(n,i,{error:R.Errors.E_SERVER_RESPONSE_ERROR,details:{code:R.Errors.E_SERVER_COMMAND_ERROR,message:R.Errors[R.Errors.E_SERVER_COMMAND_ERROR],reason:""+i.__expression.toString(),domain:"TcHmi.System.Symbol",errors:[r.error]},response:r});else{var t=r.commands;if(t){var o=t[0];if(o)return o.error?void R.Callback.callSafe(n,i,{error:R.Errors.E_SERVER_COMMAND_ERROR,details:{code:R.Errors.E_SERVER_COMMAND_ERROR,message:R.Errors[R.Errors.E_SERVER_COMMAND_ERROR],reason:""+i.__expression.toString(),domain:"TcHmi.System.Symbol",errors:[o.error]},value:o.readValue,response:r}):void R.Callback.callSafe(n,i,{error:R.Errors.NONE,value:o.readValue,response:r});R.Callback.callSafe(n,i,{error:R.Errors.E_SERVER_COMMAND_MISSING,details:{code:R.Errors.E_SERVER_COMMAND_MISSING,message:R.Errors[R.Errors.E_SERVER_COMMAND_MISSING],reason:""+i.__expression.toString(),domain:"TcHmi.System.Symbol"},response:r})}else R.Callback.callSafe(n,i,{error:R.Errors.E_SERVER_COMMANDS_MISSING,details:{code:R.Errors.E_SERVER_COMMANDS_MISSING,message:R.Errors[R.Errors.E_SERVER_COMMANDS_MISSING],reason:""+i.__expression.toString(),domain:"TcHmi.System.Symbol"},response:r})}else R.Callback.callSafe(n,i,{error:R.Errors.E_SERVER_INVALID_RESPONSE,details:{code:R.Errors.E_SERVER_INVALID_RESPONSE,message:R.Errors[R.Errors.E_SERVER_INVALID_RESPONSE],reason:i.__expression.toString()+": Missing response from server.",domain:"TcHmi.System.Symbol"},response:r})}else R.Callback.callSafe(n,i,{error:e.error})})},e.prototype.__readSymbolTypeInternal=function(o){var e=this.__expression.getName();try{var n=this;b.Services.internalSymbolManager.read(e,function(e){if(e.error!==R.Errors.NONE)R.Callback.callSafe(o,n,{error:e.error});else{var r=n.__expression.getPathTokens();if(r&&0<r.length){var t=n.__readSubValue(e.value,r);return void R.Callback.callSafe(o,n,{error:R.Errors.NONE,value:tchmi_clone_object(t)})}R.Callback.callSafe(o,n,{error:R.Errors.NONE,value:tchmi_clone_object(e.value)})}})}catch(e){return R.Log.error(e),void R.Callback.callSafe(o,this,{error:R.Errors.E_EXCEPTION,details:{code:R.Errors.E_EXCEPTION,message:R.Errors[R.Errors.E_EXCEPTION],reason:this.__expression.toString()+', Exception: "'+e+'"',domain:"TcHmi.System.Symbol"}})}},e.prototype.__readSymbolTypeLocalizedText=function(r){var e=this.__expression.getName(),t=b.Services.localizationManager.get(e);if(void 0!==t)try{return void R.Callback.callSafe(r,this,{error:R.Errors.NONE,value:t.text})}catch(e){return R.Log.error(e),void R.Callback.callSafe(r,this,{error:R.Errors.E_EXCEPTION,details:{code:R.Errors.E_EXCEPTION,message:R.Errors[R.Errors.E_EXCEPTION],reason:this.__expression.toString()+', Exception: "'+e+'"',domain:"TcHmi.System.Symbol"}})}else R.Callback.callSafe(r,this,{error:R.Errors.E_SYMBOL_UNKNOWN,details:{code:R.Errors.E_SYMBOL_UNKNOWN,message:R.Errors[R.Errors.E_SYMBOL_UNKNOWN],reason:""+this.__expression.toString(),domain:"TcHmi.System.Symbol"}})},e.prototype.__readSymbolTypeFunction=function(r){var t=this;new b.FunctionExpression(this.__expression.getContent()).execute({success:function(e){R.Callback.callSafe(r,t,{error:R.Errors.NONE,value:e})},error:function(e){R.Callback.callSafe(r,t,{error:e})}})},e.prototype.__readSymbolTypeControl=function(r){var e=this.__expression.getName(),t=tchmi_clone_object(this.__expression.getPathTokens()),o=R.Controls.get(e);if(o)if(null!==t){var n=null;t&&0<t.length&&(n=t.shift());var i=R.System.Services.controlManager.getAttributeByPropertyName(o,n);if(null!=i)try{var a=tchmi_clone_object(o[i.propertyGetterName].call(o));if(t&&0<t.length){var s=this.__readSubValue(a,t);return void R.Callback.callSafe(r,this,{error:R.Errors.NONE,value:s})}return void R.Callback.callSafe(r,this,{error:R.Errors.NONE,value:a})}catch(e){return R.Log.error(e),void R.Callback.callSafe(r,this,{error:R.Errors.E_EXCEPTION,details:{code:R.Errors.E_EXCEPTION,message:R.Errors[R.Errors.E_EXCEPTION],reason:this.__expression.toString()+', Exception: "'+e+'"',domain:"TcHmi.System.Symbol"}})}else R.Callback.callSafe(r,this,{error:R.Errors.E_CONTROL_ATTRIBUTE_NOT_FOUND})}else R.Callback.callSafe(r,this,{error:R.Errors.NONE,value:o});else R.Callback.callSafe(r,this,{error:R.Errors.E_CONTROL_INSTANCE_NOT_FOUND})},e.prototype.__readSymbolTypePartialParam=function(r){var e=this.__expression.getName().split("."),t=e.pop(),o=e.join("."),n=this.__expression.getPathTokens(),i=R.Controls.get(o);if(i){var a=R.System.Services.controlManager.getAttributeByPropertyName(i,t);if(null!=a)try{var s=i[a.propertyGetterName].call(i);if(n&&0<n.length){var l=this.__readSubValue(s,n);return void R.Callback.callSafe(r,this,{error:R.Errors.NONE,value:tchmi_clone_object(l)})}return void R.Callback.callSafe(r,this,{error:R.Errors.NONE,value:tchmi_clone_object(s)})}catch(e){return R.Log.error(e),void R.Callback.callSafe(r,this,{error:R.Errors.E_EXCEPTION,details:{code:R.Errors.E_EXCEPTION,message:R.Errors[R.Errors.E_EXCEPTION],reason:this.__expression.toString()+', Exception: "'+e+'"',domain:"TcHmi.System.Symbol"}})}else R.Callback.callSafe(r,this,{error:R.Errors.E_CONTROL_ATTRIBUTE_NOT_FOUND})}else R.Callback.callSafe(r,this,{error:R.Errors.E_CONTROL_INSTANCE_NOT_FOUND,details:{code:R.Errors.E_CONTROL_INSTANCE_NOT_FOUND,message:R.Errors[R.Errors.E_CONTROL_INSTANCE_NOT_FOUND],reason:this.__expression.toString()+", Missing instance for control: "+o+".",domain:"TcHmi.System.Symbol"}})},e.prototype.__readSymbolTypeTemplateParam=function(r){var t=this,e=this.__expression.getName(),o=this.__expression.getPath(),n=this.__expression.getPathTokens(),i=b.Services.templateParamSymbolManager.get(e);try{if(!(i.value instanceof R.SymbolExpression)){if(n&&0<n.length){var a=this.__readSubValue(i.value,n);return void R.Callback.callSafe(r,t,{error:R.Errors.NONE,value:tchmi_clone_object(a)})}return void R.Callback.callSafe(r,t,{error:R.Errors.NONE,value:tchmi_clone_object(i.value)})}var s=i.value,l=s.getTag(),c=s.getName(),_=s.getPath(),u="%"+l+"%"+c;null!==_&&(u+=_),n&&0<n.length&&(u+=o),u+="%/"+l+"%";var d=new R.System.Symbol(u);d.read(function(e){e.error===R.Errors.NONE?R.Callback.callSafe(r,t,{error:R.Errors.NONE,value:tchmi_clone_object(e.value)}):R.Callback.callSafe(r,t,{error:e.error}),d.destroy(),d=null})}catch(e){return R.Log.error(e),void R.Callback.callSafe(r,t,{error:R.Errors.E_EXCEPTION,details:{code:R.Errors.E_EXCEPTION,message:R.Errors[R.Errors.E_EXCEPTION],reason:t.__expression.toString()+': Exception: "'+e+'"',domain:"TcHmi.System.Symbol"}})}},e.prototype.write=function(e,r){this.writeEx(e,null,r)},e.prototype.writeEx=function(e,r,t){switch(R.Log.debug("[Source=Framework, Module=TcHmi.System.Symbol, Expression="+this.__expression.toString()+"] Write symbol="+this.__expression.toString()+(r?"":" (no dirtyPaths)")+" with value:"),R.Log.debug(e,!0),r&&(R.Log.debug("[Source=Framework, Module=TcHmi.System.ServerManager] Write dirtyPaths:"),R.Log.debug(r,!0)),this.__expression.getType()){case R.SymbolType.Server:return void this.__writeSymbolTypeServer(e,r,t);case R.SymbolType.Internal:return void this.__writeSymbolTypeInternal(e,r,t);case R.SymbolType.LocalizedText:case R.SymbolType.Function:return void R.Callback.callSafe(t,this,{error:R.Errors.E_SYMBOL_READONLY});case R.SymbolType.Control:return void this.__writeSymbolTypeControl(e,r,t);case R.SymbolType.PartialParam:return void this.__writeSymbolTypePartialParam(e,r,t);case R.SymbolType.TemplateParam:return void this.__writeSymbolTypeTemplateParam(e,r,t);default:return void R.Callback.callSafe(t,this,{error:R.Errors.E_NOT_SUPPORTED,details:{code:R.Errors.E_NOT_SUPPORTED,message:R.Errors[R.Errors.E_NOT_SUPPORTED],reason:""+this.__expression.toString(),domain:"TcHmi.System.Symbol"}})}},e.prototype.__writeSymbolTypeServer=function(e,d,m){var h=this,g=this.__expression.getName(),p=tchmi_clone_object(e);this.resolveSchema(function(e){if(h.__state===E.Ready)if(e.error===R.Errors.NONE){var r={requestType:"ReadWrite",commands:[]},t=h.__schema;if(d)for(var o=0,n=d.length;o<n;o++){var i=d[o],a=b.resolveSymbolPathToTokenArray(i),s=h.resolveSubSchema(t,a),l=h.__readSubValue(p,a),c=R.ValueConverter.toSchemaType(l,s);r.commands.push({commandOptions:["SendErrorMessage"],symbol:g+i,writeValue:c})}else{c=R.ValueConverter.toSchemaType(p,t);r.commands.push({commandOptions:["SendErrorMessage"],symbol:g,writeValue:c})}var _=h.__expression.getOptions().Timeout,u=h.__expression.getOptions().Parallel;u||(u=!1),R.Server.requestEx(r,{timeout:_,parallel:u},function(e){if(void 0===e.error||e.error===R.Errors.NONE){var r=e.response;if(r)if(r&&r.error&&r.error)R.Callback.callSafe(m,h,{error:R.Errors.E_SERVER_RESPONSE_ERROR,details:{code:R.Errors.E_SERVER_RESPONSE_ERROR,message:R.Errors[R.Errors.E_SERVER_RESPONSE_ERROR],reason:""+h.__expression.toString(),domain:"TcHmi.System.Symbol",errors:[r.error]},response:r});else{var t=r.commands;if(t){var o=t[0];if(o)return o.error?void R.Callback.callSafe(m,h,{error:R.Errors.E_SERVER_COMMAND_ERROR,details:{code:R.Errors.E_SERVER_COMMAND_ERROR,message:R.Errors[R.Errors.E_SERVER_COMMAND_ERROR],reason:""+h.__expression.toString(),domain:"TcHmi.System.Symbol",errors:[o.error]},response:r}):void R.Callback.callSafe(m,h,{error:R.Errors.NONE,value:o.readValue,response:r});R.Callback.callSafe(m,h,{error:R.Errors.E_SERVER_COMMAND_MISSING,details:{code:R.Errors.E_SERVER_COMMAND_MISSING,message:R.Errors[R.Errors.E_SERVER_COMMAND_MISSING],reason:""+h.__expression.toString(),domain:"TcHmi.System.Symbol"},response:r})}else R.Callback.callSafe(m,h,{error:R.Errors.E_SERVER_COMMANDS_MISSING,details:{code:R.Errors.E_SERVER_COMMANDS_MISSING,message:R.Errors[R.Errors.E_SERVER_COMMANDS_MISSING],reason:""+h.__expression.toString(),domain:"TcHmi.System.Symbol"},response:r})}else R.Callback.callSafe(m,h,{error:R.Errors.E_SERVER_INVALID_RESPONSE,details:{code:R.Errors.E_SERVER_INVALID_RESPONSE,message:R.Errors[R.Errors.E_SERVER_INVALID_RESPONSE],reason:h.__expression.toString()+": Missing response from server.",domain:"TcHmi.System.Symbol"}})}else R.Callback.callSafe(m,h,{error:e.error,details:e.details})})}else R.Callback.callSafe(m,h,{error:R.Errors.E_SYMBOL_RESOLVE_SCHEMA,details:{code:R.Errors.E_SYMBOL_RESOLVE_SCHEMA,message:R.Errors[R.Errors.E_SYMBOL_RESOLVE_SCHEMA],reason:""+h.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0}});else R.Callback.callSafe(m,h,{error:R.Errors.E_SYMBOL_STATE_INVALID,details:{code:R.Errors.E_SYMBOL_STATE_INVALID,message:R.Errors[R.Errors.E_SYMBOL_STATE_INVALID],reason:""+h.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0}})})},e.prototype.__writeSymbolTypeInternal=function(s,l,c){var _=this,u=this.__expression.getName(),d=this.__expression.getPath(),m=this.__expression.getPathTokens();try{this.resolveSchema(function(e){if(e.error===R.Errors.NONE){var n=_.__schema,i=tchmi_clone_object(s),r=[];if(m&&0<m.length){if(l)for(var t=0,o=l.length;t<o;t++)r.push(d+l[t]);else r.push(d);b.Services.internalSymbolManager.read(u,function(e){if(e.error===R.Errors.NONE){var r=tchmi_clone_object(e.value),t=_.__readSubValue(r,m),o=R.ValueConverter.toSchemaType(i,n);tchmi_equal(t,o)?R.Callback.callSafe(c,this,{error:R.Errors.NONE}):(_.__writeSubValue(r,o,m),b.Services.internalSymbolManager.write(u,r,function(e){R.Callback.callSafe(c,_,{error:e.error})}))}else R.Callback.callSafe(c,_,{error:e.error})})}else{var a=R.ValueConverter.toSchemaType(i,n);b.Services.internalSymbolManager.write(u,a,function(e){R.Callback.callSafe(c,_,{error:e.error})})}}else R.Callback.callSafe(c,_,{error:R.Errors.E_SYMBOL_RESOLVE_SCHEMA,details:{code:R.Errors.E_SYMBOL_RESOLVE_SCHEMA,message:R.Errors[R.Errors.E_SYMBOL_RESOLVE_SCHEMA],reason:""+_.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0}})})}catch(e){return R.Log.error(e),void R.Callback.callSafe(c,_,{error:R.Errors.E_EXCEPTION,details:{code:R.Errors.E_EXCEPTION,message:R.Errors[R.Errors.E_EXCEPTION],reason:_.__expression.toString()+': Exception: "'+e+'"',domain:"TcHmi.System.Symbol"}})}},e.prototype.__writeSymbolTypeControl=function(l,c,_){var u=this,e=this.__expression.getName(),d=this.__expression.getPath(),m=tchmi_clone_object(this.__expression.getPathTokens()),h=R.Controls.get(e);if(h)if(null!==m){var r=null;m&&0<m.length&&(r=m.shift());var g=R.System.Services.controlManager.getAttributeByPropertyName(h,r);if(null!=g)if(g.readOnly)R.Callback.callSafe(_,u,{error:R.Errors.E_SYMBOL_READONLY});else try{this.resolveSchema(function(e){if(e.error===R.Errors.NONE){var r=u.__schema,t=tchmi_clone_object(l),o=tchmi_clone_object(h[g.propertyGetterName].call(h));if(m&&0<m.length){var n=[];if(c)for(var i=0,a=c.length;i<a;i++)n.push(d+c[i]);else n.push(d);return tchmi_equal(u.__readSubValue(o,m),s=R.ValueConverter.toSchemaType(t,r))?void R.Callback.callSafe(_,this,{error:R.Errors.NONE}):(u.__writeSubValue(o,s,m),R.System.Services.controlManager.setControlPropertyByAttribute(h,g,o,n),void R.Callback.callSafe(_,u,{error:R.Errors.NONE}))}if(!tchmi_equal(o,t)){var s=R.ValueConverter.toSchemaType(t,r);return R.System.Services.controlManager.setControlPropertyByAttribute(h,g,tchmi_clone_object(s)),void R.Callback.callSafe(_,u,{error:R.Errors.NONE})}R.Callback.callSafe(_,this,{error:R.Errors.NONE})}else R.Callback.callSafe(_,u,{error:R.Errors.E_SYMBOL_RESOLVE_SCHEMA,details:{code:R.Errors.E_SYMBOL_RESOLVE_SCHEMA,message:R.Errors[R.Errors.E_SYMBOL_RESOLVE_SCHEMA],reason:""+u.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0}})})}catch(e){return R.Log.error(e),void R.Callback.callSafe(_,u,{error:R.Errors.E_EXCEPTION,details:{code:R.Errors.E_EXCEPTION,message:R.Errors[R.Errors.E_EXCEPTION],reason:u.__expression.toString()+': Exception: "'+e+'"',domain:"TcHmi.System.Symbol"}})}else R.Callback.callSafe(_,u,{error:R.Errors.E_CONTROL_ATTRIBUTE_NOT_FOUND})}else R.Callback.callSafe(_,u,{error:R.Errors.E_NOT_ALLOWED});else R.Callback.callSafe(_,u,{error:R.Errors.E_CONTROL_INSTANCE_NOT_FOUND})},e.prototype.__writeSymbolTypePartialParam=function(l,c,_){var u=this,e=this.__expression.getName().split("."),r=e.pop(),t=e.join("."),d=this.__expression.getPath(),m=this.__expression.getPathTokens(),h=R.Controls.get(t);if(h){var g=R.System.Services.controlManager.getAttributeByPropertyName(h,r);if(null!=g)try{this.resolveSchema(function(e){if(e.error===R.Errors.NONE){var r=u.__schema,t=tchmi_clone_object(l),o=tchmi_clone_object(tchmi_clone_object(h[g.propertyGetterName].call(h)));if(m&&0<m.length){var n,i=[];if(c)for(var a=0,s=c.length;a<s;a++)i.push(d+c[a]);else i.push(d);return tchmi_equal(u.__readSubValue(o,m),n=R.ValueConverter.toSchemaType(t,r))?void R.Callback.callSafe(_,this,{error:R.Errors.NONE}):(u.__writeSubValue(o,n,m),R.System.Services.controlManager.setControlPropertyByAttribute(h,g,o,i),void R.Callback.callSafe(_,u,{error:R.Errors.NONE}))}return tchmi_equal(o,n=R.ValueConverter.toSchemaType(t,r))?void R.Callback.callSafe(_,this,{error:R.Errors.NONE}):(R.System.Services.controlManager.setControlPropertyByAttribute(h,g,n),void R.Callback.callSafe(_,u,{error:R.Errors.NONE}))}R.Callback.callSafe(_,u,{error:R.Errors.E_SYMBOL_RESOLVE_SCHEMA,details:{code:R.Errors.E_SYMBOL_RESOLVE_SCHEMA,message:R.Errors[R.Errors.E_SYMBOL_RESOLVE_SCHEMA],reason:""+u.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0}})})}catch(e){return R.Log.error(e),void R.Callback.callSafe(_,u,{error:R.Errors.E_EXCEPTION,details:{code:R.Errors.E_EXCEPTION,message:R.Errors[R.Errors.E_EXCEPTION],reason:u.__expression.toString()+': Exception: "'+e+'"',domain:"TcHmi.System.Symbol"}})}else R.Callback.callSafe(_,u,{error:R.Errors.E_CONTROL_ATTRIBUTE_NOT_FOUND})}else R.Callback.callSafe(_,u,{error:R.Errors.E_CONTROL_INSTANCE_NOT_FOUND})},e.prototype.__writeSymbolTypeTemplateParam=function(l,c,_){var u=this,e=this.__expression.getName(),d=this.__expression.getPath(),m=this.__expression.getPathTokens(),h=b.Services.templateParamSymbolManager.get(e);try{if(h.value instanceof R.SymbolExpression){var r=h.value,t=r.getTag(),o=r.getName(),n=r.getPath(),i="%"+t+"%"+o;null!==n&&(i+=n),m&&0<m.length&&(i+=d),i+="%/"+t+"%";var a=new R.System.Symbol(i);a.writeEx(l,c,function(e){e.error===R.Errors.NONE?R.Callback.callSafe(_,u,{error:R.Errors.NONE}):R.Callback.callSafe(_,u,{error:e.error}),a.destroy(),a=null})}else this.resolveSchema(function(e){if(e.error===R.Errors.NONE){var r=u.__schema,t=tchmi_clone_object(l),o=tchmi_clone_object(tchmi_clone_object(h.value));if(m&&0<m.length){var n,i=[];if(c)for(var a=0,s=c.length;a<s;a++)i.push(d+c[a]);else i.push(d);return tchmi_equal(u.__readSubValue(o,m),n=R.ValueConverter.toSchemaType(t,r))?void R.Callback.callSafe(_,this,{error:R.Errors.NONE}):(u.__writeSubValue(o,n,m),h.value=o,R.Callback.callSafeArray(h.callbacks,u,{error:R.Errors.NONE,value:tchmi_clone_object(h.value),dirtyPaths:i}),void R.Callback.callSafe(_,u,{error:R.Errors.NONE}))}return tchmi_equal(o,n=R.ValueConverter.toSchemaType(t,r))?void R.Callback.callSafe(_,this,{error:R.Errors.NONE}):(h.value=n,R.Callback.callSafeArray(h.callbacks,u,{error:R.Errors.NONE,value:tchmi_clone_object(h.value)}),void R.Callback.callSafe(_,u,{error:R.Errors.NONE}))}R.Callback.callSafe(_,u,{error:R.Errors.E_SYMBOL_RESOLVE_SCHEMA,details:{code:R.Errors.E_SYMBOL_RESOLVE_SCHEMA,message:R.Errors[R.Errors.E_SYMBOL_RESOLVE_SCHEMA],reason:""+u.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0}})})}catch(e){return R.Log.error(e),void R.Callback.callSafe(_,u,{error:R.Errors.E_EXCEPTION,details:{code:R.Errors.E_EXCEPTION,message:R.Errors[R.Errors.E_EXCEPTION],reason:u.__expression.toString()+': Exception: "'+e+'"',domain:"TcHmi.System.Symbol"}})}},e.prototype.watch=function(s){R.Log.debug("[Source=Framework, Module=TcHmi.System.Symbol, Expression="+this.__expression.toString()+"] Watching...");var o,r,t,l=this,n=null,i=this.__expression.getType(),c=function(){switch(R.Log.debug("[Source=Framework, Module=TcHmi.System.Symbol, Expression="+l.__expression.toString()+"] Unwatching..."),i){case R.SymbolType.Server:case R.SymbolType.Internal:case R.SymbolType.LocalizedText:o&&(o(),o=null);break;case R.SymbolType.Function:o&&(o(),o=null),r&&(r.destroy(),r=null);break;case R.SymbolType.Control:case R.SymbolType.PartialParam:null!==n&&(n(),n=null);break;case R.SymbolType.TemplateParam:var e=l.__expression.getName();b.Services.templateParamSymbolManager.get(e).value instanceof R.SymbolExpression&&(b.Services.templateParamSymbolManager.keepAlive(e)||b.Services.templateParamSymbolManager.remove(e)),o&&(o(),o=null),t&&(t.destroy(),t=null);break;default:R.Callback.callSafe(s,l,{error:R.Errors.E_NOT_SUPPORTED,details:{code:R.Errors.E_NOT_SUPPORTED,message:R.Errors[R.Errors.E_NOT_SUPPORTED],reason:""+l.__expression.toString(),domain:"TcHmi.System.Symbol"}})}};if(i===R.SymbolType.Server)o=R.System.Services.serverManager.watch(this.__expression,function(e){o||(o=e.destroy),e.error===R.Errors.NONE?R.Callback.callSafe(s,l,{error:R.Errors.NONE,value:e.value,destroy:c}):R.Callback.callSafe(s,l,{error:e.error,details:{code:e.error,message:R.Errors[e.error],reason:""+l.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0},destroy:c})});else if(i===R.SymbolType.Internal)o=R.System.Services.internalSymbolManager.watch(this.__expression.getName(),function(e){if(o||(o=e.destroy),e.error!==R.Errors.NONE)R.Callback.callSafe(s,l,{error:e.error,details:{code:e.error,message:R.Errors[e.error],reason:""+l.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0},destroy:c});else{var r=l.__expression.getPathTokens();if(r&&0<r.length){var t=l.__readSubValue(e.value,r);return void R.Callback.callSafe(s,l,{error:R.Errors.NONE,value:tchmi_clone_object(t),destroy:c})}R.Callback.callSafe(s,l,{error:R.Errors.NONE,value:tchmi_clone_object(e.value),destroy:c})}});else if(i===R.SymbolType.LocalizedText)o=R.System.Services.localizationManager.watch(this.__expression.getName(),function(e){if(o||(o=e.destroy),e.error!==R.Errors.NONE)R.Callback.callSafe(s,l,{error:e.error,destroy:c});else{if(e.error===R.Errors.NONE){var r=l.__expression.getPathTokens();return r&&0<r.length?void R.Callback.callSafe(s,l,{error:R.Errors.E_NOT_SUPPORTED,details:{code:R.Errors.E_NOT_SUPPORTED,message:R.Errors[R.Errors.E_NOT_SUPPORTED],reason:l.__expression.toString()+': Reading by path is not supported on symbols of type "LocalizedText".',domain:"TcHmi.System.Symbol"},destroy:c}):void R.Callback.callSafe(s,l,{error:R.Errors.NONE,value:tchmi_clone_object(e.value),destroy:c})}R.Callback.callSafe(s,l,{error:e.error,details:{code:e.error,message:R.Errors[e.error],reason:""+l.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0},destroy:c})}});else if(i===R.SymbolType.Function)r=new R.System.FunctionExpression(this.__expression.getContent(),!0),o=r.watch(function(e){if(o||(o=e.destroy),e.error===R.Errors.NONE){var r=l.__expression.getPathTokens();return r&&0<r.length?void R.Callback.callSafe(s,l,{error:R.Errors.E_NOT_SUPPORTED,details:{code:R.Errors.E_NOT_SUPPORTED,message:R.Errors[R.Errors.E_NOT_SUPPORTED],reason:l.__expression.toString()+': Reading by path is not supported on symbols of type "Function".',domain:"TcHmi.System.Symbol"},destroy:c}):void R.Callback.callSafe(s,l,{error:R.Errors.NONE,value:tchmi_clone_object(e.value),destroy:c})}R.Callback.callSafe(s,l,{error:e.error,details:{code:e.error,message:R.Errors[e.error],reason:""+l.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0},destroy:c})});else if(i===R.SymbolType.Control){var e=l.__expression.getName();if(!e)return R.Callback.callSafe(s,l,{error:R.Errors.E_INVALID,details:{code:R.Errors.E_INVALID,message:R.Errors[R.Errors.E_INVALID],reason:l.__expression.toString()+", Expression does not contain a valid name token.",domain:"TcHmi.System.Symbol"},destroy:c}),c;var a=l.__expression.getPathTokens(),_=R.Controls.get(e);if(!_)return R.Callback.callSafe(s,l,{error:R.Errors.E_CONTROL_INSTANCE_NOT_FOUND,details:{code:R.Errors.E_CONTROL_INSTANCE_NOT_FOUND,message:R.Errors[R.Errors.E_CONTROL_INSTANCE_NOT_FOUND],reason:l.__expression.toString()+": Can't find control instance with name: "+e,domain:"TcHmi.System.Symbol"},destroy:c}),c;var u=null;if(a&&0<a.length&&(u=a[0]),u){var d=R.System.Services.controlManager.getAttributeByPropertyName(_,u);if(!d)return R.Callback.callSafe(s,l,{error:R.Errors.E_CONTROL_ATTRIBUTE_NOT_FOUND,details:{code:R.Errors.E_CONTROL_ATTRIBUTE_NOT_FOUND,message:R.Errors[R.Errors.E_CONTROL_ATTRIBUTE_NOT_FOUND],reason:l.__expression.toString()+", Can't find attribute definition for property: "+u+" of control: "+e+" of type: "+_.getType()+".",domain:"TcHmi.System.Symbol"},destroy:c}),c;if(!d.propertyGetterName)return R.Callback.callSafe(s,l,{error:R.Errors.E_CONTROL_ATTRIBUTE_INVALID_CONFIGURATION,details:{code:R.Errors.E_CONTROL_ATTRIBUTE_INVALID_CONFIGURATION,message:R.Errors[R.Errors.E_CONTROL_ATTRIBUTE_INVALID_CONFIGURATION],reason:l.__expression.toString()+', Can\'t find valid "propertyGetterName" in attribute definition for property: '+u+" of control: "+e+" of type: "+_.getType()+". Please check Description.json.",domain:"TcHmi.System.Symbol"},destroy:c}),c;n=R.EventProvider.register(e+".onFunctionResultChanged",function(e,r,t){if(r){var o,n=!1;if(t){for(i=0,a=t.length;i<a;i++)if(t[i].propertyName===d.propertyName){o=t[i].dirtyPaths,n=!0;break}}else for(var i=0,a=r.length;i<a;i++)if(r[i]===d.propertyGetterName){n=!0;break}n&&l.read(function(e){return e.error===R.Errors.NONE?void(o?R.Callback.callSafe(s,l,{error:R.Errors.NONE,value:tchmi_clone_object(e.value),dirtyPaths:o,destroy:c}):R.Callback.callSafe(s,l,{error:R.Errors.NONE,value:tchmi_clone_object(e.value),destroy:c})):void R.Callback.callSafe(s,l,{error:R.Errors.ERROR,details:{code:R.Errors.ERROR,message:R.Errors[R.Errors.ERROR],reason:""+l.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0},destroy:c})})}})}this.read(function(e){return e.error===R.Errors.NONE?void R.Callback.callSafe(s,l,{error:R.Errors.NONE,value:tchmi_clone_object(e.value),destroy:c}):void R.Callback.callSafe(s,l,{error:R.Errors.ERROR,details:{code:R.Errors.ERROR,message:R.Errors[R.Errors.ERROR],reason:""+l.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0},destroy:c})})}else if(i===R.SymbolType.PartialParam){var m=this.__expression.getName().split("."),h=(u=m.pop(),m.join("."));if(!h)return R.Callback.callSafe(s,l,{error:R.Errors.ERROR,details:{code:R.Errors.ERROR,message:R.Errors[R.Errors.ERROR],reason:""+l.__expression.toString(),domain:"TcHmi.System.Symbol"},destroy:c}),c;var g=R.Controls.get(h);if(!g)return R.Callback.callSafe(s,l,{error:R.Errors.ERROR,details:{code:R.Errors.ERROR,message:R.Errors[R.Errors.ERROR],reason:""+l.__expression.toString(),domain:"TcHmi.System.Symbol"},destroy:c}),c;var p=R.System.Services.controlManager.getAttributeByPropertyName(g,u);if(!p)return R.Callback.callSafe(s,l,{error:R.Errors.ERROR,details:{code:R.Errors.ERROR,message:R.Errors[R.Errors.ERROR],reason:""+l.__expression.toString(),destroy:c}}),c;if(!p.propertyGetterName)return R.Callback.callSafe(s,l,{error:R.Errors.ERROR,details:{code:R.Errors.ERROR,message:R.Errors[R.Errors.ERROR],reason:""+l.__expression.toString(),destroy:c}}),c;n=R.EventProvider.register(h+".onFunctionResultChanged",function(e,r,t){if(r){var o,n=!1;if(t){for(i=0,a=t.length;i<a;i++)if(t[i].propertyName===p.propertyName){o=t[i].dirtyPaths,n=!0;break}}else for(var i=0,a=r.length;i<a;i++)if(r[i]===p.propertyGetterName){n=!0;break}n&&l.read(function(e){return e.error===R.Errors.NONE?void(o?R.Callback.callSafe(s,l,{error:R.Errors.NONE,value:tchmi_clone_object(e.value),dirtyPaths:o,destroy:c}):R.Callback.callSafe(s,l,{error:R.Errors.NONE,value:tchmi_clone_object(e.value),destroy:c})):void R.Callback.callSafe(s,l,{error:e.error,details:{code:e.error,message:R.Errors[e.error],reason:""+l.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0},destroy:c})})}}),this.read(function(e){e.error===R.Errors.NONE?R.Callback.callSafe(s,l,{error:R.Errors.NONE,value:tchmi_clone_object(e.value),destroy:c}):R.Callback.callSafe(s,l,{error:e.error,details:{code:R.Errors.ERROR,message:R.Errors[R.Errors.ERROR],reason:""+l.__expression.toString(),domain:"TcHmi.System.Symbol",errors:[e.details]},destroy:c})})}else if(i===R.SymbolType.TemplateParam){var E=this.__expression.getName(),f=this.__expression.getPath(),S=(a=this.__expression.getPathTokens(),b.Services.templateParamSymbolManager.get(E));if(S.value instanceof R.SymbolExpression){S.callbacks.push(s);var y=S.value,v=y.getTag(),C=y.getName(),T=y.getPath(),M="%"+v+"%"+C;null!==T&&(M+=T),a&&0<a.length&&(M+=f),M+="%/"+v+"%",t=new R.System.Symbol(M),o=t.watch(function(e){o||(o=e.destroy),e.error===R.Errors.NONE?R.Callback.callSafe(s,l,{error:R.Errors.NONE,value:tchmi_clone_object(e.value),destroy:c}):R.Callback.callSafe(s,l,{error:e.error,details:{code:e.error,message:R.Errors[e.error],reason:""+l.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0},destroy:c})}),this.read(function(e){e.error===R.Errors.NONE?R.Callback.callSafe(s,l,{error:R.Errors.NONE,value:tchmi_clone_object(e.value),destroy:c}):R.Callback.callSafe(s,l,{error:e.error,details:{code:e.error,message:R.Errors[e.error],reason:""+l.__expression.toString(),domain:"TcHmi.System.Symbol",errors:e.details?[e.details]:void 0},destroy:c})})}else R.Callback.callSafe(s,l,{error:R.Errors.E_SYMBOL_INVALID_DATA_PROVIDER_ENTRY,details:{code:R.Errors.E_SYMBOL_INVALID_DATA_PROVIDER_ENTRY,message:R.Errors[R.Errors.E_SYMBOL_INVALID_DATA_PROVIDER_ENTRY],reason:""+l.__expression.toString(),domain:"TcHmi.System.Symbol"},destroy:c})}else R.Callback.callSafe(s,l,{error:R.Errors.E_NOT_SUPPORTED,details:{code:R.Errors.E_NOT_SUPPORTED,message:R.Errors[R.Errors.E_NOT_SUPPORTED],reason:l.__expression.toString()+", SymbolType: "+i+" does not support watching.",domain:"TcHmi.System.Symbol"},destroy:c});return c},e.isServerSymbol=function(e){return!!e.getExpression()&&e.getExpression().getType()===R.SymbolType.Server},e.isInternalSymbol=function(e){return!!e.getExpression()&&e.getExpression().getType()===R.SymbolType.Internal},e.isLocalizedTextSymbol=function(e){return!!e.getExpression()&&e.getExpression().getType()===R.SymbolType.LocalizedText},e.isPartialParamSymbol=function(e){return!!e.getExpression()&&e.getExpression().getType()===R.SymbolType.PartialParam},e.isTemplateParamSymbol=function(e){return!!e.getExpression()&&e.getExpression().getType()===R.SymbolType.TemplateParam},e.isFunctionSymbol=function(e){return!!e.getExpression()&&e.getExpression().getType()===R.SymbolType.Function},e.isControlSymbol=function(e){return!!e.getExpression()&&e.getExpression().getType()===R.SymbolType.Control},e}();b.Symbol=r}(R.System||(R.System={}))}(TcHmi||(TcHmi={})),function(n){var e,r;e=n.System||(n.System={}),r=function(){function e(e){var t=this;this.__functions={},this.__functionsDescription={};var o=n.EventProvider.register("System.onInitializedServices",function(){o();for(var e=0;e<n.System.Caches.registeredFrameworkFunctionDescription.length;e++){var r=n.System.Caches.registeredFrameworkFunctionDescription[e];t.registerFunction(r.name,r.func)}})}return e.prototype.registerFunction=function(e,r){this.__functions[e]&&n.Log.error("[Source=Framework, Module=TcHmi.System.FunctionProvider] Multiple register of hmi functions with the name "+e+" detected."),this.__functions[e]=r},e.prototype.addDescription=function(e,r){null!=r&&void 0!==r.function&&null!==r.function&&(this.__functionsDescription[r.function.name]=r)},e.prototype.isFunctionRegistered=function(e){return void 0!==this.__functions[e]&&null!==this.__functions[e]},e.prototype.getFunction=function(e){return this.__functions[e]},e.prototype.getFunctionDescription=function(e){return this.__functionsDescription[e]},e}(),e.FunctionProvider=r}(TcHmi||(TcHmi={})),function(p){var e,r,t;e=p.System||(p.System={}),r=e.Parser||(e.Parser={}),t=function(){function e(e){this.__text=null,this.__text=e}return e.prototype.loadText=function(e){this.__text=e},e.prototype.__parseExpressionFromString=function(e,r,t){for(var o=r.length,n=e.length,i=0;i<=n;i++)if("%"===e[i]){var a="";if(i+o+2<=n&&(a=e.substr(i,o+2)),a==="%"+r+"%")for(var s=0,l=0,c=e.substr(i+a.length,n-(i+a.length)),_=n-(i+a.length),u=0;u<=_;u++)if("%"===c[u]){var d="";u+o+2<=_&&(d=c.substr(u,o+2));var m="";if(u+o+3<=_&&(m=c.substr(u,o+3)),m==="%/"+r+"%"){if(l===s){var h=e.substr(i,a.length+m.length+u),g=new p.SymbolExpression(h);null!==g&&t.push(g);break}l++}else d==="%"+r+"%"&&s++}}return t},e.prototype.resolveExpressionsBySymbolType=function(e){var r=[],t=null;switch(e){case p.SymbolType.Internal:t="i";break;case p.SymbolType.Server:t="s";break;case p.SymbolType.LocalizedText:t="l";break;case p.SymbolType.PartialParam:t="pp";break;case p.SymbolType.TemplateParam:t="tp";break;case p.SymbolType.Control:t="ctrl";break;case p.SymbolType.Function:t="f";break;default:return r}return null===t||null===this.__text||""===this.__text||(r=this.__parseExpressionFromString(this.__text,t,r)).sort(function(e,r){return e.toString().length>r.toString().length?-1:e.toString().length<r.toString().length?1:0}),r},e.prototype.resolveExpressions=function(){var e=[];if(null===this.__text||0===this.__text.length)return e;for(var r=["i","s","l","pp","tp","ctrl","f"],t=0,o=r.length;t<o;t++)e=this.__parseExpressionFromString(this.__text,r[t],e);return e.sort(function(e,r){return e.toString().length>r.toString().length?-1:e.toString().length<r.toString().length?1:0}),e},e}(),r.SymbolExpressionParser=t}(TcHmi||(TcHmi={})),function(l){!function(e){var o,r;(r=o=e.ScaleMode||(e.ScaleMode={}))[r.None=0]="None",r[r.ScaleToFit=1]="ScaleToFit",r[r.ScaleToFitWidth=2]="ScaleToFitWidth",r[r.ScaleToFitHeight=3]="ScaleToFitHeight",r[r.ScaleToFill=4]="ScaleToFill";var t=function(){function e(e){this.__scaleMode=o.None,this.__view=null,this.__viewUrl=null,this.__onViewResizedEventDestroyEvent=null,this.__onViewDestroyedEventDestroyEvent=null,this.__pending=!1,window.addEventListener("resize",this.__onWindowResized())}return e.prototype.__onWindowResized=function(){var e=this;return function(){e.__scale()}},e.prototype.__onViewDestroyed=function(){var t=this;return function(e,r){t.__view===r&&(l.System.SharedResources.jqBody.children().detach(),null!==t.__onViewResizedEventDestroyEvent&&(t.__onViewResizedEventDestroyEvent(),t.__onViewResizedEventDestroyEvent=null),null!==t.__onViewDestroyedEventDestroyEvent&&(t.__onViewDestroyedEventDestroyEvent(),t.__onViewDestroyedEventDestroyEvent=null),t.__view=null,t.__viewUrl=null)}},e.prototype.__onViewResized=function(){var t=this;return function(e,r){t.__scaleMode!==o.None&&t.__scale(),l.EventProvider.raise("System.onViewResized",r)}},e.prototype.__scale=function(){if(!0!==TCHMI_ENABLE_DESIGNER_MODE_MASTER&&void 0!==this.__view&&null!==this.__view)switch(this.__scaleMode){case o.ScaleToFit:var e=l.System.SharedResources.jqBody.width()/this.__view.__element.width(),r=(t=l.System.SharedResources.jqBody.height()/this.__view.__element.height())<e?t:e;l.StyleProvider.setSimpleElementStyle(this.__view.__element,{"-webkit-transform":"scale("+r+")",transform:"scale("+r+")","-webkit-transform-origin":"0 0","transform-origin":"0 0"});break;case o.ScaleToFitWidth:r=l.System.SharedResources.jqBody.width()/this.__view.__element.width();l.StyleProvider.setSimpleElementStyle(this.__view.__element,{"-webkit-transform":"scale("+r+")",transform:"scale("+r+")","-webkit-transform-origin":"0 0","transform-origin":"0 0"});break;case o.ScaleToFitHeight:r=l.System.SharedResources.jqBody.height()/this.__view.__element.height();l.StyleProvider.setSimpleElementStyle(this.__view.__element,{"-webkit-transform":"scale("+r+")",transform:"scale("+r+")","-webkit-transform-origin":"0 0","transform-origin":"0 0"});break;case o.ScaleToFill:e=l.System.SharedResources.jqBody.width()/this.__view.__element.width();var t=l.System.SharedResources.jqBody.height()/this.__view.__element.height();l.StyleProvider.setSimpleElementStyle(this.__view.__element,{"-webkit-transform":"scale("+e+","+t+")",transform:"scale("+e+","+t+")","-webkit-transform-origin":"0 0","transform-origin":"0 0"});break;case o.None:l.StyleProvider.setSimpleElementStyle(this.__view.__element,{"-webkit-transform":"",transform:"","-webkit-transform-origin":"","transform-origin":""})}},e.prototype.setScaleMode=function(e){var r=l.System.ScaleMode.None;switch(e){case"ScaleToFit":r=l.System.ScaleMode.ScaleToFit;break;case"ScaleToFitWidth":r=l.System.ScaleMode.ScaleToFitWidth;break;case"ScaleToFitHeight":r=l.System.ScaleMode.ScaleToFitHeight;break;case"ScaleToFill":r=l.System.ScaleMode.ScaleToFill}this.__scaleMode=r,this.__scale()},e.prototype.getView=function(){return this.__view},e.prototype.loadView=function(e,i){if(void 0===i&&(i=null),!0!==this.__pending){var r=tchmi_path(e);if(this.__viewUrl!==r){this.__pending=!0,void 0!==this.__view&&null!==this.__view&&(l.System.SharedResources.jqBody.children().detach(),null!==this.__onViewResizedEventDestroyEvent&&(this.__onViewResizedEventDestroyEvent(),this.__onViewResizedEventDestroyEvent=null),null!==this.__onViewDestroyedEventDestroyEvent&&(this.__onViewDestroyedEventDestroyEvent(),this.__onViewDestroyedEventDestroyEvent=null),this.__view.destroy(),this.__view=null,this.__viewUrl=null);var a=this,t=function(e,r){var t=$(r),o=t.attr("id"),n=l.control[o];if(null==n&&(n=e===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL?l.System.Services.controlManager.compile(t.attr("data-tchmi-partial-url",e).attr("data-tchmi-creator-partial-key",TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL)):l.System.Services.controlManager.compile(t.attr("data-tchmi-partial-url",e))),null==n)return a.__pending=!1,void("function"==typeof i&&i.call(a,{error:l.Errors.ERROR}));a.__view=n,a.__viewUrl=e,a.__onViewResizedEventDestroyEvent=l.EventProvider.register(a.__view.__id+".onResized",a.__onViewResized()),a.__onViewDestroyedEventDestroyEvent=l.EventProvider.register(a.__view.__id+".onDestroyed",a.__onViewDestroyed()),"__TcHmiMain"===l.System.Services.dialogManager.getDialogOwner()&&l.System.Services.dialogManager.showDialog("__TcHmiMain",!1),null===l.System.Services.dialogManager.getDialogOwner()||"function"!=typeof i?(l.System.SharedResources.jqBody.children().detach(),!0===TCHMI_ENABLE_DESIGNER_MODE&&!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER?l.System.SharedResources.jqBody.append(l.System.Services.Engineering.designerModeManager.rootControlManager.getViewPortSimulator().empty().append(a.__view.__element)):l.System.SharedResources.jqBody.append(a.__view.__element),a.__scale(),a.__pending=!1,"function"==typeof i&&i.call(a,{error:l.Errors.NONE})):i.call(a,{error:l.Errors.ERROR})},o=l.System.Caches.partialMarkupCache[r];if(null!=o)t(r,o),o=null;else{var n=new XMLHttpRequest;n.open("GET",r+(TCHMI_ENABLE_DESIGNER_MODE?"?preventcache="+Math.random():""));var s=function(e){a.__pending=!1,l.Log.error("[Source=Framework, Module=TcHmi.System.ViewManager] Loading "+r+" failed! Errordetail: "+n.statusText),"function"==typeof i&&i.call(a,{error:l.Errors.ERROR})};n.addEventListener("load",function(e){200===n.status?t(r,n.responseText):s(e)}),n.addEventListener("error",s),n.send()}}else"function"==typeof i&&i.call(this,{error:l.Errors.NONE})}else"function"==typeof i&&i.call(this,{error:l.Errors.ERROR})},e.prototype.loadViewObject=function(e,r){void 0===r&&(r=null),!0!==this.__pending?(this.__pending=!0,void 0!==this.__view&&null!==this.__view&&(l.System.SharedResources.jqBody.children().detach(),null!==this.__onViewResizedEventDestroyEvent&&(this.__onViewResizedEventDestroyEvent(),this.__onViewResizedEventDestroyEvent=null),null!==this.__onViewDestroyedEventDestroyEvent&&(this.__onViewDestroyedEventDestroyEvent(),this.__onViewDestroyedEventDestroyEvent=null),this.__view.destroy(),this.__view=null,this.__viewUrl=null),this.__view=e,this.__viewUrl=null,this.__onViewResizedEventDestroyEvent=l.EventProvider.register(this.__view.__id+".onResized",this.__onViewResized()),this.__onViewDestroyedEventDestroyEvent=l.EventProvider.register(this.__view.__id+".onDestroyed",this.__onViewDestroyed()),l.System.SharedResources.jqBody.children().detach(),!0===TCHMI_ENABLE_DESIGNER_MODE&&!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER?l.System.SharedResources.jqBody.append(l.System.Services.Engineering.designerModeManager.rootControlManager.getViewPortSimulator().empty().append(this.__view.__element)):l.System.SharedResources.jqBody.append(this.__view.__element),this.__scale(),this.__pending=!1,"function"==typeof r&&r.call(this,{error:l.Errors.NONE})):"function"==typeof r&&r.call(this,{error:l.Errors.ERROR})},e}();e.ViewManager=t}(l.System||(l.System={}))}(TcHmi||(TcHmi={})),function(w){var _,e;_=w.System||(w.System={}),e=function(){function e(e){var l=this;this.__activeThemes="Base",this.__registered_themedValueFiles_fromControl={},this.__registered_styleCheets_fromControl={},this.__control_defaultValueInternal={},this.__usercontrol_defaultValueInternal={},this.resolveUserControlDefaultValueInternal=function(){for(var e in l.__usercontrol_defaultValueInternal={},w.System.Caches.partialCompositeConfigCache){var r=w.System.Caches.partialCompositeConfigCache[e];if(r&&r.parameters){var t=e.replace(".json","");l.__usercontrol_defaultValueInternal[t]={};for(var o=r.parameters,n=0,i=o.length;n<i;n++)l.__usercontrol_defaultValueInternal[t][o[n].propertyName]=o[n].defaultValueInternal}}l.__triggerAllControlsWithImplicitValues()},this.__watchAttributeDefaults={},this.__destroyFunctionResultChanged={},this.__settingThemeValueInProgess=!1,this.__onControlDestroyed=function(e,r){var t=r.getId();void 0!==l.__watchAttributeDefaults[t]&&(delete l.__watchAttributeDefaults[t],l.__destroyFunctionResultChanged[t]&&(l.__destroyFunctionResultChanged[t](),delete l.__destroyFunctionResultChanged[t]))},this.__onControlClassNamesChanged=function(e,r){if(l.__project_themeFiles[l.__activeThemes]){if(r.oldClassNames)for(var t=0,o=r.oldClassNames;t<o.length;t++){var n=o[t];if(l.__project_themeFiles[l.__activeThemes].controlClassValues&&l.__project_themeFiles[l.__activeThemes].controlClassValues[n])return void l.__triggerAllControlsWithImplicitValues()}for(var i=0,a=r.newClassName;i<a.length;i++){var s=a[i];if(l.__project_themeFiles[l.__activeThemes].controlClassValues&&l.__project_themeFiles[l.__activeThemes].controlClassValues[s])return void l.__triggerAllControlsWithImplicitValues()}}},w.EventProvider.register("System.onControlDestroyed",this.__onControlDestroyed),w.EventProvider.register("System.onControlClassNamesChanged",this.__onControlClassNamesChanged),w.EventProvider.register("System.onPartialCompositeConfigCreated",this.resolveUserControlDefaultValueInternal),w.EventProvider.register("System.onPartialCompositeConfigChanged",this.resolveUserControlDefaultValueInternal),w.EventProvider.register("System.onPartialCompositeConfigRemoved",this.resolveUserControlDefaultValueInternal),this.__clearCaches(),w.System.config.themes||(w.System.config.themes={}),w.System.config.activeTheme&&this.setTheme(w.System.config.activeTheme,!1);var r=document.fonts;r&&r.addEventListener&&r.addEventListener("loadingdone",function(){w.Log.debug("[Source=Framework, Module=TcHmi.System.ThemeManager] System has loaded another font file. Triggering a onThemeDataChanged."),w.EventProvider.raise("onThemeDataChanged")})}return e.prototype.__clearCaches=function(){this.__control_themeFiles={},this.__project_themeFiles={}},e.prototype.getTheme=function(){return this.__activeThemes},e.prototype.setTheme=function(e,r){return"string"!=typeof e||""===e?w.Errors.E_PARAMETER_INVALID:(tchmi_equal(this.__activeThemes,e)||(this.__activeThemes=e,r&&this.processActiveTheme()),w.Errors.NONE)},e.prototype.registerControlThemeFiles=function(e){var r=e.name,t=e.themes;if(t)for(var o in t)for(var n=0;n<t[o].resources.length;n++){var i=t[o].resources[n];i.name?"ThemedValues"===i.type?(this.__registered_themedValueFiles_fromControl[o]||(this.__registered_themedValueFiles_fromControl[o]={}),this.__registered_themedValueFiles_fromControl[o][r]||(this.__registered_themedValueFiles_fromControl[o][r]=[]),this.__registered_themedValueFiles_fromControl[o][r].push(i)):"Stylesheet"===i.type&&(this.__registered_styleCheets_fromControl[o]||(this.__registered_styleCheets_fromControl[o]={}),this.__registered_styleCheets_fromControl[o][r]||(this.__registered_styleCheets_fromControl[o][r]=[]),this.__registered_styleCheets_fromControl[o][r].push(i)):(w.Log.warn("[Source=Framework, Module=TcHmi.System.ThemeManager] No file path found for theme entry  ("+o+") and control ("+r+") in Description.json:"),w.Log.warn(i))}},e.prototype.processActiveTheme=function(){var a=this,e=!1,r=0,s=function(e){--r<=0&&(w.Log.debug("[Source=Framework, Module=TcHmi.System.ThemeManager] System has loaded and parsed all async files. Triggering a control resize check and event onThemeDataChanged."),w.System.Services.controlManager.checkControlGeometry(),w.EventProvider.raise("onThemeDataChanged"))};for(var t in w.Engineering.ErrorPane.remove("ThemeManager_multipleThemes"),w.System.config.themes)if(this.__activeThemes===t)for(var o="",n=0;n<w.System.config.themes[t].resources.length;n++){if("Stylesheet"!==(v=w.System.config.themes[t].resources[n]).type)if("ThemedValues"===v.type)if(v.name){if(o){w.Engineering.ErrorPane.add("ThemeManager_multipleThemes","Only one ThemedValues entry per theme ("+t+") allowed in tchmiconfig.json. Only "+o+" will be used.",w.Engineering.ErrorPane.MessageType.Error);break}o=v.name,null!==this.__project_themeFiles[t]&&(void 0===this.__project_themeFiles[t]?(this.__project_themeFiles[t]=null,function(t,o){var n=new XMLHttpRequest;n.addEventListener("load",function(e){if(200!==n.status)delete a.__project_themeFiles[t],w.Log.warn("[Source=Framework, Module=TcHmi.System.ThemeManager] Loading "+o+" failed: "+n.statusText);else{var r=w.ValueConverter.toObject(n.responseText,null);null!==r?(a.__project_themeFiles[t]=r,a.__triggerAllControlsWithImplicitValues(),w.Log.debug("[Source=Framework, Module=TcHmi.System.ThemeManager] Fetched, parsed and triggered "+o)):(delete a.__project_themeFiles[t],w.Log.warn("[Source=Framework, Module=TcHmi.System.ThemeManager] Failed to parse "+o+". Change log verbosity to debug to get further information about the object."),w.Log.debug("[Source=Framework, Module=TcHmi.System.ThemeManager] "+n.responseText))}s()});var e=function(e){delete a.__project_themeFiles[t],0===n.status||w.Log.warn("Failed to load "+o),s()};n.addEventListener("error",e),n.addEventListener("abort",e),n.addEventListener("timeout",e),n.open("GET",tchmi_path(o)),n.send(),r++,w.Log.debug("[Source=Framework, Module=TcHmi.System.ThemeManager] Fetching "+o+" async.")}(t,v.name)):e=!0)}else w.Log.error("[Source=Framework, Module=TcHmi.System.ThemeManager] Entry missing name property in tchmiconfig.json. Change log verbosity to debug to get further information about the object."),w.Log.debug(v);else w.Log.error("[Source=Framework, Module=TcHmi.System.ThemeManager] Type value of entry invalid in tchmiconfig.json (has to be ThemedValues or Stylesheet). Change log verbosity to debug to get further information about the object."),w.Log.debug(v)}var i=[this.__activeThemes];for(var l in"Base"!==this.__activeThemes&&i.push("Base"),this.__registered_themedValueFiles_fromControl)if(-1!==i.indexOf(l))for(var c in this.__registered_themedValueFiles_fromControl[l])if(w.System.Caches.registeredControls[c]&&w.System.Caches.registeredControls[c].directory)for(var _=!1,u=0;u<this.__registered_themedValueFiles_fromControl[l][c].length;u++){var d=this.__registered_themedValueFiles_fromControl[l][c][u];if(void 0===this.__control_themeFiles[l]&&(this.__control_themeFiles[l]={}),_){w.Log.error("[Source=Framework, Module=TcHmi.System.ThemeManager] Only one ThemedValues entry per theme ("+l+") and control ("+c+") allowed in Description.json."),w.Log.debug(this.__registered_themedValueFiles_fromControl[l][c]);break}_=!0,null!==this.__control_themeFiles[l][c]&&(void 0===this.__control_themeFiles[l][c]?(this.__control_themeFiles[l][c]=null,function(t,o,n){var i=new XMLHttpRequest;i.addEventListener("load",function(e){if(200!==i.status)delete a.__control_themeFiles[t][o],w.Log.warn("[Source=Framework, Module=TcHmi.System.ThemeManager] Loading "+n+" failed: "+i.statusText);else{var r=w.ValueConverter.toObject(i.responseText);null!==r?(a.__control_themeFiles[t][o]=r,a.__triggerAllControlsWithImplicitValues(),w.Log.debug("[Source=Framework, Module=TcHmi.System.ThemeManager] Fetched, parsed and triggered "+n)):(delete a.__control_themeFiles[t][o],w.Log.warn("[Source=Framework, Module=TcHmi.System.ThemeManager] Failed to parse "+n+". Change log verbosity to debug to get further information about the object."),w.Log.debug("[Source=Framework, Module=TcHmi.System.ThemeManager] "+i.responseText))}s()});var e=function(e){delete a.__control_themeFiles[t][o],0===i.status||w.Log.warn("[Source=Framework, Module=TcHmi.System.ThemeManager] Failed to load "+n),s()};i.addEventListener("error",e),i.addEventListener("abort",e),i.addEventListener("timeout",e),i.open("GET",tchmi_path(w.System.config.basePath+"/Controls/"+w.System.Caches.registeredControls[o].directory+"/"+n)),i.send(),r++,w.Log.debug("[Source=Framework, Module=TcHmi.System.ThemeManager] Fetching "+n+" async.")}(l,c,d.name)):e=!0)}else w.Log.error("[Source=Framework, Module=TcHmi.System.ThemeManager] Did not find "+c+" in control type cache. Skipping...");for(var m=document.head.querySelectorAll("link[data-tchmi-from-theme]"),h=0;h<m.length;h++){(R=m[h]).parentElement.removeChild(R),w.Log.debug("[Source=Framework, Module=TcHmi.System.ThemeManager] Removing CSS styles from "+R.getAttribute("href")+".")}var g=[],p=function(e){if(w.System.Caches.registeredControls[e.controlType]&&w.System.Caches.registeredControls[e.controlType].directory){!function(e){if(!(w.System.config.themes&&w.System.config.themes[a.__activeThemes]&&w.System.config.themes[a.__activeThemes].replacesThemeForControls&&-1!==w.System.config.themes[a.__activeThemes].replacesThemeForControls.indexOf(e))){var r=[],t=a.__activeThemes;if(a.__registered_styleCheets_fromControl[a.__activeThemes]&&a.__registered_styleCheets_fromControl[a.__activeThemes][e])r=a.__registered_styleCheets_fromControl[a.__activeThemes][e];else{if(!a.__registered_styleCheets_fromControl.Base||!a.__registered_styleCheets_fromControl.Base[e])return;r=a.__registered_styleCheets_fromControl.Base[e],t="Base"}for(var o=0;o<r.length;o++)g.push({theme:t,url:tchmi_path(w.System.config.basePath+"/Controls/"+w.System.Caches.registeredControls[e].directory+"/"+r[o].name)})}}(e.controlType);for(var r=0;r<e.children.length;r++){var t=e.children[r];p(t)}}else w.Log.error("[Source=Framework, Module=TcHmi.System.ThemeManager] Did not find "+e.controlType+" in control type cache. Skipping...")},E=w.System.Services.controlManager.getInheritanceTree();if(E&&p(E),w.System.config.dependencyFiles)for(var f=0;f<w.System.config.dependencyFiles.length;f++){var S=w.System.config.dependencyFiles[f];"Stylesheet"===S.type&&g.push({theme:"theme-independent-project-file",url:tchmi_path(S.name)})}for(var y in w.System.config.themes)if(this.__activeThemes===y)for(n=0;n<w.System.config.themes[y].resources.length;n++){var v;"Stylesheet"===(v=w.System.config.themes[y].resources[n]).type&&(v.name?g.push({theme:y,url:tchmi_path(v.name)}):(w.Log.error("[Source=Framework, Module=TcHmi.System.ThemeManager] Entry missing name property in tchmiconfig.json. Change log verbosity to debug to get further information about the object."),w.Log.debug(v)))}for(var C=0;C<g.length;C++){var T=!0,M=g[C],b=document.head.getElementsByTagName("link");for(h=0;h<b.length;h++){var R;if(tchmi_path((R=b[h]).getAttribute("href"))===M.url){T=!1,R.dataset.tchmiFromTheme||(R.dataset.tchmiFromTheme=M.theme,w.Log.warn("[Source=Framework, Module=TcHmi.System.ThemeManager] CSS file "+M.url+" is already loaded. Adjusted include order.")),document.head.appendChild(R);break}}if(T){var N=document.createElement("link");N.rel="stylesheet",N.type="text/css",N.href=M.url,N.dataset.tchmiFromTheme=M.theme,N.addEventListener("load",s),N.addEventListener("error",s),document.head.appendChild(N),r++,w.Log.debug("[Source=Framework, Module=TcHmi.System.ThemeManager] Adding CSS styles from "+M.url+".")}}e&&this.__triggerAllControlsWithImplicitValues(),r<=0&&(w.Log.debug("[Source=Framework, Module=TcHmi.System.ThemeManager] System has loaded and parsed all sync files. Triggering a onThemeDataChanged."),w.EventProvider.raise("onThemeDataChanged"))},e.prototype.__triggerAllControlsWithImplicitValues=function(){for(var e in this.__watchAttributeDefaults){var r=this.__watchAttributeDefaults[e],t=w.Controls.get(e);if(t)for(var o in r)this.__settingThemeValueInProgess=!0,w.System.Services.controlManager.setControlProperty(t,o,null),this.__settingThemeValueInProgess=!1}},e.prototype.resolveDefaultValueInternal=function(){var e=_.Services.controlManager.getDescriptionCache();for(var r in e){var t=e[r];void 0===this.__control_defaultValueInternal[t.type]&&(this.__control_defaultValueInternal[t.type]={});for(var o=0,n=t.fullDescription.inheritedAttributes;o<n.length;o++){var i=n[o];void 0===this.__control_defaultValueInternal[t.type][i.propertyName]&&(this.__control_defaultValueInternal[t.type][i.propertyName]=i.defaultValueInternal)}}},e.prototype.getDefaultPropertyValue=function(e,r){var t=null,o=e.getClassNames();if(o&&0<o.length){for(var n=0,i=o;n<i.length;n++){var a=i[n];this.__project_themeFiles[this.__activeThemes]&&this.__project_themeFiles[this.__activeThemes].controlClassValues&&this.__project_themeFiles[this.__activeThemes].controlClassValues[a]&&void 0!==this.__project_themeFiles[this.__activeThemes].controlClassValues[a].attributes[r]&&null!==this.__project_themeFiles[this.__activeThemes].controlClassValues[a].attributes[r]&&(t=this.__project_themeFiles[this.__activeThemes].controlClassValues[a].attributes[r])}if(null!==t)return{error:w.Errors.NONE,origin:"project",originThemeName:this.__activeThemes,value:tchmi_clone_object(t)}}var s=e.getType();if(this.__project_themeFiles[this.__activeThemes]&&this.__project_themeFiles[this.__activeThemes].controlTypeValues&&this.__project_themeFiles[this.__activeThemes].controlTypeValues[s]&&void 0!==this.__project_themeFiles[this.__activeThemes].controlTypeValues[s].attributes[r]&&null!==this.__project_themeFiles[this.__activeThemes].controlTypeValues[s].attributes[r])return t=this.__project_themeFiles[this.__activeThemes].controlTypeValues[s].attributes[r],{error:w.Errors.NONE,origin:"project",originThemeName:this.__activeThemes,value:tchmi_clone_object(t)};if(w.System.config.themes&&w.System.config.themes[this.__activeThemes]&&w.System.config.themes[this.__activeThemes].replacesThemeForControls&&-1!==w.System.config.themes[this.__activeThemes].replacesThemeForControls.indexOf(s));else{var l=[this.__activeThemes];"Base"!==this.__activeThemes&&l.push("Base");for(var c=0,_=l;c<_.length;c++){var u=_[c];if(this.__control_themeFiles[u]&&this.__control_themeFiles[u][s]&&this.__control_themeFiles[u][s].controlTypeValues&&this.__control_themeFiles[u][s].controlTypeValues[s]&&this.__control_themeFiles[u][s].controlTypeValues[s].attributes&&void 0!==this.__control_themeFiles[u][s].controlTypeValues[s].attributes[r]&&null!==this.__control_themeFiles[u][s].controlTypeValues[s].attributes[r])return t=this.__control_themeFiles[u][s].controlTypeValues[s].attributes[r],{error:w.Errors.NONE,origin:"control",originThemeName:u,value:tchmi_clone_object(t)}}}if(this.__control_defaultValueInternal[s]&&void 0!==this.__control_defaultValueInternal[s][r])return t=this.__control_defaultValueInternal[s][r],{error:w.Errors.NONE,origin:"control",originThemeName:this.__activeThemes,value:tchmi_clone_object(t)};if("tchmi-user-control-host"===s){var d=e.getTargetUserControl();if(null!=d){var m=tchmi_path(d);if(this.__usercontrol_defaultValueInternal[m]&&void 0!==this.__usercontrol_defaultValueInternal[m][r])return t=this.__usercontrol_defaultValueInternal[m][r],{error:w.Errors.NONE,origin:"control",originThemeName:this.__activeThemes,value:tchmi_clone_object(t)}}}return{error:w.Errors.NONE,origin:"control",originThemeName:this.__activeThemes,value:null}},e.prototype.getThemeResource=function(e,r){var t=null,o=e.getClassNames();if(o&&0<o.length){for(var n=0,i=o;n<i.length;n++){var a=i[n];this.__project_themeFiles[this.__activeThemes]&&this.__project_themeFiles[this.__activeThemes].controlClassValues&&this.__project_themeFiles[this.__activeThemes].controlClassValues[a]&&void 0!==this.__project_themeFiles[this.__activeThemes].controlClassValues[a].themedResources[r]&&null!==this.__project_themeFiles[this.__activeThemes].controlClassValues[a].themedResources[r]&&(t=this.__project_themeFiles[this.__activeThemes].controlClassValues[a].themedResources[r])}if(null!==t)return{error:w.Errors.NONE,origin:"project",originThemeName:this.__activeThemes,value:tchmi_clone_object(t)}}var s=e.getType();if(this.__project_themeFiles[this.__activeThemes]&&this.__project_themeFiles[this.__activeThemes].controlTypeValues&&this.__project_themeFiles[this.__activeThemes].controlTypeValues[s]&&this.__project_themeFiles[this.__activeThemes].controlTypeValues[s].themedResources&&void 0!==this.__project_themeFiles[this.__activeThemes].controlTypeValues[s].themedResources[r]&&null!==this.__project_themeFiles[this.__activeThemes].controlTypeValues[s].themedResources[r])return t=this.__project_themeFiles[this.__activeThemes].controlTypeValues[s].themedResources[r],{error:w.Errors.NONE,origin:"project",originThemeName:this.__activeThemes,value:tchmi_clone_object(t)};if(w.System.config.themes&&w.System.config.themes[this.__activeThemes]&&w.System.config.themes[this.__activeThemes].replacesThemeForControls&&-1!==w.System.config.themes[this.__activeThemes].replacesThemeForControls.indexOf(s))return{error:w.Errors.NONE,origin:"project",originThemeName:this.__activeThemes,value:null};var l=[this.__activeThemes];"Base"!==this.__activeThemes&&l.push("Base");for(var c=0,_=l;c<_.length;c++){var u=_[c];if(this.__control_themeFiles[u]&&this.__control_themeFiles[u][s]&&this.__control_themeFiles[u][s].controlTypeValues&&this.__control_themeFiles[u][s].controlTypeValues[s]&&this.__control_themeFiles[u][s].controlTypeValues[s].themedResources&&void 0!==this.__control_themeFiles[u][s].controlTypeValues[s].themedResources[r]&&null!==this.__control_themeFiles[u][s].controlTypeValues[s].themedResources[r])return t=this.__control_themeFiles[u][s].controlTypeValues[s].themedResources[r],{error:w.Errors.NONE,origin:"control",originThemeName:u,value:tchmi_clone_object(t)}}return{error:w.Errors.ERROR,origin:"control",originThemeName:this.__activeThemes,value:null}},e.prototype.watchAttributeDefaults=function(e,r){var t=e.getId();if(void 0===this.__watchAttributeDefaults[t])this.__watchAttributeDefaults[t]={};else if(!0===this.__watchAttributeDefaults[t][r])return;this.__watchAttributeDefaults[t][r]=!0},e.prototype.startAttributeSetterWatcher=function(e){this.__watchAttributeDefaults[e]&&(this.__destroyFunctionResultChanged[e]||(this.__destroyFunctionResultChanged[e]=w.EventProvider.register(e+".onFunctionResultChanged",this.__handleFunctionResultChanged(e))))},e.prototype.unwatchAttributeDefaults=function(e,r){var t=e.getId();void 0!==this.__watchAttributeDefaults[t]&&void 0!==this.__watchAttributeDefaults[t][r]&&(delete this.__watchAttributeDefaults[t][r],0===Object.keys(this.__watchAttributeDefaults[t]).length&&(delete this.__watchAttributeDefaults[t],this.__destroyFunctionResultChanged[t]&&(this.__destroyFunctionResultChanged[t](),delete this.__destroyFunctionResultChanged[t])))},e.prototype.__handleFunctionResultChanged=function(l){var c=this;return function(e,r){if(!c.__settingThemeValueInProgess){var t=w.Controls.get(l);if(t)for(var o=t.getType(),n=0,i=r;n<i.length;n++){var a=i[n],s=_.Services.controlManager.getDescriptionAttributeByPropertyGetterName(o,a);s&&!s.readOnly&&c.unwatchAttributeDefaults(t,s.propertyName)}}}},e}(),_.ThemeManager=e}(TcHmi||(TcHmi={})),function(C){var e,r;e=C.System||(C.System={}),r=function(){function e(e){var v=this;if(this.__optionsList={},this.__detachEventDestroy=null,this.__abortClick=function(e){if(e.target===v.__masterDiv.lastElementChild&&v.__masterDiv.lastElementChild&&v.__masterDiv.lastElementChild instanceof HTMLElement){var r=v.__masterDiv.lastElementChild.dataset.tchmiTopMostLayerOrigin;if(r)if("TopMostLayer-Uncontrolled"===r)v.remove(null,$(v.__masterDiv.lastElementChild.firstElementChild),!0);else{var t=C.Controls.get(r);t&&v.remove(t,$(v.__masterDiv.lastElementChild.firstElementChild),!0)}}},this.__checkDetachedControls=function(e,r){var t=r.getId();if(v.__optionsList[t])for(var o=v.__masterDiv.children,n=0;n<o.length;n++)if(o[n]instanceof HTMLElement){var i=o[n];i.dataset.tchmiTopMostLayerOrigin&&i.dataset.tchmiTopMostLayerOrigin===t&&v.remove(r,$(i.firstElementChild),!0)}},this.__updateAllChildPosition=function(e,r){if(e&&Array.isArray(e)){for(var t=!1,o=[],n=[],i=0,a=e.length;i<a;i++){var s=e[i],l=s.target;"attributes"===s.type&&"style"===s.attributeName&&(l instanceof HTMLElement&&-1===o.indexOf(l)&&s.oldValue&&(o.push(l),n.push(s.oldValue)))}for(var c=0;c<o.length;c++){var _=o[c];if(n[c]!==_.getAttribute("style")){t=!0;break}}if(!1===t)return}var u=[],d=v.__masterDiv.children;for(i=0;i<d.length;i++)if(d[i]instanceof HTMLElement){var m=d[i],h=m.firstElementChild;if(m.dataset.tchmiTopMostLayerElementGuid&&m.dataset.tchmiTopMostLayerOrigin&&v.__optionsList[m.dataset.tchmiTopMostLayerOrigin]&&v.__optionsList[m.dataset.tchmiTopMostLayerOrigin][m.dataset.tchmiTopMostLayerElementGuid]){var g=v.__optionsList[m.dataset.tchmiTopMostLayerOrigin][m.dataset.tchmiTopMostLayerElementGuid],p=!0===g.centerVertical||!0===g.centerHorizontal;if(p||g.resizeCb){var E=!1;if(p){var f=m.firstElementChild.getBoundingClientRect();if(!0===g.centerVertical){var S=(document.documentElement.clientHeight-f.height)/2;h.style.top!==S+"px"&&(h.style.top=S+"px",E=!0)}if(!0===g.centerHorizontal){var y=(document.documentElement.clientWidth-f.width)/2;h.style.left!==y+"px"&&(h.style.left=y+"px",E=!0)}}!1!==p&&!0!==E||!g.resizeCb||u.push({callback:g.resizeCb,thisArg:C.Controls.get(m.dataset.tchmiTopMostLayerOrigin),args:{error:C.Errors.NONE,element:$(m),parentPixelSize:{width:document.documentElement.clientWidth,height:document.documentElement.clientHeight}}})}}}for(i=0;i<u.length;i++)C.Callback.callSafe(u[i].callback,u[i].thisArg,u[i].args)},this.__dimLastContainer=function(){for(var e,r=v.__masterDiv.children,t=0;t<r.length;t++)if(r[t].firstElementChild instanceof HTMLElement){var o=r[t];if(o.classList.remove("tchmi-topmostlayer-non-modal"),o.dataset.tchmiTopMostLayerOrigin&&o.dataset.tchmiTopMostLayerElementGuid&&v.__optionsList[o.dataset.tchmiTopMostLayerOrigin]&&v.__optionsList[o.dataset.tchmiTopMostLayerOrigin][o.dataset.tchmiTopMostLayerElementGuid]){var n=v.__optionsList[o.dataset.tchmiTopMostLayerOrigin][o.dataset.tchmiTopMostLayerElementGuid];!1!==n.dimBackground&&(e=o),o.style.backgroundColor="",!1===n.modal&&o.classList.add("tchmi-topmostlayer-non-modal")}}e&&(e.style.backgroundColor="rgba(0, 0, 0, 0.5)")},this.__masterDiv=document.createElement("div"),this.__masterDiv.id="tchmi-system-top-layer-master",this.__masterDiv.style.zIndex="5000",this.__masterDiv.style.position="absolute",this.__masterDiv.addEventListener("click",this.__abortClick,!1),"function"==typeof MutationObserver)this.__mutationObserver=new MutationObserver(this.__updateAllChildPosition);else if("function"==typeof e){var r={servicesName:"TopMostLayer",error:C.Errors.E_NOT_SUPPORTED,dialogManagerMessage:"Browser support for MutationObserver missing."};e.call(null,r)}}return e.prototype.add=function(e,r,t){if(!r)return!1;if(1!==r.length)return!1;if(!(r[0]instanceof HTMLElement))return!1;if(r[0].hasAttribute("data-tchmi-type"))return!1;var o,n=r[0];if(n.parentElement&&n.parentElement.classList.contains("tchmi-system-topmostlayer-container"))return!1;o=e?e.getId():"TopMostLayer-Uncontrolled",n.classList.add("tchmi-in-topmostlayer");var i=document.createElement("div");if(i.dataset.tchmiTopMostLayerOrigin=o,i.classList.add("tchmi-system-topmostlayer-container"),i.style.position="fixed",i.style.width="100%",i.style.height="100%",i.style.overscrollBehavior="contain",i.appendChild(n),this.__masterDiv.appendChild(i),t){this.__optionsList[o]||(this.__optionsList[o]={});var a=tchmi_create_guid();i.dataset.tchmiTopMostLayerElementGuid=a;var s=this.__optionsList[o][a]=t;s.styleBackup={},!0!==s.centerVertical&&!0!==s.centerHorizontal||(!0===s.centerHorizontal&&(s.styleBackup.left=n.style.left),!0===s.centerVertical&&(s.styleBackup.top=n.style.top),s.styleBackup.position=n.style.position,n.style.position="absolute",this.__mutationObserver.observe(n,{attributes:!0,attributeFilter:["style","class","id"],attributeOldValue:!0,childList:!0,subtree:!0}))}if(this.__dimLastContainer(),!this.__masterDiv.parentElement){window.addEventListener("resize",this.__updateAllChildPosition,{passive:!0,capture:!1}),this.__detachEventDestroy=C.EventProvider.register("System.onControlDetached",this.__checkDetachedControls),document.body.appendChild(this.__masterDiv)}return this.__updateAllChildPosition(),!0},e.prototype.remove=function(e,r,t){if(!r)return r;if(1!==r.length)return r;if(!(r[0]instanceof HTMLElement))return r;var o=r[0];if(!this.__masterDiv.contains(o))return r;if(!o.parentElement)return r;o.classList.remove("tchmi-in-topmostlayer"),this.__masterDiv.removeChild(o.parentElement);var n,i=o.parentElement,a=r.detach();if(!this.__masterDiv.firstElementChild){document.body.removeChild(this.__masterDiv);window.removeEventListener("resize",this.__updateAllChildPosition,{passive:!0,capture:!1}),this.__detachEventDestroy&&(this.__detachEventDestroy(),this.__detachEventDestroy=null),this.__mutationObserver.disconnect()}if(n=e?e.getId():"TopMostLayer-Uncontrolled",this.__optionsList[n]&&i.dataset.tchmiTopMostLayerElementGuid&&this.__optionsList[n][i.dataset.tchmiTopMostLayerElementGuid]){var s=this.__optionsList[n][i.dataset.tchmiTopMostLayerElementGuid],l={error:C.Errors.NONE,element:a,canceled:t};!0!==s.centerVertical&&!0!==s.centerHorizontal||(o.style.position=s.styleBackup.position,!0===s.centerHorizontal&&(o.style.left=s.styleBackup.left),!0===s.centerVertical&&(o.style.top=s.styleBackup.top)),delete this.__optionsList[n][i.dataset.tchmiTopMostLayerElementGuid],s.removeCb&&C.Callback.callSafe(s.removeCb,e||null,l),0===Object.keys(this.__optionsList[n]).length&&delete this.__optionsList[n]}return this.__dimLastContainer(),a},e}(),e.TopMostLayer=r}(TcHmi||(TcHmi={})),function(r){var e,t,o;e=r.System||(r.System={}),t=e.Engineering||(e.Engineering={}),o=function(){function e(e){this.__cmd=e,this.__result=r.Errors.NONE,this.sendSynchronousConfirmation=!0}return e.prototype.confirmRequest=function(e){new r.System.Engineering.SyncCmdToCreatorConfirmation({name:"Confirmation",confirmId:e,errorCode:this.__result,replyTo:null}).send()},e}(),t.SyncCmdToFramework=o}(TcHmi||(TcHmi={})),function(n){var e,i,r;e=n.System||(n.System={}),i=e.Engineering||(e.Engineering={}),r=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){if(!1!==TCHMI_ENABLE_DESIGNER_MODE_MASTER&&tchmi_path(this.__cmd.targetPartial)===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL){for(var e=this.__cmd.controls,r=0,t=e.length;r<t;r++){var o=n.control[e[r]];if(void 0===o){n.Log.error('[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkRemoveControls] Failed to remove control "'+e[r]+'": Not found in control cache.\n');break}null!==o.__parent&&o.__parent.__pcElement.children("#"+tchmi_css_escape_selector(o.__id)).remove(),o.destroy()}new i.SyncCmdToCreatorSyncControls({name:"SyncControls",targetPartial:TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL,controls:[],replyTo:null}).send()}},e}(i.SyncCmdToFramework),i.SyncCmdToFrameworkRemoveControls=r}(TcHmi||(TcHmi={})),function(e){var r,t,o;r=e.System||(e.System={}),t=r.Engineering||(r.Engineering={}),o=function(t){function e(e){var r=t.call(this,e)||this;return r.sendSynchronousConfirmation=!1,r}return __extends(e,t),e.prototype.run=function(){},e}(t.SyncCmdToFramework),t.SyncCmdToFrameworkConfirmation=o}(TcHmi||(TcHmi={})),function(t){var e,r,o;e=t.System||(t.System={}),r=e.Engineering||(e.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){var e=tchmi_path(this.__cmd.targetPartial);!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&e===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL&&t.System.Services.Engineering.designerModeManager.setControlLocked(this.__cmd.targetControl,this.__cmd.locked)},e}(r.SyncCmdToFramework),r.SyncCmdToFrameworkControlLocked=o}(TcHmi||(TcHmi={})),function(i){var a,e,r;a=i.System||(i.System={}),e=a.Engineering||(a.Engineering={}),r=function(t){function e(e){var r=t.call(this,e)||this;return r.__controlsToSelect=[],r.__createsPending=0,r}return __extends(e,t),e.prototype.createCallback=function(){var n=this;return function(e){if(n.__createsPending--,n.__createsPending<=0&&!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&0<n.__controlsToSelect.length){i.System.Services.Engineering.designerModeManager.unselectEach(!0);for(var r=0,t=n.__controlsToSelect.length;r<t;r++){var o=n.__controlsToSelect[r];i.System.Services.Engineering.designerModeManager.select(o,!0)}!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&i.System.Services.Engineering.designerModeManager.resyncSelectedControls()}}},e.prototype.run=function(){if(!1!==TCHMI_ENABLE_DESIGNER_MODE_MASTER&&tchmi_path(this.__cmd.targetPartial)===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL){var e=this.__cmd.controls;if(null!=e)for(var r=0,t=e.length;r<t;r++){var o=this.__cmd.controls[r],n=null;void 0!==o.controlHtml&&null!==o.controlHtml&&(n=a.tchmi_utf8str_base64decode(o.controlHtml)),null!==n?(this.__createsPending++,!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&!0===o.select&&this.__controlsToSelect.push(o.controlId),i.System.Services.Engineering.designerModeManager.createControl(this.__cmd.targetPartial,o.targetParentControl,o.domPosition,n,this.createCallback())):(i.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkCreateControls] Failed to decode base64 encoded html content of "+o.controlId),this.__result=i.Errors.E_PARAMETER_INVALID),n=o=null}else this.__result=i.Errors.E_PARAMETER_INVALID}},e}(e.SyncCmdToFramework),e.SyncCmdToFrameworkCreateControls=r}(TcHmi||(TcHmi={})),function(c){var _,e,r;_=c.System||(c.System={}),e=_.Engineering||(_.Engineering={}),r=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){if(void 0===this.__cmd.targetPartial||null===this.__cmd.targetPartial)return c.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkCurrentPartialContent] Failed to synchronize partial. Command property targetPartial="+this.__cmd.targetPartial+"."),void(this.__result=c.Errors.E_PARAMETER_INVALID);var r=tchmi_path(this.__cmd.targetPartial),e=c.ValueConverter.toObject(_.tchmi_utf8str_base64decode(this.__cmd.piggyBack),null);if(null===e||!0!==e.broadcast||e.requestInstance!==TCHMI_DYNAMIC_INSTANCE_ID){var t=this.__cmd.content;if(null==t||""===t)return c.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkCurrentPartialContent] Failed to synchronize partial="+r+". Command property content="+t+"."),void(this.__result=c.Errors.E_PARAMETER_INVALID);var o=_.tchmi_utf8str_base64decode(t);if(null===o)return c.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkCurrentPartialContent] Failed to synchronize partial="+r+". Failed to decode base64 encoded html content."),void(this.__result=c.Errors.E_PARAMETER_INVALID);t=null;var n=$(o);if(0===n.length||void 0===n[0].id)return c.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkCurrentPartialContent] Failed to synchronize partial="+r+". Failed to read attribute=id."),void(this.__result=c.Errors.E_PARAMETER_INVALID);if(void 0!==c.control[n[0].id])try{c.System.Services.Engineering.designerModeManager.syncControl(r,n[0].id,n[0].outerHTML)}catch(e){return c.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkCurrentPartialContent] Failed to synchronize partial="+r+". Unexpected exception="+e+"."),void(this.__result=c.Errors.E_PARAMETER_INVALID)}try{var i=null,a=0;if(-1<r.indexOf(".view")?(i=_.config.views,a=1):-1<r.indexOf(".content")?(i=_.config.content,a=2):-1<r.indexOf(".usercontrol")&&(i=_.config.userControls,a=3),i)for(var s=0,l=i.length;s<l;s++)if(i[s].url===r){3!==a&&(1!==a&&2!==a||!0!==i[s].preload)||(c.System.Caches.partialMarkupCache[r]=o);break}}catch(e){c.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkCurrentPartialContent] Failed to synchronize partial="+r+". Unexpected exception="+e+".")}c.EventProvider.raise("System.onPartialChanged",{url:r,content:o}),!0===TCHMI_ENABLE_DESIGNER_MODE&&!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&c.System.Services.Engineering.designerModeManager.highlightManager.processDomVisibility()}},e}(e.SyncCmdToFramework),e.SyncCmdToFrameworkCurrentPartialContent=r}(TcHmi||(TcHmi={})),function(e){var t,r,o;t=e.System||(e.System={}),r=t.Engineering||(t.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){!0!==TCHMI_ENABLE_DESIGNER_MODE_MASTER&&!0===TCHMI_ENABLE_DESIGNER_MODE_SLAVE&&tchmi_path(this.__cmd.targetPartial)===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL&&!0===this.__cmd.locked&&t.Services.Engineering.designerModeManager.lock()},e}(r.SyncCmdToFramework),r.SyncCmdToFrameworkCurrentPartialEditorLockState=o}(TcHmi||(TcHmi={})),function(e){var t,r,o;t=e.System||(e.System={}),r=t.Engineering||(t.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&tchmi_path(this.__cmd.targetPartial)===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL&&t.Services.Engineering.designerModeManager.highlightManager.setHighlightContainerVisibility(this.__cmd.state)},e}(r.SyncCmdToFramework),r.SyncCmdToFrameworkCurrentPartialHighlightContainerState=o}(TcHmi||(TcHmi={})),function(t){var e,r,o;e=t.System||(t.System={}),r=e.Engineering||(e.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){var e=tchmi_path(this.__cmd.targetPartial);!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&e===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL&&t.System.Services.Engineering.designerModeManager.highlightManager.setCreatorVisibilityAttribute(this.__cmd.targetControl,this.__cmd.visibility)},e}(r.SyncCmdToFramework),r.SyncCmdToFrameworkDomVisibility=o}(TcHmi||(TcHmi={})),function(r){var e,t,o;e=r.System||(r.System={}),t=e.Engineering||(e.Engineering={}),o=function(t){function e(e){var r=t.call(this,e)||this;return r.sendSynchronousConfirmation=!1,r}return __extends(e,t),e.prototype.run=function(){if(!1!==TCHMI_ENABLE_DESIGNER_MODE_MASTER&&tchmi_path(this.__cmd.targetPartial)===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL){var e=this.__cmd.states;null!=e?(void 0!==e.leftCtrl&&null!==e.leftCtrl&&void 0!==e.leftCtrl.down&&!0===e.leftCtrl.down||void 0!==e.rightCtrl&&null!==e.rightCtrl&&void 0!==e.rightCtrl.down&&!0===e.rightCtrl.down?r.System.Services.Engineering.designerModeManager.interactionManager.setCtrlModifierKeyState(!0):r.System.Services.Engineering.designerModeManager.interactionManager.setCtrlModifierKeyState(!1),void 0!==e.leftShift&&null!==e.leftShift&&void 0!==e.leftShift.down&&!0===e.leftShift.down||void 0!==e.rightShift&&null!==e.rightShift&&void 0!==e.rightShift.down&&!0===e.rightShift.down?r.System.Services.Engineering.designerModeManager.interactionManager.setShiftModifierKeyState(!0):r.System.Services.Engineering.designerModeManager.interactionManager.setShiftModifierKeyState(!1)):this.__result=r.Errors.E_PARAMETER_INVALID}},e}(t.SyncCmdToFramework),t.SyncCmdToFrameworkKeyStates=o}(TcHmi||(TcHmi={})),function(o){var e,n,r;e=o.System||(o.System={}),n=e.Engineering||(e.Engineering={}),r=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){if(!1!==TCHMI_ENABLE_DESIGNER_MODE_MASTER){var e=tchmi_path(this.__cmd.targetPartial);if(e===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL)if(void 0!==this.__cmd.type&&null!==this.__cmd.type){var r=o.System.Services.Engineering.designerModeManager.hierarchyManager.getContainerFromPoint({left:this.__cmd.position.left+window.scrollX,top:this.__cmd.position.top+window.scrollY});if(r){var t={name:"DropControlPosition",targetPartial:e,controls:[{piggyBack:this.__cmd.piggyBack,targetParentControl:r.tco.__id,type:this.__cmd.type,position:{centerX:r.centerX,centerY:r.centerY}}],replyTo:null};null===r.rowIndex||null===r.cellIndex||0===r.rowIndex&&0===r.cellIndex||(t.controls[0].attributes=[{name:"data-tchmi-grid-row-index",value:r.rowIndex},{name:"data-tchmi-grid-column-index",value:r.cellIndex}]),new n.SyncCmdToCreatorDropControlPosition(t).send()}else this.__result=o.Errors.ERROR}else this.__result=o.Errors.E_PARAMETER_INVALID}},e}(n.SyncCmdToFramework),n.SyncCmdToFrameworkRequestDropControlPosition=r}(TcHmi||(TcHmi={})),function(t){var e,r,o;e=t.System||(t.System={}),r=e.Engineering||(e.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){var e=tchmi_path(this.__cmd.targetPartial);!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&e===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL&&t.System.Services.Engineering.designerModeManager.rootControlManager.scroll(this.__cmd.position)},e}(r.SyncCmdToFramework),r.SyncCmdToFrameworkScrollPositionChanged=o}(TcHmi||(TcHmi={})),function(t){var e,r,o;e=t.System||(t.System={}),r=e.Engineering||(e.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){var e=tchmi_path(this.__cmd.targetPartial);!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&e===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL&&t.System.Services.Engineering.designerModeManager.select(this.__cmd.control)},e}(r.SyncCmdToFramework),r.SyncCmdToFrameworkSelectControl=o}(TcHmi||(TcHmi={})),function(t){var e,r,o;e=t.System||(t.System={}),r=e.Engineering||(e.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){var e=tchmi_path(this.__cmd.targetPartial);!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&e===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL&&t.System.Services.Engineering.designerModeManager.selectEach(!1)},e}(r.SyncCmdToFramework),r.SyncCmdToFrameworkSelectEachControl=o}(TcHmi||(TcHmi={})),function(t){var e,r,o;e=t.System||(t.System={}),r=e.Engineering||(e.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){var e=tchmi_path(this.__cmd.targetPartial);!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&e===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL&&t.System.Services.serverManager.setServerAddress(this.__cmd.host,this.__cmd.port,this.__cmd.protocol)},e}(r.SyncCmdToFramework),r.SyncCmdToFrameworkServerAddress=o}(TcHmi||(TcHmi={})),function(s){var l,e,r;l=s.System||(s.System={}),e=l.Engineering||(l.Engineering={}),r=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){if(!1!==TCHMI_ENABLE_DESIGNER_MODE_MASTER){var r=tchmi_path(this.__cmd.targetPartial);if(r===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL){for(var e=!1,t=this.__cmd.controls,o=0,n=t.length;o<n;o++){var i=t[o];try{var a=l.tchmi_utf8str_base64decode(i.controlHtml);null===a&&s.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkSyncControls] Failed to decode base64 encoded html content of "+i.targetControl+"."),!0===s.System.Services.Engineering.designerModeManager.syncControl(r,i.targetControl,a)&&(e=!0)}catch(e){s.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkSyncControls] Failed to synchronize control="+i.targetControl+" in partial="+r+" with unexpected exception="+e+"."),this.__result=s.Errors.ERROR}}!0===e&&s.System.Services.Engineering.designerModeManager.highlightManager.processDomVisibility()}}},e}(e.SyncCmdToFramework),e.SyncCmdToFrameworkSyncControls=r}(TcHmi||(TcHmi={})),function(g){var e,r,t;e=g.System||(g.System={}),r=e.Engineering||(e.Engineering={}),t=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.__refreshBaseConfig=function(e,r){e.scaleMode!==r.scaleMode&&g.System.Services.viewManager.setScaleMode(e.scaleMode),!1===TCHMI_ENABLE_DESIGNER_MODE_MASTER?e.startupView!==r.startupView&&g.System.Services.viewManager.loadView(e.startupView):e.creatorSettings&&e.creatorSettings.viewport&&(e.creatorSettings.viewport.defaultHeight!==r.creatorSettings.viewport.defaultHeight||e.creatorSettings.viewport.defaultWidth!==r.creatorSettings.viewport.defaultWidth)&&g.System.Services.Engineering.designerModeManager.rootControlManager.setCreatorViewPortPosition(g.System.Services.viewManager.getView()),e.activeTheme!==r.activeTheme?g.System.Services.themeManager.setTheme(e.activeTheme,!0):tchmi_equal(e.dependencyFiles,r.dependencyFiles)&&tchmi_equal(e.themes,r.themes)||g.System.Services.themeManager.processActiveTheme(),TCHMI_ENABLE_DESIGNER_MODE&&TCHMI_ENABLE_DESIGNER_MODE_SLAVE&&!tchmi_equal(e.tcHmiServer,r.tcHmiServer)&&g.System.Services.serverManager.refreshGlobalSubscriptionRequests()},e.prototype.__loadViewPartial=function(r,t){var o=null;if(!0===r.preload&&!0!==TCHMI_ENABLE_DESIGNER_MODE_MASTER){var n=new XMLHttpRequest;n.open("GET",r.url+"?preventcache="+Math.random()),n.addEventListener("load",function(e){200===n.status?o=n.responseText:g.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkTcHmiConfigChanged] Failed to load file="+r.url+", status="+n.status),g.Callback.callSafe(t,null,r,o)}),n.addEventListener("error",function(e){g.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkTcHmiConfigChanged] Failed to load file="+r.url+", status="+n.status),g.Callback.callSafe(t,null,r,o)}),n.send()}},e.prototype.__loadViewPartialCallback=function(e,r){if(null!=r){var t=tchmi_path(e.url);if(void 0!==e.url&&null!==e.url&&!0===e.preload&&(g.System.Caches.partialMarkupCache[t]=r),!0===e.preload&&void 0!==e.url&&null!==e.url&&!0!==TCHMI_ENABLE_DESIGNER_MODE_MASTER){var o=g.System.Services.controlManager.compile(r);void 0!==o&&(o.__keepAlive=!0,o.__element.attr("data-tchmi-partial-url",e.url))}g.EventProvider.raise("System.onPartialCreated",{url:t})}},e.prototype.__refreshViewPartials=function(e,r){if(null!=e&&null!=r){for(var t=[],o=0,n=r.length;o<n;o++){for(var i=r[o],a=!1,s=0,l=e.length;s<l;s++)if(e[s].url===i.url){a=!0;break}!1===a&&t.push(i)}var c=[];for(o=0,n=e.length;o<n;o++){var _=e[o],u=!1;for(s=0,l=r.length;s<l;s++)if(i=r[s],_.url===i.url){u=!0;break}!1===u&&c.push(_)}for(o=0,n=t.length;o<n;o++)if(void 0!==(m=t[o]).url&&null!==m.url){var d=tchmi_path(m.url);delete g.System.Caches.partialMarkupCache[d],g.EventProvider.raise("System.onPartialRemoved",{url:d})}for(o=0,n=c.length;o<n;o++){var m=c[o];this.__loadViewPartial(m,this.__loadViewPartialCallback)}}},e.prototype.__loadContentPartial=function(r,t){if(!0===r.preload&&!0!==TCHMI_ENABLE_DESIGNER_MODE_MASTER){var o=new XMLHttpRequest;o.open("GET",r.url+"?preventcache="+Math.random()),o.addEventListener("load",function(e){200===o.status?r=g.ValueConverter.toObject(o.responseText):g.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkTcHmiConfigChanged] Failed to load file="+r.url+", status="+o.status),g.Callback.callSafe(t,null,r,null)}),o.addEventListener("error",function(e){g.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkTcHmiConfigChanged] Failed to load file="+r.url+", status="+o.status),g.Callback.callSafe(t,null,r,null)}),o.send()}},e.prototype.__loadContentPartialCallback=function(e,r){var t=tchmi_path(e.url);if(null!=r&&void 0!==e.url&&null!==e.url&&!0===e.preload&&(g.System.Caches.partialMarkupCache[t]=r),!0===e.preload&&void 0!==e.url&&null!==e.url&&!0!==TCHMI_ENABLE_DESIGNER_MODE_MASTER){var o=g.System.Services.controlManager.compile(r);void 0!==o&&o.__element.attr("data-tchmi-partial-url",e.url)}g.EventProvider.raise("System.onPartialCreated",{url:t})},e.prototype.__refreshContentPartials=function(e,r){if(null!=e&&null!=r){for(var t=[],o=0,n=r.length;o<n;o++){for(var i=r[o],a=!1,s=0,l=e.length;s<l;s++)if(e[s].url===i.url){a=!0;break}!1===a&&t.push(i)}var c=[];for(o=0,n=e.length;o<n;o++){var _=e[o],u=!1;for(s=0,l=r.length;s<l;s++)if(i=r[s],_.url===i.url){u=!0;break}!1===u&&c.push(_)}for(o=0,n=t.length;o<n;o++){var d=t[o];if(void 0!==d.url&&null!==d.url){var m=tchmi_path(d.url);delete g.System.Caches.partialMarkupCache[m],g.EventProvider.raise("System.onPartialRemoved",{url:m})}}for(o=0,n=c.length;o<n;o++){var h=c[o];this.__loadViewPartial(h,this.__loadViewPartialCallback)}}},e.prototype.__loadUserControlPartial=function(t,o){var n=null,i=null,a=t.url.replace(".usercontrol",".usercontrol.json"),s=new XMLHttpRequest;s.open("GET",t.url+"?preventcache="+Math.random()),s.addEventListener("load",function(e){if(200===s.status){n=s.responseText;var r=new XMLHttpRequest;r.open("GET",a+"?preventcache="+Math.random()),r.addEventListener("load",function(e){200===r.status?i=g.ValueConverter.toObject(r.responseText):g.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkTcHmiConfigChanged] Failed to load file="+a+", status="+r.status),g.Callback.callSafe(o,null,t,n,i)}),r.addEventListener("error",function(e){g.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkTcHmiConfigChanged] Failed to load file="+a+", status="+r.status),g.Callback.callSafe(o,null,t,n,i)}),r.send()}else g.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkTcHmiConfigChanged] Failed to load file="+t.url+", status="+s.status),g.Callback.callSafe(o,null,t,n,i)}),s.addEventListener("error",function(e){g.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkTcHmiConfigChanged] Failed to load file="+t.url+", status="+s.status),g.Callback.callSafe(o,null,t,n,i)}),s.send()},e.prototype.__loadUserControlPartialCallback=function(e,r,t){if(null!=r){var o=tchmi_path(e.url),n=tchmi_path(e.url.replace(".usercontrol",".usercontrol.json"));void 0!==e.url&&null!==e.url&&(g.System.Caches.partialMarkupCache[o]=r),null!=t&&void 0!==e.url&&null!==e.url&&(g.System.Caches.partialCompositeConfigCache[n]=t),g.EventProvider.raise("System.onPartialCreated",{url:o}),g.EventProvider.raise("System.onPartialCompositeConfigCreated",{url:n})}},e.prototype.__refreshUserControlPartials=function(e,r){if(null!=e&&null!=r){for(var t=[],o=0,n=r.length;o<n;o++){for(var i=r[o],a=!1,s=0,l=e.length;s<l;s++)(_=e[s]).url===i.url&&(a=!0);!1===a&&t.push(i)}var c=[];for(o=0,n=e.length;o<n;o++){var _=e[o];for(a=!1,s=0,l=r.length;s<l;s++)i=r[s],_.url===i.url&&(a=!0);!1===a&&c.push(_)}for(o=0,n=t.length;o<n;o++)if(void 0!==(m=t[o]).url&&null!==m.url){var u=tchmi_path(m.url),d=tchmi_path(m.url.replace(".usercontrol",".usercontrol.json"));delete g.System.Caches.partialMarkupCache[u],delete g.System.Caches.partialCompositeConfigCache[d],g.EventProvider.raise("System.onPartialRemoved",{url:u}),g.EventProvider.raise("System.onPartialCompositeConfigRemoved",{url:d})}for(o=0,n=c.length;o<n;o++){var m=c[o];this.__loadUserControlPartial(m,this.__loadUserControlPartialCallback)}}},e.prototype.__refreshSymbols=function(e,r){var t=0,o=0,n=e.internal,i=r.internal,a=null,s=null,l=!1,c=[],_=!1,u=[],d=[];if(null!=i&&null!=n)for(s in i)if(i.hasOwnProperty(s)){for(a in l=!0,n)if(n.hasOwnProperty(a)){if(s===a){l=!1;break}a=null}!0===l&&c.push(s),l=!1,s=null}for(t=0,o=c.length;t<o;t++)g.System.Services.internalSymbolManager.remove(c[t]);if(null!=i&&null!=n)for(a in n)if(n.hasOwnProperty(a)){for(s in _=!0,i)if(i.hasOwnProperty(s)&&a===s){_=!1,tchmi_equal(n[a].value,i[s].value)&&n[a].persist===i[s].persist&&n[a].type===i[s].type&&n[a].readonly===i[s].readonly||d.push({key:a,item:n[a]});break}!0===_&&u.push({key:a,item:n[a]})}for(t=0,o=u.length;t<o;t++)g.System.Services.internalSymbolManager.add(u[t].key,u[t].item);for(t=0,o=d.length;t<o;t++)g.System.Services.internalSymbolManager.update(d[t].key,d[t].item)},e.prototype.__refreshLocale=function(e){null!=e&&"string"==typeof e&&g.System.Services.localizationManager.loadLocale(e,null)},e.prototype.__doReloadTcHmiConfig=function(e){var r=null,t=g.System.config,o=this,n=new XMLHttpRequest;n.open("GET","Properties/tchmiconfig.json?preventcache="+Math.random()),n.addEventListener("load",function(e){if(200===n.status){if(null===(r=g.ValueConverter.toObject(n.responseText)))return;o.__doRefreshTcHmiConfig(r,t)}else g.Log.error('[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkTcHmiConfigChanged] Error while rereading tchmiconfig.json while performing "TcHmiConfigChanged" command! Command will be ignored. Errordetail: '+n.statusText)}),n.addEventListener("error",function(e){g.Log.error('[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkTcHmiConfigChanged] Error while rereading tchmiconfig.json while performing "TcHmiConfigChanged" command! Command will be ignored. Errordetail: '+n.statusText)}),n.send()},e.prototype.__doRefreshTcHmiConfig=function(e,r){g.System.config=e,g.System.config.basePath=r.basePath,this.__refreshBaseConfig(e,r),this.__refreshViewPartials(e.views,r.views),this.__refreshContentPartials(e.content,r.content),this.__refreshUserControlPartials(e.userControls,r.userControls),this.__refreshSymbols(e.symbols,r.symbols),this.__refreshLocale(e.locale)},e.prototype.__doReloadUserControlConfig=function(t){var o=this,n=new XMLHttpRequest;n.open("GET",t+"?preventcache="+Math.random()),n.addEventListener("load",function(e){if(200===n.status){var r=g.ValueConverter.toObject(n.responseText);o.__doRefreshUserControlConfig(t,r)}else g.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkTcHmiConfigChanged] Error while rereading config "+t+' while performing "TcHmiConfigChanged" command! Errordetail: '+n.statusText)}),n.addEventListener("error",function(e){g.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkTcHmiConfigChanged] Error while rereading config "+t+' while performing "TcHmiConfigChanged" command! Errordetail: '+n.statusText)}),n.send()},e.prototype.__doRefreshUserControlConfig=function(e,r){g.System.Caches.partialCompositeConfigCache[e]=r,g.EventProvider.raise("System.onPartialCompositeConfigChanged",{url:e})},e.prototype.__doReloadLocalizationFile=function(t){var o=this,n=new XMLHttpRequest;n.open("GET",t+"?preventcache="+Math.random()),n.addEventListener("load",function(e){if(200===n.status){var r=g.ValueConverter.toObject(n.responseText);o.__doRefreshLocalizationFile(t,r)}else g.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkTcHmiConfigChanged] Error while rereading config "+t+' while performing "TcHmiConfigChanged" command! Errordetail: '+n.statusText)}),n.addEventListener("error",function(e){g.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.SyncCmdToFrameworkTcHmiConfigChanged] Error while rereading config "+t+' while performing "TcHmiConfigChanged" command! Errordetail: '+n.statusText)}),n.send()},e.prototype.__doRefreshLocalizationFile=function(e,r){var t=r.locale;null!=t&&g.System.Services.localizationManager.getLocale()===t&&g.System.Services.localizationManager.processLocalizationData(r,!0)},e.prototype.__doRefreshThemeFile=function(e){g.System.Services.themeManager.__clearCaches(),g.System.Services.themeManager.processActiveTheme()},e.prototype.run=function(){var e=this.__cmd,r=tchmi_path(e.configPath);switch(e.type){case"TcHmiConfig":this.__doReloadTcHmiConfig(r);break;case"UserControlConfig":this.__doReloadUserControlConfig(r);break;case"Localization":this.__doReloadLocalizationFile(r);break;case"ThemeConfig":this.__doRefreshThemeFile(r)}},e}(r.SyncCmdToFramework),r.SyncCmdToFrameworkTcHmiConfigChanged=t}(TcHmi||(TcHmi={})),function(t){var e,r,o;e=t.System||(t.System={}),r=e.Engineering||(e.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){var e=tchmi_path(this.__cmd.targetPartial);!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&e===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL&&t.System.Services.Engineering.designerModeManager.unselect(this.__cmd.control)},e}(r.SyncCmdToFramework),r.SyncCmdToFrameworkUnselectControl=o}(TcHmi||(TcHmi={})),function(t){var e,r,o;e=t.System||(t.System={}),r=e.Engineering||(e.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){var e=tchmi_path(this.__cmd.targetPartial);!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&e===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL&&t.System.Services.Engineering.designerModeManager.unselectEach(!1)},e}(r.SyncCmdToFramework),r.SyncCmdToFrameworkUnselectEachControl=o}(TcHmi||(TcHmi={})),function(t){var e,r,o;e=t.System||(t.System={}),r=e.Engineering||(e.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){tchmi_path(this.__cmd.targetPartial)===tchmi_path(TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL)&&t.System.Services.Engineering.designerModeManager.lock()},e}(r.SyncCmdToFramework),r.SyncCmdToFrameworkPartialEditorLocked=o}(TcHmi||(TcHmi={})),function(e){var r,t,o;r=e.System||(e.System={}),t=r.Engineering||(r.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){tchmi_path(this.__cmd.targetPartial)===tchmi_path(TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL)&&void 0!==window.location&&null!==window.location&&window.location.reload(!0)},e}(t.SyncCmdToFramework),t.SyncCmdToFrameworkPartialEditorUnlocked=o}(TcHmi||(TcHmi={})),function(r){var e,t,o;e=r.System||(r.System={}),t=e.Engineering||(e.Engineering={}),o=function(t){function e(e){var r=t.call(this,e)||this;return r.sendSynchronousConfirmation=!1,r}return __extends(e,t),e.prototype.run=function(){r.System.Services.Engineering.designerModeManager.syncManager.beginTransaction(this.__cmd.transactionName)},e}(t.SyncCmdToFramework),t.SyncCmdToFrameworkTransactionBegin=o}(TcHmi||(TcHmi={})),function(r){var e,t,o;e=r.System||(r.System={}),t=e.Engineering||(e.Engineering={}),o=function(t){function e(e){var r=t.call(this,e)||this;return r.sendSynchronousConfirmation=!1,r}return __extends(e,t),e.prototype.run=function(){r.System.Services.Engineering.designerModeManager.syncManager.commitTransaction(this.__cmd.transactionName)},e}(t.SyncCmdToFramework),t.SyncCmdToFrameworkTransactionCommit=o}(TcHmi||(TcHmi={})),function(t){var e,r,o;e=t.System||(t.System={}),r=e.Engineering||(e.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e.prototype.run=function(){var e=tchmi_path(this.__cmd.targetPartial);!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&e===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL&&t.System.Services.Engineering.designerModeManager.rootControlManager.setCreatorZoom(this.__cmd.factor)},e}(r.SyncCmdToFramework),r.SyncCmdToFrameworkZoom=o}(TcHmi||(TcHmi={})),function(r){var e,t,o;e=r.System||(r.System={}),t=e.Engineering||(e.Engineering={}),o=function(){function e(e){this.__cmd=e}return e.prototype.send=function(){r.System.Services.Engineering.designerModeComManager.sendCommand(this.__cmd)},e}(),t.SyncCmdToCreator=o}(TcHmi||(TcHmi={})),function(e){var r,t,o;r=e.System||(e.System={}),t=r.Engineering||(r.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e}(t.SyncCmdToCreator),t.SyncCmdToCreatorConfirmation=o}(TcHmi||(TcHmi={})),function(e){var r,t,o;r=e.System||(e.System={}),t=r.Engineering||(r.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e}(t.SyncCmdToCreator),t.SyncCmdToCreatorControlDoubleClick=o}(TcHmi||(TcHmi={})),function(e){var r,t,o;r=e.System||(e.System={}),t=r.Engineering||(r.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e}(t.SyncCmdToCreator),t.SyncCmdToCreatorCopyMoveControls=o}(TcHmi||(TcHmi={})),function(e){var r,t,o;r=e.System||(e.System={}),t=r.Engineering||(r.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e}(t.SyncCmdToCreator),t.SyncCmdToCreatorMessages=o}(TcHmi||(TcHmi={})),function(e){var r,t,o;r=e.System||(e.System={}),t=r.Engineering||(r.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e}(t.SyncCmdToCreator),t.SyncCmdToCreatorDropControlPosition=o}(TcHmi||(TcHmi={})),function(e){var r,t,o;r=e.System||(e.System={}),t=r.Engineering||(r.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e}(t.SyncCmdToCreator),t.SyncCmdToCreatorRegisterSyncView=o}(TcHmi||(TcHmi={})),function(e){var r,t,o;r=e.System||(e.System={}),t=r.Engineering||(r.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e}(t.SyncCmdToCreator),t.SyncCmdToCreatorRequestCurrentPartialContent=o}(TcHmi||(TcHmi={})),function(e){var r,t,o;r=e.System||(e.System={}),t=r.Engineering||(r.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e}(t.SyncCmdToCreator),t.SyncCmdToCreatorRequestCurrentPartialEditorLockState=o}(TcHmi||(TcHmi={})),function(e){var r,t,o;r=e.System||(e.System={}),t=r.Engineering||(r.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e}(t.SyncCmdToCreator),t.SyncCmdToCreatorRequestRequiredViewPortSize=o}(TcHmi||(TcHmi={})),function(e){var r,t,o;r=e.System||(e.System={}),t=r.Engineering||(r.Engineering={}),o=function(r){function e(e){return r.call(this,e)||this}return __extends(e,r),e}(t.SyncCmdToCreator),t.SyncCmdToCreatorSyncControls=o}(TcHmi||(TcHmi={})),function(e){var r,a,t;r=e.System||(e.System={}),a=r.Engineering||(r.Engineering={}),t=function(){function e(){this.__messages={}}return e.prototype.add=function(e,r,t){if(!1!==TCHMI_ENABLE_DESIGNER_MODE&&!1!==TCHMI_ENABLE_DESIGNER_MODE_MASTER){this.remove(e);var o=tchmi_create_guid(),n={identifier:o,type:t,content:r},i={append:!0,identifier:o,targetPartial:TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL,targetInstance:TCHMI_DYNAMIC_INSTANCE_ID,type:t,content:r,line:null,position:null,unixTimestamp:Math.round((new Date).getTime()/1e3)};this.__messages[e]=n,new a.SyncCmdToCreatorMessages({name:"Messages",messages:[i],replyTo:null}).send()}},e.prototype.remove=function(e){var r=this.__messages[e];if(r){var t={remove:!0,identifier:r.identifier};new a.SyncCmdToCreatorMessages({name:"Messages",messages:[t],replyTo:null}).send(),delete this.__messages[e]}},e}(),a.ErrorPane=t}(TcHmi||(TcHmi={})),function(o){var n,i,e;n=o.System||(o.System={}),i=n.Engineering||(n.Engineering={}),e=function(){function t(e){var r=this;this.__websocket=void 0,this.__pendingSyncCommandMessageRequests=[],this.__pendingSyncCommandMessageResponses=[],this.__connectionWatcherInterval=0,this.__pendingMessageWatcherInterval=0,this.__pendingSyncCommandMessageRequestWatcherInterval=0,this.__unloaded=!1,this.__readyForSynchronization=!1,this.__onUnload=function(e){r.__unloaded=!0,r.__websocket&&(r.__websocket.close(),r.__websocket=void 0)},this.__connectionWatcherTick=function(){return function(){void 0===r.__websocket&&r.__open()}},this.__pendingSyncCommandMessageResponseWatcherTick=function(){return function(){void 0!==r.__websocket&&r.__websocket.readyState===WebSocket.OPEN&&!0===r.__readyForSynchronization&&(r.__pendingMessageWatcherInterval&&(window.clearInterval(r.__pendingMessageWatcherInterval),r.__pendingMessageWatcherInterval=0),r.__handlePendingSyncCommandMessageResponses())}},this.__pendingSyncCommandMessageRequestWatcherTick=function(){return function(){void 0!==r.__websocket&&r.__websocket.readyState===WebSocket.OPEN&&!0===r.__readyForSynchronization&&(r.__pendingSyncCommandMessageRequestWatcherInterval&&(window.clearInterval(r.__pendingSyncCommandMessageRequestWatcherInterval),r.__pendingSyncCommandMessageRequestWatcherInterval=0),r.__handlePendingSyncCommandMessageRequests())}},o.EventProvider.register("System.onUnload",this.__onUnload);var t=o.EventProvider.register("onInitialized",function(){t(),r.__open()})}return t.prototype.__handlePendingSyncCommandMessageResponses=function(){for(;void 0!==this.__pendingSyncCommandMessageResponses&&0<this.__pendingSyncCommandMessageResponses.length;)this.__handleSyncCommandMessageResponse(this.__pendingSyncCommandMessageResponses.shift())},t.prototype.__handlePendingSyncCommandMessageRequests=function(){for(;void 0!==this.__pendingSyncCommandMessageRequests&&0<this.__pendingSyncCommandMessageRequests.length;){if(!0===TCHMI_CONSOLE_LOG_DESIGNER_MODE_COM_MESSAGES)try{o.Log.debug("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeComManager] Request to TwinCAT HMI Creator."),o.Log.debug(this.__pendingSyncCommandMessageRequests[0])}catch(e){}void 0!==this.__websocket&&this.__websocket.send(this.__pendingSyncCommandMessageRequests.shift())}},t.prototype.__handleSyncCommandMessageResponse=function(r){if(r.command){var e,t=!0;switch(r.command.name){case"Messages":break;case"Confirmation":t=!1,e=new i.SyncCmdToFrameworkConfirmation(r.command);break;case"TransactionBegin":t=!1,e=new i.SyncCmdToFrameworkTransactionBegin(r.command);break;case"TransactionCommit":t=!1,e=new i.SyncCmdToFrameworkTransactionCommit(r.command);break;case"ScrollPositionChanged":t=!1,e=new i.SyncCmdToFrameworkScrollPositionChanged(r.command);break;case"RequestDropControlPosition":e=new i.SyncCmdToFrameworkRequestDropControlPosition(r.command);break;case"CreateControls":e=new i.SyncCmdToFrameworkCreateControls(r.command);break;case"SyncControls":e=new i.SyncCmdToFrameworkSyncControls(r.command);break;case"RemoveControls":e=new i.SyncCmdToFrameworkRemoveControls(r.command);break;case"SelectControl":e=new i.SyncCmdToFrameworkSelectControl(r.command);break;case"UnselectControl":e=new i.SyncCmdToFrameworkUnselectControl(r.command);break;case"SelectEachControl":e=new i.SyncCmdToFrameworkSelectEachControl(r.command);break;case"ServerAddress":t=!1,e=new i.SyncCmdToFrameworkServerAddress(r.command);break;case"UnselectEachControl":e=new i.SyncCmdToFrameworkUnselectEachControl(r.command);break;case"DomVisibility":e=new i.SyncCmdToFrameworkDomVisibility(r.command);break;case"ControlLocked":e=new i.SyncCmdToFrameworkControlLocked(r.command);break;case"KeyStates":t=!1,e=new i.SyncCmdToFrameworkKeyStates(r.command);break;case"CurrentPartialContent":e=new i.SyncCmdToFrameworkCurrentPartialContent(r.command);break;case"TcHmiConfigChanged":e=new i.SyncCmdToFrameworkTcHmiConfigChanged(r.command);break;case"Zoom":t=!1,e=new i.SyncCmdToFrameworkZoom(r.command);break;case"PartialEditorLocked":t=!1,e=new i.SyncCmdToFrameworkPartialEditorLocked(r.command);break;case"PartialEditorUnlocked":t=!1,e=new i.SyncCmdToFrameworkPartialEditorUnlocked(r.command);break;case"CurrentPartialEditorLockState":e=new i.SyncCmdToFrameworkCurrentPartialEditorLockState(r.command);break;case"CurrentPartialHighlightContainerState":e=new i.SyncCmdToFrameworkCurrentPartialHighlightContainerState(r.command)}if(!t||!0!==n.Services.Engineering.designerModeManager.isLocked())if(void 0!==e){try{e.run()}catch(e){o.Log.error('[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeComManager] Unexpected exception handled while performing "'+r.command.name+'" command: \n'+e.toString())}e.sendSynchronousConfirmation&&e.confirmRequest(r.id)}else o.Log.debug('[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeComManager] Command "'+r.command.name+'" not implemented.')}},t.prototype.__websocketOnOpen=function(){var r=this;return function(e){o.Log.debug("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeComManager] WebSocket with url="+r.__websocket.url+" opened.")}},t.prototype.__websocketOnClose=function(){var r=this;return function(e){!0!==r.__unloaded&&(e.code&&!e.reason?o.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeComManager] WebSocket with url="+r.__websocket.url+" was closed with code="+e.code+"."):e.code&&e.reason?o.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeComManager] WebSocket with url="+r.__websocket.url+" was closed with code="+e.code+" and reason="+e.reason+"."):o.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeComManager] WebSocket with url="+r.__websocket.url+" was closed."),r.__websocket=void 0,r.__connectionWatcherInterval&&window.clearInterval(r.__connectionWatcherInterval),r.__connectionWatcherInterval=window.setInterval(r.__connectionWatcherTick(),t.RECONNECT_INTERVAL))}},t.prototype.__websocketOnMessage=function(){var t=this;return function(e){if(!0!==t.__unloaded&&(t.__handlePendingSyncCommandMessageResponses(),void 0!==e&&void 0!==e.data)){var r=o.ValueConverter.toObject(e.data,null);if(null===r||!r.command)return o.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeComManager] Failed to parse JSON message from TcHmiCreator!"),void o.Log.debug(r);try{!0===TCHMI_CONSOLE_LOG_DESIGNER_MODE_COM_MESSAGES&&"KeyStates"!==r.command.name&&(o.Log.debug("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeComManager] Response from TwinCAT HMI Creator."),o.Log.debug(r))}catch(e){}t.__handleSyncCommandMessageResponse(r)}}},t.prototype.__open=function(){if(!0!==this.__unloaded)if(void 0!==TCHMI_ENABLE_DESIGNER_MODE_WEBSOCKET_URL){if(void 0===this.__websocket){try{this.__websocket=new WebSocket(TCHMI_ENABLE_DESIGNER_MODE_WEBSOCKET_URL+"/DesignerWebsocketname="+TCHMI_ENABLE_DESIGNER_MODE_WEBSOCKET_URL)}catch(e){return void o.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeComManager] Opening connection to Engineering failed! No live view functionality will be available.")}this.__websocket.onopen=this.__websocketOnOpen(),this.__websocket.onclose=this.__websocketOnClose(),this.__websocket.onmessage=this.__websocketOnMessage()}}else o.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeComManager] Missing flag=TCHMI_ENABLE_DESIGNER_MODE_WEBSOCKET_URL.")},t.prototype.sendCommand=function(e){var r={id:tchmi_create_guid(),timestamp:(new Date).getTime(),command:e},t=JSON.stringify(r);!1!==this.__readyForSynchronization?void 0!==this.__websocket&&this.__websocket.readyState===WebSocket.OPEN?("RegisterSyncView"!==e.name&&this.__handlePendingSyncCommandMessageRequests(),!0===TCHMI_CONSOLE_LOG_DESIGNER_MODE_COM_MESSAGES&&(o.Log.debug("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeComManager] Request to TwinCAT HMI Creator."),o.Log.debug(r)),this.__websocket.send(t),"RegisterSyncView"===e.name&&this.__handlePendingSyncCommandMessageRequests()):(this.__pendingSyncCommandMessageRequestWatcherInterval||(this.__pendingSyncCommandMessageRequestWatcherInterval=window.setInterval(this.__pendingSyncCommandMessageRequestWatcherTick(),250)),"RegisterSyncView"===e.name?this.__pendingSyncCommandMessageRequests.unshift(t):this.__pendingSyncCommandMessageRequests.push(t)):"RegisterSyncView"===e.name?this.__pendingSyncCommandMessageRequests.unshift(t):this.__pendingSyncCommandMessageRequests.push(t)},t.prototype.makeReadyForSynchronization=function(){this.__readyForSynchronization=!0,this.__pendingSyncCommandMessageRequestWatcherInterval||(this.__pendingSyncCommandMessageRequestWatcherInterval=window.setInterval(this.__pendingSyncCommandMessageRequestWatcherTick(),250))},t.prototype.isReadyForSynchronization=function(){return this.__readyForSynchronization},t.RECONNECT_INTERVAL=5e3,t}(),i.DesignerModeComManager=e}(TcHmi||(TcHmi={})),function(Y){var X,a,e;X=Y.System||(Y.System={}),a=X.Engineering||(X.Engineering={}),e=function(){function e(e){if(this.__locked=!1,this.metaDataManager=new a.DesignerModeControlMetaDataManager(this),!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER){this.hierarchyManager=new a.DesignerModeMasterHierarchyManager(this),this.rootControlManager=new a.DesignerModeMasterRootControlManager(this),this.highlightManager=new a.DesignerModeMasterControlHighlightManager(this),this.syncManager=new a.DesignerModeMasterSyncManager(this),this.interactionManager=new a.DesignerModeMasterInteractionManager(this),this.controlMoveManager=new a.DesignerModeMasterControlMoveManager(this),this.rectSelectManager=new a.DesignerModeMasterRectSelectManager(this),this.controlResizeManager=new a.DesignerModeMasterControlResizeManager(this);var r=document.createElement("link");r.rel="stylesheet",r.type="text/css",r.href=tchmi_path(Y.System.config.basePath+"/StyleEngineering.css"),document.head.appendChild(r),Y.EventProvider.register("onThemeDataChanged",this.__onThemeDataChanged())}Y.EventProvider.register("onControlAttached",this.__onControlAttached())}return e.prototype.__onControlAttached=function(){var C=this;return function(e,r){var t;if(null!=r){if(t=r.__element.attr("data-tchmi-partial-url"),!0===TCHMI_ENABLE_DESIGNER_MODE&&!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&!0===C.hierarchyManager.isDesignerModeControl(r.__id)){var o=!1;tchmi_path(t)===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL&&(o=!0);var n=!0;"Collapsed"===r.__element.attr("data-tchmi-creator-visibility")&&(n=!1);var i=!1;"True"===r.__element.attr("data-tchmi-creator-locked")&&(i=!0);var a=!1;"Collapsed"===r.getVisibility()&&(a=!0);var s=C.metaDataManager.getControlMetaData(r.__id);if(null===s){var l=0,c=Y.StyleProvider.getSimpleElementStyle(r.__element,"z-index");void 0!==c["z-index"]&&(l=parseInt(c["z-index"],10),isNaN(l)&&(l=0)),s={id:r.__id,parent:null,jControlPosition:C.highlightManager.createControlPosition(r,2e3+l),jHierarchyControlposition:C.highlightManager.createHierarchyControlPosition(r,2e3+l),jOriginalPosition:C.highlightManager.createOriginalPosition(r,1e3+l),jHierarchyOriginalPosition:C.highlightManager.createHierarchyOriginalPosition(r,1e3+l),jAnchorContainer:C.highlightManager.createAnchorContainer(r,3e3+l,i),jHierarchyAnchorContainer:C.highlightManager.createHierarchyAnchorContainer(r,3e3+l,i),isSelected:!1,isSelectedPrev:!1,isPartialRoot:o,controlCollapsed:a,isContainerControl:r.__isContainerControl,isGridControl:"tchmi-grid"===r.getType(),domVisibility:n,locked:i,controlAttributeDimension:{},controlCssPixelDimension:{},relativeControlRotation:0,absoluteParentRotation:0},!0===o&&(s.jControlPosition[0].classList.add("tchmi-creator-root-partial"),s.jHierarchyControlposition[0].classList.add("tchmi-creator-root-partial"),s.jOriginalPosition[0].classList.add("tchmi-creator-root-partial"),s.jHierarchyOriginalPosition[0].classList.add("tchmi-creator-root-partial"),s.jAnchorContainer[0].classList.add("tchmi-creator-root-partial"),s.jHierarchyAnchorContainer[0].classList.add("tchmi-creator-root-partial")),s.jAnchorContainer[0].classList.toggle("tchmi-creator-control-locked",i),s.jHierarchyAnchorContainer[0].classList.toggle("tchmi-creator-control-locked",i),s.jAnchorContainer[0].classList.toggle("tchmi-creator-control-height-inactive","Content"===r.getHeightMode()),s.jAnchorContainer[0].classList.toggle("tchmi-creator-control-width-inactive","Content"===r.getWidthMode()),C.highlightManager.processHighlightType(s),C.highlightManager.processDomVisibility(s),!0===s.isGridControl&&C.highlightManager.createGridHighlighter(r,s),C.metaDataManager.register(s)}else s.isPartialRoot=o,s.controlCollapsed=a,s.domVisibility=n;C.metaDataManager.refreshControlMetaData(s),C.controlMoveManager.registerControl(s),C.hierarchyManager.registerContainerControl(s),C.controlResizeManager.registerControl(s);for(var _=r;null!=_;){if(!0===_.__isContainerControl&&void 0!==r.__parent&&null!==r.__parent&&r.__parent.__id===_.__id){var u=C.metaDataManager.getControlMetaData(_.__id);if(null===u){var d=0;d=parseInt(_.__element.css("zIndex"),10),isNaN(d)&&(d=0);var m=!0;"Collapsed"===_.__element.attr("data-tchmi-creator-visibility")&&(m=!1);var h=!1;"True"===_.__element.attr("data-tchmi-creator-locked")&&(h=!0);var g=!1;"Collapsed"===_.getVisibility()&&(g=!0),(u={id:_.__id,parent:null,jControlPosition:C.highlightManager.createControlPosition(_,2e3+d),jHierarchyControlposition:C.highlightManager.createHierarchyControlPosition(_,2e3+d),jOriginalPosition:C.highlightManager.createOriginalPosition(_,1e3+d),jHierarchyOriginalPosition:C.highlightManager.createHierarchyOriginalPosition(_,1e3+d),jAnchorContainer:C.highlightManager.createAnchorContainer(_,3e3+d,h),jHierarchyAnchorContainer:C.highlightManager.createHierarchyAnchorContainer(_,3e3+d,h),isSelected:!1,isSelectedPrev:!1,isPartialRoot:!1,controlCollapsed:g,isContainerControl:_.__isContainerControl,isGridControl:"tchmi-grid"===_.getType(),domVisibility:m,locked:h,controlAttributeDimension:{},controlCssPixelDimension:{},relativeControlRotation:0,absoluteParentRotation:0}).jAnchorContainer[0].classList.toggle("tchmi-creator-control-locked",h),u.jHierarchyAnchorContainer[0].classList.toggle("tchmi-creator-control-locked",h),C.metaDataManager.refreshControlMetaData(u),!0===u.isGridControl&&C.highlightManager.createGridHighlighter(_,u),C.metaDataManager.register(u)}s.parent=u}_=_.__parent}if(C.highlightManager.setContainerPositions(r,s),null!==s.parent&&null!==r.__parent){var p=r.__element.next(),E=null;if(0!==p.length&&(E=C.metaDataManager.getControlMetaData(p[0].id)),E)E.jOriginalPosition.before(s.jOriginalPosition),E.jOriginalPosition.before(s.jHierarchyOriginalPosition),E.jControlPosition.before(s.jControlPosition),E.jControlPosition.before(s.jHierarchyControlposition),E.jAnchorContainer.before(s.jAnchorContainer),E.jAnchorContainer.before(s.jHierarchyAnchorContainer);else if(!1===s.parent.isGridControl)s.parent.jHierarchyOriginalPosition.append(s.jOriginalPosition),s.parent.jHierarchyOriginalPosition.append(s.jHierarchyOriginalPosition),s.parent.jHierarchyControlposition.append(s.jControlPosition),s.parent.jHierarchyControlposition.append(s.jHierarchyControlposition),s.parent.jHierarchyAnchorContainer.append(s.jAnchorContainer),s.parent.jHierarchyAnchorContainer.append(s.jHierarchyAnchorContainer);else{var f=r.getGridRowIndex();f>=r.__parent.__rowOptions.length&&(f=0);var S=r.getGridColumnIndex();S>=r.__parent.__columnOptions.length&&(S=0);var y=s.parent.jHierarchyControlposition.children("[data-tchmi-creator-grid-rowindex="+f+"][data-tchmi-creator-grid-cellindex="+S+"]");0===y.length&&Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Fatal internal error: Could not find target grid cell for "+r.__parent.__id+" to attach highlight container."),y.append(s.jOriginalPosition),y.append(s.jHierarchyOriginalPosition),y.append(s.jControlPosition),y.append(s.jHierarchyControlposition),y.append(s.jAnchorContainer),y.append(s.jHierarchyAnchorContainer)}}else{var v=C.rootControlManager.getViewPortHighlightingSimulator();v.append(s.jOriginalPosition),v.append(s.jHierarchyOriginalPosition),v.append(s.jControlPosition),v.append(s.jHierarchyControlposition),v.append(s.jAnchorContainer),v.append(s.jHierarchyAnchorContainer),Y.System.SharedResources.jqBody.append(v)}C.interactionManager.refreshControlDimensionCache(s),s.isPartialRoot&&C.rootControlManager.setRootControl(r,s)}null!=t&&(t===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL&&C.__registerSyncView(),C.requestCurrentPartialContent(t,!1))}}},e.prototype.__onThemeDataChanged=function(){var r=this;return function(e){r.metaDataManager.refreshControlMetaData()}},e.prototype.__registerSyncView=function(){if(!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER||!0===TCHMI_ENABLE_DESIGNER_MODE_SLAVE){var e="Slave";!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&(e="Master"),new a.SyncCmdToCreatorRegisterSyncView({name:"RegisterSyncView",targetPartial:TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL,targetInstance:TCHMI_DYNAMIC_INSTANCE_ID,syncViewLevel:e,replyTo:null}).send(),Y.System.Services.Engineering.designerModeComManager.makeReadyForSynchronization(),!1!==TCHMI_ENABLE_DESIGNER_MODE_MASTER&&!0!==TCHMI_ENABLE_DESIGNER_MODE_SLAVE||new a.SyncCmdToCreatorRequestCurrentPartialEditorLockState({name:"RequestCurrentPartialEditorLockState",targetPartial:TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL,replyTo:TCHMI_DYNAMIC_INSTANCE_ID}).send()}},e.prototype.__resyncControls=function(e){var r={name:"SyncControls",targetPartial:TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL,controls:[],replyTo:null};for(var t in e){var o=e[t],n=Y.control[t];if(void 0!==n){var i=X.tchmi_utf8str_base64encode(n.__pcElement[0].outerHTML);null!==i?r.controls.push({targetControl:o.id,descriptionPath:Y.System.Services.controlManager.getDescriptionPath(n.getType()),controlHtml:i}):Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Failed to base64 encode html content of control="+t+".")}else Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Failed to resync control="+t+". Not found in control cache.")}new a.SyncCmdToCreatorSyncControls(r).send()},e.prototype.resyncSelectedControls=function(){this.__resyncControls(this.metaDataManager.getSelectedControlsMetaData())},e.prototype.requestCurrentPartialContent=function(e,r){void 0===r&&(r=!1);var t=TCHMI_DYNAMIC_INSTANCE_ID;!0===r&&(t="*");var o=null;try{o=X.tchmi_utf8str_base64encode(JSON.stringify({requestInstance:TCHMI_DYNAMIC_INSTANCE_ID,broadcast:r}))}catch(e){Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Unexpected exception="+e+".")}new a.SyncCmdToCreatorRequestCurrentPartialContent({name:"RequestCurrentPartialContent",targetPartial:e,piggyBack:o,replyTo:t}).send()},e.prototype.syncControl=function(e,r,t){var o=this;if(!r)return Y.Log.debug("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Synchronization failed. Invalid target control."),!1;if(!t)return Y.Log.debug("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Synchronization failed. Invalid or missing html."),!1;var n=Y.control[r];if(void 0===n)return Y.Log.debug("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Synchronization failed. Control="+r+" not found in control cache."),!1;var i=$(t);if(0===i.length)return!1;if(1!==i.length&&1!==(i=i.filter("div[data-tchmi-type]")).length)return Y.Log.debug("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Synchronization failed. Only one control is allowed but got "+i.length),!1;if(!i.attr("data-tchmi-type"))return Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Synchronization failed for control="+r+". Missing attribute=data-tchmi-type."),!1;if(!i.attr("id"))return Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Synchronization failed for control="+r+". Missing attribute=id."),!1;var a=n.__pcElement.clone();if(0===a.length)return!1;if(i[0].outerHTML===a[0].outerHTML)return!1;var s=n.__attrs,l=X.resolveAttributesFromControlElement(i),c=this.metaDataManager.getControlMetaData(r),_=l.id.value;if(r!==_&&n.__parent){var u=n.__parent.__pcElement.clone();return u.find("#"+r).replaceWith($(t)),this.syncControl(e,u.attr("id"),u[0].outerHTML),c.isSelected&&Y.EventProvider.register(_+".onAttached",function(e,r){o.select(_,!0),e.destroy()}),!0}var d={"data-tchmi-creator-visibility":!0,"data-tchmi-creator-locked":!0,"data-tchmi-creator-viewport-width":!0,"data-tchmi-creator-viewport-height":!0,"data-tchmi-zindex":!0},m=[],h=[];for(var g in l){var p=l[g];void 0!==(f=s[g])&&tchmi_equal(p.value,f.value)||m.push(p),d[p.name]&&delete d[p.name]}for(var E in s){var f;void 0===l[(f=s[E]).name]&&h.push(f)}for(var S in d){switch(S){case"data-tchmi-creator-visibility":null!==c&&(c.domVisibility=!0);break;case"data-tchmi-creator-locked":null!==c&&(c.locked=!1);break;case"data-tchmi-zindex":if(null!==c){var y=0;c.jOriginalPosition.css("z-index",1e3+y),c.jHierarchyOriginalPosition.css("z-index",1e3+y),c.jControlPosition.css("z-index",2e3+y),c.jHierarchyControlposition.css("z-index",2e3+y),c.jAnchorContainer.css("z-index",3e3+y),c.jHierarchyAnchorContainer.css("z-index",3e3+y)}}n.__element.removeAttr(S),n.__pcElement.removeAttr(S)}if(null!=m)for(var v=0,C=m.length;v<C;v++)switch((M=m[v]).name.toLowerCase()){case"data-tchmi-creator-visibility":if(!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&null!==c)switch(M.value){case"Collapsed":c.domVisibility=!1;break;default:c.domVisibility=!0}n.__element.attr(M.name,M.value);break;case"data-tchmi-creator-locked":if(!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&null!==c)switch(M.value){case"True":c.locked=!0;break;default:c.locked=!1}n.__element.attr(M.name,M.value);break;case"data-tchmi-creator-viewport-width":case"data-tchmi-creator-viewport-height":n.__element.attr(M.name,M.value);break;case"data-tchmi-zindex":!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&null!==c&&(y=parseInt(M.value,10),isNaN(y)&&(y=0),0<=y&&(c.jOriginalPosition.css("z-index",1e3+y),c.jHierarchyOriginalPosition.css("z-index",1e3+y),c.jControlPosition.css("z-index",2e3+y),c.jHierarchyControlposition.css("z-index",2e3+y),c.jAnchorContainer.css("z-index",3e3+y),c.jHierarchyAnchorContainer.css("z-index",3e3+y)))}var T=i[0].innerHTML;for("tchmi-html-host"===n.getType()&&null!=T&&n.setContent(T),T=null,v=0,C=h.length;v<C;v++)if(void 0!==(M=h[v]).descr&&null!==M.descr&&(M.valueType===X.ControlAttributeValueType.Simple&&n.__element.removeAttr(M.name),delete n.__attrs[M.name],!0!==M.descr.readOnly))if(!0===Y.Symbol.isSymbolExpression(M.value))try{Y.System.Services.bindingManager.removeBinding(M.descr.propertyName,n,!0)}catch(e){Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Synchronization failed. Unexpected exception="+e+" while removing binding for attribute="+M.descr.propertyName+" of control="+n.getId()+".")}else Y.System.Services.controlManager.setControlPropertyByAttribute(n,M.descr,null);for(v=0,C=m.length;v<C;v++){var M;if(void 0!==(M=m[v]).descr&&null!==M.descr&&(M.valueType===X.ControlAttributeValueType.Simple&&n.__element.attr(M.name,M.value),!0!==(n.__attrs[M.name]=M).descr.readOnly))if(!0===Y.Symbol.isSymbolExpression(M.value)){var b=!0,R=Y.System.Services.bindingManager.getBinding(M.descr.propertyName,n);if(null!=R){var N=R.getSymbol();if(null!=N){var w=N.getExpression();if(null!=w&&M.value===w.toString()){b=!1;break}}}if(!0===b)try{Y.System.Services.bindingManager.removeBinding(M.descr.propertyName,n,!1),Y.System.Services.bindingManager.createBinding(M.value,M.descr.propertyName,n)}catch(e){Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Synchronization failed. Unexpected exception="+e+" while creating binding for attribute="+M.descr.propertyName+" of control="+n.getId()+".")}}else{try{Y.System.Services.bindingManager.removeBinding(M.descr.propertyName,n,!1)}catch(e){Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Synchronization failed. Unexpected exception="+e+" while removing binding from attribute="+M.descr.propertyName+" of control="+n.getId()+".")}Y.System.Services.controlManager.setControlPropertyByAttribute(n,M.descr,M.value)}}if(!0===n.__isContainerControl){var O=i.children(),I=a.children("div[data-tchmi-type]"),A=[];for(v=0,C=I.length;v<C;v++){for(var D=I.eq(v),k=!0,P=0,L=O.length;P<L;P++)if("DIV"===O[P].nodeName&&!1!==O[P].hasAttribute("data-tchmi-type")&&D[0].id===O[P].id){k=!1;break}if(!0===k){A.push(D[0].id);var H=Y.control[D[0].id];H&&H.destroy()}}var x=[],F=-1;for(v=0,C=O.length;v<C;v++)if("DIV"===O[v].nodeName&&!1!==O[v].hasAttribute("data-tchmi-type")){F++;var V=!0;for(P=0,L=I.length;P<L;P++)if(I[P].id===O[v].id){V=!1;break}if(!0===V){x.push(O[v].id);try{this.createControl(e,r,F,O[v].outerHTML,null)}catch(e){Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Synchronization failed. Unexpected exception="+e+" while creating control="+O[v].id+".")}}}for(v=0,C=O.length;v<C;v++)if("DIV"===O[v].nodeName&&!1!==O[v].hasAttribute("data-tchmi-type")){var U=!1;for(P=0,L=x.length;P<L;P++)if(O[v].id===x[P]){U=!0;break}if(!0!==U){var G=!1;for(P=0,L=A.length;P<L;P++)if(O[v].id===A[P]){G=!0;break}if(!0!==G)try{this.syncControl(e,O[v].id,O[v].outerHTML)}catch(e){Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Synchronization failed. Unexpected exception="+e+" while syncing control="+O[v].id+".")}}}}var j=n.__pcElement;if(n.__pcElement=i.clone(),void 0!==n.__parent&&null!==n.__parent)for(var B=n.__parent;null!==B;)B.__pcElement.find("#"+tchmi_css_escape_selector(j.attr("id"))).replaceWith(n.__pcElement.clone()),B=B.__parent;if(!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&this.hierarchyManager.isDesignerModeControl(r)){var W=this.metaDataManager.refreshControlMetaData(r);if(null!=W)if(this.interactionManager.refreshControlDimensionCache(),!0===W.isPartialRoot)this.rootControlManager.setCreatorViewPortPosition(n);else if(n.__parent){var q=n.__parent;do{if("Content"===q.getHeightMode()||"Content"===q.getWidthMode()){var z=this.metaDataManager.getControlMetaData(q.__id);if(!z){q=null;break}if(z.isPartialRoot){this.rootControlManager.setCreatorViewPortPosition(q);break}q=q.__parent}else q=null}while(null!==q)}}return null!==c&&(c.jAnchorContainer[0].classList.toggle("tchmi-creator-control-locked",c.locked),c.jHierarchyAnchorContainer[0].classList.toggle("tchmi-creator-control-locked",c.locked),c.jAnchorContainer[0].classList.toggle("tchmi-creator-control-height-inactive","Content"===n.getHeightMode()),c.jAnchorContainer[0].classList.toggle("tchmi-creator-control-width-inactive","Content"===n.getWidthMode())),!0},e.prototype.createControl=function(e,r,t,o,n){void 0===n&&(n=null);var i=this,a=$(o);if(0!==a.length){var s=a.attr("data-tchmi-type");if(s){var l=a.attr("id");if(l)if(Y.Controls.get(l))Y.Log.error('[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Failed to create instance of control. Id: "'+l+'" does already exist.');else{var c=null;if(null!=r&&""!==r){if(void 0===(c=Y.control[r]))return void Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Failed to create control. Target parent control="+r+" not found in control cache.")}else{if(!("tchmi-view"===s&&void 0!==a.attr("data-tchmi-view")||"tchmi-content"===s&&void 0!==a.attr("data-tchmi-content")||"tchmi-user-control"===s&&void 0!==a.attr("data-tchmi-user-control")))return void Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Failed to create control. Only controls of type 'tchmi-view', 'tchmi-content' or 'tchmi-user-control' are valid as a root element.");a.attr("data-tchmi-partial-url",tchmi_path(TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL)).attr("data-tchmi-creator-partial-key",TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL)}var _=Y.System.Services.controlManager.compile(a[0].outerHTML,c,t);if(void 0!==_){if(null!==c){if(!0!==c.__isContainerControl||"function"!=typeof c.addChild)return void Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Failed to create control. Can't add child to a not 'TcHmiContainerControl' based control! Requested parent target control="+c.getId()+" has type="+c.getType()+".");if(0===t)c.__pcElement.prepend(_.__pcElement.clone());else{for(var u=c.__pcElement.children(),d=-1,m=0,h=0,g=u.length;h<g;h++)if("DIV"===u[h].nodeName&&!1!==u[h].hasAttribute("data-tchmi-type")){if(t===++m){d=h;break}if(t<m)break}-1===d?c.__pcElement.append(_.__pcElement.clone()):u.eq(d).after(_.__pcElement.clone())}}else{var p=_.getType();if("tchmi-view"!==p&&"tchmi-user-control"!==p&&"tchmi-content"!==p)return void Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Failed to create control. Can't load root element because it is of type="+p+" but only controls of type tchmi-view, tchmi-content and tchmi-user-control are allowed as root element.");Y.System.Services.viewManager.loadViewObject(_)}var E=_.getId();Y.EventProvider.register(E+".onAttached",function(e,r){e.destroy(),"function"==typeof n&&n.call(i,{error:Y.Errors.NONE})})}}else Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Failed to create control. Invalid control html. Missing attribute=id.")}else Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Failed to create control. Invalid control html. Missing attribute=data-tchmi-type.")}else Y.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Failed to create control. Invalid control html.")},e.prototype.select=function(e,r){if(void 0===r&&(r=!1),!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER){var t=this.metaDataManager.getControlMetaData(e);if(null!==t){var o=Y.control[t.id];if(void 0!==o){if(t.isSelectedPrev=t.isSelected,t.isSelected=!0,this.metaDataManager.selectControl(t),this.highlightManager.processHighlightType(t),o.__parent&&o.__parent.getChildren&&t.parent){for(var n=!1,i=0,a=o.__parent.getChildren();i<a.length;i++){var s=a[i],l=this.metaDataManager.getControlMetaData(s.__id);if(l&&l.isSelected){n=!0;break}}t.parent.jControlPosition[0].classList.toggle("tchmi-creator-childcontrol-selected",n)}!0!==r&&this.__resyncControls(this.metaDataManager.getSelectedControlsMetaData())}}else Y.Log.debug("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeManager] Failed to select control="+e+".")}},e.prototype.unselect=function(e,r){if(void 0===r&&(r=!1),!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER){var t=this.metaDataManager.getControlMetaData(e);if(null!==t){var o=Y.control[t.id];if(void 0!==o){if(t.isSelected=!1,this.metaDataManager.unselectControl(t),t.isSelectedPrev=!1,this.highlightManager.processHighlightType(t),o.__parent&&o.__parent.getChildren&&t.parent){for(var n=!1,i=0,a=o.__parent.getChildren();i<a.length;i++){var s=a[i],l=this.metaDataManager.getControlMetaData(s.__id);if(l&&l.isSelected){n=!0;break}}t.parent.jControlPosition[0].classList.toggle("tchmi-creator-childcontrol-selected",n)}!0!==r&&this.resyncSelectedControls()}}}},e.prototype.selectEach=function(e){this.unselectEach(!0);var r=this.metaDataManager.getControlMetaData();for(var t in r)!1===r[t].isPartialRoot&&this.select(t,!0);!0!==e&&this.resyncSelectedControls()},e.prototype.unselectEach=function(e){var r=this.metaDataManager.getControlMetaData();for(var t in r)!0===r[t].isSelected&&this.unselect(t,!0);!0!==e&&this.resyncSelectedControls()},e.prototype.setControlLocked=function(e,r){var t=this.metaDataManager.getControlMetaData(e);null!==t&&(t.locked=r,t.jAnchorContainer[0].classList.toggle("tchmi-creator-control-locked",r),t.jHierarchyAnchorContainer[0].classList.toggle("tchmi-creator-control-locked",r));var o=Y.Controls.get(e);o&&(r?(o.__element.attr("data-tchmi-creator-locked","True"),o.__pcElement.attr("data-tchmi-creator-locked","True")):(o.__element.removeAttr("data-tchmi-creator-locked"),o.__pcElement.removeAttr("data-tchmi-creator-locked")))},e.prototype.lock=function(){if((this.__locked=!0)===TCHMI_ENABLE_DESIGNER_MODE_SLAVE)Y.System.Services.dialogManager.updateText("__TcHmiDesignerLock","Target document was locked due to critical changes!<br />This live-view instance will be reloaded if the document state is cleared..."),Y.System.Services.dialogManager.showDialog("__TcHmiDesignerLock",!0,Y.DialogManager.DialogType.Overlay);else if(!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER){Y.System.Services.dialogManager.updateText("__TcHmiDesignerLock",""),Y.System.Services.dialogManager.showDialog("__TcHmiDesignerLock",!0,Y.DialogManager.DialogType.Overlay),this.unselectEach(!0);var e=X.Services.viewManager.getView();null!=e&&e.__element.css({filter:"blur(2px)"})}Y.System.SharedResources.jqBody.css({overflow:"hidden"})},e.prototype.unlock=function(){throw new Error("Not implemented!")},e.prototype.isLocked=function(){return this.__locked},e}(),a.DesignerModeManager=e}(TcHmi||(TcHmi={})),function(s){var e,r,t;e=s.System||(s.System={}),r=e.Engineering||(e.Engineering={}),t=function(){function e(e){this.__controlsMetaData={},this.__selectedControlsMetaData={},this.__selectedControlIdsWithChildren=[],this.__designerModeManager=e,s.EventProvider.register("onControlDetached",this.__onControlDetached())}return e.prototype.register=function(e){this.__controlsMetaData[e.id]=e},e.prototype.unregister=function(e){void 0!==this.__controlsMetaData[e]&&(!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&this.__designerModeManager.highlightManager.handleControlRemoved(this.__controlsMetaData[e]),delete this.__controlsMetaData[e],!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&this.__designerModeManager.interactionManager.refreshControlDimensionCache()),void 0!==this.__selectedControlsMetaData[e]&&(delete this.__selectedControlsMetaData[e],this.__rebuildSelectIdCache())},e.prototype.__onControlDetached=function(){var t=this;return function(e,r){null!=r&&t.unregister(r.__id)}},e.prototype.getControlMetaData=function(e){return null==e?this.__controlsMetaData:void 0!==this.__controlsMetaData[e]?this.__controlsMetaData[e]:null},e.prototype.refreshControlMetaData=function(e){var r,t;if("string"==typeof e)r=this.getControlMetaData(e),t=e;else{if(!e){for(var o in this.__designerModeManager.interactionManager.clearSnapPositionCache(),this.__controlsMetaData)this.refreshControlMetaData(this.__controlsMetaData[o]);return null}t=(r=e).id}if(null==r)return null;var n=s.control[t];if(null==n)return s.Log.error('[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeComManager] Failed to refresh Control Meta Data of control "'+t+'": Not found in control cache.\n'),null;var i=n.getElement();return r.controlAttributeDimension=this.__getControlAttributeDimension(n),r.controlCssPixelDimension=this.__getControlCssPixelDimension(n),r.relativeControlRotation=this.__getRelativeRotation(i),r.absoluteParentRotation=this.__getAbsoluteRotation(i.offsetParent()),!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER&&(this.__designerModeManager.highlightManager.setContainerPositions(n,r),this.__designerModeManager.highlightManager.updateGripCursors(r),this.__designerModeManager.interactionManager.refreshControlDimensionCache(r)),r},e.prototype.getSelectedControlsMetaData=function(){return this.__selectedControlsMetaData},e.prototype.selectControl=function(e){var n=this;this.__selectedControlsMetaData[e.id]=e;var r=s.control[e.id];if(void 0!==r){var t=s.System.resolveControlHierarchy(r,null),i=function(e){var r=e.ctrl;if(-1===n.__selectedControlIdsWithChildren.indexOf(r.__id)&&n.__selectedControlIdsWithChildren.push(r.__id),!0===r.__isContainerControl)for(var t=0,o=e.children_hierarchy.length;t<o;t++)i(e.children_hierarchy[t])};i(t),this.__rebuildSelectIdCache(e)}},e.prototype.unselectControl=function(e){delete this.__selectedControlsMetaData[e.id],this.__rebuildSelectIdCache()},e.prototype.getSelectedControlIdsWithChildren=function(){return this.__selectedControlIdsWithChildren},e.prototype.__rebuildSelectIdCache=function(e){var n=this;if(void 0!==e){if(!0!==e.isPartialRoot){var r=s.control[e.id];if(void 0!==r){var t=s.System.resolveControlHierarchy(r,null),i=function(e){var r=e.ctrl;if(-1===n.__selectedControlIdsWithChildren.indexOf(r.__id)&&n.__selectedControlIdsWithChildren.push(r.__id),!0===r.__isContainerControl)for(var t=0,o=e.children_hierarchy.length;t<o;t++)i(e.children_hierarchy[t])};i(t)}}}else for(var o in this.__selectedControlIdsWithChildren=[],this.__selectedControlsMetaData){var a=this.__selectedControlsMetaData[o];!1===a.isPartialRoot&&this.__rebuildSelectIdCache(a)}},e.prototype.__getControlAttributeDimension=function(e){return{topValue:e.getTop(),topUnit:e.getTopUnit(),leftValue:e.getLeft(),leftUnit:e.getLeftUnit(),widthValue:e.getWidth(),widthUnit:e.getWidthUnit(),widthMode:e.getWidthMode(),rightValue:e.getRight(),rightUnit:e.getRightUnit(),heightValue:e.getHeight(),heightUnit:e.getHeightUnit(),heightMode:e.getHeightMode(),bottomValue:e.getBottom(),bottomUnit:e.getBottomUnit()}},e.prototype.__getControlCssPixelDimension=function(e){var r={width:null,height:null,left:null,top:null,right:null,bottom:null},t=e.getElement();if(t){var o=t.css("width");o&&(r.width=parseFloat(o));var n=t.css("height");n&&(r.height=parseFloat(n));var i=t.css("left");i&&(r.left=parseFloat(i));var a=t.css("top");a&&(r.top=parseFloat(a));var s=t.css("right");s&&(r.right=parseFloat(s));var l=t.css("bottom");l&&(r.bottom=parseFloat(l))}return r},e.prototype.__getAbsoluteRotation=function(e){if(0===e.length)return 0;var r=0,t=e.offsetParent();return 0===t.length||t[0].nodeName&&"html"===t[0].nodeName.toLowerCase()||(r=this.__getAbsoluteRotation(t)),r+this.__getRelativeRotation(e)},e.prototype.__getRelativeRotation=function(e){if(0===e.length)return 0;var r=e.css("transform"),t=0;if("none"!==r){var o=r.substring(r.indexOf("(")+1,r.lastIndexOf(")")).split(",");if(6===o.length){var n=parseFloat(o[0]),i=parseFloat(o[1]);t=Math.round(Math.atan2(i,n)*(180/Math.PI))}}return t},e}(),r.DesignerModeControlMetaDataManager=t}(TcHmi||(TcHmi={})),function(d){var e,r,t;e=d.System||(d.System={}),r=e.Engineering||(e.Engineering={}),t=function(){function e(e){this.__transactionLock=[],this.__designerModeManager=e}return e.prototype.beginTransaction=function(e){-1===this.__transactionLock.indexOf(e)&&this.__transactionLock.push(e)},e.prototype.commitTransaction=function(e){var r=this.__transactionLock.indexOf(e);-1!==r&&this.__transactionLock.splice(r,1),0===this.__transactionLock.length&&this.__sendPendingCommands()},e.prototype.__sendPendingCommands=function(){},e.prototype.transactionActive=function(){return 0===this.__transactionLock.length},e.prototype.updatePcElementAndSync=function(e){var r=[],t=["top","left","width","right","height","bottom"],o=this.__designerModeManager.metaDataManager.getSelectedControlsMetaData();for(var n in o){var i=o[n];if(null!=i){var a=d.control[i.id];if(void 0!==a){r.push(a);for(var l=a.__pcElement.clone(),c=d.StyleProvider.getSimpleElementStyle(a.__element,t),s=function(e){if(void 0!==c[e]){var r="data-tchmi-"+e,t=l.attr(r);if(d.Symbol.isSymbolExpression(t)){var o=new d.System.Symbol(t);if(o){if(o.getExpression().getType()===d.SymbolType.Server)return o.destroy(),o=null,"continue";o.read(function(e){e.error===d.Errors.NONE&&(t=e.value),o.destroy(),o=null})}}"string"==typeof t&&(t=parseFloat(t));var n="data-tchmi-"+e+"-unit",i=l.attr(n),a=c[e].replace(/[-.0-9]/g,"");"px"!==a&&"%"!==a&&(a="px"),void 0===i?"px"!==a&&l.attr(n,a):i!==a&&l.attr(n,a);var s=parseFloat(c[e]);Math.round(t)===Math.round(s)||void 0===t&&["height","width"].includes(e)&&["Content","Parent"].includes(l.attr("data-tchmi-"+e+"-mode"))||("px"===a?l.attr(r,s.toFixed(0)):"%"===a&&l.attr(r,s.toFixed(1)))}},_=0,u=t;_<u.length;_++)s(u[_]);!0===i.domVisibility?l.removeAttr("data-tchmi-creator-visibility"):l.attr("data-tchmi-creator-visibility","False"),!1===i.locked?l.removeAttr("data-tchmi-creator-locked"):l.attr("data-tchmi-creator-locked","True"),0===this.__transactionLock.length&&this.__designerModeManager.syncControl(TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL,i.id,l[0].outerHTML)}}}d.EventProvider.raise(e,r)},e}(),r.DesignerModeMasterSyncManager=t}(TcHmi||(TcHmi={})),function(R){var e,r,t;e=R.System||(R.System={}),r=e.Engineering||(e.Engineering={}),t=function(){function e(e){this.__dragtargetContainerHighlighting={},this.__designerModeManager=e,R.System.SharedResources.jqBody.on("dragover.DesignerModeMasterHierarchyManager.body",function(e){e.preventDefault()}).on("dragenter.DesignerModeMasterHierarchyManager.body",this.__onDragEnter()).on("dragleave.DesignerModeMasterHierarchyManager.body",this.__onDragLeave())}return e.prototype.isDesignerModeControl=function(n){var i=!1,a=function(e){if(e.ctrl.__id!==n)for(var r=0,t=e.children_hierarchy.length;r<t;r++){var o=e.children_hierarchy[r];if(a(o),!0===i)return}else i=!0},e=void 0,r=$('div[data-tchmi-creator-partial-key="'+TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL+'"]');if(0<r.length&&(e=R.control[r[0].id]),void 0!==e){var t=R.System.resolveControlHierarchy(e,null);a(t)}return i},e.prototype.registerContainerControl=function(e){e.jControlPosition.on("dragover.DesignerModeMasterHierarchyManager."+e.id,function(e){e.preventDefault()}),e.jControlPosition.on("dragenter.DesignerModeMasterHierarchyManager."+e.id,this.__onDragEnter()),e.jControlPosition.on("dragleave.DesignerModeMasterHierarchyManager."+e.id,this.__onDragLeave())},e.prototype.registerContainerElement=function(e){e.on("dragenter.DesignerModeMasterHierarchyManager",this.__onDragEnter()).on("dragleave.DesignerModeMasterHierarchyManager",this.__onDragLeave())},e.prototype.__onDragEnter=function(){var r=this;return function(e){e.preventDefault(),r.addHighlightDropTarget({left:e.pageX,top:e.pageY},e.target)}},e.prototype.__onDragLeave=function(){var t=this;return function(e){var r=(e.target.hasAttribute("data-tchmi-creator-target-control")?e.target.getAttribute("data-tchmi-creator-target-control"):"body")+"_r"+(e.target.hasAttribute("data-tchmi-creator-grid-rowindex")?e.target.getAttribute("data-tchmi-creator-grid-rowindex"):null)+"_c"+(e.target.hasAttribute("data-tchmi-creator-grid-cellindex")?e.target.getAttribute("data-tchmi-creator-grid-cellindex"):null);t.__dragtargetContainerHighlighting[r]&&(t.__dragtargetContainerHighlighting[r].classList.remove("tchmi-creator-possibledroptarget"),delete t.__dragtargetContainerHighlighting[r])}},e.prototype.addHighlightDropTarget=function(e,r){var t=this.getContainerFromPoint(e);if(this.removeHighlightDropTarget(),t&&t.jHighlighter){var o=(r.hasAttribute("data-tchmi-creator-target-control")?r.getAttribute("data-tchmi-creator-target-control"):"body")+"_r"+t.rowIndex+"_c"+t.cellIndex;t.jHighlighter[0].classList.add("tchmi-creator-possibledroptarget"),this.__dragtargetContainerHighlighting[o]=t.jHighlighter[0]}},e.prototype.removeHighlightDropTarget=function(){for(var e in this.__dragtargetContainerHighlighting)this.__dragtargetContainerHighlighting[e].classList.remove("tchmi-creator-possibledroptarget"),delete this.__dragtargetContainerHighlighting[e]},e.prototype.getContainerFromPoint=function(e){var s=R.System.Services.viewManager.getView();if(null===s)return null;var r,t=$(document.elementFromPoint(e.left-window.scrollX,e.top-window.scrollY)),o=void 0;if(0===t.length||t[0]===document.body){o=s;var n=this.__designerModeManager.metaDataManager.getControlMetaData(o.__id);n&&(r=n.jControlPosition)}else{var l=function(e){var r=e.ctrl,t=r.getType();if(("data-tchmi-view"===t||"data-tchmi-content"===t||"data-tchmi-user-control"===t)&&r.getId()!==s.getId())return[];var o=[];if(!0===r.__isContainerControl){o.push(r);for(var n=0,i=e.children_hierarchy.length;n<i;n++){var a=l(e.children_hierarchy[n]);o=o.concat(a)}}return o},i=R.System.resolveControlHierarchy(s,null),a=l(i),c=t;do{var _=c.attr("data-tchmi-creator-target-control");if(void 0!==_){for(var u=!1,d=0,m=a.length;d<m;d++){var h=a[d];if(h.__id===_){o=h,r=c,u=!0;break}}if(!0===u)break}c=c.parent()}while(0<c.length);(c=null)==o&&(o=s)}var g=e.left,p=e.top,E=null,f=null;if("tchmi-grid"===o.getType()){if(t[0].classList.contains("tchmi-creator-gridcell"))r=t;else{var S=t.parent();S.length&&S[0].classList.contains("tchmi-creator-hierarchy-gridcellposition")&&(r=S)}var y=parseInt(r.attr("data-tchmi-creator-grid-rowindex"),10),v=parseInt(r.attr("data-tchmi-creator-grid-cellindex"),10);if(!isNaN(v)&&!isNaN(y)){E=y,f=v;var C=r.position();g-=C.left,p-=C.top}}var T=o.__element;if(0<T.length)do{var M=T.position();g-=M.left,p-=M.top,T=T.offsetParent(),g-=parseFloat(T.css("border-left-width")),p-=parseFloat(T.css("border-top-width"))}while(0<T.length&&!0!==T.is(R.System.SharedResources.jqBody)&&T[0]!==document.documentElement);var b=this.__designerModeManager.rootControlManager.getCreatorZoomFactor();return{tco:o,jHighlighter:r,centerX:Math.round(g/b),centerY:Math.round(p/b),rowIndex:E,cellIndex:f}},e}(),r.DesignerModeMasterHierarchyManager=t}(TcHmi||(TcHmi={})),function(O){var e,g,r;e=O.System||(O.System={}),g=e.Engineering||(e.Engineering={}),r=function(){function e(e){this.__rootControlMetaElements=[],this.__scrollPosition={left:0,top:0},this.__creatorZoomFactor=1,this.__viewportCurrentWidth=0,this.__vpCurrentHeight=0,this.__scrollAnimationFrameId=0,this.__zoomAnimationFrameId=0,this.__designerModeManager=e,document.body.classList.add("tchmi-creator-chessboard"),O.System.SharedResources.jqBody.css({overflow:"hidden"}),this.__viewPortSimulator=$('<div class="tchmi-creator-view-port-simulator"></div>'),this.__viewPortHighlightingSimulator=$('<div class="tchmi-creator-view-port-highlighting"></div>'),window.setInterval(this.__onRequiredViewPortSizeWatchTick(),50)}return e.prototype.getCreatorZoomFactor=function(){return this.__creatorZoomFactor},e.prototype.getViewPortSimulator=function(){return this.__viewPortSimulator},e.prototype.getViewPortHighlightingSimulator=function(){return this.__viewPortHighlightingSimulator},e.prototype.scroll=function(e){var r=this;e.left===this.__scrollPosition.left&&e.top===this.__scrollPosition.top||(this.__scrollPosition.left=e.left,this.__scrollPosition.top=e.top,0!==this.__scrollAnimationFrameId&&window.cancelAnimationFrame(this.__scrollAnimationFrameId),this.__scrollAnimationFrameId=window.requestAnimationFrame(function(){document.scrollingElement.scrollLeft=r.__scrollPosition.left,document.scrollingElement.scrollTop=r.__scrollPosition.top,r.__scrollAnimationFrameId=0}))},e.prototype.setCreatorZoom=function(e){var r=this;void 0!==e&&this.__creatorZoomFactor!==e&&(this.__creatorZoomFactor=e,0!==this.__zoomAnimationFrameId&&window.cancelAnimationFrame(this.__zoomAnimationFrameId),this.__zoomAnimationFrameId=window.requestAnimationFrame(function(){1!==r.__creatorZoomFactor?r.__viewPortSimulator.css("transform","scale("+r.__creatorZoomFactor+")"):r.__viewPortSimulator.css("transform",""),r.__designerModeManager.metaDataManager.refreshControlMetaData(),r.__zoomAnimationFrameId=0}))},e.prototype.setRootControl=function(e,r){this.setCreatorViewPortPosition(e),this.__rootControlMeta=r,this.__rootControlMetaElements[0]=this.__rootControlMeta.jControlPosition,this.__rootControlMetaElements[1]=this.__rootControlMeta.jAnchorContainer},e.prototype.__onRequiredViewPortSizeWatchTick=function(){var h=this;return function(){if(h.__rootControlMeta){for(var e=0,r=0,t=0,o=h.__rootControlMetaElements.length;t<o;t++){var n=h.__rootControlMetaElements[t];if(null!=n){var i=n[0].getBoundingClientRect(),a=i.width,s=i.height,l=n[0].offsetWidth,c=n[0].offsetHeight,_=n[0].scrollWidth-l,u=n[0].scrollHeight-c,d=a+(i.left+window.pageXOffset-document.documentElement.clientLeft)+_,m=s+(i.top+window.pageYOffset-document.documentElement.clientTop)+u;e<d&&(e=d),r<m&&(r=m)}}e=Math.floor(e),r=Math.floor(r),e===h.__viewportCurrentWidth&&r===h.__vpCurrentHeight||(new g.SyncCmdToCreatorRequestRequiredViewPortSize({name:"RequestRequiredViewPortSize",targetPartial:TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL,width:e,height:r,replyTo:TCHMI_DYNAMIC_INSTANCE_ID}).send(),h.__viewportCurrentWidth=e,h.__vpCurrentHeight=r)}}},e.prototype.setCreatorViewPortPosition=function(e){if(e){var r=1024,t=parseInt(e.__element.attr("data-tchmi-creator-viewport-width"),10);!isNaN(t)&&0<t?r=t:$.isNumeric(O.System.config.creatorSettings.viewport.defaultWidth)&&0<O.System.config.creatorSettings.viewport.defaultWidth&&(r=O.System.config.creatorSettings.viewport.defaultWidth);var o=!1,n=e.getWidth(),i=e.getWidthUnit(),a=e.getWidthMode();if("Parent"===a)n=null;else if("Content"===a){var s=O.StyleProvider.getSimpleElementStyle(e.__element,"width").width;if(s){var l=parseInt(s,10);n=isNaN(l)||-1===s.indexOf("px")?null:l}else n=null}if("%"===i?o=!0:null===n&&(o=!0),!1===o){var c=e.getMinWidth(),_=e.getMinWidthUnit(),u=c;null!==c&&"%"===_&&(u=c*r/100),null!==u&&n<u&&(o=!0)}if(!1===o){var d=e.getMaxWidth(),m=e.getMaxWidthUnit(),h=d;null!==d&&"%"===m&&(h=d*r/100),null!==h&&h<n&&(o=!0)}!1===o&&(r=parseInt(e.__element.css("left"),10)+parseInt(e.__element.css("width"),10));var g=768,p=parseInt(e.__element.attr("data-tchmi-creator-viewport-height"),10);!isNaN(p)&&0<p?g=p:$.isNumeric(O.System.config.creatorSettings.viewport.defaultHeight)&&0<O.System.config.creatorSettings.viewport.defaultHeight&&(g=O.System.config.creatorSettings.viewport.defaultHeight);var E=!1,f=e.getHeight(),S=e.getHeightUnit(),y=e.getHeightMode();if("Parent"===y)f=null;else if("Content"===y){var v=O.StyleProvider.getSimpleElementStyle(e.__element,"height").height;if(v){var C=parseInt(v,10);isNaN(C)||-1===v.indexOf("px")||(f=C)}}if("%"===S?E=!0:null===f&&(E=!0),!1===E){var T=e.getMinHeight(),M=e.getMinHeightUnit(),b=T;null!==T&&"%"===M&&(b=T*g/100),null!==b&&f<b&&(E=!0)}if(!1===E){var R=e.getMaxHeight(),N=e.getMaxHeightUnit(),w=R;null!==R&&"%"===N&&(w=R*g/100),null!==w&&w<f&&(E=!0)}!1===E&&(g=parseInt(e.__element.css("top"),10)+parseInt(e.__element.css("height"),10)),O.StyleProvider.setSimpleElementStyle(this.__viewPortSimulator,{width:r+"px",height:g+"px"}),O.StyleProvider.setSimpleElementStyle(this.__viewPortHighlightingSimulator,{width:r*this.__creatorZoomFactor+"px",height:g*this.__creatorZoomFactor+"px"})}},e}(),g.DesignerModeMasterRootControlManager=r}(TcHmi||(TcHmi={})),function(O){var e,r,t;e=O.System||(O.System={}),r=e.Engineering||(e.Engineering={}),t=function(){function e(e){this.__highlightContainerVisibility=!0,this.__selectorGripsId=["TopLeft","TopCenter","TopRight","CenterRight","BottomRight","BottomCenter","BottomLeft","CenterLeft"],this.__selectorGrips=["nwse","ns","nesw","ew","nwse","ns","nesw","ew"],this.__designerModeManager=e,O.EventProvider.register("System.onControlResized",this.__onControlResized()),O.EventProvider.register("System.onControlMoved",this.__onControlMoved()),O.EventProvider.register("System.onControlVisibilityChanged",this.__onControlVisibilityChanged()),O.EventProvider.register("System.onControlGetRowCountChanged",this.__onGridRowOrColumnChanged()),O.EventProvider.register("System.onControlGetColumnCountChanged",this.__onGridRowOrColumnChanged()),O.EventProvider.register("System.onGridCellResized",this.__onGridCellResized()),O.EventProvider.register("System.onControlGridRowIndexChanged",this.__onGridRowOrColumnIndexChanged()),O.EventProvider.register("System.onControlGridColumnIndexChanged",this.__onGridRowOrColumnIndexChanged())}return e.prototype.handleControlRemoved=function(e){e.jOriginalPosition.remove(),e.jHierarchyOriginalPosition.remove(),e.jControlPosition.remove(),e.jHierarchyControlposition.remove(),e.jAnchorContainer.remove(),e.jHierarchyAnchorContainer.remove()},e.prototype.__onControlResized=function(){var o=this;return function(e,r){if(!0!==o.__designerModeManager.controlResizeManager.getControlResizing()){var t=o.__designerModeManager.metaDataManager.getControlMetaData(r.__id);null!==t&&(r.__parent&&t.parent&&!0===t.parent.isGridControl&&o.setGridcellContainerPositions(r.__parent,t.parent),o.setContainerPositions(r,t),t.isPartialRoot&&o.__designerModeManager.rootControlManager.setCreatorViewPortPosition(r))}}},e.prototype.__onControlMoved=function(){var o=this;return function(e,r){if(!0!==o.__designerModeManager.controlMoveManager.getControlMoveActive()){var t=o.__designerModeManager.metaDataManager.getControlMetaData(r.__id);null!==t&&(r.__parent&&t.parent&&!0===t.parent.isGridControl&&o.setGridcellContainerPositions(r.__parent,t.parent),o.setContainerPositions(r,t))}}},e.prototype.__onControlVisibilityChanged=function(){var o=this;return function(e,r){var t=o.__designerModeManager.metaDataManager.getControlMetaData(r.__id);null!==t&&("Collapsed"===r.getVisibility()?t.controlCollapsed=!0:t.controlCollapsed=!1,o.setContainerPositions(r,t))}},e.prototype.__onGridRowOrColumnIndexChanged=function(){var a=this;return function(e,r){if(r.__parent&&"tchmi-grid"===r.__parent.getType()){var t=a.__designerModeManager.metaDataManager.getControlMetaData(r.__id);if(null!==t&&null!==t.parent){var o=r.getGridRowIndex();o>=r.__parent.__rowOptions.length&&(o=0);var n=r.getGridColumnIndex();n>=r.__parent.__columnOptions.length&&(n=0);var i=t.parent.jHierarchyControlposition.children("[data-tchmi-creator-grid-rowindex="+o+"][data-tchmi-creator-grid-cellindex="+n+"]");0===i.length&&O.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeMasterHighlightManager] Fatal internal error: Could not find target grid cell for "+r.__parent.__id+" to attach highlight container."),i.append(t.jOriginalPosition),i.append(t.jHierarchyOriginalPosition),i.append(t.jControlPosition),i.append(t.jHierarchyControlposition),i.append(t.jAnchorContainer),i.append(t.jHierarchyAnchorContainer)}}}},e.prototype.__onGridRowOrColumnChanged=function(){var a=this;return function(e,r){var t=a.__designerModeManager.metaDataManager.getControlMetaData(r.__id);if(null!==t&&(a.createGridHighlighter(r,t),"function"==typeof r.getChildren)){for(var o=0,n=r.getChildren();o<n.length;o++){var i=n[o];a.setContainerPositions(i,a.__designerModeManager.metaDataManager.getControlMetaData(i.__id))}a.__designerModeManager.interactionManager.refreshControlDimensionCache()}}},e.prototype.__onGridCellResized=function(){var o=this;return function(e,r){if(!0!==o.__designerModeManager.controlResizeManager.getControlResizing()){var t=o.__designerModeManager.metaDataManager.getControlMetaData(r.__id);null!==t&&(o.setGridcellContainerPositions(r,t),o.__designerModeManager.interactionManager.refreshControlDimensionCache())}}},e.prototype.setHighlightContainerVisibility=function(e){this.__highlightContainerVisibility=e;var r=this.__designerModeManager.metaDataManager.getControlMetaData();for(var t in r){var o=r[t];this.processHighlightType(o)}this.processDomVisibility()},e.prototype.setCreatorVisibilityAttribute=function(e,r){var t=this.__designerModeManager.metaDataManager.getControlMetaData(e);null!==t&&(t.domVisibility=r,this.processDomVisibility(t))},e.prototype.processDomVisibility=function(e){var r;if(!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER)for(var t in r=e?{singleCtrl:e}:this.__designerModeManager.metaDataManager.getControlMetaData()){var o=r[t],n=O.control[o.id];n?(n.__element[0].classList.toggle("tchmi-creator-controlhidden",!1===o.domVisibility),!1===o.domVisibility?(o.jOriginalPosition.css({display:"none"}),o.jHierarchyOriginalPosition.css({display:"none"}),o.jControlPosition.css({display:"none"}),o.jHierarchyControlposition.css({display:"none"}),o.jAnchorContainer.css({display:"none"}),o.jHierarchyAnchorContainer.css({display:"none"})):(o.jOriginalPosition.css({display:""}),o.jHierarchyOriginalPosition.css({display:""}),o.jControlPosition.css({display:""}),o.jHierarchyControlposition.css({display:""}),o.jAnchorContainer.css({display:""}),o.jHierarchyAnchorContainer.css({display:""}))):O.Log.error('[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeMasterHighlightManager] Failed to handle control "'+o.id+'": Not found in control cache.\n')}},e.prototype.__handleOuterDimension=function(e,r,t,o,n,i,a,s,l){var c=a.__element,_=s.jOriginalPosition.children(".tchmi-creator-distance-"+r),u=parseFloat(c.css(r)),d=u*l;if("top"!==r&&20<=d||"top"===r&&35<=d)O.StyleProvider.setSimpleElementStyle(_,{width:d+"px",display:"","background-color":"","border-color":"",opacity:""});else{var m=30;-9<=d&&(m=20),"top"===r&&(m+=17),O.StyleProvider.setSimpleElementStyle(_,{width:m+"px",display:"","background-color":"transparent","border-color":"transparent",opacity:""})}var h=!0;if(null!==t){if("px"===o)e[r]=d+o,!0!==this.__designerModeManager.controlResizeManager.getControlResizing()&&!0!==this.__designerModeManager.controlMoveManager.getControlMoveActive()&&t?_.text(t.toFixed(0)+o):_.text(u.toFixed(0)+o);else if("%"===o){var g=void 0;"top"===r||"bottom"===r?g=parseFloat(c.parent().css("height")):"left"!==r&&"right"!==r||(g=parseFloat(c.parent().css("width")));var p=u/g*100;e[r]=p+o,!0!==this.__designerModeManager.controlResizeManager.getControlResizing()&&!0!==this.__designerModeManager.controlMoveManager.getControlMoveActive()&&t?_.text(t.toFixed(1)+o):_.text(p.toFixed(1)+o)}3!=++n||"right"!==r&&"bottom"!==r||(h=!1,O.StyleProvider.setSimpleElementStyle(_,{width:"40px",display:"",opacity:"0.5"}),"%"!==o&&d<=7&&_.text(u.toFixed(1)))}else h=!1,O.StyleProvider.setSimpleElementStyle(_,"display","none");return s.jOriginalPosition[0].classList.toggle("tchmi-creator-control-definedfrom"+r,h),n},e.prototype.__handleInnerDimension=function(e,r,t,o,n,i,a,s,l,c){var _=s.__element,u=l.jOriginalPosition.children(".tchmi-creator-distance-"+r);if(l.controlCollapsed)e[r]="0",O.StyleProvider.setSimpleElementStyle(u,{display:"none"}),i++;else{var d=parseFloat(_.css(r));if(O.StyleProvider.setSimpleElementStyle(u,{width:d*c+"px",display:"",opacity:""}),"px"===o){var m=d*c;e[r]=m+o,!0!==this.__designerModeManager.controlResizeManager.getControlResizing()&&!0!==this.__designerModeManager.controlMoveManager.getControlMoveActive()&&t?u.text(t.toFixed(0)+o):u.text(d.toFixed(0)+o),"Parent"!==n&&null!==t&&i++}else"%"===o&&(m=d/parseFloat(_.parent().css(r))*100,e[r]=m+o,!0!==this.__designerModeManager.controlResizeManager.getControlResizing()&&!0!==this.__designerModeManager.controlMoveManager.getControlMoveActive()&&t?u.text(t.toFixed(1)+o):u.text(m.toFixed(1)+o),"Parent"!==n&&null!==t&&i++);"Parent"===n||"Content"===n?null!==t?O.StyleProvider.setSimpleElementStyle(u,{opacity:"0.5"}):O.StyleProvider.setSimpleElementStyle(u,{display:"none"}):"Value"===n&&(null!==t?O.StyleProvider.setSimpleElementStyle(u,{opacity:"1.0"}):O.StyleProvider.setSimpleElementStyle(u,{display:"none"}))}return i},e.prototype.setContainerPositions=function(e,r){if(null!=e){var t=e.__element;if(t&&0!==t.length&&null!=r&&!1!==r.domVisibility){var o=this.__designerModeManager.rootControlManager.getCreatorZoomFactor(),n={top:"",height:"",bottom:"",left:"",width:"",right:""},i=0,a=t.parent().outerHeight(),s=e.getTop(),l=e.getTopUnit();i=this.__handleOuterDimension(n,"top",s,l,i,a,e,r,o),s=e.getHeight(),l=e.getHeightUnit();var c=e.getHeightMode();i=this.__handleInnerDimension(n,"height",s,l,c,i,a,e,r,o),s=e.getBottom(),l=e.getBottomUnit(),(i=this.__handleOuterDimension(n,"bottom",s,l,i,a,e,r,o))<2&&this.__handleOuterDimension(n,"top",0,"px",i,a,e,r,o),i=0,a=t.parent().outerWidth(),s=e.getLeft(),l=e.getLeftUnit(),i=this.__handleOuterDimension(n,"left",s,l,i,a,e,r,o),s=e.getWidth(),l=e.getWidthUnit(),c=e.getWidthMode(),i=this.__handleInnerDimension(n,"width",s,l,c,i,a,e,r,o),s=e.getRight(),l=e.getRightUnit(),(i=this.__handleOuterDimension(n,"right",s,l,i,a,e,r,o))<2&&this.__handleOuterDimension(n,"left",0,"px",i,a,e,r,o),i=0,O.StyleProvider.setSimpleElementStyle(r.jOriginalPosition,n),O.StyleProvider.setSimpleElementStyle(r.jHierarchyOriginalPosition,n);var _=t.css("transform");if(1!==o&&0===_.indexOf("matrix")){var u="",d=[],m=_.substring(_.lastIndexOf("(")+1,_.lastIndexOf(")")).split(",");6===m.length?(u="matrix",d=[4,5]):16===m.length&&(u="matrix3d",d=[12,13,14]);for(var h=0,g=d;h<g.length;h++)m[f=g[h]]=(parseInt(m[f],10)*o).toString();n.transform=u+"("+m.join(",")+")"}else n.transform="none"!==_?_:"";if(""!==n.transform){var p=t.css("transform-origin");if(p){for(var E=p.split(" "),f=0,S=E.length;f<S;f++)-1!==E[f].indexOf("px")&&(E[f]=parseInt(E[f],10)*o+"px");n["transform-origin"]=E.join(" ")}else n["transform-origin"]=""}else n["transform-origin"]="";r.jControlPosition.css(n),r.jHierarchyControlposition.css(n),r.jAnchorContainer.css(n),r.jHierarchyAnchorContainer.css(n);var y=O.StyleProvider.getComputedElementStyle(t,["border-width","border-style"]),v=y["border-width"];v||(v="0px");var C=y["border-style"];C||(C="none");var T=v.split("px"),M="";T.forEach(function(e,r){var t=parseFloat(e);isNaN(t)||(M+=t*o+"px ")});var b={"border-width":M,"border-style":C,"border-color":"transparent"};if(O.StyleProvider.setSimpleElementStyle(r.jHierarchyOriginalPosition,b),O.StyleProvider.setSimpleElementStyle(r.jHierarchyControlposition,b),O.StyleProvider.setSimpleElementStyle(r.jHierarchyAnchorContainer,b),e.__parent&&r.parent&&!0===r.parent.isGridControl&&0===r.jHierarchyControlposition.parent().length){var R=e.getGridRowIndex();R>=e.__parent.__rowOptions.length&&(R=0);var N=e.getGridColumnIndex();N>=e.__parent.__columnOptions.length&&(N=0);var w=r.parent.jHierarchyControlposition.children("[data-tchmi-creator-grid-rowindex="+R+"][data-tchmi-creator-grid-cellindex="+N+"]");0===w.length&&O.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeMasterHighlightManager] Fatal internal error: Could not find target grid cell for "+e.__parent.__id+" to attach highlight container."),r.jHierarchyControlposition.parent().is(w)||(w.append(r.jOriginalPosition),w.append(r.jHierarchyOriginalPosition),w.append(r.jControlPosition),w.append(r.jHierarchyControlposition),w.append(r.jAnchorContainer),w.append(r.jHierarchyAnchorContainer))}!0===r.isGridControl&&this.setGridcellContainerPositions(e,r)}}},e.prototype.setGridcellContainerPositions=function(e,r){if(null!=e){var t=e.__element;if(t&&0!==t.length&&null!=r&&!1!==r.domVisibility&&!0!==r.controlCollapsed){var o=this.__designerModeManager.rootControlManager.getCreatorZoomFactor(),n=r.jHierarchyControlposition.children(".tchmi-creator-hierarchy-gridcellposition");n=n.add(r.jControlPosition.children(".tchmi-creator-gridcell"));for(var i=0;i<n.length;i++){var a=n.eq(i),s=parseInt(a.attr("data-tchmi-creator-grid-rowindex"),10),l=t.children().children(".tchmi-grid-grid").children().eq(s),c=parseInt(a.attr("data-tchmi-creator-grid-cellindex"),10),_=l.children().eq(c);if(0===l.length||0===_.length)return;var u=void 0,d=void 0;a.hasClass("tchmi-creator-gridcell")?(u=parseFloat(t.css("border-top-width")),d=parseFloat(t.css("border-left-width"))):(u=parseFloat(_.css("border-top-width")),d=parseFloat(_.css("border-left-width")));var m={height:_[0].offsetHeight*o+"px",width:_[0].offsetWidth*o+"px",top:(u+_[0].offsetTop)*o+"px",left:(d+_[0].offsetLeft)*o+"px"};a.css(m)}}}},e.prototype.updateGripCursors=function(e){var r,t=Math.round((e.relativeControlRotation+e.absoluteParentRotation)*(8/360));for(t<0&&(t+=8),r=0;r<8;r++){var o=(r+t)%8;e.jAnchorContainer.children('[data-tchmi-creator-anchor-name="'+this.__selectorGripsId[r]+'"]').css("cursor",this.__selectorGrips[o]+"-resize")}},e.prototype.processHighlightType=function(e){!0===e.isSelected?e.jControlPosition[0].classList.remove("tchmi-creator-active-highlight"):e.jControlPosition[0].classList.toggle("tchmi-creator-active-highlight",this.__highlightContainerVisibility),e.jControlPosition[0].classList.toggle("tchmi-creator-control-selected",e.isSelected),e.jOriginalPosition[0].classList.toggle("tchmi-creator-control-selected",e.isSelected),e.jAnchorContainer[0].classList.toggle("tchmi-creator-control-selected",e.isSelected),e.jOriginalPosition[0].classList.toggle("tchmi-creator-active-highlight",this.__highlightContainerVisibility)},e.prototype.createControlPosition=function(e,r){var t=e.getType(),o=O.System.Services.controlManager.getDescription(t);return null!==o&&(t=o.displayName),$('<div   data-tchmi-creator-target-control="'+e.__id+'" \n                                class="tchmi-creator-controlposition tchmi-box" \n                                style="z-index:'+r+';">\n                                <div class="tchmi-creator-controlname tchmi-box"\n                                    title="'+t+": "+e.__id+'">'+e.__id+"</div>\n                        </div>")},e.prototype.createHierarchyControlPosition=function(e,r){return $('<div   data-tchmi-creator-target-control="'+e.__id+'" \n                                class="tchmi-creator-hierarchy-controlposition tchmi-box" \n                                style="z-index:'+r+';">\n                        </div>')},e.prototype.createOriginalPosition=function(e,r){return $('<div   data-tchmi-creator-target-control="'+e.__id+'" \n                                class="tchmi-creator-originalposition tchmi-box" \n                                style="z-index:'+r+';">\n\n                                <div class="tchmi-creator-distance-line tchmi-box tchmi-creator-distance-top"></div>\n                                <div class="tchmi-creator-distance-line tchmi-box tchmi-creator-distance-left"></div>\n                                <div class="tchmi-creator-distance-line tchmi-box tchmi-creator-distance-width"></div>\n                                <div class="tchmi-creator-distance-line tchmi-box tchmi-creator-distance-right"></div>\n                                <div class="tchmi-creator-distance-line tchmi-box tchmi-creator-distance-height"></div>\n                                <div class="tchmi-creator-distance-line tchmi-box tchmi-creator-distance-bottom"></div>\n\n                                <div class="tchmi-creator-snapline tchmi-box tchmi-creator-snapline-top"></div>\n                                <div class="tchmi-creator-snapline tchmi-box tchmi-creator-snapline-left"></div>\n                                <div class="tchmi-creator-snapline tchmi-box tchmi-creator-snapline-right"></div>\n                                <div class="tchmi-creator-snapline tchmi-box tchmi-creator-snapline-bottom"></div>\n\n                        </div>')},e.prototype.createHierarchyOriginalPosition=function(e,r){return $('<div   data-tchmi-creator-target-control="'+e.__id+'" \n                                class="tchmi-creator-hierarchy-originalposition" \n                                style="z-index:'+r+';">\n                        </div>')},e.prototype.createAnchorContainer=function(e,r,t){return $('<div   data-tchmi-creator-target-control="'+e.__id+'" \n                                class="tchmi-creator-anchorcontainer tchmi-box'+(t?" tchmi-creator-control-locked":"")+'" \n                                style="border-width: 1px;z-index:'+r+';">\n\n                                <div data-tchmi-creator-anchor-name="TopLeft"      class="tchmi-creator-anchor-rect tchmi-box tchmi-creator-anchor-top-left"></div>\n                                <div data-tchmi-creator-anchor-name="TopCenter"    class="tchmi-creator-anchor-rect tchmi-box tchmi-creator-anchor-top-center"></div>\n                                <div data-tchmi-creator-anchor-name="TopRight"     class="tchmi-creator-anchor-rect tchmi-box tchmi-creator-anchor-top-right"></div>\n                                <div data-tchmi-creator-anchor-name="CenterLeft"   class="tchmi-creator-anchor-rect tchmi-box tchmi-creator-anchor-center-left"></div>\n                                <div data-tchmi-creator-anchor-name="CenterRight"  class="tchmi-creator-anchor-rect tchmi-box tchmi-creator-anchor-center-right"></div>\n                                <div data-tchmi-creator-anchor-name="BottomLeft"   class="tchmi-creator-anchor-rect tchmi-box tchmi-creator-anchor-bottom-left"></div>\n                                <div data-tchmi-creator-anchor-name="BottomCenter" class="tchmi-creator-anchor-rect tchmi-box tchmi-creator-anchor-bottom-center"></div>\n                                <div data-tchmi-creator-anchor-name="BottomRight"  class="tchmi-creator-anchor-rect tchmi-box tchmi-creator-anchor-bottom-right"></div>\n                        </div>')},e.prototype.createHierarchyAnchorContainer=function(e,r,t){return $('<div   data-tchmi-creator-target-control="'+e.__id+'" \n                                class="tchmi-creator-hierarchy-anchorcontainer'+(t?" tchmi-creator-control-locked":"")+'" \n                                style="z-index:'+r+';">\n                        </div>')},e.prototype.createGridHighlighter=function(e,r){if(r)if(e.__rowOptions)if(e.__columnOptions){var t=r.jHierarchyControlposition.children(".tchmi-creator-hierarchy-gridcellposition");t.children().detach(),t.remove(),r.jControlPosition.children(".tchmi-creator-gridcell").remove();for(var o=O.StyleProvider.getSimpleElementStyle(r.jControlPosition,"z-index"),n=$(),i=$(),a=0;a<e.__rowOptions.length;a++)for(var s=0;s<e.__columnOptions.length;s++){var l=$('<div data-tchmi-creator-target-control="'+e.__id+'" \n                            class="tchmi-creator-hierarchy-gridcellposition tchmi-box" \n                            style="z-index:'+o["z-index"]+'"\n                            data-tchmi-creator-grid-rowindex="'+a+'" data-tchmi-creator-grid-cellindex="'+s+'">\n                            </div>');n=n.add(l);var c=$('<div data-tchmi-creator-target-control="'+e.__id+'" \n                            class="tchmi-creator-gridcell tchmi-box"\n                            style="z-index:'+o["z-index"]+'"\n                            data-tchmi-creator-grid-rowindex="'+a+'" data-tchmi-creator-grid-cellindex="'+s+'">\n                            </div>');this.__designerModeManager.hierarchyManager.registerContainerElement(c),i=i.add(c)}r.jHierarchyControlposition.append(n),r.jControlPosition.append(i)}else O.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeMasterHighlightManager] Grid control "+e.getId()+" has invalid Column Options.");else O.Log.error("[Source=Framework, Module=TcHmi.System.Engineering.DesignerModeMasterHighlightManager] Grid control "+e.getId()+" has invalid Row Options.")},e}(),r.DesignerModeMasterControlHighlightManager=t}(TcHmi||(TcHmi={})),function(u){var c,e,r;c=u.System||(u.System={}),e=c.Engineering||(c.Engineering={}),r=function(){function e(e){this.__rectSelecting=!1,this.__lockRectSelect=!1,this.__designerModeManager=e,this.__selectionDragHighlighter=$('<div class="tchmi-creator-selection-drag-container"></div>'),this.__documentRectSelectMouseDownNs="mousedown.DesignerModeManager.DocumentRectSelectMouseDown",this.__documentRectSelectMouseMoveNs="mousemove.DesignerModeManager.DocumentRectSelectMouseMove",this.__documentRectSelectMouseUpNs="mouseup.DesignerModeManager.DocumentRectSelectMouseUp",u.System.SharedResources.jqDocument.on(this.__documentRectSelectMouseDownNs,this.__onDocumentRectSelectMouseDown())}return e.prototype.getRectSelecting=function(){return this.__rectSelecting},e.prototype.lockRectSelect=function(){this.__lockRectSelect=!0},e.prototype.resetState=function(){this.__rectSelecting=!1,this.__lockRectSelect=!1,u.System.SharedResources.jqDocument.off(this.__documentRectSelectMouseMoveNs),u.System.SharedResources.jqDocument.off(this.__documentRectSelectMouseUpNs)},e.prototype.__onDocumentRectSelectMouseDown=function(){var r=this;return function(e){1===e.which&&(r.__designerModeManager.interactionManager.handleInteractionStart(e,null),r.__lockRectSelect=!1,u.System.SharedResources.jqDocument.on(r.__documentRectSelectMouseMoveNs,r.__onDocumentRectSelectMouseMove()),u.System.SharedResources.jqDocument.on(r.__documentRectSelectMouseUpNs,r.__onDocumentRectSelectMouseUp()))}},e.prototype.__onDocumentRectSelectMouseMove=function(){var l=this;return function(e){if(1===e.which&&!0!==l.__designerModeManager.controlMoveManager.getControlMoveActive()&&!0!==l.__designerModeManager.controlResizeManager.getControlResizing()&&!0!==l.__lockRectSelect){var r=l.__designerModeManager.interactionManager.getStartMousePos(),t=e.pageX-r.left,o=e.pageY-r.top;if(0!==t||0!==o){var n=0,i=0,a=0,s=0;l.__designerModeManager.controlMoveManager.setMouseMoving(!0),0<=t?(n=t,i=r.left):(n=-t,i=r.left+t),0<=o?(a=o,s=r.top):(a=-o,s=r.top+o),l.__selectionDragHighlighter.css({width:n+"px",left:i+"px",height:a+"px",top:s+"px"}),c.SharedResources.jqBody.append(l.__selectionDragHighlighter),l.__rectSelecting=!0,l.__designerModeManager.controlMoveManager.lockControlMove(),l.__designerModeManager.controlResizeManager.lockControlResize()}}}},e.prototype.__onDocumentRectSelectMouseUp=function(){var r=this;return function(e){1!==e.which?(3===e.which&&r.__selectionDragHighlighter.remove(),r.__designerModeManager.controlMoveManager.setMouseMoving(!1)):!0===r.__lockRectSelect&&!1===r.__rectSelecting||(r.__processRectSelect(r.__selectionDragHighlighter[0].getBoundingClientRect(),e.ctrlKey,e.altKey),r.__designerModeManager.resyncSelectedControls(),r.__selectionDragHighlighter.remove(),r.__designerModeManager.controlMoveManager.setMouseMoving(!1)),r.resetState()}},e.prototype.__processRectSelect=function(e,r,t){var o=!0,n=this.__designerModeManager.metaDataManager.getControlMetaData();for(var i in n){var a=n[i];if(!1!==a.domVisibility){for(var s=!1,l=a.parent;null!==l;){if(!1===l.domVisibility){s=!0;break}l=l.parent}if(!0!==s){var c=u.control[a.id];if(void 0!==c&&void 0!==c.__element&&null!==c.__element){var _=a.jControlPosition[0].getBoundingClientRect();if(!0===this.__hasClientRectIntersection(_,e,t)){if(!0===a.isPartialRoot)continue;!0===o&&!1===r&&(this.__designerModeManager.unselectEach(!0),o=!1),this.__designerModeManager.select(a.id,!0)}}}}}},e.prototype.__hasClientRectIntersection=function(e,r,t){var o=e.left,n=e.right,i=e.top,a=e.bottom,s=r.left,l=r.right,c=r.top,_=r.bottom;return!1===t?!(l<o||n<s||_<i||a<c):s<o&&n<l&&c<i&&a<_},e}(),e.DesignerModeMasterRectSelectManager=r}(TcHmi||(TcHmi={})),function(T){var e,v,r;e=T.System||(T.System={}),v=e.Engineering||(e.Engineering={}),r=function(){function e(e){this.__copyMoveRectHighlightOffset={left:0,top:0},this.__activeControl=null,this.__activeControlPrev=null,this.__mouseMoving=!1,this.__lockControlMove=!1,this.__controlMoveActive=!1,this.__designerModeManager=e,this.__copyMoveRectHighlighter=document.createElement("canvas"),this.__copyMoveRectHighlighter.classList.add("tchmi-creator-copymove-container"),this.__highlightMouseDownNs="mousedown.DesignerModeManager.HighlightMouseDown",this.__highlightMouseMoveNs="mousemove.DesignerModeManager.HighlightMouseMove",this.__highlightMouseUpNs="mouseup.DesignerModeManager.HighlightMouseUp",this.__onHighlightMouseUpLastProc=new Date}return e.prototype.registerControl=function(e){e.jControlPosition.on(this.__highlightMouseDownNs,this.__onHighlightMouseDown())},e.prototype.getControlMoveActive=function(){return this.__controlMoveActive},e.prototype.lockControlMove=function(){this.__lockControlMove=!0},e.prototype.setMouseMoving=function(e){this.__mouseMoving=e},e.prototype.resetState=function(){this.__lockControlMove=!1,this.__controlMoveActive=!1,T.System.SharedResources.jqDocument.off(this.__highlightMouseMoveNs),T.System.SharedResources.jqDocument.off(this.__highlightMouseUpNs),T.StyleProvider.setSimpleElementStyle(T.System.SharedResources.jqBody,"cursor",""),this.__designerModeManager.hierarchyManager.removeHighlightDropTarget(),this.__copyMoveRectHighlighter.remove(),null!==this.__activeControl&&(this.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snaptop"),this.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapleft"),this.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapbottom"),this.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapright"),this.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snaptop-remote"),this.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapleft-remote"),this.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapbottom-remote"),this.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapright-remote"))},e.prototype.__onHighlightMouseDown=function(){var o=this;return function(e){if(1===e.which){var r=$(e.target).attr("data-tchmi-creator-target-control"),t=o.__designerModeManager.metaDataManager.getControlMetaData(r);null!==t&&(o.__activeControlPrev=o.__activeControl,o.__activeControl=t,o.__designerModeManager.interactionManager.handleInteractionStart(e,t),o.__designerModeManager.interactionManager.setAnchorName(void 0),o.__lockControlMove=!1,T.System.SharedResources.jqDocument.on(o.__highlightMouseMoveNs,o.__onHighlightMouseMove()),T.System.SharedResources.jqDocument.on(o.__highlightMouseUpNs,o.__onHighlightMouseUp()))}}},e.prototype.__onHighlightMouseMove=function(){var C=this;return function(e){var r;if(null!==C.__activeControl&&!0!==C.__designerModeManager.controlResizeManager.getControlResizing()&&!0!==C.__activeControl.isPartialRoot&&!0!==C.__designerModeManager.rectSelectManager.getRectSelecting()&&!0!==C.__lockControlMove)if(1===e.which){var t=C.__activeControl;do{if(!0===t.locked)return;t=t.parent}while(t);if(!1===C.__mouseMoving){if(!1===e.ctrlKey&&!1===C.__activeControl.isSelected)for(var o in r=C.__designerModeManager.metaDataManager.getSelectedControlsMetaData())null!==(d=r[o])&&null!==C.__activeControl&&d.id!==C.__activeControl.id&&C.__designerModeManager.unselect(d.id,!0);C.__designerModeManager.select(C.__activeControl.id,!0)}var n=C.__designerModeManager.interactionManager.getStartMousePos(),i=e.pageX-n.left,a=e.pageY-n.top;if(0!==i||0!==a)if((C.__mouseMoving=!0)===e.shiftKey&&(Math.abs(i)>Math.abs(a)?a=0:i=0),C.__controlMoveActive=!0,C.__designerModeManager.rectSelectManager.lockRectSelect(),!1===e.ctrlKey||Math.abs(i)<5&&Math.abs(a)<5){var s=C.__designerModeManager.rootControlManager.getCreatorZoomFactor(),l=C.__designerModeManager.interactionManager.handleSnapping(C.__activeControl,{left:i/s,top:a/s},{left:e.pageX,top:e.pageY},!e.altKey);for(var o in r=C.__designerModeManager.metaDataManager.getSelectedControlsMetaData())!0!==(d=r[o]).isPartialRoot&&C.__processMove(d,l);C.__copyMoveRectHighlighter.parentElement&&(T.StyleProvider.setSimpleElementStyle(T.System.SharedResources.jqBody,"cursor",""),C.__designerModeManager.hierarchyManager.removeHighlightDropTarget(),C.__copyMoveRectHighlighter.remove())}else if(C.__copyMoveRectHighlighter.parentElement)C.__copyMoveRectHighlighter.style.top=C.__copyMoveRectHighlightOffset.top+a+window.scrollY+"px",C.__copyMoveRectHighlighter.style.left=C.__copyMoveRectHighlightOffset.left+i+window.scrollX+"px",C.__designerModeManager.hierarchyManager.addHighlightDropTarget({left:e.pageX,top:e.pageY},e.target);else{C.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snaptop"),C.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapleft"),C.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapbottom"),C.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapright"),C.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snaptop-remote"),C.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapleft-remote"),C.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapbottom-remote"),C.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapright-remote");var c={top:Number.POSITIVE_INFINITY,left:Number.POSITIVE_INFINITY,rightside:Number.NEGATIVE_INFINITY,bottomside:Number.NEGATIVE_INFINITY},_=!0;null===C.__activeControl.parent&&(_=!1);var u=[];for(var o in r=C.__designerModeManager.metaDataManager.getSelectedControlsMetaData()){var d=r[o];if(C.__processMove(d,{left:0,top:0}),T.StyleProvider.setSimpleElementStyle(d.jControlPosition,"pointer-events","none"),!1!==_)if(null!==d.parent)if(d.parent.id===C.__activeControl.parent.id){var m=d.jControlPosition[0].getBoundingClientRect();c.top>m.top&&(c.top=m.top),c.left>m.left&&(c.left=m.left),c.bottomside<m.top+m.height&&(c.bottomside=m.top+m.height),c.rightside<m.left+m.width&&(c.rightside=m.left+m.width),u.push({top:m.top,left:m.left,height:m.height,width:m.width})}else _=!1;else _=!1}if(C.__designerModeManager.hierarchyManager.addHighlightDropTarget({left:e.pageX,top:e.pageY},e.target),!1===_)T.StyleProvider.setSimpleElementStyle(T.System.SharedResources.jqBody,"cursor","no-drop");else{T.StyleProvider.setSimpleElementStyle(T.System.SharedResources.jqBody,"cursor","copy"),C.__copyMoveRectHighlightOffset.top=c.top,C.__copyMoveRectHighlightOffset.left=c.left;var h=c.top+a+window.scrollY,g=c.left+i+window.scrollX,p=c.bottomside-c.top,E=c.rightside-c.left;C.__copyMoveRectHighlighter.width=E,C.__copyMoveRectHighlighter.height=p,C.__copyMoveRectHighlighter.style.cssText="top:"+h+"px;left:"+g+"px;height:"+p+"px;width:"+E+"px;";var f=C.__copyMoveRectHighlighter.getContext("2d");f.strokeStyle="gray";for(var S=0,y=u;S<y.length;S++){var v=y[S];f.strokeRect(v.left+window.scrollX+i-g,v.top+window.scrollY+a-h,v.width,v.height)}document.body.appendChild(C.__copyMoveRectHighlighter)}for(var o in r)d=r[o],T.StyleProvider.setSimpleElementStyle(d.jControlPosition,"pointer-events","")}else C.__designerModeManager.rectSelectManager.lockRectSelect()}else C.resetState()}},e.prototype.__processMove=function(e,r){var t=r.left,o=r.top,n=e,i=!1;do{if(!0===n.locked){i=!0;break}n=n.parent}while(n);if(!0!==i){var a=T.control[e.id];if(a){for(var s=!1,l=a.__element.parents("[data-tchmi-type]"),c=this.__designerModeManager.metaDataManager.getSelectedControlIdsWithChildren(),_=0,u=l.length;_<u;_++)if(-1!==c.indexOf(l[_].id)){s=!0;break}if(!0!==s){var d,m=null,h={};null!==e.controlAttributeDimension.topValue&&("%"!==e.controlAttributeDimension.topUnit?(d=e.controlAttributeDimension.topValue+Math.sin(-e.absoluteParentRotation)*t+Math.cos(-e.absoluteParentRotation)*o,h.top=Math.round(d)+"px"):(null===m&&(m=a.__element.parent().outerHeight()),d=e.controlAttributeDimension.topValue+100*(+Math.sin(-e.absoluteParentRotation)*t+Math.cos(-e.absoluteParentRotation)*o)/m,h.top=d+"%")),null!==e.controlAttributeDimension.bottomValue&&("%"!==e.controlAttributeDimension.bottomUnit?(d=e.controlAttributeDimension.bottomValue-Math.sin(-e.absoluteParentRotation)*t-Math.cos(-e.absoluteParentRotation)*o,h.bottom=Math.round(d)+"px"):(null===m&&(m=a.__element.parent().outerHeight()),d=e.controlAttributeDimension.bottomValue+100*(-Math.sin(-e.absoluteParentRotation)*t-Math.cos(-e.absoluteParentRotation)*o)/m,h.bottom=d+"%")),null===e.controlAttributeDimension.topValue&&null===e.controlAttributeDimension.bottomValue&&(h.top=Math.round(Math.sin(-e.absoluteParentRotation)*t+Math.cos(-e.absoluteParentRotation)*o)+"px"),(m=null)!==e.controlAttributeDimension.leftValue&&("%"!==e.controlAttributeDimension.leftUnit?(d=e.controlAttributeDimension.leftValue+Math.cos(e.absoluteParentRotation)*t+Math.sin(e.absoluteParentRotation)*o,h.left=Math.round(d)+"px"):(null===m&&(m=a.__element.parent().outerWidth()),d=e.controlAttributeDimension.leftValue+100*(+Math.cos(e.absoluteParentRotation)*t+Math.sin(e.absoluteParentRotation)*o)/m,h.left=d+"%")),null!==e.controlAttributeDimension.rightValue&&("%"!==e.controlAttributeDimension.rightUnit?(d=e.controlAttributeDimension.rightValue-Math.cos(e.absoluteParentRotation)*t-Math.sin(e.absoluteParentRotation)*o,h.right=Math.round(d)+"px"):(null===m&&(m=a.__element.parent().outerWidth()),d=e.controlAttributeDimension.rightValue+100*(-Math.cos(e.absoluteParentRotation)*t-Math.sin(e.absoluteParentRotation)*o)/m,h.right=d+"%")),null===e.controlAttributeDimension.leftValue&&null===e.controlAttributeDimension.rightValue&&(h.left=Math.round(Math.cos(e.absoluteParentRotation)*t+Math.sin(e.absoluteParentRotation)*o)+"px"),T.StyleProvider.setSimpleElementStyle(a.__element,h),a.__parent&&e.parent&&!0===e.parent.isGridControl&&this.__designerModeManager.highlightManager.setGridcellContainerPositions(a.__parent,e.parent),this.__designerModeManager.highlightManager.setContainerPositions(a,e)}}else T.Log.error('Failed to move control "'+e.id+'": Not found in control cache.\n')}},e.prototype.__onHighlightMouseUp=function(){var y=this;return function(e){var r={};if(1===e.which)if(!0!==y.__lockControlMove||!0!==y.__designerModeManager.rectSelectManager.getRectSelecting()){null===y.__activeControl&&(y.__mouseMoving=!1,y.resetState());var t=y.__activeControl,o=y.__activeControlPrev;!1===y.__mouseMoving&&(!1===e.ctrlKey&&!1===t.isSelected&&y.__designerModeManager.unselectEach(!0),y.__designerModeManager.select(t.id,!0),y.__designerModeManager.rectSelectManager.lockRectSelect());var n=y.__designerModeManager.interactionManager.getStartMousePos(),i=e.pageX-n.left,a=e.pageY-n.top,s=!1;if(null!=o&&t.id===o.id&&Math.abs(i)<5&&Math.abs(a)<5){var l=y.__onHighlightMouseUpLastProc.getTime();(new Date).getTime()-l<=500&&(s=!0)}if(y.__onHighlightMouseUpLastProc=new Date,!1===s){!0===e.ctrlKey&&!1===y.__mouseMoving&&!0===t.isSelectedPrev&&t.isSelected&&y.__designerModeManager.unselect(t.id,!0);var c=!0;if(!0===e.ctrlKey){c=!1,null===t.parent&&(c=!0),Math.abs(i)<5&&Math.abs(a)<5&&(c=!0),r=y.__designerModeManager.metaDataManager.getSelectedControlsMetaData();var _={name:"CopyMoveControls",targetPartial:TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL,deltaPosition:{left:null,top:null},controls:[],targetParentControl:"",replyTo:null};if(!1===c)for(var u in r){if(null===(S=r[u]).parent){c=!0;break}if(S.parent.id!==t.parent.id){c=!0;break}_.controls.push(S.id),T.StyleProvider.setSimpleElementStyle(S.jControlPosition,"pointer-events","none")}var d=y.__designerModeManager.hierarchyManager.getContainerFromPoint({left:e.pageX,top:e.pageY});if(_.targetParentControl=d.tco.__id,null!==d.rowIndex&&null!==d.cellIndex&&(_.attributes=[{name:"data-tchmi-grid-row-index",value:d.rowIndex},{name:"data-tchmi-grid-column-index",value:d.cellIndex}]),null!==t.parent&&_.targetParentControl===t.parent.id&&null!==t.controlAttributeDimension.topValue&&"px"===t.controlAttributeDimension.topUnit&&null!==t.controlAttributeDimension.heightValue&&"px"===t.controlAttributeDimension.heightUnit&&"Value"===t.controlAttributeDimension.heightMode)if(!0===t.parent.isGridControl){if(0===t.absoluteParentRotation){var m=t.jOriginalPosition.parent()[0].getBoundingClientRect(),h=d.jHighlighter[0].getBoundingClientRect();_.deltaPosition.top=a+(m.top-h.top)}}else _.deltaPosition.top=a;for(var u in null!==t.parent&&_.targetParentControl===t.parent.id&&null!==t.controlAttributeDimension.leftValue&&"px"===t.controlAttributeDimension.leftUnit&&null!==t.controlAttributeDimension.widthValue&&"px"===t.controlAttributeDimension.widthUnit&&"Value"===t.controlAttributeDimension.widthMode&&(!0===t.parent.isGridControl?0===t.absoluteParentRotation&&(m=t.jOriginalPosition.parent()[0].getBoundingClientRect(),h=d.jHighlighter[0].getBoundingClientRect(),_.deltaPosition.left=i+(m.left-h.left)):_.deltaPosition.left=i),r)S=r[u],T.StyleProvider.setSimpleElementStyle(S.jControlPosition,"pointer-events","");!1===c&&new v.SyncCmdToCreatorCopyMoveControls(_).send()}if(!0===c){var g=T.control[t.id];if(void 0!==g){var p=T.System.resolveControlHierarchy(g,null),E=function(e){for(var r=0,t=e.children_hierarchy.length;r<t;r++){var o=e.children_hierarchy[r];y.__designerModeManager.highlightManager.setContainerPositions(o.ctrl,y.__designerModeManager.metaDataManager.getControlMetaData(o.ctrl.__id)),E(o)}};E(p)}y.__designerModeManager.syncManager.updatePcElementAndSync("System.onControlPositionParameterChanged"),y.__designerModeManager.resyncSelectedControls()}}else{var f=T.control[t.id];void 0!==f&&new v.SyncCmdToCreatorControlDoubleClick({name:"ControlDoubleClick",targetPartial:TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL,targetControl:{id:t.id,type:f.getType()},replyTo:null}).send()}y.__mouseMoving=!1,y.resetState()}else y.resetState();else{if(3===e.which&&!0===y.__controlMoveActive)for(var u in r=y.__designerModeManager.metaDataManager.getSelectedControlsMetaData()){var S;!0!==(S=r[u]).isPartialRoot&&y.__processMove(S,{left:0,top:0})}y.resetState()}}},e}(),v.DesignerModeMasterControlMoveManager=r}(TcHmi||(TcHmi={})),function(h){var e,r,t;e=h.System||(h.System={}),r=e.Engineering||(e.Engineering={}),t=function(){function e(e){this.__lockControlResize=!1,this.__controlResizing=!1,this.__activeControl=null,this.__designerModeManager=e,this.__anchorMouseDownNs="mousedown.DesignerModeManager.AnchorMouseDown",this.__anchorMouseMoveNs="mousemove.DesignerModeManager.AnchorMouseMove",this.__anchorMouseUpNs="mouseup.DesignerModeManager.AnchorMouseUp"}return e.prototype.registerControl=function(e){e.jAnchorContainer.children(".tchmi-creator-anchor-rect").on(this.__anchorMouseDownNs,this.__onAnchorMouseDown())},e.prototype.getControlResizing=function(){return this.__controlResizing},e.prototype.lockControlResize=function(){this.__lockControlResize=!0},e.prototype.__onAnchorMouseDown=function(){var o=this;return function(e){if(1===e.which){var r=$(e.target).parent().attr("data-tchmi-creator-target-control");if(o.__activeControl=o.__designerModeManager.metaDataManager.getControlMetaData(r),null!==o.__activeControl){var t=$(e.target).attr("data-tchmi-creator-anchor-name");o.__designerModeManager.interactionManager.setAnchorName(t),t&&(o.__designerModeManager.interactionManager.handleInteractionStart(e,o.__activeControl),o.__lockControlResize=!1,h.System.SharedResources.jqDocument.on(o.__anchorMouseMoveNs,o.__onAnchorMouseMove()),h.System.SharedResources.jqDocument.on(o.__anchorMouseUpNs,o.__onAnchorMouseUp()))}}}},e.prototype.__onAnchorMouseMove=function(){var d=this;return function(e){if(null!==d.__activeControl&&!0!==d.__designerModeManager.rectSelectManager.getRectSelecting()&&!0!==d.__lockControlResize){var r=d.__designerModeManager.interactionManager.getAnchorName();if(r){if(1!==e.which)return h.System.SharedResources.jqDocument.off(d.__anchorMouseMoveNs),h.System.SharedResources.jqDocument.off(d.__anchorMouseUpNs),d.__controlResizing=!1,void d.__designerModeManager.rectSelectManager.resetState();var t=d.__activeControl;do{if(!0===t.locked)return;t=t.parent}while(t);d.__controlResizing=!0,d.__designerModeManager.rectSelectManager.lockRectSelect();var o=d.__designerModeManager.interactionManager.getStartMousePos(),n=d.__designerModeManager.interactionManager.getPositionInsideControl(),i=e.pageX-o.left,a=e.pageY-o.top;!0===e.shiftKey&&0!==n.width&&("TopLeft"===r||"BottomRight"===r?a=i*(n.height/n.width):"TopRight"!==r&&"BottomLeft"!==r||(a=-i*(n.height/n.width)));var s=d.__designerModeManager.rootControlManager.getCreatorZoomFactor(),l=d.__designerModeManager.metaDataManager.getSelectedControlsMetaData(),c=d.__designerModeManager.interactionManager.handleSnapping(d.__activeControl,{left:i/s,top:a/s},{left:e.pageX,top:e.pageY},!e.altKey);for(var _ in l){var u=l[_];d.__processResize(u,c,r),u.isPartialRoot&&d.__designerModeManager.rootControlManager.setCreatorViewPortPosition(h.control[u.id])}}}}},e.prototype.__processResize=function(e,r,t){var o=e,n=!1;do{if(!0===o.locked){n=!0;break}o=o.parent}while(o);if(!0!==n){var i=h.control[e.id];if(void 0!==i){var a=Math.sin(-e.absoluteParentRotation)*r.left+Math.cos(-e.absoluteParentRotation)*r.top,s=Math.cos(e.absoluteParentRotation)*r.left+Math.sin(e.absoluteParentRotation)*r.top,l=this.__getResizedRect(e,t,s,a),c={},_=!1;if(null!==l.heightValue&&"Parent"!==l.heightMode&&(0<=l.heightValue?c.height=l.heightValue+l.heightUnit:(c.height="0",_=!0)),null!==l.topValue&&!1===_&&(c.top=l.topValue+l.topUnit),null!==l.bottomValue&&!1===_&&(c.bottom=l.bottomValue+l.bottomUnit),null===l.topValue&&null===l.bottomValue&&(c.top="0"),_=!1,null!==l.widthValue&&"Parent"!==l.widthMode&&(0<=l.widthValue?c.width=l.widthValue+l.widthUnit:(c.width="0",_=!0)),null!==l.leftValue&&!1===_&&(c.left=l.leftValue+l.leftUnit),null!==l.rightValue&&!1===_&&(c.right=l.rightValue+l.rightUnit),null===l.leftValue&&null===l.rightValue&&(c.left="0"),h.StyleProvider.setSimpleElementStyle(i.__element,c),i.__parent&&e.parent&&!0===e.parent.isGridControl&&this.__designerModeManager.highlightManager.setGridcellContainerPositions(i.__parent,e.parent),this.__designerModeManager.highlightManager.setContainerPositions(h.control[e.id],e),null!==this.__activeControl&&void 0!==h.control[this.__activeControl.id]){var u=this,d=function(e){for(var r=0,t=e.children_hierarchy.length;r<t;r++){var o=e.children_hierarchy[r];u.__designerModeManager.highlightManager.setContainerPositions(o.ctrl,u.__designerModeManager.metaDataManager.getControlMetaData(o.ctrl.__id)),d(o)}},m=h.System.resolveControlHierarchy(h.control[this.__activeControl.id],null);d(m)}}}},e.prototype.__getResizedRect=function(e,r,t,o){var n,i,a,s=e.controlAttributeDimension,l=e.relativeControlRotation;if(e.isPartialRoot){var c=this.__designerModeManager.rootControlManager.getViewPortSimulator();n=c.outerHeight(),i=c.outerWidth(),a=this.__designerModeManager.interactionManager.getPositionInsideControl()}else n=e.jControlPosition.parent().outerHeight(),i=e.jControlPosition.parent().outerWidth(),a={top:0,left:0,width:0,right:0,height:0,bottom:0};var _=this.__designerModeManager.rootControlManager.getCreatorZoomFactor(),u=tchmi_clone_object(s),d=Math.sin(l),m=Math.cos(l),h=-d*t+m*o,g=m*t+d*o;switch(r){case"TopLeft":null!==u.widthValue?"%"!==u.widthUnit?u.widthValue+=-g:u.widthValue+=100*-g/i:(null===u.leftValue&&null!==u.rightValue||null!==u.leftValue&&null===u.rightValue)&&("%"!==u.widthUnit?u.widthValue=e.controlCssPixelDimension.width-g:u.widthValue=e.controlCssPixelDimension.width/i*100-100*g/i),null!==u.heightValue?"%"!==u.heightUnit?u.heightValue+=-h:u.heightValue+=100*-h/n:(null===u.topValue&&null!==u.bottomValue||null!==u.topValue&&null===u.bottomValue)&&("%"!==u.heightUnit?u.heightValue=e.controlCssPixelDimension.height-h:u.heightValue=e.controlCssPixelDimension.height/n*100-100*h/n),null!==u.topValue&&("%"!==u.topUnit?u.topValue+=o:u.topValue+=100*o/n),null!==u.leftValue&&("%"!==u.leftUnit?u.leftValue+=t:u.leftValue+=100*t/i);break;case"TopCenter":null!==u.heightValue?"%"!==u.heightUnit?u.heightValue+=-h:u.heightValue+=100*-h/n:(null===u.topValue&&null!==u.bottomValue||null!==u.topValue&&null===u.bottomValue)&&("%"!==u.heightUnit?u.heightValue=e.controlCssPixelDimension.height-h:u.heightValue=e.controlCssPixelDimension.height/n*100-100*h/n),null!==u.topValue&&("%"!==u.topUnit?u.topValue+=m*h:u.topValue+=m*h*100/n),null!==u.leftValue&&("%"!==u.leftUnit?u.leftValue+=-d*h:u.leftValue+=-d*h*100/n);break;case"TopRight":null!==u.widthValue?"%"!==u.widthUnit?u.widthValue+=g:u.widthValue+=100*g/i:(null===u.leftValue&&null!==u.rightValue||null!==u.leftValue&&null===u.rightValue)&&("%"!==u.widthUnit?u.widthValue=e.controlCssPixelDimension.width+g:u.widthValue=e.controlCssPixelDimension.width/i*100+100*g/i),null!==u.heightValue?"%"!==u.heightUnit?u.heightValue+=-h:u.heightValue+=100*-h/n:(null===u.topValue&&null!==u.bottomValue||null!==u.topValue&&null===u.bottomValue)&&("%"!==u.heightUnit?u.heightValue=e.controlCssPixelDimension.height+h:u.heightValue=e.controlCssPixelDimension.height/n*100+100*h/n),null!==u.topValue&&("%"!==u.topUnit?u.topValue+=m*h:u.topValue+=m*h*100/n),null!==u.leftValue?"%"!==u.leftUnit?u.leftValue+=-d*h:u.leftValue+=-d*h*100/n:null!==u.rightValue&&("%"!==u.rightUnit?u.rightValue+=-m*g:u.rightValue+=-m*g*100/i),null!==u.rightValue&&("%"!==u.rightUnit?u.rightValue+=-m*g:u.rightValue+=-m*g*100/i);break;case"CenterLeft":null!==u.widthValue?"%"!==u.widthUnit?u.widthValue+=-g:u.widthValue+=100*-g/i:(null===u.leftValue&&null!==u.rightValue||null!==u.leftValue&&null===u.rightValue)&&("%"!==u.widthUnit?u.widthValue=e.controlCssPixelDimension.width-g:u.widthValue=e.controlCssPixelDimension.width/i*100-100*g/i),null!==u.topValue?"%"!==u.topUnit?u.topValue+=d*g:u.topValue+=d*g*100/i:null!==u.bottomValue&&("%"!==u.bottomUnit?u.bottomValue+=-d*g:u.bottomValue+=-d*g*100/i),null!==u.leftValue&&("%"!==u.leftUnit?u.leftValue+=m*g:u.leftValue+=m*g*100/i);break;case"CenterRight":!1===e.isPartialRoot?(null!==u.widthValue?"%"!==u.widthUnit?u.widthValue+=g:u.widthValue+=100*g/i:(null===u.leftValue&&null!==u.rightValue||null!==u.leftValue&&null===u.rightValue)&&("%"!==u.widthUnit?u.widthValue=e.controlCssPixelDimension.width+g:u.widthValue=e.controlCssPixelDimension.width/i*100+100*g/i),null!==u.rightValue&&("%"!==u.rightUnit?u.rightValue+=-g:u.rightValue+=100*-g/i)):(u.widthValue=a.width/_+g,u.widthUnit="px",null!==u.rightValue&&("%"!==u.rightUnit?u.rightValue+=-m*g:(u.rightValue=u.rightValue/100*i-m*g,u.rightUnit="px")));break;case"BottomLeft":null!==u.widthValue?"%"!==u.widthUnit?u.widthValue+=-g:u.widthValue+=100*-g/i:(null===u.leftValue&&null!==u.rightValue||null!==u.leftValue&&null===u.rightValue)&&("%"!==u.widthUnit?u.widthValue=e.controlCssPixelDimension.width-g:u.widthValue=e.controlCssPixelDimension.width/i*100-100*g/i),null!==u.heightValue?"%"!==u.heightUnit?u.heightValue+=h:u.heightValue+=100*h/n:(null===u.topValue&&null!==u.bottomValue||null!==u.topValue&&null===u.bottomValue)&&("%"!==u.heightUnit?u.heightValue=e.controlCssPixelDimension.height+h:u.heightValue=e.controlCssPixelDimension.height/n*100+100*h/n),u.topValue,null!==u.bottomValue&&("%"!==u.bottomUnit?u.bottomValue+=-m*h:u.bottomValue+=-m*h*100/n),null!==u.leftValue&&("%"!==u.leftUnit?u.leftValue+=m*g:u.leftValue+=m*g*100/i);break;case"BottomCenter":!1===e.isPartialRoot?(null!==u.heightValue?"%"!==u.heightUnit?u.heightValue+=h:u.heightValue+=100*h/n:(null===u.topValue&&null!==u.bottomValue||null!==u.topValue&&null===u.bottomValue)&&("%"!==u.heightUnit?u.heightValue=e.controlCssPixelDimension.height+h:u.heightValue=e.controlCssPixelDimension.height/n*100+100*h/n),null!==u.bottomValue&&("%"!==u.bottomUnit?u.bottomValue+=-h:u.bottomValue+=100*-h/n)):(u.heightValue=a.height/_+h,u.heightUnit="px",null!==u.bottomValue&&("%"!==u.bottomUnit?u.bottomValue+=-m*h:(u.bottomValue=u.bottomValue/100*n-m*h,u.bottomUnit="px")));break;case"BottomRight":!1===e.isPartialRoot?(null!==u.widthValue?"%"!==u.widthUnit?u.widthValue+=g:u.widthValue+=100*g/i:(null===u.leftValue&&null!==u.rightValue||null!==u.leftValue&&null===u.rightValue)&&("%"!==u.widthUnit?u.widthValue=e.controlCssPixelDimension.width+g:u.widthValue=e.controlCssPixelDimension.width/i*100+100*g/i),null!==u.heightValue?"%"!==u.heightUnit?u.heightValue+=h:u.heightValue+=100*h/n:(null===u.topValue&&null!==u.bottomValue||null!==u.topValue&&null===u.bottomValue)&&("%"!==u.heightUnit?u.heightValue=e.controlCssPixelDimension.height+h:u.heightValue=e.controlCssPixelDimension.height/n*100+100*h/n),null!==u.bottomValue&&("%"!==u.bottomUnit?u.bottomValue+=-m*h:u.bottomValue+=-m*h*100/n),null!==u.rightValue&&("%"!==u.rightUnit?u.rightValue+=-m*g:u.rightValue+=-m*g*100/i)):(u.heightValue=a.height/_+h,u.heightUnit="px",null!==u.bottomValue&&("%"!==u.bottomUnit?u.bottomValue+=-m*h:(u.bottomValue=u.bottomValue/100*n-m*h,u.bottomUnit="px")),u.widthValue=a.width/_+g,u.widthUnit="px",null!==u.rightValue&&("%"!==u.rightUnit?u.rightValue+=-m*g:(u.rightValue=u.rightValue/100*i-m*g,u.rightUnit="px")))}return u},e.prototype.__onAnchorMouseUp=function(){var r=this;return function(e){1===e.which&&(h.System.SharedResources.jqDocument.off(r.__anchorMouseMoveNs),h.System.SharedResources.jqDocument.off(r.__anchorMouseUpNs),null!==r.__activeControl&&(r.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snaptop"),r.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapleft"),r.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapbottom"),r.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapright"),r.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snaptop-remote"),r.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapleft-remote"),r.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapbottom-remote"),r.__activeControl.jOriginalPosition[0].classList.remove("tchmi-creator-control-snapright-remote"),!0!==r.__lockControlResize&&(r.__controlResizing=!1,r.__designerModeManager.rectSelectManager.lockRectSelect(),r.__designerModeManager.syncManager.updatePcElementAndSync("System.onControlSizeParameterChanged"),r.__designerModeManager.resyncSelectedControls())))}},e}(),r.DesignerModeMasterControlResizeManager=t}(TcHmi||(TcHmi={})),function(t){var e,r,o;e=t.System||(t.System={}),r=e.Engineering||(e.Engineering={}),o=function(){function e(e){this.__verPositionCache={},this.__horPositionCache={},this.__anchorName=void 0,this.__designerModeManager=e,this.__bodyMouseUpNs="mouseup.DesignerModeManager.BodyMouseUp",t.System.SharedResources.jqBody.on(this.__bodyMouseUpNs,this.__onBodyMouseUp()),this.__modifierKeyPressed={ctrl:!1,shift:!1},this.__startMousePosition={left:0,top:0},this.__positionInsideControl={top:0,left:0,right:0,bottom:0,height:0,width:0}}return e.prototype.getAnchorName=function(){return this.__anchorName},e.prototype.setAnchorName=function(e){this.__anchorName=e},e.prototype.getStartMousePos=function(){return this.__startMousePosition},e.prototype.getPositionInsideControl=function(){return this.__positionInsideControl},e.prototype.setCtrlModifierKeyState=function(e){this.__modifierKeyPressed.ctrl=e},e.prototype.setShiftModifierKeyState=function(e){this.__modifierKeyPressed.shift=e},e.prototype.clearSnapPositionCache=function(){this.__horPositionCache={},this.__verPositionCache={}},e.prototype.handleInteractionStart=function(e,r){if(this.__startMousePosition.left=e.pageX,this.__startMousePosition.top=e.pageY,null!==r){var t=r.jOriginalPosition[0].getBoundingClientRect();this.__positionInsideControl.top=e.pageY-t.top-window.scrollY,this.__positionInsideControl.left=e.pageX-t.left-window.scrollX,this.__positionInsideControl.right=t.right+window.scrollX-e.pageX,this.__positionInsideControl.bottom=t.bottom+window.scrollY-e.pageY,this.__positionInsideControl.height=t.height,this.__positionInsideControl.width=t.width}},e.prototype.__onBodyMouseUp=function(){var r=this;return function(e){void 0!==e.target&&null!==e.target&&t.System.SharedResources.jqBody.is(e.target)&&r.__designerModeManager.unselectEach(!1)}},e.prototype.refreshControlDimensionCache=function(e){if(e){if(0===e.absoluteParentRotation&&(this.__addPositionCacheEntry(e.jOriginalPosition[0],e.id,e.isContainerControl),!0===e.isGridControl))for(var r=e.jControlPosition.children(".tchmi-creator-gridcell"),t=0,o=r.length;t<o;t++)this.__addPositionCacheEntry(r[t],e.id,!0)}else{this.clearSnapPositionCache();var n=this.__designerModeManager.metaDataManager.getControlMetaData();for(var i in n)this.refreshControlDimensionCache(n[i])}},e.prototype.__addSnapPosition=function(e,r,t){e[t]?e[t].push(r):e[t]=[r]},e.prototype.__addPositionCacheEntry=function(e,r,t){var o=tchmi_clone_object(e.getBoundingClientRect());for(var n in o.left+=window.scrollX,o.top+=window.scrollY,o.right+=window.scrollX,o.bottom+=window.scrollY,o)o[n]=Math.round(o[n]);this.__addSnapPosition(this.__verPositionCache,{name:r,controlTopOrLeft:!0,remoteMatch:!1},o.top),this.__addSnapPosition(this.__verPositionCache,{name:r,controlTopOrLeft:!0,remoteMatch:!0},o.top-10),t&&this.__addSnapPosition(this.__verPositionCache,{name:r,controlTopOrLeft:!1,remoteMatch:!0},o.top+10),this.__addSnapPosition(this.__verPositionCache,{name:r,controlTopOrLeft:!1,remoteMatch:!1},o.bottom),this.__addSnapPosition(this.__verPositionCache,{name:r,controlTopOrLeft:!1,remoteMatch:!0},o.bottom+10),t&&this.__addSnapPosition(this.__verPositionCache,{name:r,controlTopOrLeft:!0,remoteMatch:!0},o.bottom-10),this.__addSnapPosition(this.__horPositionCache,{name:r,controlTopOrLeft:!0,remoteMatch:!1},o.left),this.__addSnapPosition(this.__horPositionCache,{name:r,controlTopOrLeft:!0,remoteMatch:!0},o.left-10),t&&this.__addSnapPosition(this.__horPositionCache,{name:r,controlTopOrLeft:!1,remoteMatch:!0},o.left+10),this.__addSnapPosition(this.__horPositionCache,{name:r,controlTopOrLeft:!1,remoteMatch:!1},o.right),this.__addSnapPosition(this.__horPositionCache,{name:r,controlTopOrLeft:!1,remoteMatch:!0},o.right+10),t&&this.__addSnapPosition(this.__horPositionCache,{name:r,controlTopOrLeft:!0,remoteMatch:!0},o.right-10)},e.prototype.handleSnapping=function(e,r,t,o){var n=0,i=0,a=this.__designerModeManager.rootControlManager.getCreatorZoomFactor(),s=!1,l=!1,c=!1,_=!1,u=!1,d=!1,m=!1,h=!1;if(o&&0===e.absoluteParentRotation){var g=this.__designerModeManager.metaDataManager.getSelectedControlIdsWithChildren(),p=!0,E=!0,f=!0,S=!0;switch(this.__anchorName){case"TopLeft":S=E=!1;break;case"TopCenter":S=f=E=!1;break;case"TopRight":f=E=!1;break;case"CenterRight":f=E=p=!1;break;case"CenterLeft":S=E=p=!1;break;case"BottomLeft":S=p=!1;break;case"BottomCenter":S=f=p=!1;break;case"BottomRight":f=p=!1}var y=void 0,v=void 0;if(!0===p||!0===E)for(y in this.__verPositionCache){var C=this.__verPositionCache[y];if(v=parseInt(y,10),!isNaN(v))if(!0===p&&v-5<t.top-this.__positionInsideControl.top&&t.top-this.__positionInsideControl.top<v+5)for(var T=0,M=C;T<M.length;T++){var b=M[T];if(-1===g.indexOf(b.name)&&(!0!==b.remoteMatch||!0!==b.controlTopOrLeft)){!1===s&&!1===l?(i=v-(t.top-this.__positionInsideControl.top),s=!0,u=b.remoteMatch):v-i==t.top-this.__positionInsideControl.top&&(s=!0,u=b.remoteMatch);break}}else if(!0===E&&v-5<t.top-this.__positionInsideControl.top+this.__positionInsideControl.height&&t.top-this.__positionInsideControl.top+this.__positionInsideControl.height<v+5)for(var R=0,N=C;R<N.length;R++)if(b=N[R],-1===g.indexOf(b.name)&&(!0!==b.remoteMatch||!1!==b.controlTopOrLeft)){!1===s&&!1===l?(i=v-(t.top-this.__positionInsideControl.top+this.__positionInsideControl.height),l=!0,d=b.remoteMatch):v-i===t.top-this.__positionInsideControl.top+this.__positionInsideControl.height&&(l=!0,d=b.remoteMatch);break}if(!0===s&&!0===l)break}if(!0===f||!0===S)for(y in this.__horPositionCache){if(C=this.__horPositionCache[y],v=parseInt(y,10),!isNaN(v))if(!0===f&&v-5<t.left-this.__positionInsideControl.left&&t.left-this.__positionInsideControl.left<v+5){for(var w=0,O=C;w<O.length;w++)if(b=O[w],-1===g.indexOf(b.name)&&(!0!==b.remoteMatch||!0!==b.controlTopOrLeft)){!1===c&&!1===_?(n=v-(t.left-this.__positionInsideControl.left),c=!0,m=b.remoteMatch):v-n==t.left-this.__positionInsideControl.left&&(c=!0,m=b.remoteMatch);break}}else if(!0===S&&v-5<t.left-this.__positionInsideControl.left+this.__positionInsideControl.width&&t.left-this.__positionInsideControl.left+this.__positionInsideControl.width<v+5)for(var I=0,A=C;I<A.length;I++)if(b=A[I],-1===g.indexOf(b.name)&&(!0!==b.remoteMatch||!1!==b.controlTopOrLeft)){!1===c&&!1===_?(n=v-(t.left-this.__positionInsideControl.left+this.__positionInsideControl.width),_=!0,h=b.remoteMatch):v-n===t.left-this.__positionInsideControl.left+this.__positionInsideControl.width&&(_=!0,h=b.remoteMatch);break}if(!0===c&&_)break}}return e.jOriginalPosition[0].classList.toggle("tchmi-creator-control-snaptop",s),e.jOriginalPosition[0].classList.toggle("tchmi-creator-control-snapbottom",l),e.jOriginalPosition[0].classList.toggle("tchmi-creator-control-snapleft",c),e.jOriginalPosition[0].classList.toggle("tchmi-creator-control-snapright",_),e.jOriginalPosition[0].classList.toggle("tchmi-creator-control-snaptop-remote",u),e.jOriginalPosition[0].classList.toggle("tchmi-creator-control-snapbottom-remote",d),e.jOriginalPosition[0].classList.toggle("tchmi-creator-control-snapleft-remote",m),e.jOriginalPosition[0].classList.toggle("tchmi-creator-control-snapright-remote",h),{left:r.left+n/a,top:r.top+i/a}},e}(),r.DesignerModeMasterInteractionManager=o}(TcHmi||(TcHmi={})),function(g){var e,r;e=g.System||(g.System={}),r=function(){function e(e){this.__entries={},this.__locale="en",this.__localeRequested=""}return e.prototype.processLocalizationData=function(e,r){void 0===r&&(r=!1);var t=e.locale,o=e.localizedText;if(null==t)return g.Errors.E_PARAMETER_INVALID;if(null==o)return g.Errors.E_PARAMETER_INVALID;this.__locale=t;var n=[];for(var i in o){(l=this.__entries[i])?tchmi_equal(l.text,o[i])||(l.text=o[i],n.push(l)):(l={text:o[i],callbacks:[]},this.__entries[i]=l)}for(var a=0,s=n.length;a<s;a++){for(var l,c=[],_=0,u=(l=n[a]).callbacks.length;_<u;_++)c[_]=l.callbacks[_];for(var d=0,m=c;d<m.length;d++){var h=m[d];-1!==l.callbacks.indexOf(h)&&g.Callback.callSafe(h.callback,this,{error:g.Errors.NONE,value:l.text,destroy:h.destroy})}}g.System.Services.serverManager.request({requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"SetLocale",writeValue:this.__locale}]});return document.documentElement.lang=this.__locale,r||g.EventProvider.raise("onLocaleChanged",this.__locale),g.Errors.NONE},e.prototype.getLocale=function(){return this.__locale},e.prototype.loadLocale=function(e,o){var n=this;void 0===o&&(o=null);var r=g.System.config.languages;if(0!==Object.keys(r).length){if("string"!=typeof e||0===e.length)return g.Log.error("[Source=Framework, Module=TcHmi.System.LocalizationManager] No locale requested."),void("function"==typeof o&&o.call(null,{error:g.Errors.E_PARAMETER_INVALID}));if(this.__localeRequested!==e){if(null==r)return g.Log.error("[Source=Framework, Module=TcHmi.System.LocalizationManager] No locale defined in tchmiconfig.json."),void("function"==typeof o&&o.call(null,{error:g.Errors.E_PARAMETER_INVALID}));var t=r[e];if(null==t){for(var i=e.toLowerCase().split("-"),a=0,s=Object.keys(r);a<s.length;a++){var l=s[a];if(l.toLowerCase().split("-")[0]===i[0]){t=r[l];break}}if(null==t)return void("function"==typeof o?o.call(null,{error:g.Errors.E_PARAMETER_INVALID}):g.Log.error("[Source=Framework, Module=TcHmi.System.LocalizationManager] Did not found a localization file for requested locale "+e+"."))}this.__localeRequested=e;var c=new XMLHttpRequest;c.open("GET",t+(TCHMI_ENABLE_DESIGNER_MODE?"?preventcache="+Math.random():""));var _=function(e){g.Log.error("[Source=Framework, Module=TcHmi.System.LocalizationManager] Failed to load file= "+t+" with error="+c.statusText),"function"==typeof o&&o.call(null,{error:g.Errors.E_PARAMETER_INVALID})};c.addEventListener("load",function(e){if(200===c.status){var r=g.ValueConverter.toObject(c.responseText),t=n.processLocalizationData(r);"function"==typeof o&&o.call(null,{error:t})}else _(e)}),c.addEventListener("error",_),c.send()}else"function"==typeof o&&o.call(null,{error:g.Errors.NONE})}else"function"==typeof o&&o.call(null,{error:g.Errors.NONE})},e.prototype.get=function(e){return this.__entries[e]},e.prototype.watch=function(e,r){var t=this.__entries[e];if(!t)return function(){};var o=null,n=function(){var e=t.callbacks.indexOf(o);-1!==e&&(t.callbacks.splice(e,1),o.callback=null)};return o={callback:r,destroy:n},t.callbacks.push(o),g.Callback.callSafe(r,this,{error:g.Errors.NONE,value:t.text,destroy:n}),n},e}(),e.LocalizationManager=r}(TcHmi||(TcHmi={})),function(f){var a,e;a=f.System||(f.System={}),e=function(){function o(e){var r=this;this.__isInitialized=!1,this.__unloaded=!1,this.__lastConnectState=0,this.__cyclicReconnect=!1,this.__watchSymbolCache={},this.__requestCache={},this.__requestQueue=[],this.__requestPending=null,this.__requestIdCount=0,this.__conWatcherIntervalId=0,this.__conWatcherFirstAccessReject=new Date,this.__symbolWatcherIntervalId=0,this.__symbolWatcherStartTime=new Date,this.__onUnload=function(e){"__TcHmiServermanager"===f.System.Services.dialogManager.getDialogOwner()&&f.System.Services.dialogManager.showDialog("__TcHmiServermanager",!1),r.__unloaded=!0,r.__cyclicReconnect=!1,r.__lastConnectState=4,r.close()},f.EventProvider.register("System.onUnload",this.__onUnload);var t=window.location.port;if(t||(t="https:"===window.location.protocol?"443":"80"),this.setServerAddress(window.location.hostname,t,window.location.protocol),"undefined"==typeof WebSocket&&"function"==typeof e){var o={servicesName:"ServerManager",error:f.Errors.E_NOT_SUPPORTED,details:{code:f.Errors.E_NOT_SUPPORTED,message:f.Errors[f.Errors.E_NOT_SUPPORTED],domain:"TcHmi.System.ServerManager"},dialogManagerMessage:"Browser support for Websocket missing."};e.call(null,o)}}return o.prototype.onWsOpen=function(l){var c=this;return function(e){if(c.__websocket){TCHMI_ENABLE_DESIGNER_MODE&&f.Engineering.ErrorPane.remove("E_SERVER_CONNECTION_LOST"),f.Log.debug("[Source=Framework, Module=TcHmi.System.ServerManager] WebSocket with url="+c.__websocket.url+" opened.");var s=function(){c.request({requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"Diagnostics::LICENSE"}]},function(e){var r,t=1;if(null==e||e.error!==f.Errors.NONE||void 0===e.response||null===e.response)t=1;else{var o=e.response.error;if(void 0!==o)t=o.code===f.Server.Error.HMI_E_MISSING_LICENSE_HANDSHAKE||o.code===f.Server.Error.HMI_E_LICENSE_VERIFY?6:1;else{var n=e.response.commands;if(null==n||void 0===n[0]||null===n[0])t=1;else if(void 0!==n[0].error)t=(r=n[0].error).code===f.Server.Error.HMI_E_MISSING_LICENSE_HANDSHAKE||r.code===f.Server.Error.HMI_E_LICENSE_VERIFY?6:r.code===f.Server.Error.HMI_E_INSUFFICIENT_ACCESS?5:2;else{var i=n[0].readValue;t=null==i?1:void 0!==i.STATE&&"Unregistered"===i.STATE?6:3}}}if(3===t)c.__isInitialized=!0,c.__cyclicReconnect=!0,0!==c.__conWatcherIntervalId&&(window.clearInterval(c.__conWatcherIntervalId),c.__conWatcherIntervalId=0),f.EventProvider.raise("onWebSocketOpened"),0===c.__symbolWatcherIntervalId&&(c.__symbolWatcherStartTime=new Date,c.__symbolWatcherIntervalId=window.setInterval(c.symbolWatcherTick(),100)),"__TcHmiServermanager"===f.System.Services.dialogManager.getDialogOwner()&&f.System.Services.dialogManager.showDialog("__TcHmiServermanager",!1),f.Callback.callSafe(l,null,{error:f.Errors.NONE,url:c.__websocket?c.__websocket.url:void 0}),c.__lastConnectState=t;else if(6===t){var a=new Date;c.__lastConnectState!==t&&(c.__conWatcherFirstAccessReject=a),!TCHMI_ENABLE_DESIGNER_MODE||5e3<a.getTime()-c.__conWatcherFirstAccessReject.getTime()?("function"==typeof l?("__TcHmiServermanager"===f.System.Services.dialogManager.getDialogOwner()&&f.System.Services.dialogManager.showDialog("__TcHmiServermanager",!1),f.Callback.callSafe(l,null,{error:f.Errors.E_WEBSOCKET_OPEN_SERVER_LICENSE_MISSING,url:c.__websocket?c.__websocket.url:void 0})):(TCHMI_ENABLE_DESIGNER_MODE_MASTER?f.System.Services.dialogManager.updateText("__TcHmiServermanager","Error: TwinCAT HMI Server license is missing. Please reopen window.",f.DialogManager.DialogSeverity.Error):f.System.Services.dialogManager.updateText("__TcHmiServermanager",'Error: TwinCAT HMI Server license is missing.\n<input type="submit" value="Retry" style="margin-left:30px;" onclick="window.location.reload()">',f.DialogManager.DialogSeverity.Error),f.System.Services.dialogManager.showDialog("__TcHmiServermanager",!0,f.DialogManager.DialogType.Overlay)),c.__close()):window.setTimeout(s,500),c.__lastConnectState=t}else 2===t?("function"==typeof l?("__TcHmiServermanager"===f.System.Services.dialogManager.getDialogOwner()&&f.System.Services.dialogManager.showDialog("__TcHmiServermanager",!1),f.Callback.callSafe(l,null,{error:f.Errors.E_SERVER_COMMAND_ERROR,details:{code:f.Errors.E_SERVER_COMMAND_ERROR,message:f.Errors[f.Errors.E_SERVER_COMMAND_ERROR],domain:"TcHmi.System.ServerManager",errors:r?[r]:void 0},url:c.__websocket?c.__websocket.url:void 0})):(TCHMI_ENABLE_DESIGNER_MODE_MASTER?f.System.Services.dialogManager.updateText("__TcHmiServermanager","Error: Communication to TwinCAT HMI Server failed. Please reopen window.",f.DialogManager.DialogSeverity.Error):f.System.Services.dialogManager.updateText("__TcHmiServermanager",'Error: Failed to check TwinCAT HMI Server license.\n<input type="submit" value="Retry" style="margin-left:30px;" onclick="window.location.reload()">',f.DialogManager.DialogSeverity.Error),f.System.Services.dialogManager.showDialog("__TcHmiServermanager",!0,f.DialogManager.DialogType.Overlay)),c.__close()):5===t?"function"==typeof l?("__TcHmiServermanager"===f.System.Services.dialogManager.getDialogOwner()&&f.System.Services.dialogManager.showDialog("__TcHmiServermanager",!1),f.Callback.callSafe(l,null,{error:f.Errors.E_WEBSOCKET_OPEN_SERVER_NO_ACCESS,url:c.__websocket?c.__websocket.url:void 0})):(TCHMI_ENABLE_DESIGNER_MODE_MASTER?f.System.Services.dialogManager.updateText("__TcHmiServermanager","Error: No Access to TwinCAT HMI Server license. This session was logged out or the server is wrong configured. Relogin in 5 seconds.",f.DialogManager.DialogSeverity.Error):f.System.Services.dialogManager.updateText("__TcHmiServermanager",'Error: No Access to TwinCAT HMI Server license. This session was logged out or the server is wrong configured. Relogin in 5 seconds.\n<input type="submit" value="Reload now" style="margin-left:30px;" onclick="window.location.reload()">',f.DialogManager.DialogSeverity.Error),f.System.Services.dialogManager.showDialog("__TcHmiServermanager",!0,f.DialogManager.DialogType.Overlay),window.setTimeout(function(){window.location.reload()},5e3)):("function"==typeof l?("__TcHmiServermanager"===f.System.Services.dialogManager.getDialogOwner()&&f.System.Services.dialogManager.showDialog("__TcHmiServermanager",!1),f.Callback.callSafe(l,null,{error:f.Errors.E_WEBSOCKET_OPEN_SERVER_LICENSE_CHECK_FAILED,url:c.__websocket?c.__websocket.url:void 0})):(TCHMI_ENABLE_DESIGNER_MODE_MASTER?f.System.Services.dialogManager.updateText("__TcHmiServermanager","Error: Communication to TwinCAT HMI Server failed. Please reopen window.",f.DialogManager.DialogSeverity.Error):f.System.Services.dialogManager.updateText("__TcHmiServermanager",'Error: Communication to TwinCAT HMI Server failed.\n<input type="submit" value="Retry" style="margin-left:30px;" onclick="window.location.reload()">',f.DialogManager.DialogSeverity.Error),f.System.Services.dialogManager.showDialog("__TcHmiServermanager",!0,f.DialogManager.DialogType.Overlay)),c.__close()),c.__lastConnectState=t})};s()}else f.Callback.callSafe(l,null,{error:f.Errors.ERROR})}},o.prototype.onWsClose=function(r){var t=this;return function(e){!0===t.__unloaded||(e.code&&1e3!==e.code&&!e.reason?f.Log.error("[Source=Framework, Module=TcHmi.System.ServerManager] WebSocket with url="+this.url+" was closed with code="+e.code+"."):e.code&&1e3!==e.code&&e.reason?f.Log.error("[Source=Framework, Module=TcHmi.System.ServerManager] WebSocket with url="+this.url+" was closed with code="+e.code+" and reason="+e.reason+"."):f.Log.debug("[Source=Framework, Module=TcHmi.System.ServerManager] WebSocket with url="+this.url+" was closed.")),3===t.__lastConnectState&&(t.__lastConnectState=0,!1===t.__unloaded&&(f.System.Services.dialogManager.updateText("__TcHmiServermanager","Connection to server lost. Reopening connection...",f.DialogManager.DialogSeverity.Error),f.System.Services.dialogManager.showDialog("__TcHmiServermanager",!0,f.DialogManager.DialogType.Overlay),f.Engineering.ErrorPane.add("E_SERVER_CONNECTION_LOST","Connection to server lost. Reopening connection...",f.Engineering.ErrorPane.MessageType.Error))),f.EventProvider.raise("onWebSocketClosed"),!(t.__isInitialized=!1)===t.__cyclicReconnect&&0===t.__conWatcherIntervalId&&(t.__conWatcherIntervalId=window.setInterval(t.conWatcherTick(),o.RECONNECT_INTERVAL)),f.Callback.callSafe(r,null,{error:f.Errors.E_WEBSOCKET_NOT_READY,url:this.url}),t.__websocket=void 0}},o.prototype.onWsMessage=function(){var o=this;return function(e){var r=f.ValueConverter.toObject(e.data,null);if(!0===TCHMI_CONSOLE_LOG_TCHMISERVER_MESSAGES&&(f.Log.debug("[Source=Framework, Module=TcHmi.System.ServerManager] Response from TwinCAT HMI Server:"),f.Log.debug(r)),null!=r&&void 0!==r.id&&null!==r.id){var t=o.getRequest(r.id);t&&(0!==t.timeoutTimer&&(clearTimeout(t.timeoutTimer),t.timeoutTimer=0),f.Callback.callSafe(t.responseCallback,o,{error:f.Errors.NONE,response:r}))}}},o.prototype.conWatcherTick=function(){var e=this;return function(){!0===e.__cyclicReconnect&&void 0===e.__websocket&&e.open()}},o.prototype.open=function(e){if(!this.__websocket){var r=this.__websocketProtocol+"//"+this.__websocketHost+":"+this.__websocketPort;try{this.__websocket=new WebSocket(r)}catch(e){return void f.Log.error("[Source=Framework, Module=TcHmi.System.ServerManager] Opening connection to Hmi Webserver failed!")}this.__websocket.onopen=this.onWsOpen(e),this.__websocket.onclose=this.onWsClose(e),this.__websocket.onmessage=this.onWsMessage()}},o.prototype.__close=function(){this.__websocket&&(this.__websocket.close(1e3),this.__websocket=void 0)},o.prototype.close=function(){this.__websocket&&(0!==this.__conWatcherIntervalId&&(window.clearInterval(this.__conWatcherIntervalId),this.__conWatcherIntervalId=0),this.__close())},o.prototype.requestQueueHasPendingRequest=function(){return!!this.__requestPending},o.prototype.requestQueueDone=function(e){e&&this.__requestPending&&this.__requestPending.id===e.id&&(this.__requestPending=null,this.requestQueueNext())},o.prototype.requestQueueAdd=function(e){this.__requestQueue.push(e),!(e.queued=!0)===this.requestQueueHasPendingRequest()&&this.requestQueueNext()},o.prototype.requestQueueRemove=function(e){for(var r=-1,t=0,o=this.__requestQueue.length;t<o;t++){if(this.__requestQueue[t].id===e.id){r=t;break}}0<=r&&this.__requestQueue.splice(r,1)},o.prototype.requestQueueNext=function(){var e=this.__requestQueue.shift();e&&(this.__requestPending=e,this.__websocket.send(JSON.stringify(e.message)))},o.prototype.getFreeRequestId=function(){var e=0,r=0;do{if(e=0,1e6<=++r){f.Log.error("[Source=Framework, Module=TcHmi.System.ServerManager] Reached maxium of parallel requests."),e=null;break}this.__requestIdCount++,1e6<=this.__requestIdCount&&(this.__requestIdCount=1),e=this.__requestIdCount}while(this.__requestCache[e]);return e},o.prototype.setServerAddress=function(e,r,t){e&&(this.__websocketHost=e),r&&(this.__websocketPort=r.toString()),"http:"===t?this.__websocketProtocol="ws:":"https:"===t&&(this.__websocketProtocol="wss:")},o.prototype.getRequest=function(e){return this.__requestCache[e]},o.prototype.registerRequest=function(e,r,t){return this.__requestCache[e]?null:(this.__requestCache[e]={id:e,type:r,message:t,deletionPending:!1,timeoutCallback:null,timeoutTimer:0,timeout:null,interval:null,callbacks:[],responseCallback:null,queued:!1},this.__requestCache[e])},o.prototype.unregisterRequest=function(e){var r=this.__requestCache[e];r&&(0!==r.timeoutTimer&&(clearTimeout(r.timeoutTimer),r.timeoutTimer=0),this.requestQueueRemove(r),delete this.__requestCache[e])},o.prototype.registerRequestCallback=function(e,r){var t=this.__requestCache[e];t&&t.callbacks.push(r)},o.prototype.unregisterRequestCallback=function(e,r){var t=this.__requestCache[e];if(t){var o=t.callbacks.indexOf(r);-1<o&&t.callbacks.splice(o,1)}},o.prototype.registerEventCallback=function(e,r){var t=this,o=this.registerRequest(e,300);return o.responseCallback=function(e){f.Callback.callSafeArray(o.callbacks,t,{error:f.Errors.NONE,response:e.response})},this.registerRequestCallback(e,r),e},o.prototype.symbolWatcherTick=function(){var r=this;return function(){var e=new Date;!0===r.__isInitialized&&void 0!==r.__websocket&&null!==r.__websocket&&r.__websocket.readyState===WebSocket.OPEN&&(250<e.getTime()-r.__symbolWatcherStartTime.getTime()&&1===r.symbolWatcherRefresh()&&0!==r.__symbolWatcherIntervalId&&(window.clearInterval(r.__symbolWatcherIntervalId),r.__symbolWatcherIntervalId=0))}},o.prototype.symbolWatcherRefresh=function(){var p=this,e=!1,r=[],t={},o=this.__watchSymbolCache;for(var n in o){var i=o[n];null!==i.reqId&&r.lastIndexOf(i.reqId)<0&&(r.push(i.reqId),i.reqId=null),0===i.refs?delete o[n]:t[n]||(t[n]=i)}if(0<r.length){for(var a={requestType:"ReadWrite",commands:[]},s=0,l=r.length;s<l;s++){var c=r[s];a.commands.push({commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"Unsubscribe",writeValue:c}),f.Log.debug("[Source=Framework, Module=TcHmi.System.ServerManager] Unsubscribing request with id="+c+".")}this.request(a,function(e){var r=e.response;if(r.error&&f.Log.error("[Source=Framework, Module=TcHmi.System.ServerManager] Server responds with error. "+f.Log.buildMessage(r.error)),void 0!==r){var t=r.commands;if(null!=t)for(var o=0,n=t.length;o<n;o++){var i=t[o];null!=i&&(void 0!==i.error&&null!==i.error&&f.Log.error("[Source=Framework, Module=TcHmi.System.ServerManager] Server responds with error for command for symbol="+i.symbol+". "+f.Log.buildMessage(i.error)),void 0!==i.writeValue&&null!==i.writeValue&&p.releaseRequest(i.writeValue))}}})}var _={};for(var n in t){var u=t[n],d="";null===u.interval?d+="GLOBAL":d+=u.interval,d+="_",null===u.timeout?d+="GLOBAL":d+=u.timeout;var m=_[d];if(c=this.getFreeRequestId()){m?u.reqId=m.message.id:(u.reqId=c,m={interval:u.interval,timeout:u.timeout,watchEntries:[],message:{requestType:"Subscription",id:c,commands:[]}},null!==u.interval&&(m.message.intervalTime=u.interval)),m.watchEntries.push(u);var h=m.message.commands,g=!0;for(s=0,l=h.length;s<l;s++){if(h[s].symbol===u.name){g=!1;break}}g&&(h.push({commandOptions:["SendErrorMessage"],symbol:u.name}),f.Log.debug("[Source=Framework, Module=TcHmi.System.ServerManager] Subscribing symbol "+u.name+" in request id="+c+".")),_[d]=m}else e=!0}if(e)return 0;var E=function(g){for(var e=0,r=g.watchEntries.length;e<r;e++)for(var t=g.watchEntries[e],o=0,n=t.callbacks.length;o<n;o++){var i=t.callbacks[o];!1===i.dirty&&(i.refreshLock=!0)}p.request(g.message,function(e){if(e.error===f.Errors.NONE){var r=e.response;r.error&&f.Log.error("[Source=Framework, Module=TcHmi.System.ServerManager] Server responds with error. "+f.Log.buildMessage(r.error));for(var t=0,o=r.commands.length;t<o;t++){var n=r.commands[t];if(n){var i=n.symbol;null===g.interval?i+="_GLOBAL":i+="_"+g.interval,null===g.timeout?i+="_GLOBAL":i+="_"+g.timeout;var a=p.__watchSymbolCache[i];if(a)if(void 0===n.error){if(void 0!==n.readValue){var s=!tchmi_equal(a.value,n.readValue);a.value=n.readValue;for(var l=[],c=0,_=a.callbacks.length;c<_;c++){var u=a.callbacks[c];l.push(u)}for(var d=0,m=l;d<m.length;d++){var h=m[d];-1!==a.callbacks.indexOf(h)&&(!1===h.refreshLock||!0===s?(h.refreshLock=!1,h.dirty=!1,f.Callback.callSafe(h.callback,p,{error:f.Errors.NONE,value:tchmi_clone_object(a.value),destroy:h.destroy})):h.refreshLock=!1)}}}else f.System.ServerManager.__callSafeArrayEx(a.callbacks,p,{error:f.Errors.E_SERVER_COMMAND_ERROR,details:{code:f.Errors.E_SERVER_COMMAND_ERROR,message:f.Errors[f.Errors.E_SERVER_COMMAND_ERROR],domain:"TcHmi.System.ServerManager",reason:n.symbol,errors:[n.error]}})}}}else for(t=0,o=g.watchEntries.length;t<o;t++)f.System.ServerManager.__callSafeArrayEx(g.watchEntries[t].callbacks,p,{error:e.error})})};for(var n in _)E(_[n]);return e?0:1},o.prototype.watch=function(e,n){if(!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER)return f.Callback.callSafe(n,this,{error:f.Errors.E_NOT_SUPPORTED}),function(){};if(null==e)return f.Callback.callSafe(n,this,{error:f.Errors.E_PARAMETER_INVALID}),function(){};if(null==n||"function"!=typeof n)return function(){};var r=e.getOptions().Interval?e.getOptions().Interval:null,t=e.getOptions().Timeout?e.getOptions().Timeout:null,i=this,o=e.getName(),a=o;a+=null===r?"_GLOBAL":"_"+r,a+=null===t?"_GLOBAL":"_"+t;var s=this.__watchSymbolCache[a],l=function(){var e=!1;if(s){s.refs--;for(var r=-1,t=0,o=s.callbacks.length;t<o;t++)if(s.callbacks[t].callback===n){r=t;break}-1<r&&s.callbacks.splice(r,1),0===s.refs&&(e=!0)}e&&0===i.__symbolWatcherIntervalId&&(i.__symbolWatcherStartTime=new Date,i.__symbolWatcherIntervalId=window.setInterval(i.symbolWatcherTick(),100))};return s?(s.callbacks.push({callback:n,dirty:!0,refreshLock:!1,destroy:l}),s.refs++):(s={reqId:null,name:o,expression:e,interval:r,timeout:t,refs:1,value:null,callbacks:[{callback:n,dirty:!0,refreshLock:!1,destroy:l}]},this.__watchSymbolCache[a]=s),0===this.__symbolWatcherIntervalId&&(this.__symbolWatcherStartTime=new Date,this.__symbolWatcherIntervalId=window.setInterval(this.symbolWatcherTick(),100)),l},o.prototype.request=function(e,r){return this.requestEx(e,null,r)},o.prototype.requestEx=function(e,r,t){if(!e)return f.Callback.callSafe(t,this,{error:f.Errors.E_PARAMETER_INVALID}),null;if((void 0===e.id||null===e.id)&&(e.id=this.getFreeRequestId(),null===e.id))return f.Callback.callSafe(t,this,{error:f.Errors.ERROR}),null;if(this.__websocket&&this.__websocket.readyState!==WebSocket.CLOSING&&this.__websocket.readyState!==WebSocket.CLOSED&&this.__websocket.readyState!==WebSocket.CONNECTING){var o,n=!1,i=0;switch(e.requestType){case"ReadWrite":i=100,n=!r||!0!==r.parallel;break;case"Subscription":n=!(i=200);break;case"Event":n=!(i=300)}o=r&&!0===r.refresh?this.getRequest(e.id):this.registerRequest(e.id,i,e),"function"==typeof t&&this.registerRequestCallback(e.id,t),!0===TCHMI_CONSOLE_LOG_TCHMISERVER_MESSAGES&&(f.Log.debug("[Source=Framework, Module=TcHmi.System.ServerManager] Request to TwinCAT HMI Server."),f.Log.debug(e)),200===i&&(void 0===e.intervalTime||null===e.intervalTime?(e.intervalTime=f.System.config.tcHmiServer.websocketIntervalTime,void 0!==e.intervalTime&&null!==e.intervalTime&&"number"==typeof e.intervalTime||(e.intervalTime=500)):o.interval=e.intervalTime),r&&void 0!==r.timeout&&null!==r.timeout&&(o.timeout=r.timeout),o.timeoutCallback=function(){f.Callback.callSafe(t,a,{error:f.Errors.E_TIMEOUT,details:{code:f.Errors.E_TIMEOUT,message:f.Errors[f.Errors.E_TIMEOUT],domain:"TcHmi.System.ServerManager",reason:'Request with id: "'+o.id+'" does not respond within expected time.'}}),o.queued&&a.requestQueueDone(o),a.releaseRequest(o.id)},o.responseCallback=function(e){f.Callback.callSafeArray(o.callbacks,a,{error:f.Errors.NONE,response:e.response}),o.queued&&a.requestQueueDone(o),200!==o.type&&a.releaseRequest(o.id)};var a=this,s=void 0;s=null!==o.timeout?o.timeout:f.System.config.tcHmiServer&&f.System.config.tcHmiServer.websocketTimeout?f.System.config.tcHmiServer.websocketTimeout:5e3,o.timeoutTimer=setTimeout(function(){f.Callback.callSafe(o.timeoutCallback,a)},s),n?this.requestQueueAdd(o):this.__websocket.send(JSON.stringify(o.message))}else f.Callback.callSafe(t,this,{error:f.Errors.E_WEBSOCKET_NOT_READY});return e.id},o.prototype.releaseRequest=function(e){this.unregisterRequest(e)},o.prototype.getWebSocketReadyState=function(){return void 0!==this.__websocket&&null!==this.__websocket?this.__websocket.readyState:null},o.prototype.login=function(e,r,t,o,n){void 0===t&&(t=!0);var i={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"Login",writeValue:{userName:e,password:r,persistent:t}}]};return a.Services.serverManager.requestEx(i,o,function(e){e.error===f.Errors.NONE?e.response.commands&&1===e.response.commands.length&&void 0===e.response.commands[0].error&&void 0!==e.response.sessionId?(f.Log.debug("Login successful with username: "+e.response.commands[0].writeValue.userName),document.cookie="sessionId="+e.response.sessionId+"; path=/",window.location.reload(!0)):e.response.commands&&1===e.response.commands.length&&e.response.commands[0].error&&(f.Log.error("[Source=Framework, Module=TcHmi.System.ServerManager] Login failed with error "+f.Log.buildMessage(e.response.commands[0].error)),f.Callback.callSafe(n,null,e)):f.Callback.callSafe(n,null,e)}),!0},o.prototype.logout=function(e,r){return a.Services.serverManager.requestEx({requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"Logout"}]},e,function(e){e.error===f.Errors.NONE?window.location.href="/Logout?Location="+window.location.pathname:f.Callback.callSafe(r,null,e)}),!0},o.prototype.forceLogout=function(e,r,t){var o={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"ForceLogout",writeValue:e}]};return a.Services.serverManager.requestEx(o,r,t),!0},o.prototype.refreshGlobalSubscriptionRequest=function(r){var t=this;this.request({requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"Unsubscribe",writeValue:r.id}]},function(e){null===r.interval&&delete r.message.intervalTime,null===r.timeout&&r.timeoutTimer&&(clearTimeout(r.timeoutTimer),r.timeoutTimer=null),t.requestEx(r.message,{refresh:!0})})},o.prototype.refreshGlobalSubscriptionRequests=function(){var e=this.__requestCache;for(var r in e){var t=e[r];200!==t.type||null!==t.interval&&null!==t.timeout||this.refreshGlobalSubscriptionRequest(t)}},o.__callSafeArrayEx=function(e,r){for(var t=[],o=2;o<arguments.length;o++)t[o-2]=arguments[o];for(var n,i=[],a=0,s=e.length;a<s;a++)i.push(e[a]);for(var l=0,c=i;l<c.length;l++){var _=c[l];if(-1!==e.indexOf(_)){var u=(n=f.Callback).callSafe.apply(n,[_.callback,r].concat(t));if(void 0!==u)return u}}},o.RECONNECT_INTERVAL=5e3,o}(),a.ServerManager=e}(TcHmi||(TcHmi={})),function(l){var e,r,t,o;e=l.System||(l.System={}),o=function(){function e(e){var a=this;this.__onEventReceived=function(r){var e=a.__subscriptions.firstOrDefault(function(e){return e.responseId===r.response.id});if(e)if(r.error===l.Errors.NONE){var t=r.response;if(!t)return void l.Callback.callSafe(e.callback,null,{error:l.Errors.E_SERVER_RESPONSE_MISSING});if(t.error)return void l.Callback.callSafe(e.callback,null,{error:l.Errors.E_SERVER_RESPONSE_ERROR,details:{code:l.Errors.E_SERVER_RESPONSE_ERROR,message:l.Errors[l.Errors.E_SERVER_RESPONSE_ERROR],errors:[t.error]}});var o=t.commands;if(!o)return void l.Callback.callSafe(e.callback,null,{error:l.Errors.E_SERVER_COMMANDS_MISSING});var n=o[0];if(!n)return void l.Callback.callSafe(e.callback,null,{error:l.Errors.E_SERVER_COMMAND_MISSING});if(n.error)return void l.Callback.callSafe(e.callback,null,{error:l.Errors.E_SERVER_COMMAND_ERROR,details:{code:l.Errors.E_SERVER_COMMAND_ERROR,message:l.Errors[l.Errors.E_SERVER_COMMAND_ERROR],errors:[n.error]}});var i=n.readValue;if(!i)return void l.Callback.callSafe(e.callback,null,{error:l.Errors.E_SERVER_READVALUE_MISSING});l.Callback.callSafe(e.callback,null,{error:l.Errors.NONE,event:i})}else l.Callback.callSafe(e.callback,null,{error:r.error})},this.__subscriptions=new l.List}return e.prototype.confirmAlarm=function(e,n){var r={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"ConfirmAlarm",writeValue:e}]};l.System.Services.serverManager.request(r,function(e){if(e.error===l.Errors.NONE){var r=e.response;if(!r)return void l.Callback.callSafe(n,null,{error:l.Errors.E_SERVER_RESPONSE_MISSING});if(r.error)return void l.Callback.callSafe(n,null,{error:l.Errors.E_SERVER_RESPONSE_ERROR,details:{code:l.Errors.E_SERVER_RESPONSE_ERROR,message:l.Errors[l.Errors.E_SERVER_RESPONSE_ERROR],errors:[r.error]}});var t=r.commands;if(!t)return void l.Callback.callSafe(n,null,{error:l.Errors.E_SERVER_COMMANDS_MISSING});var o=t[0];if(!o)return void l.Callback.callSafe(n,null,{error:l.Errors.E_SERVER_COMMAND_MISSING});if(o.error)return void l.Callback.callSafe(n,null,{error:l.Errors.E_SERVER_COMMAND_ERROR,details:{code:l.Errors.E_SERVER_COMMAND_ERROR,message:l.Errors[l.Errors.E_SERVER_COMMAND_ERROR],errors:[o.error]}});l.Callback.callSafe(n,null,{error:l.Errors.NONE})}else l.Callback.callSafe(n,null,{error:e.error})})},e.prototype.listEvents=function(e,i){var r={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"ListEvents",writeValue:e}]};l.System.Services.serverManager.request(r,function(e){if(e.error===l.Errors.NONE){var r=e.response;if(!r)return void l.Callback.callSafe(i,null,{error:l.Errors.E_SERVER_RESPONSE_MISSING});if(r.error)return void l.Callback.callSafe(i,null,{error:l.Errors.E_SERVER_RESPONSE_ERROR,details:{code:l.Errors.E_SERVER_RESPONSE_ERROR,message:l.Errors[l.Errors.E_SERVER_RESPONSE_ERROR],errors:[r.error]}});var t=r.commands;if(!t)return void l.Callback.callSafe(i,null,{error:l.Errors.E_SERVER_COMMANDS_MISSING});var o=t[0];if(!o)return void l.Callback.callSafe(i,null,{error:l.Errors.E_SERVER_COMMAND_MISSING});if(o.error)return void l.Callback.callSafe(i,null,{error:l.Errors.E_SERVER_COMMAND_ERROR,details:{code:l.Errors.E_SERVER_COMMAND_ERROR,message:l.Errors[l.Errors.E_SERVER_COMMAND_ERROR],errors:[o.error]}});var n=o.readValue;if(!n)return void l.Callback.callSafe(i,null,{error:l.Errors.E_SERVER_READVALUE_MISSING});l.Callback.callSafe(i,null,{error:l.Errors.NONE,events:n})}else l.Callback.callSafe(i,null,{error:e.error})})},e.prototype.subscribe=function(e,i){var a=this,s=l.System.Services.serverManager.getFreeRequestId(),r={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"SubscribeEvents",writeValue:{responseId:s,filter:e}}]};return l.System.Services.serverManager.request(r,function(e){if(e.error===l.Errors.NONE){var r=e.response;if(!r)return void l.Callback.callSafe(i,null,{error:l.Errors.E_SERVER_RESPONSE_MISSING});if(r.error)return void l.Callback.callSafe(i,null,{error:l.Errors.E_SERVER_RESPONSE_ERROR,details:{code:l.Errors.E_SERVER_RESPONSE_ERROR,message:l.Errors[l.Errors.E_SERVER_RESPONSE_ERROR],errors:[r.error]}});var t=r.commands;if(!t)return void l.Callback.callSafe(i,null,{error:l.Errors.E_SERVER_COMMANDS_MISSING});var o=t[0];if(!o)return void l.Callback.callSafe(i,null,{error:l.Errors.E_SERVER_COMMAND_MISSING});if(o.error)return void l.Callback.callSafe(i,null,{error:l.Errors.E_SERVER_COMMAND_ERROR,details:{code:l.Errors.E_SERVER_COMMAND_ERROR,message:l.Errors[l.Errors.E_SERVER_COMMAND_ERROR],errors:[o.error]}});var n={responseId:s,callback:i};a.__subscriptions.push(n),l.System.Services.serverManager.registerEventCallback(s,a.__onEventReceived)}else l.Callback.callSafe(i,null,{error:e.error})}),s},e.prototype.unsubscribe=function(r,n){var i=this,a=this.__subscriptions.firstOrDefault(function(e){return e.responseId===r});if(null!==a){var e={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"UnsubscribeEvents",writeValue:a.responseId}]};l.System.Services.serverManager.request(e,function(e){if(e.error===l.Errors.NONE){var r=e.response;if(!r)return void l.Callback.callSafe(n,null,{error:l.Errors.E_SERVER_RESPONSE_MISSING});if(r.error)return void l.Callback.callSafe(n,null,{error:l.Errors.E_SERVER_RESPONSE_ERROR,details:{code:l.Errors.E_SERVER_RESPONSE_ERROR,message:l.Errors[l.Errors.E_SERVER_RESPONSE_ERROR],errors:[r.error]}});var t=r.commands;if(!t)return void l.Callback.callSafe(n,null,{error:l.Errors.E_SERVER_COMMANDS_MISSING});var o=t[0];if(!o)return void l.Callback.callSafe(n,null,{error:l.Errors.E_SERVER_COMMAND_MISSING});if(o.error)return void l.Callback.callSafe(n,null,{error:l.Errors.E_SERVER_COMMAND_ERROR,details:{code:l.Errors.E_SERVER_COMMAND_ERROR,message:l.Errors[l.Errors.E_SERVER_COMMAND_ERROR],errors:[o.error]}});l.System.Services.serverManager.releaseRequest(a.responseId),i.__subscriptions.remove(a),l.Callback.callSafe(n,null,{error:l.Errors.NONE})}else l.Callback.callSafe(n,null,{error:e.error})})}},e.prototype.updateSubscription=function(r,e,n){var t=this.__subscriptions.firstOrDefault(function(e){return e.responseId===r});if(null!==t){var o={requestType:"ReadWrite",commands:[{commandOptions:["SendErrorMessage","SendWriteValue"],symbol:"UpdateEventsSubscription",writeValue:{responseId:t.responseId,filter:e}}]};l.System.Services.serverManager.request(o,function(e){if(e.error===l.Errors.NONE){var r=e.response;if(!r)return void l.Callback.callSafe(n,null,{error:l.Errors.E_SERVER_RESPONSE_MISSING});if(r.error)return void l.Callback.callSafe(n,null,{error:l.Errors.E_SERVER_RESPONSE_ERROR,details:{code:l.Errors.E_SERVER_RESPONSE_ERROR,message:l.Errors[l.Errors.E_SERVER_RESPONSE_ERROR],errors:[r.error]}});var t=r.commands;if(!t)return void l.Callback.callSafe(n,null,{error:l.Errors.E_SERVER_COMMANDS_MISSING});var o=t[0];if(!o)return void l.Callback.callSafe(n,null,{error:l.Errors.E_SERVER_COMMAND_MISSING});if(o.error)return void l.Callback.callSafe(n,null,{error:l.Errors.E_SERVER_COMMAND_ERROR,details:{code:l.Errors.E_SERVER_COMMAND_ERROR,message:l.Errors[l.Errors.E_SERVER_COMMAND_ERROR],errors:[o.error]}});l.Callback.callSafe(n,null,{error:l.Errors.NONE})}else l.Callback.callSafe(n,null,{error:e.error})})}},e}(),e.ServerEventManager=o,r=o=e.ServerEventManager||(e.ServerEventManager={}),(t=r.ServerAlarmChangeType||(r.ServerAlarmChangeType={}))[t.Raise=0]="Raise",t[t.Change=1]="Change",t[t.Dispose=2]="Dispose"}(TcHmi||(TcHmi={})),function(E){var f,c,e,r;f=E.System||(E.System={}),r=function(){function e(e){this.__triggerMap={}}return e.prototype.__resolveValue=function(t,e){if(e)switch(e.objectType){case"StaticValue":var r=e.value;t.success(r);break;case"Symbol":var o=new f.Symbol(e.symbolExpression);o.read(function(e){e.error===E.Errors.NONE?t.success(e.value):t.error(e.error,e.details),o.destroy(),o=null});break;case"FunctionExpression":if(E.IFunction.isFunctionExpression(e)){var n=new f.FunctionExpression(e.functionExpression);try{n.execute({success:function(e){t.success(e)},error:function(e,r){t.error(e,r)}})}catch(e){t.error(E.Errors.E_TRIGGER_FUNCTION_EXPRESSION_EXCEPTION,{code:E.Errors.E_TRIGGER_FUNCTION_EXPRESSION_EXCEPTION,message:E.Errors[E.Errors.E_TRIGGER_FUNCTION_EXPRESSION_EXCEPTION],reason:e})}}else t.error(E.Errors.E_PARAMETER_INVALID,{code:E.Errors.E_PARAMETER_INVALID,message:E.Errors[E.Errors.E_PARAMETER_INVALID]});break;default:t.error(E.Errors.E_NOT_SUPPORTED,{code:E.Errors.E_NOT_SUPPORTED,message:E.Errors[E.Errors.E_NOT_SUPPORTED]})}else t.error(E.Errors.E_PARAMETER_INVALID,{code:E.Errors.E_PARAMETER_INVALID,message:E.Errors[E.Errors.E_PARAMETER_INVALID]})},e.prototype.__resolveValueAsArray=function(t,r){var o=[];if(r){var n=r.length,i=0,a=this,s=function(){var e=r[i];a.__resolveValue({success:function(e){o.push(e),i===n-1?t.success(o):(i++,s())},error:function(e,r){t.error(e,r)},trigger:t.trigger,event:t.event},e)};s()}else t.success(o)},e.prototype.__resolveConditionExpressionsResult=function(n,e){for(var o=this,i=!1,a=[],s=2*e.length,r=function(r,t){o.__resolveValue({success:function(e){i||(r.result[t]=e,0===--s&&function(){var e="";e+="(";for(var r=0,t=a.length;r<t;r++)null!==a[r].expression.logic&&"OR"!==a[r].expression.logic||(e+="("),"=="===a[r].expression.compareOperator||"==="===a[r].expression.compareOperator?(e+="tchmi_equal(",e+="results["+r+"].result.compare1",e+=",",e+="results["+r+"].result.compare2",e+=",false)"):"!="===a[r].expression.compareOperator||"!=="===a[r].expression.compareOperator?(e+="!tchmi_equal(",e+="results["+r+"].result.compare1",e+=",",e+="results["+r+"].result.compare2",e+=",false)"):(e+="(",e+="results["+r+"].result.compare1",e+=a[r].expression.compareOperator,e+="results["+r+"].result.compare2",e+=")"),void 0!==a[r+1]?"AND"===a[r+1].expression.logic?e+=" && ":"OR"===a[r+1].expression.logic&&(e+=") || "):e+=")";e+=")",e+="\n//# sourceURL=TcHmi_System_TriggerManager_ConditionExpressionsResult_Eval";var o=!1;try{o=gIsolatedEval_TcHmi_System_TriggerManager_ConditionExpressionsResult(e,a)}catch(e){E.Log.error(e),n.error(E.Errors.E_EXCEPTION,{code:E.Errors.E_EXCEPTION,message:E.Errors[E.Errors.E_EXCEPTION],reason:e})}n.success(o)}())},error:function(e,r){i=!0,n.error(e,r)},trigger:n.trigger,event:n.event},r.expression[t])},t=0,l=e.length;t<l&&!i;t++){var c={expression:e[t],result:{compare1:void 0,compare2:void 0}};r(a[t]=c,"compare1"),r(c,"compare2")}},e.prototype.__taControlApiFunction=function(o,e){var r=e,t=r.control,n=r.fn;if(null==t)throw new Error("Property=control is missing.");if(null==n)throw new Error("Property=fn is missing.");var i=null;if(!0===E.Symbol.isSymbolExpression(r.control)){var a=new E.SymbolExpression(r.control);i=E.Controls.get(a.getName())}else i=E.Controls.get(r.control);if(null==i)throw new Error("Missing instance for control="+t+".");var s=i[n];if("function"!=typeof s)throw new Error("Missing function="+n+" in control="+t+".");this.__resolveValueAsArray({success:function(e){var r,t=!0;try{r=s.call.apply(s,[i].concat(e))}catch(e){t=!1,E.Log.error(e),o.error(E.Errors.E_EXCEPTION,{code:E.Errors.E_EXCEPTION,message:E.Errors[E.Errors.E_EXCEPTION],reason:e})}t&&o.success(r)},error:function(e,r){o.error(e,r)},trigger:o.trigger,event:o.event},r.fnParams)},e.prototype.__taWriteToSymbol=function(t,o){this.__resolveValue({success:function(e){var r=new f.Symbol(o.symbolExpression);r.write(e,function(e){e.error===E.Errors.NONE?t.success():t.error(e.error,e.details),r.destroy(),r=null})},error:function(e,r){t.error(e,r)},trigger:t.trigger,event:t.event},o.value)},e.prototype.__taFunction=function(r,e){if(null!=e){var t={objectType:"Function",active:e.active,fn:e.fn,fnParams:e.fnParams};new E.Function(t).executeEx(null,function(e){e.error===E.Errors.NONE?r.success(e.result):r.error(e.error,e.details)})}},e.prototype.__taActionTemplate=function(t,e){if(null!=e){var r=e.templateName;if(null==r||""===r||"string"!=typeof r)return void t.error(E.Errors.E_PARAMETER_INVALID,{code:E.Errors.E_PARAMETER_INVALID,message:E.Errors[E.Errors.E_PARAMETER_INVALID],reason:'Invalid action template name: "'+r+'"'});if(void 0===f.config||null===f.config)return void t.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR],reason:"TcHmiConfig is invalid"});var o=f.config.actionTemplates;if(null==o||void 0===o.length)return void t.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR],reason:'TcHmiConfig property: "actionTemplates" is invalid'});for(var n=null,i=0,a=o.length;i<a&&(n=o[i]).name!==r;i++)n=null;if(null===n)return void t.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR],reason:'Can not find action template with name: "'+r+'".'});var s=tchmi_create_guid(),l=!1,c=n.parameters,_=function(){if(c&&c.length)for(var e=0,r=c.length;e<r;e++){var t=c[e];if(t.name){var o=s+"."+t.name;E.System.Services.templateParamSymbolManager.keepAlive(o)||E.System.Services.templateParamSymbolManager.remove(o)}}},u=e.fnParams;for(i=0,a=c.length;i<a;i++){if((g=c[i]).name){var d=s+"."+g.name,m=u[i];if(E.IFunction.isSymbol(m))E.System.Services.templateParamSymbolManager.add(d,g.type,new E.SymbolExpression(m.symbolExpression));else{if(!E.IFunction.isStaticValue(m)){if(m){t.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR],reason:'Unsupported action value with objectType: "'+m.objectType+'" for ActionTemplate: "'+e.templateName+'" in action template parameter with name: "'+g.name+'". Supported objectTypse are Symbol and StaticValue. Action template processing will be aborted.'}),l=!0;break}t.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR],reason:'Missing parameter number: "'+(i+1)+'" for ActionTemplate: "'+e.templateName+'". Action template processing will be aborted.'}),l=!0;break}E.System.Services.templateParamSymbolManager.add(d,g.type,m.value)}}}if(l)t.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR]}),_();else{var h=JSON.stringify(n.actions);for(i=0,a=c.length;i<a;i++){var g;if((g=c[i]).name){g.name;h=h.replace(new RegExp(tchmi_escape_regex("%tp%"+g.name),"g"),"%tp%"+s+"."+g.name)}}var p=E.ValueConverter.toObject(h,null);if(null===p)t.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR],reason:'Failed to reparse adjusted json in Triggermanager in "'+event+'".'});else try{this.__processActionList({success:function(e){t.success(),_()},error:function(e,r){t.error(e,r),_()},trigger:t.trigger,event:t.event},p)}catch(e){t.error(E.Errors.E_EXCEPTION,{code:E.Errors.E_EXCEPTION,message:E.Errors[E.Errors.E_EXCEPTION],reason:'Unexpected exception "'+e+'" in action template: "'+n.name+'".'})}}}},e.prototype.__taCreateBinding=function(r,e){var t=e.sourceExpression;if(t){var o=e.target;if(c.isControlAttributeBindingTarget(o)){var n=o.attributeExpression,i=new E.SymbolExpression(n);if(i.getType()===E.SymbolType.Control){var a=E.Controls.get(i.getName()),s=E.System.Services.controlManager.getAttributeByPropertyName(a,i.getPathTokens()[0]);if(null!=s&&!0!==s.readOnly&&void 0!==s.propertyName&&null!==s.propertyName&&null!=a)try{E.System.Services.bindingManager.createBinding(t,s.propertyName,a),r.success()}catch(e){return void r.error(E.Errors.E_EXCEPTION,{code:E.Errors.E_EXCEPTION,message:E.Errors[E.Errors.E_EXCEPTION],reason:e})}else r.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR]})}else r.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR]})}else r.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR]})}else r.error(E.Errors.E_PARAMETER_INVALID,{code:E.Errors.E_PARAMETER_INVALID,message:E.Errors[E.Errors.E_PARAMETER_INVALID]})},e.prototype.__taRemoveBinding=function(r,e){var t=!1,o=e.target;if(c.isControlAttributeBindingTarget(o)){var n=o.attributeExpression,i=new E.SymbolExpression(n);if(i.getType()===E.SymbolType.Control){var a=E.Controls.get(i.getName()),s=E.System.Services.controlManager.getAttributeByPropertyName(a,i.getPathTokens()[0]);if(null!=s&&!0!==s.readOnly&&void 0!==s.propertySetterName&&null!==s.propertySetterName&&null!=a){var l=E.System.Services.bindingManager.getBinding(s.propertyName,a);if(l&&l.getSymbol()&&void 0!==l.getPropertyName()&&null!==l.getPropertyName()&&void 0!==l.getControl()&&null!==l.getControl())try{E.System.Services.bindingManager.removeBinding(l.getPropertyName(),l.getControl())}catch(e){return t=!0,E.Log.error(e),void r.error(E.Errors.E_EXCEPTION,{code:E.Errors.E_EXCEPTION,message:E.Errors[E.Errors.E_EXCEPTION],reason:e})}t||r.success()}else r.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR]})}else r.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR]})}else r.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR]})},e.prototype.__taFunctionExpression=function(t,e){c.isFunctionExpression(e)&&new f.FunctionExpression(e.functionExpression).execute({success:function(e){t.success(e)},error:function(e,r){t.error(e,r)}})},e.prototype.__taJavaScript=function(t,o){if(c.isJavaScript(o)){var e="",r=o.sourceLines;if(Array.isArray(r)){try{for(var n=0,i=r.length;n<i;n++)e+=r[n]+"\n";e+="\n//# sourceURL=TcHmi_System_TriggerManager___taJavaScript_Eval"}catch(e){return E.Log.error(e),void t.error(E.Errors.E_EXCEPTION,{code:E.Errors.E_EXCEPTION,message:E.Errors[E.Errors.E_EXCEPTION],reason:e})}try{gIsolatedEval_TcHmi_System_TriggerManager_JavaScriptAction({success:function(e){"Asynchronous"===o.waitMode&&t.success()},error:function(e,r){"Asynchronous"===o.waitMode&&t.error(e,r)}},e),"Asynchronous"!==o.waitMode&&t.success()}catch(e){E.Log.error(e),"Asynchronous"!==o.waitMode&&t.error(E.Errors.E_TRIGGER_JAVASCRIPT_EVAL_EXCEPTION,{code:E.Errors.E_TRIGGER_JAVASCRIPT_EVAL_EXCEPTION,message:E.Errors[E.Errors.E_TRIGGER_JAVASCRIPT_EVAL_EXCEPTION],reason:e})}}else t.error(E.Errors.E_PARAMETER_INVALID,{code:E.Errors.E_PARAMETER_INVALID,message:E.Errors[E.Errors.E_PARAMETER_INVALID]})}},e.prototype.__taCondition=function(t,r){if(r){var e=r.expressions;if(e)try{var o=this;this.__resolveConditionExpressionsResult({success:function(e){!0===e?o.__processActionList({success:function(e){},error:function(e,r){},trigger:t.trigger,event:t.event},r.true):o.__processActionList({success:function(e){},error:function(e,r){},trigger:t.trigger,event:t.event},r.false),t.success()},error:function(e,r){t.error(e,r)},trigger:t.trigger,event:t.event},e)}catch(e){E.Log.error(e),t.error(E.Errors.E_TRIGGER_RESOLVE_CONDITION_EXPRESSION_EXCEPTION,{code:E.Errors.E_TRIGGER_RESOLVE_CONDITION_EXPRESSION_EXCEPTION,message:E.Errors[E.Errors.E_TRIGGER_RESOLVE_CONDITION_EXPRESSION_EXCEPTION],reason:e})}else t.error(E.Errors.E_PARAMETER_INVALID,{code:E.Errors.E_PARAMETER_INVALID,message:E.Errors[E.Errors.E_PARAMETER_INVALID]})}else t.error(E.Errors.E_PARAMETER_INVALID,{code:E.Errors.E_PARAMETER_INVALID,message:E.Errors[E.Errors.E_PARAMETER_INVALID]})},e.prototype.__taSwitchCase=function(a,e){if(null!=e){var r=e.compare;if(null!=r){var s=e.cases;if(null!=s){var t=null;void 0!==e.caseDefault&&null!==e.caseDefault&&(t=e.caseDefault);var o=this,l=void 0;this.__resolveValue({success:function(e){l=e,function(){var e,n=0,i=null,r=function(){var e=s[n];if(null==e)return a.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR]}),"break";var r,t=e.caseValue;if(null==t)return a.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR]}),"break";switch(t.objectType){case"StaticValue":r=t.value;break;case"Symbol":var o=new f.Symbol(t.symbolExpression);if(null!=o){if(!f.Symbol.isInternalSymbol(o)){a.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR],reason:'Symbol of type: "'+E.SymbolType[o.getExpression().getType()]+'" is not supported in switch case. Please use only StaticValue or InternalSymbol.'}),o.destroy();break}o.read(function(e){r=e.value,o.destroy()})}break;default:return a.error(E.Errors.ERROR,{code:E.Errors.ERROR,message:E.Errors[E.Errors.ERROR],reason:'Object type: "'+t.objectType+'" is not supported in switch case. Please use only StaticValue or Symbol.'}),"continue"}return!0===tchmi_equal(r,l,!1)&&(i=e),null!==i?"break":void 0};for(n=0,e=s.length;n<e&&"break"!==r();n++);null!==i?o.__processActionList({success:function(){},error:function(){},trigger:a.trigger,event:a.event},i.actions):null!==t&&o.__processActionList({success:function(){},error:function(){},trigger:a.trigger,event:a.event},t.actions)}(),a.success(E.Errors.NONE)},error:function(e,r){a.error(e,r)},trigger:a.trigger,event:a.event},r)}else a.error(E.Errors.E_PARAMETER_INVALID,{code:E.Errors.E_PARAMETER_INVALID,message:E.Errors[E.Errors.E_PARAMETER_INVALID]})}else a.error(E.Errors.E_PARAMETER_INVALID,{code:E.Errors.E_PARAMETER_INVALID,message:E.Errors[E.Errors.E_PARAMETER_INVALID]})}else a.error(E.Errors.E_PARAMETER_INVALID,{code:E.Errors.E_PARAMETER_INVALID,message:E.Errors[E.Errors.E_PARAMETER_INVALID]})},e.prototype.__processAction=function(t,o){var n=this;if(!1!==o.active){var e={success:function(e){n.__processActionList({success:function(e){t.success(e)},error:function(e,r){t.error(e,r)},trigger:t.trigger,event:t.event},o.success)},error:function(e,r){E.Log.error("[Source=Framework, Module=TcHmi.System.TriggerManager, Event="+t.event.name+", ObjectType="+o.objectType+"] "+E.Log.buildMessage(r)),n.__processActionList({success:function(e){t.success(e)},error:function(e,r){t.error(e)},trigger:t.trigger,event:t.event},o.error)},trigger:t.trigger,event:t.event};try{var r=!1;switch(o.objectType){case"Condition":this.__taCondition(e,o);break;case"SwitchCase":this.__taSwitchCase(e,o);break;case"ControlApiFunction":this.__taControlApiFunction(e,o);break;case"WriteToSymbol":this.__taWriteToSymbol(e,o);break;case"Function":this.__taFunction(e,o);break;case"JavaScript":this.__taJavaScript(e,o);break;case"ActionTemplate":this.__taActionTemplate(e,o);break;case"CreateBinding":this.__taCreateBinding(e,o);break;case"RemoveBinding":this.__taRemoveBinding(e,o);break;case"FunctionExpression":this.__taFunctionExpression(e,o);break;case"Comment":t.success();break;default:r=!0}!0===r&&t.error(E.Errors.E_NOT_SUPPORTED,{code:E.Errors.E_NOT_SUPPORTED,message:E.Errors[E.Errors.E_NOT_SUPPORTED],reason:'Object type: "'+o.objectType+'" is not supported.'})}catch(e){E.Log.error(e),t.error(E.Errors.E_TRIGGER_ACTION_EXCEPTION,{code:E.Errors.E_TRIGGER_ACTION_EXCEPTION,message:E.Errors[E.Errors.E_TRIGGER_ACTION_EXCEPTION],reason:e})}}else t.success()},e.prototype.__processActionList=function(e,r){if(r){var n=r.length;if(0!==n){var i=0,a=this,s=function(){var t=r[i],o=function(){i===n-1?e.success():(i++,s())};a.__processAction({success:function(){void 0!==t.asyncWait&&!0!==t.asyncWait||o()},error:function(e,r){void 0!==t.asyncWait&&!0!==t.asyncWait||o()},trigger:e.trigger,event:e.event},t),void 0!==t.asyncWait&&!1===t.asyncWait&&o()};s()}else e.success()}else e.success()},e.prototype.__onTriggerEvent=function(t){var o=this;return function(e,r){E.Log.debug("[Source=Framework, Module=TcHmi.System.TriggerManager] Trigger event="+e.name),E.Log.debug("[Source=Framework, Module=TcHmi.System.TriggerManager] argument=event"),E.Log.debug(e),E.Log.debug("[Source=Framework, Module=TcHmi.System.TriggerManager] argument=data"),E.Log.debug(r),void 0!==o.__triggerMap&&null!==o.__triggerMap&&(!0===t.preventDefault&&r&&"function"==typeof r.preventDefault&&r.preventDefault(),o.__processActionList({success:function(e){},error:function(e,r){},trigger:t,event:e},t.actions))}},e.prototype.register=function(e){if((!0!==TCHMI_ENABLE_DESIGNER_MODE||!0!==TCHMI_ENABLE_DESIGNER_MODE_MASTER)&&null!=e)for(var r=0,t=e.length;r<t;r++){var o=e[r];if(void 0!==o.event&&null!==o.event&&"string"==typeof o.event&&(void 0!==o.actions&&null!==o.actions&&"object"==typeof o.actions&&!1!==Array.isArray(o.actions))){var n=E.EventProvider.register(o.event,this.__onTriggerEvent(o),o.preventDefault?{passive:!1,capture:!1}:void 0),i=this.__triggerMap[o.event];void 0===i?(i=[{trigger:o,destroyTriggerEvent:n}],this.__triggerMap[o.event]=i):i.push({trigger:o,destroyTriggerEvent:n})}}},e.prototype.unregister=function(e){if((!0!==TCHMI_ENABLE_DESIGNER_MODE||!0!==TCHMI_ENABLE_DESIGNER_MODE_MASTER)&&null!=e)for(var r=0,t=e.length;r<t;r++){var o=e[r];if(void 0!==o.event&&null!==o.event&&"string"==typeof o.event&&(void 0!==o.actions&&null!==o.actions&&"object"==typeof o.actions&&!1!==Array.isArray(o.actions))){var n=this.__triggerMap[o.event];if(void 0!==n){for(var i=0,a=n.length;i<a;i++){var s=n[i];if(tchmi_equal(o,s.trigger)){s.destroyTriggerEvent(),n.splice(i,1),i--,a--;break}s=null}0===n.length&&delete this.__triggerMap[o.event]}}}},e}(),f.TriggerManager=r,(e=c=f.Trigger||(f.Trigger={})).isCondition=function(e){return"Condition"===e.objectType},e.isSwitchCase=function(e){return"SwitchCase"===e.objectType},e.isControlApiFunction=function(e){return"ControlApiFunction"===e.objectType},e.isWriteToSymbol=function(e){return"WriteToSymbol"===e.objectType},e.isCreateBinding=function(e){return"CreateBinding"===e.objectType},e.isComment=function(e){return"Comment"===e.objectType},e.isRemoveBinding=function(e){return"RemoveBinding"===e.objectType},e.isFunction=function(e){return null!==e&&"Function"===e.objectType},e.isJavaScript=function(e){return"JavaScript"===e.objectType},e.isActionTemplate=function(e){return"ActionTemplate"===e.objectType},e.isFunctionExpression=function(e){return null!==e&&"FunctionExpression"===e.objectType},e.isControlAttributeBindingTarget=function(e){return"ControlAttributeBindingTarget"===e.objectType}}(TcHmi||(TcHmi={})),function(t){var e=function(){function e(){}
/**
         * Loads a language file and refreshes localization symbols.
         * @function
         * @param {string | null} locale
         * @param {null | function} callback
         * @preserve (Part of the public API)
         */return e.load=function(e,r){void 0===r&&(r=null),t.System.Services.localizationManager.loadLocale(e,r)},
/**
         * Returns the current locale string.
         * @function
         * @returns {string}
         * @preserve (Part of the public API)
         */
e.get=function(){return t.System.Services.localizationManager.getLocale()},
/**
         * Returns the list of registered locales.
         * @function
         * @returns {string[]}
         * @preserve (Part of the public API)
         */
e.getRegisteredLocales=function(){var e=[];for(var r in t.System.config.languages)e.push(r);return e},e}();t.Locale=e}(TcHmi||(TcHmi={})),function(le){var ce,e,r,t;if(e=ce=le.System||(le.System={}),(r=e.Services||(e.Services={})).Engineering||(r.Engineering={}),(t=e.Caches||(e.Caches={})).registeredFrameworkFunctionDescription=[],t.registeredControls={},t.templateMarkupCache={},t.partialMarkupCache={},t.partialCompositeConfigCache={},e.config={basePath:""},(e.isInitialized=!1)===TCHMI_UNITTEST_MODE){if(TCHMI_DYNAMIC_INSTANCE_ID=tchmi_create_guid(),le.Log.debug("[Source=Framework, Module=TcHmi] TCHMI_DYNAMIC_INSTANCE_ID: "+TCHMI_DYNAMIC_INSTANCE_ID),4<=TCHMI_CONSOLE_LOG_LEVEL&&"object"==typeof performance&&"function"==typeof performance.now&&le.Log.debug("[Source=Framework, Module=TcHmi] Time to main function: "+performance.now().toFixed(3).toString()+"ms"),le.System.SharedResources.jqWindow=$(window),le.System.SharedResources.jqDocument=$(document),window.addEventListener("unload",le.System.__unload),ce.Services.dialogManager=new ce.DialogManager,"loading"!==document.readyState)le.System.SharedResources.jqBody=$(document.body),le.System.SharedResources.jqBody.empty(),!0!==TCHMI_ENABLE_DESIGNER_MODE_MASTER&&le.System.Services.dialogManager.showDialog("__TcHmiMain",!0,le.DialogManager.DialogType.SYSTEMLoading);else{var o=function(){document.removeEventListener("readystatechange",o),le.System.SharedResources.jqBody=$(document.body),le.System.SharedResources.jqBody.empty(),!0!==TCHMI_ENABLE_DESIGNER_MODE_MASTER&&le.System.Services.dialogManager.showDialog("__TcHmiMain",!0,le.DialogManager.DialogType.SYSTEMLoading)};document.addEventListener("readystatechange",o)}le.System.Services.dialogManager.updateText("__TcHmiMain","Loading...");var _e=1,ue=[],de=0,me=[],he=0,ge=[],pe=0,Ee=[],fe=0,Se=[],ye=0,ve=[],Ce=0,Te=window.setInterval(function(){le.System.Services.dialogManager.updateProgress()},300),Me=function(e){if(1e4!==_e&&e.error!==le.Errors.NONE)throw le.System.Services.dialogManager.updateText("__TcHmiMain","Error: Initializing "+e.servicesName+" failed: "+e.dialogManagerMessage,le.DialogManager.DialogSeverity.Error),_e=1e4,n(),new Error("Aborting initializing services")},be=TCHMI_ENABLE_DESIGNER_MODE?"?preventcache="+TCHMI_DYNAMIC_INSTANCE_ID:"",Re={HmiConfigJsonFetch:2e9,HmiDescriptionJsonFetch:2e9,OpenServerConnection:2e9,ControlsDescriptionJsonFetch:2e9,ControlsDescriptionJsonResolved:2e9,TypeDefinitionsResolved:2e9,ControlsTemplatesFetch:2e9,FunctionDescriptionJsonFetch:2e9,UserFunctionDescriptionJsonFetch:2e9,UserControlPartialsConfigFetch:2e9,UserControlPartialsMarkupPreloaded:2e9,ViewPartialsMarkupPreloaded:2e9,ViewPartialsMarkupCompiled:2e9,ContentPartialsMarkupPreloaded:2e9,ContentPartialsMarkupCompiled:2e9},n=function a(){switch(_e){case 0:break;case 1:_e=0,le.Log.performanceLog("[Source=Framework, Module=TcHmi] Loading Properties/tchmiconfig.json"),le.Log.debug("[Source=Framework, Module=TcHmi] Loading Properties/tchmiconfig.json..."),le.System.Services.dialogManager.updateText("__TcHmiMain","Loading Properties/tchmiconfig.json..."),Re.HmiConfigJsonFetch=1;var o=new XMLHttpRequest;o.open("GET","Properties/tchmiconfig.json"+be);var n=function(e){le.Log.error("[Source=Framework, Module=TcHmi] Loading tchmiconfig.json failed! Errordetail: "+o.statusText),le.System.Services.dialogManager.updateText("__TcHmiMain","Fatal internal error. Loading base config tchmiconfig.json failed! "+o.statusText,le.DialogManager.DialogSeverity.Error),_e=1e4,a()};o.addEventListener("load",function(e){if(200===o.status){le.System.config=le.ValueConverter.toObject(o.responseText),null===le.System.config&&(le.System.config={basePath:""}),le.System.config.creatorSettings?le.System.config.creatorSettings.viewport||(le.System.config.creatorSettings.viewport={defaultHeight:0,defaultWidth:0}):le.System.config.creatorSettings={viewport:{defaultHeight:0,defaultWidth:0}},le.System.config.userFunctions||(le.System.config.userFunctions=[]);var r=0;if(le.System.config.userFunctions)for(ue=le.System.config.userFunctions,de=ue.length,r=0;r<de;r++)ue[r].url=tchmi_path(ue[r].url);if(le.System.config.userControls||(le.System.config.userControls=[]),le.System.config.userControls)for(me=le.System.config.userControls,he=me.length,r=0;r<he;r++)me[r].url=tchmi_path(me[r].url);if(le.System.config.content||(le.System.config.content=[]),le.System.config.content)for(Ee=le.System.config.content,fe=Ee.length,r=0;r<fe;r++)Ee[r].url=tchmi_path(Ee[r].url);if(le.System.config.views||(le.System.config.views=[]),le.System.config.views)for(ge=le.System.config.views,pe=ge.length,r=0;r<pe;r++)ge[r].url=tchmi_path(ge[r].url);if(le.System.config.tcHmiServer||(le.System.config.tcHmiServer={websocketIntervalTime:500}),!0===TCHMI_ENABLE_DESIGNER_MODE){var t=TCHMI_ENABLE_DESIGNER_MODE_FALLBACK_CONFIG_JSON;null!==t&&(void 0!==t.basePath&&(le.System.config.basePath=t.basePath),t.tcHmiServer&&t.tcHmiServer.websocketIntervalTime&&(le.System.config.tcHmiServer.websocketIntervalTime=t.tcHmiServer.websocketIntervalTime))}le.Log.debug("[Source=Framework, Module=TcHmi] Loading tchmiconfig.json finished!"),Re.HmiConfigJsonFetch=0,_e=6,a()}else n(e)}),o.addEventListener("error",n),o.send();break;case 6:le.Log.performanceLog("[Source=Framework, Module=TcHmi] Loading framework description"),_e=0,le.Log.debug("[Source=Framework, Module=TcHmi] Loading framework Description.json..."),le.System.Services.dialogManager.updateText("__TcHmiMain","Loading Description.json..."),Re.HmiDescriptionJsonFetch=1;var r=tchmi_path(le.System.config.basePath+"/Description.json"),t=new XMLHttpRequest;t.open("GET",r+be);var i=function(e){le.Log.error("[Source=Framework, Module=TcHmi] Loading "+r+" failed! Errordetail: "+t.statusText),le.System.Services.dialogManager.updateText("__TcHmiMain","Fatal internal error. Loading Framework "+r+" failed! "+t.statusText,le.DialogManager.DialogSeverity.Error),_e=1e4,a()};t.addEventListener("load",function(e){200===t.status?(le.Log.debug("[Source=Framework, Module=TcHmi] Loading framework Description.json finished!"),le.System.description=le.ValueConverter.toObject(t.responseText),le.version=le.System.description.version,Re.HmiDescriptionJsonFetch=0,_e=2,a()):i(e)}),t.addEventListener("error",i),t.send();break;case 2:if("loading"===document.readyState){var e=function(){document.removeEventListener("readystatechange",e),0===_e||1e4===_e||a()};document.addEventListener("readystatechange",e);break}if("3.2.1"!==$().jquery)return le.Log.error("[Source=Framework, Module=TcHmi] Mismatching jQuery version. Please avoid overriding built in jQuery version."),le.System.Services.dialogManager.updateText("__TcHmiMain","Mismatching jQuery version. Please avoid overriding.",le.DialogManager.DialogSeverity.Error),_e=1e4,void a();_e=3;case 3:if(le.Log.performanceLog("[Source=Framework, Module=TcHmi] Initializing services"),_e=0,le.System.Services.dialogManager.updateText("__TcHmiMain","Initializing services..."),le.System.Services.internalSymbolManager=new ce.InternalSymbolManager(Me),le.System.Services.templateParamSymbolManager=new ce.TemplateParamSymbolManager(Me),le.System.Services.bindingManager=new ce.BindingManager(Me),le.System.Services.localizationManager=new ce.LocalizationManager(Me),le.System.Services.serverManager=new ce.ServerManager(Me),le.System.Services.triggerManager=new ce.TriggerManager(Me),le.System.Services.accessManager=new ce.AccessManager(Me),le.System.Services.topMostLayer=new ce.TopMostLayer(Me),le.System.Services.serverEventManager=new ce.ServerEventManager(Me),le.System.Services.functionProvider=new ce.FunctionProvider(Me),le.System.Services.controlManager=new ce.ControlManager(Me),le.System.Services.themeManager=new ce.ThemeManager(Me),le.System.Services.styleManager=new ce.StyleManager(Me),le.System.Services.typeManager=new ce.TypeManager(Me),le.System.Services.animationProvider=new ce.AnimationProvider(Me),le.System.Services.viewManager=new ce.ViewManager(Me),!0===TCHMI_ENABLE_DESIGNER_MODE&&(le.System.Services.Engineering.designerModeManager=new ce.Engineering.DesignerModeManager(Me),le.System.Services.Engineering.designerModeComManager=new ce.Engineering.DesignerModeComManager(Me),le.System.Services.Engineering.errorPane=new ce.Engineering.ErrorPane),!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER){var s=TCHMI_ENABLE_DESIGNER_MODE_FALLBACK_CONFIG_JSON;null!==s&&void 0!==s.tcHmiServer&&s.tcHmiServer.websocketOverwrite&&le.System.Services.serverManager.setServerAddress(s.tcHmiServer.websocketOverwrite.host,s.tcHmiServer.websocketOverwrite.port)}le.EventProvider.raise("System.onInitializedServices"),le.Log.debug("[Source=Framework, Module=TcHmi] Initializing services finished!"),_e=7;case 7:le.Log.performanceLog("[Source=Framework, Module=TcHmi] Opening websocket to server"),_e=0,le.Log.debug("[Source=Framework, Module=TcHmi] Opening websocket to server..."),le.System.Services.dialogManager.updateText("__TcHmiMain","Opening Websocket connection..."),Re.OpenServerConnection=1,le.System.Services.serverManager.open(function(e){if(0!==Re.OpenServerConnection&&1e4!==_e){if(e.error===le.Errors.NONE)Re.OpenServerConnection=0,le.Log.debug("[Source=Framework, Module=TcHmi] Opening websocket to server finished!"),_e=8;else{if(e.error===le.Errors.E_WEBSOCKET_OPEN_SERVER_LICENSE_CHECK_FAILED)le.Log.error("[Source=Framework, Module=TcHmi] Failed to check TwinCAT HMI Server license."),le.System.Services.dialogManager.updateText("__TcHmiMain",'Error: Communication to TwinCAT HMI Server failed.<br>\n<input type="submit" value="Retry" style="padding:10px;" onclick="window.location.reload()">',le.DialogManager.DialogSeverity.Error);else if(e.error===le.Errors.E_SERVER_COMMAND_ERROR)le.Log.error("[Source=Framework, Module=TcHmi] TwinCAT HMI Server license symbol invalid."),le.System.Services.dialogManager.updateText("__TcHmiMain",'Error: Communication to TwinCAT HMI Server failed (System-Symbols mapped?).<br>\n<input type="submit" value="Retry" style="padding:10px;" onclick="window.location.reload()">',le.DialogManager.DialogSeverity.Error);else if(e.error===le.Errors.E_WEBSOCKET_OPEN_SERVER_LICENSE_MISSING)le.Log.error("[Source=Framework, Module=TcHmi] TwinCAT HMI Server license is missing."),TCHMI_ENABLE_DESIGNER_MODE_MASTER?le.System.Services.dialogManager.updateText("__TcHmiMain","Error: TwinCAT HMI Server license is missing. Please reopen window.",le.DialogManager.DialogSeverity.Error):le.System.Services.dialogManager.updateText("__TcHmiMain",'Error: TwinCAT HMI Server license is missing.<br>\n<input type="submit" value="Retry" style="padding:10px;" onclick="window.location.reload()">',le.DialogManager.DialogSeverity.Error);else if(e.error===le.Errors.E_WEBSOCKET_OPEN_SERVER_NO_ACCESS)le.System.Services.dialogManager.updateText("__TcHmiMain",'Error: No Access to TwinCAT HMI Server license. This session was logged out or the server is wrong configured. Autoreload in 5 seconds.<br>\n<input type="submit" value="Reload now" style="padding:10px;" onclick="window.location.reload()">',le.DialogManager.DialogSeverity.Error),window.setTimeout(function(){window.location.reload()},5e3);else if(!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER)le.System.Services.dialogManager.updateText("__TcHmiMain",'Opening connection to engineering server failed.<br>Please start the server from the context menu in the project tree.<br>\n<input type="submit" value="Retry" style="padding:10px;" onclick="window.location.reload()">',le.DialogManager.DialogSeverity.Error);else{var r=e.url&&-1===e.url.indexOf(window.location.host),t="Fatal Error. Opening";"https:"===window.location.protocol&&(t+=" secure"),t+=" Websocket connection failed!",t+=" Perhaps";var o=[];"https:"===window.location.protocol&&o.push(" the HTTPS server certificate is not trusted for websocket (missing trust always)"),e.url&&!0===r&&o.push(" the server "+e.url+" is no working websocket server"),o.push(" we have a proxy problem"),t+=o.join(" or"),t+='. The browser console could have some more information.<br>\n<input type="submit" value="Retry" style="padding:10px;" onclick="window.location.reload()">',le.System.Services.dialogManager.updateText("__TcHmiMain",t,le.DialogManager.DialogSeverity.Error)}_e=1e4}a()}});break;case 8:le.Log.performanceLog("[Source=Framework, Module=TcHmi] Resolving type definitions"),le.Log.debug("[Source=Framework, Module=TcHmi] Resolving type definitions..."),le.System.Services.dialogManager.updateText("__TcHmiMain","Resolving type definitions..."),Re.TypeDefinitionsResolved=1;ce.Services.typeManager.doWatchTypeDefinitions(function(e){if(e.error===le.Errors.NONE)Re.TypeDefinitionsResolved=0,le.Log.debug("[Source=Framework, Module=TcHmi] Resolving type definitions finished!"),_e=4;else{le.Log.error("[Source=Framework, Module=TcHmi] Fatal internal error. Resolving type definitions failed: "+le.Errors[e.error]);le.System.Services.dialogManager.updateText("__TcHmiMain","Fatal internal error. Resolving type definitions failed!",le.DialogManager.DialogSeverity.Error),_e=1e4}a()});break;case 4:le.Log.performanceLog("[Source=Framework, Module=TcHmi] Loading internal symbols"),_e=0,le.System.Services.dialogManager.updateText("__TcHmiMain","Loading internal symbols...");var l=le.System.config.symbols;if(l&&l.internal)for(var c in l.internal)le.System.Services.internalSymbolManager.add(c,l.internal[c]);l=null,le.Log.debug("[Source=Framework, Module=TcHmi] Loading internal symbols finished!"),_e=5;case 5:le.Log.performanceLog("[Source=Framework, Module=TcHmi] Loading localization"),_e=0,le.System.Services.dialogManager.updateText("__TcHmiMain","Loading localization...");var _=ce.Services.accessManager.getCurrentUserConfig().locale;if(""===_&&le.System.config.locale&&(_=le.System.config.locale),""!==_)return void ce.Services.localizationManager.loadLocale(_,function(e){e.error!==le.Errors.NONE?le.Log.error("[Source=Framework, Module=TcHmi] Did not found a localization file for requested locale "+_+". Localized symbols are not available."):le.Log.debug("[Source=Framework, Module=TcHmi] Loading localization finished!"),_e=9,a()});le.Log.debug("[Source=Framework, Module=TcHmi] Loading localization finished!"),_e=9;case 9:for(var c in le.System.Caches.registeredControls){var u=le.System.Caches.registeredControls[c];void 0!==u.directory&&null!==u.directory&&(Se.push(u.directory),ye++),void 0!==u.templatePath&&null!==u.templatePath&&-1===ve.indexOf(u.templatePath)&&ve.push(u.templatePath)}if(Ce=ve.length,le.Log.performanceLog("[Source=Framework, Module=TcHmi] Loading "+ye+" control Description.json"),_e=0,Se&&0<ye){le.System.Services.dialogManager.updateText("__TcHmiMain","Loading control descriptions..."),Re.ControlsDescriptionJsonFetch=ye;for(var d=function(e,r){var t=tchmi_path(e+"/Description.json"),o=new XMLHttpRequest;o.open("GET",r+be);var n=function(e){1e4!==_e&&(le.Log.error("[Source=Framework, Module=TcHmi] Loading "+r+" failed! Errordetail: "+o.statusText),le.System.Services.dialogManager.updateText("__TcHmiMain","Fatal internal error. Loading "+r+" failed! "+o.statusText,le.DialogManager.DialogSeverity.Error),_e=1e4,a())};o.addEventListener("load",function(e){if(200===o.status){if(1e4!==_e){var r=le.ValueConverter.toObject(o.responseText);le.System.Services.controlManager.addDescription(t,r),Re.ControlsDescriptionJsonFetch--,le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+t+" finished!"),ce.Services.themeManager.registerControlThemeFiles(r),Re.ControlsDescriptionJsonFetch<=0&&(r=null,_e=10,a())}}else n(e)}),o.addEventListener("error",n),o.send()},m=0,h=Se;m<h.length;m++){var g=h[m];le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+g+"Description.json..."),d(g,tchmi_path(le.System.config.basePath+"/Controls/"+g+"/Description.json"))}break}_e=10;case 10:le.Log.performanceLog("[Source=Framework, Module=TcHmi] Parse "+ye+" control Description.json"),_e=0,le.Log.debug("[Source=Framework, Module=TcHmi] Resolving control inheritation..."),le.System.Services.dialogManager.updateText("__TcHmiMain","Resolving control inheritation..."),Re.ControlsDescriptionJsonResolved=1;try{le.System.Services.controlManager.resolveDescriptionInheritation()}catch(e){return le.Log.error(e),le.System.Services.dialogManager.updateText("__TcHmiMain","Fatal internal error. Resolving control description inheritation failed!",le.DialogManager.DialogSeverity.Error),_e=1e4,void a()}try{le.System.Services.controlManager.resolveTemplateInheritation()}catch(e){return le.Log.error(e),le.System.Services.dialogManager.updateText("__TcHmiMain","Fatal internal error. Resolving control template inheritation failed!",le.DialogManager.DialogSeverity.Error),_e=1e4,void a()}le.System.Services.themeManager.resolveDefaultValueInternal(),le.System.Services.themeManager.processActiveTheme(),Re.ControlsDescriptionJsonResolved=0,_e=11;case 11:if(le.Log.performanceLog("[Source=Framework, Module=TcHmi] Loading templates for "+ye+" controls"),_e=0,ve&&0<Ce){le.System.Services.dialogManager.updateText("__TcHmiMain","Loading control templates..."),Re.ControlsTemplatesFetch=Ce;for(var p=function(e,r){var t=tchmi_path(e),o=new XMLHttpRequest;o.open("GET",r+be);var n=function(e){1e4!==_e&&(le.Log.error("[Source=Framework, Module=TcHmi] Loading "+r+" failed! Errordetail: "+o.statusText),le.System.Services.dialogManager.updateText("__TcHmiMain","Fatal internal error. Loading "+r+" failed! "+o.statusText,le.DialogManager.DialogSeverity.Error),_e=1e4,a())};o.addEventListener("load",function(e){200===o.status?1e4!==_e&&(ce.Caches.templateMarkupCache[t]=o.responseText,Re.ControlsTemplatesFetch--,le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+t+" finished!"),Re.ControlsTemplatesFetch<=0&&(_e=12,a())):n(e)}),o.addEventListener("error",n),o.send()},E=0,f=ve;E<f.length;E++){var S=f[E];le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+S+"..."),p(S,tchmi_path(le.System.config.basePath+"/Controls/"+S))}break}Re.ControlsTemplatesFetch=0,_e=12;case 12:if(Re.FunctionDescriptionJsonFetch=le.System.Caches.registeredFrameworkFunctionDescription.length,le.Log.performanceLog("[Source=Framework, Module=TcHmi] Loading "+Re.FunctionDescriptionJsonFetch+" framework functions"),(_e=0)<Re.FunctionDescriptionJsonFetch){le.System.Services.dialogManager.updateText("__TcHmiMain","Loading functions...");for(var y=function(e,r){var t=tchmi_path(e),o=new XMLHttpRequest;o.open("GET",r+be);var n=function(e){1e4!==_e&&(le.Log.error("[Source=Framework, Module=TcHmi] Loading "+r+" failed! Errordetail: "+o.statusText),le.System.Services.dialogManager.updateText("__TcHmiMain","Fatal internal error. Loading "+r+" failed! "+o.statusText,le.DialogManager.DialogSeverity.Error),_e=1e4,a())};o.addEventListener("load",function(e){if(200===o.status){if(1e4!==_e){le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+t+" finished!");var r=le.ValueConverter.toObject(o.responseText);return le.System.Services.functionProvider.addDescription(t,r),Re.FunctionDescriptionJsonFetch--,Re.FunctionDescriptionJsonFetch<=0?(_e=13,void a()):void 0}}else n(e)}),o.addEventListener("error",n),o.send()},v=0,C=le.System.Caches.registeredFrameworkFunctionDescription;v<C.length;v++){var T=C[v];le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+T.descriptionUrl+"...");var M=tchmi_path(le.System.config.basePath+"/Functions/"+T.descriptionUrl);y(T.descriptionUrl,M)}break}_e=13;case 13:if(le.Log.performanceLog("[Source=Framework, Module=TcHmi] Loading "+de+" user functions"),_e=0,ue&&0<de){le.System.Services.dialogManager.updateText("__TcHmiMain","Loading user functions..."),Re.UserFunctionDescriptionJsonFetch=de;for(var b=function(t){var o=tchmi_path(t),n=new XMLHttpRequest;n.open("GET",t+be);var i=function(e){le.Log.info("[Source=Framework, Module=TcHmi] Loading "+t+" failed. "+n.statusText+" Skipping!"),Re.UserFunctionDescriptionJsonFetch--,Re.UserFunctionDescriptionJsonFetch<=0&&(_e=14,a())};n.addEventListener("load",function(e){if(200===n.status){var r=le.ValueConverter.toObject(n.responseText);le.System.Services.functionProvider.addDescription(o,r),le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+t+" finished!"),Re.UserFunctionDescriptionJsonFetch--,Re.UserFunctionDescriptionJsonFetch<=0&&(_e=14,a())}else i(e)}),n.addEventListener("error",i),n.send()},R=0,N=ue;R<N.length;R++){var w=N[R].url.replace(".js",".function.json");le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+w+"..."),b(w)}break}_e=14;case 14:if(le.Log.performanceLog("[Source=Framework, Module=TcHmi] Loading "+he+" user control descriptions"),_e=0,me&&0<he){le.System.Services.dialogManager.updateText("__TcHmiMain","Loading user control config..."),Re.UserControlPartialsConfigFetch=he;for(var O=function(r){var t=new XMLHttpRequest;t.open("GET",r+be);var o=function(e){le.Log.info("[Source=Framework, Module=TcHmi] Loading "+r+" failed. "+t.statusText+" Skipping!"),Re.UserControlPartialsConfigFetch--,Re.UserControlPartialsConfigFetch<=0&&(le.System.Services.themeManager.resolveUserControlDefaultValueInternal(),_e=15,a())};t.addEventListener("load",function(e){200===t.status?(le.System.Caches.partialCompositeConfigCache[r]=le.ValueConverter.toObject(t.responseText),le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+r+" finished!"),Re.UserControlPartialsConfigFetch--,Re.UserControlPartialsConfigFetch<=0&&(le.System.Services.themeManager.resolveUserControlDefaultValueInternal(),_e=15,a())):o(e)}),t.addEventListener("error",o),t.send()},I=0,A=me;I<A.length;I++){var D=A[I].url.replace(".usercontrol",".usercontrol.json");le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+D+"..."),O(D)}break}_e=15;case 15:if(le.Log.performanceLog("[Source=Framework, Module=TcHmi] Preloading "+he+" user control markup"),_e=0,me&&0<he){le.System.Services.dialogManager.updateText("__TcHmiMain","Loading user control markup..."),Re.UserControlPartialsMarkupPreloaded=he;for(var k=function(r){var t=new XMLHttpRequest;t.open("GET",r+be);var o=function(e){1e4!==_e&&(le.Log.error("[Source=Framework, Module=TcHmi] Loading "+r+" failed! Errordetail: "+t.statusText),r===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL?(le.System.Services.dialogManager.updateText("__TcHmiMain","Fatal internal error. Loading "+r+" failed! Probably a syntax error in HTML or a wrong entry in tchmiconfig.json. "+t.statusText,le.DialogManager.DialogSeverity.Error),_e=1e4,a()):(Re.UserControlPartialsMarkupPreloaded--,Re.UserControlPartialsMarkupPreloaded<=0&&(_e=18,a())))};t.addEventListener("load",function(e){200===t.status?1e4!==_e&&(ce.Caches.partialMarkupCache[r]=t.responseText,Re.UserControlPartialsMarkupPreloaded--,le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+r+" finished!"),Re.UserControlPartialsMarkupPreloaded<=0&&(_e=18,a())):o(e)}),t.addEventListener("error",o),t.send()},P=0,L=me;P<L.length;P++){var H=L[P];le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+H.url+"..."),k(H.url)}if(0!==Re.UserControlPartialsMarkupPreloaded)break}_e=18;case 18:if(le.Log.performanceLog("[Source=Framework, Module=TcHmi] Preloading "+fe+" content markups"),_e=0,Ee&&0<fe){le.System.Services.dialogManager.updateText("__TcHmiMain","Loading content control markup..."),Re.ContentPartialsMarkupPreloaded=fe;for(var x=function(r){var t=new XMLHttpRequest;t.open("GET",r+be);var o=function(e){1e4!==_e&&(le.Log.error("[Source=Framework, Module=TcHmi] Loading "+r+" failed! Errordetail: "+t.statusText),r===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL?(le.System.Services.dialogManager.updateText("__TcHmiMain","Fatal internal error. Loading "+r+" failed! Probably a syntax error in HTML or a wrong entry in tchmiconfig.json. "+t.statusText,le.DialogManager.DialogSeverity.Error),_e=1e4,a()):(Re.ContentPartialsMarkupPreloaded--,Re.ContentPartialsMarkupPreloaded<=0&&(_e=16,a())))};t.addEventListener("load",function(e){200===t.status?1e4!==_e&&(ce.Caches.partialMarkupCache[r]=t.responseText,Re.ContentPartialsMarkupPreloaded--,le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+r+" finished!"),Re.ContentPartialsMarkupPreloaded<=0&&(_e=16,a())):o(e)}),t.addEventListener("error",o),t.send()},F=0,V=Ee;F<V.length;F++){!0!==(q=V[F]).preload||!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER||!0===TCHMI_ENABLE_DESIGNER_MODE&&q.url===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL?Re.ContentPartialsMarkupPreloaded--:(le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+q.url+"..."),x(q.url))}if(0!==Re.ContentPartialsMarkupPreloaded)break}_e=16;case 16:if(le.Log.performanceLog("[Source=Framework, Module=TcHmi] Preloading "+pe+" view markups"),_e=0,ge&&0<pe){le.System.Services.dialogManager.updateText("__TcHmiMain","Loading view control markup..."),Re.ViewPartialsMarkupPreloaded=pe;for(var U=function(r){var t=new XMLHttpRequest;t.open("GET",r+be);var o=function(e){if(1e4!==_e)return le.Log.error("[Source=Framework, Module=TcHmi] Loading "+r+" failed! Errordetail: "+t.statusText),r===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL?(le.System.Services.dialogManager.updateText("__TcHmiMain","Fatal internal error. Loading "+r+" failed! Probably a syntax error in HTML or a wrong entry in tchmiconfig.json. "+t.statusText,le.DialogManager.DialogSeverity.Error),_e=1e4,void a()):(Re.ViewPartialsMarkupPreloaded--,Re.ViewPartialsMarkupPreloaded<=0?(_e=19,void a()):void 0)};t.addEventListener("load",function(e){200===t.status?1e4!==_e&&(ce.Caches.partialMarkupCache[r]=t.responseText,Re.ViewPartialsMarkupPreloaded--,le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+r+" finished!"),Re.ViewPartialsMarkupPreloaded<=0&&(_e=19,a())):o(e)}),t.addEventListener("error",o),t.send()},G=0,j=ge;G<j.length;G++){!0!==(ae=j[G]).preload||!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER||!0===TCHMI_ENABLE_DESIGNER_MODE&&ae.url===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL?Re.ViewPartialsMarkupPreloaded--:(le.Log.debug("[Source=Framework, Module=TcHmi] Loading "+ae.url+"..."),U(ae.url))}if(0!==Re.ViewPartialsMarkupPreloaded)break}_e=19;case 19:le.Log.performanceLog("[Source=Framework, Module=TcHmi] Precompiling partial markup"),_e=0,le.System.Services.dialogManager.updateText("__TcHmiMain","Precompiling content control markup..."),Re.ContentPartialsMarkupCompiled=fe;for(var B=0,W=Ee;B<W.length;B++){var q;if(!0!==(q=W[B]).preload||!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER||!0===TCHMI_ENABLE_DESIGNER_MODE&&q.url===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL)Re.ContentPartialsMarkupCompiled--;else{le.Log.debug("[Source=Framework, Module=TcHmi] Precompiling "+q.url+"...");var z=q.url;if(null!=(Z=ce.Caches.partialMarkupCache[z])){var Y=$(Z);void 0!==Y&&0<Y.length&&(Y.attr("data-tchmi-partial-url",z),Z=Y[0].outerHTML),Y=null;var X=le.System.Services.controlManager.compile(Z);void 0!==X&&(X.__keepAlive=!0),Z=null,le.Log.debug("[Source=Framework, Module=TcHmi] Precompiling "+z+" finished!")}Re.ContentPartialsMarkupCompiled--}}_e=17;case 17:le.Log.performanceLog("[Source=Framework, Module=TcHmi] Precompiling view markup"),_e=0,le.System.Services.dialogManager.updateText("__TcHmiMain","Precompiling view control markup..."),Re.ViewPartialsMarkupCompiled=pe;for(var K=0,J=ge;K<J.length;K++){if(!0!==(ae=J[K]).preload||!0===TCHMI_ENABLE_DESIGNER_MODE_MASTER||!0===TCHMI_ENABLE_DESIGNER_MODE&&ae.url===TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL)Re.ViewPartialsMarkupCompiled--;else{le.Log.debug("[Source=Framework, Module=TcHmi] Precompiling "+ae.url+"...");var Z;z=ae.url;if(null!=(Z=ce.Caches.partialMarkupCache[z])){var Q=$(Z);void 0!==Q&&0<Q.length&&(Q.attr("data-tchmi-partial-url",z),Z=Q[0].outerHTML),Q=null;var ee=le.System.Services.controlManager.compile(Z);void 0!==ee&&(ee.__keepAlive=!0),Z=null,le.Log.debug("[Source=Framework, Module=TcHmi] Precompiling "+z+" finished!")}Re.ViewPartialsMarkupCompiled--}}_e=1e3;case 1e3:var re;if(le.Log.performanceLog("[Source=Framework, Module=TcHmi] Finalising framework"),_e=0,le.Log.debug("[Source=Framework, Module=TcHmi] Internal event registration..."),le.System.Services.dialogManager.updateText("__TcHmiMain","Internal event registration..."),le.System.Services.triggerManager&&le.System.config&&le.System.config.trigger&&le.System.Services.triggerManager.register(le.System.config.trigger),le.Log.debug("[Source=Framework, Module=TcHmi] Loading view..."),!0===TCHMI_ENABLE_DESIGNER_MODE)re=tchmi_path(TCHMI_ENABLE_DESIGNER_MODE_TARGET_PARTIAL);else{var te=le.System.config.startupView;if(null==te)return le.System.Services.dialogManager.updateText("__TcHmiMain","Fatal internal error. No startup view defined!",le.DialogManager.DialogSeverity.Error),_e=1e4,void a();for(var oe=!1,ne=0,ie=ge;ne<ie.length;ne++){var ae;if(tchmi_path((ae=ie[ne]).url)===tchmi_path(te)){oe=!0;break}}if(null==te||!0!==oe)return le.System.Services.dialogManager.updateText("__TcHmiMain","Fatal internal error. Can't find a valid view definition matching the defined startup view.",le.DialogManager.DialogSeverity.Error),_e=1e4,void a();re=te}le.System.Services.dialogManager.updateText("__TcHmiMain","Loading view..."),le.System.Services.viewManager.setScaleMode(le.System.config.scaleMode),le.System.Services.viewManager.loadView(re,function(e){if(e.error!==le.Errors.NONE)return le.System.Services.dialogManager.updateText("__TcHmiMain","Fatal internal error. Loading and compiling "+re+" failed!",le.DialogManager.DialogSeverity.Error),_e=1e4,void a();le.System.isInitialized=!0,window.clearInterval(Te),Te=0,le.EventProvider.raise("onInitialized"),le.Log.performanceLog("[Source=Framework, Module=TcHmi] End"),4<=TCHMI_CONSOLE_LOG_LEVEL&&"object"==typeof performance&&"function"==typeof performance.now&&le.Log.debug("[Source=Framework, Module=TcHmi] Overall loading time: "+performance.now().toFixed(3).toString()+"ms")});break;case 1e4:if("loading"===document.readyState){var se=function(){document.removeEventListener("readystatechange",se),a()};document.addEventListener("readystatechange",se);break}window.clearInterval(Te),Te=0,le.System.Services.dialogManager.showDialog("__TcHmiMain",!0,le.DialogManager.DialogType.SYSTEMLoading),le.Log.performanceLog("[Source=Framework, Module=TcHmi] End");break;default:_e=0}};n()}}(TcHmi||(TcHmi={}));